#include <iostream>
#include <cmath>
#include <unordered_map>

//#ifndef LOCAL_D
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,popcnt,abm,mmx,tune=native")
//#pragma comment(linker, "/STACK:256000000")
//#endif


using namespace std;

typedef long long ll;

int is_full_square(ll a) {
    if (a == 1)
        return 1;
    unordered_map<int, int> divs;
    for (int i = 2; i * i <= a; i++) {
        while (a % i == 0) {
            a /= i;
            divs[i]++;
        }
    }
    if (a != 1)
        divs[a]++;
    int square_root = 1;
    for (auto [div,am]: divs) {
        if (am % 2)
            return -1;
        square_root *= pow(div, am / 2);
    }
    return square_root;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll k;
    cin >> k;
    if (k == 0) {
        cout << 0;
        return 0;
    }
    int s = is_full_square(abs(k));
    if (s != -1) {
        if (k < 0)
            cout << 0;
        else {
            cout << s;
        }
    } else {
        if (k < 0) {
            k = abs(k);
            if (k % 2) {
                cout << k / 2;
            } else {
                if (k % 4 == 2)
                    cout << "none";
                else
                    cout << abs(k / 3 - 1);
            }
        } else {
            if (k % 2) {
                return 6;
                cout << (k + 1) / 2;
            } else {
                if (k % 4 == 2) {
                    cout << "none";
                }
                else {
                    cout << (k + 1) / 3;
                }
            }
        }
    }
    return 0;
}