#pragma GCC optimize("Ofast")
#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr);

#include <bits/stdc++.h>

#define int long long
#define double long double
#define endl "\n"

using namespace std;

inline int sqr(int v) {
    int l, r;
    l = 0; r = v + 1;
    while(r != l + 1) {
        int m = (l + r) >> 1;

        if(m * m <= v)
            l = m;
        else
            r = m;

//        cerr << m << " " << v << " " << l << " " << r << endl;
    }
    return l;
}

int32_t main() {
    ON_START

    int k;
    cin >> k;
    bool isg0 = k >= 0;
    if(!isg0)
        k = -k;

    const int max = 20000000LL * 20000000LL;

    vector<int> values;

    int val = 0;
    values.reserve(20000001);
    for (int i = 0;; ++i) {
        if(i > 0)
            val += (i << 1) - 1;
        values.push_back(val);
        if(val > max)
            break;

        if(val < k)
            continue;

        int l = 0, r = values.size();
        while (r != l + 1) {
            int m = (l + r) >> 1;
            if(val - values[m] >= k) {
                l = m;
            } else {
                r = m;
            }
        }

        if(val - values[l] == k) {
            if(isg0) {
                cout << sqr(val) << endl;
                return 0;
            } else {
                cout << sqr(values[l]) << endl;
                return 0;
            }
        }
    }

    cout << "none\n";

    return 0;
}