#pragma GCC optimize("Ofast")
#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr);

#include <bits/stdc++.h>

//#define int long long
#define double long double
#define endl "\n"

using namespace std;

vector<int> getComp(int v, vector<int> gr[], bool was[]) {
    vector<int> res;
    res.push_back(v);
    was[v] = true;
    for (int g : gr[v]) {
        if(!was[g]) {
            auto _ = getComp(g, gr, was);
            for (int i : _) {
                res.push_back(i);
            }
        }
    }

    return res;
}

int calc(set<int> &can, vector<int> gr[]) {
    int res = 0;
    int maxNewCan = -1;
    int maxNewCanV = -1;

    for(int v : can) {
        int newCan = can.size();

        for (int no : gr[v]) {
            if(can.find(no) != can.end())
                newCan--;
        }

        if(newCan > maxNewCan) {
            maxNewCan = newCan;
            maxNewCanV = v;
        }
    }

//    cout << maxNewCan << " " << maxNewCanV << " " << can.size() << endl;

    if(maxNewCanV != -1) {
        for (int no : gr[maxNewCanV]) {
            can.erase(no);
        }
        can.erase(maxNewCanV);

//        cout << can.size() << " " << maxNewCan << " " << maxNewCanV << endl;

        res += calc(can, gr) + 1;
    }

    return res;
}

int32_t main() {
    ON_START

    int n;
    cin >> n;
    int a[n];
    vector<int> gr[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] != -1) {
            a[i]--;
            gr[i].push_back(a[i]);
            gr[a[i]].push_back(i);
        }
    }

    bool was[n];
    for (int i = 0; i < n; ++i) {
        was[i] = false;
    }

    int res = 0;
    for (int i = 0; i < n; ++i) {
        if (!was[i]) {
            auto comp = getComp(i, gr, was);

            set<int> can(comp.begin(), comp.end());
            res += calc(can, gr);
        }
    }

    cout << res << endl;

    return 0;
}