#include <bits/stdc++.h>

using namespace std;

#define ALL(x) (x).begin(), (x).end()
#define BALL(x) (x).rbegin(), (x).rend()
#define LAST(x) (x)[(x).size() - 1]

//#define DEBUG
#ifdef DEBUG
ifstream _in("debug.in");
#define cin _in
#endif

#define int long long
#define endl '\n'
#define INF 1e15+7
const int MOD = 1e9+7;

signed main() {
	ios_base::sync_with_stdio(false);

	int n, k;
	cin >> n >> k;
	vector<vector<int>> a(n, vector<int>(k + 1));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
		}
		a[i][k] = i + 1;
	}
	sort(ALL(a));
	/*for (auto e : a) {
		for (auto j : e) {
			cout << j << ' ';
		} cout << endl;
	}*/
	int half = n / 2;
	if (k == 1) {
		cout << "YES" << endl;
		for (int i = 0; i < half; ++i) {
			cout << a[i][k] << ' ' << a[i + half][k] << endl;
		}
	}
	else {
		vector<vector<bool>> halfs(n, vector<bool>(k));
		for (int i = 0; i < half; ++i) {
			halfs[a[i][k] - 1][0] = 0;
			halfs[a[i + half][k] - 1][0] = 1;
		}
		for (int ik = 1; ik < k; ++ik) {
			for (int i = 0; i < n; ++i) {
				swap(a[i][0], a[i][ik]);
			}
			sort(ALL(a));
			for (int i = 0; i < half; ++i) {
				halfs[a[i][k] - 1][ik] = 0;
				halfs[a[i + half][k] - 1][ik] = 1;
			}
		}
		for (int i = 0; i < n; ++i) {
			swap(a[i][0], a[i][1]); // The original row
		}
		sort(ALL(a));
		/*for (auto e : a) {
			for (auto e2 : e) {
				cout << e2 << ' ';
			} cout << endl;
		}
		for (auto e : halfs) {
			for (auto e2 : e) {
				cout << e2 << ' ';
			} cout << endl;
		}*/
		if (k == 2) {
			cout << "YES" << endl;
			int cur_take = n;
			for (int i = 0; i < n; ++i) {
				if (halfs[a[i][k] - 1][1] == 0)
					continue;
				do {
					--cur_take;
				} while (halfs[a[cur_take][k] - 1][1]);
					
				cout << a[i][k] << ' ' << a[cur_take][k] << endl;
			}
		} else {
			cout << "NO" << endl;
		}
	}
}