#include <bits/stdc++.h>

using namespace std;

const long long INF = 1e18;

void get_div(long long n, vector<long long> &div){
    for (long long i = 2; i * i <= n; i++){
        if (n % i == 0){
            div.push_back(i);
        }
    }
    div.push_back(1);
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    long long k;
    cin >> k;
    if (k == 0){
        cout << 0;
        return 0;
    }
    vector<long long> div;
    long long n = k;
    if (k < 0)
        n *= -1;
    get_div(n, div);
    long long ans = INF;
    for (long long el : div){
        if ((el + n / el) % 2 == 0){
            long long x = (el + n / el) / 2;
            long long a = (n / el - el) / 2;
            if ((k < 0 && x > a) || (k > 0 && x < a))
                swap(x, a);
            ans = min(ans, x);
        }
    }
    if (ans == INF)
        cout << "none";
    else
        cout << ans;
    return 0;
}