#include <bits/stdc++.h>

using namespace std;

long long mod = 1e9 + 7;

long long count(long long k){
    long long cnt = 0;
    while (k > 0){
        k /= 2;
        cnt++;
    }
    cout << "count: " << cnt - 1 << endl;
    return cnt - 1;
}

long long power(long long n, long long k){
    if (k == 0)
        return 1;
    if (k % 2 == 0)
        return power(n * n, k / 2) % mod;
    return power(n, k - 1) * n % mod;
}

long long next(long long k, long long curr){
    curr--;
    while (curr >= 0 && (k >> curr) % 2 == 0)
        curr--;
    cout << "next: " << curr << endl;
    return curr;
}

long long first_solution(long long n, long long k, long long curr){
    if (curr == -1)
        return 1;
    cout << "power: " << power(n + 1, curr) << endl;
    return (power(n + 1, curr) + n * first_solution(n, k, next(k, curr))) % mod;
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    long long n, m, k;
    cin >> n >> m >> k;
    if (m == 0)
        cout << first_solution(n, k, count(k));
    return 0;
}