//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,avx2,mmx,popcnt,abm,tune=native")
//#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector")

//#include <bits/stdc++.h>
#include <iostream>
#include <algorithm>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
#include <chrono>
#include <iterator>
#include <climits>

using namespace std;

mt19937 Random(time(NULL));

vector<vector<int>> graph;
bitset<300005> vis;
pair<int, int> dfs(int v) {
    vis[v] = 1;
    int ans1 = 1, ans2 = 0;
    for (int u : graph[v]) {
        if (vis[u])
            continue;
        auto p = dfs(u);
        ans1 += p.second;
        if (p.first > p.second)
            ans2 += p.first;
        else
            ans2 += p.second;
    }
    return {ans1, ans2};
}

int recur(int v, int n, int cc) {
    if (v == n)
        return cc;
    int ans1 = recur(v + 1, n, cc), ans2 = 0;
    if (!vis[v]) {
        for (int u : graph[v])
            vis[u] = 1;
        ans2 = recur(v + 1, n, cc + 1);
        for (int u : graph[v])
            vis[u] = 0;
    }
    if (ans1 > ans2)
        return ans1;
    else
        return ans2;
}

int main() {
    int n;
    cin >> n;
    vector<int> arr(n);
    graph.resize(n);
    vis = 0;
    if (n <= 20) {
        for (int i = 0; i < n; i++) {
            cin >> arr[i];
            if (arr[i] == -1) {
                continue;
            }
            arr[i]--;
            graph[i].push_back(arr[i]);
            graph[arr[i]].push_back(i);
        }
        cout << recur(0, n, 0);
        return 0;
    }
    cin >> arr[0];
    if (arr[0] == -1) {
        for (int i = 1; i < n; i++) {
            cin >> arr[i];
            if (arr[i] == -1)
                continue;
            arr[i]--;
            if (arr[i] < i)
                graph[arr[i]].push_back(i);
            else
                graph[i].push_back(arr[i]);
        }
        int ans = 0;
        for (int v = 0; v < n; v++) {
            if (vis[v])
                continue;
            auto p = dfs(v);
            if (p.first > p.second)
                ans += p.first;
            else
                ans += p.second;
        }
        cout << ans;
        return 0;
    }
    cout << Random() % n + 1;
}
/*
8
-1 1 1 3 1 2 -1 4
 */