#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unroll-all-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt")

#include <bits/stdc++.h>

using namespace std;

int n;
vector<vector<int>> g;
vector<int> take;
vector<int> netake;
vector<int> pr;

void dfs(int v) {
	take[v] = 1;
	for (int to : g[v]) {
		if (to != pr[v])
			dfs(to);
		take[v] += netake[to];
		netake[v] += max(take[to], netake[to]);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n;
	g.resize(n);
	take.resize(n);
	netake.resize(n);
	pr.resize(n);
	for (int i = 0; i < n; ++i) {
		int x; cin >> x; x--;
		pr[i] = x;
		g[x].push_back(i);
	}
	int ans = 0;
	for (int i = 0; i < n; ++i)
		if (pr[i] == -2) {
			dfs(i);
			ans += max(take[i], netake[i]);
		}
	cout << ans << endl;
} 