def sum0(i, l, r):
    return (prefixsums[i][r][0] - prefixsums[i][l - 1][0] + 1000000007) % 1000000007


def sum1(i, l, r):
    return (prefixsums[i][r][1] - prefixsums[i][l - 1][1] + 1000000007) % 1000000007


def fillprefixums(i):
    for j in range(1, n + 1):
        prefixsums[i][j] = ((prefixsums[i][j - 1][0] + dp[i][j][0] + 1000000007) % 1000000007, (prefixsums[i][j - 1][1] + dp[i][j][1] + 1000000007) % 1000000007)
    prefixsums[i].append((0, 0))


def main():
    global prefixsums, dp, n

    n, k = map(int, input().split())
    dp = [[(0, 0)]*(n + 1) for _ in range(n + 1)]
    prefixsums = [[(0, 0)] * (n + 1) for _ in range(n + 1)]

    dp[k][k] = (1, 1)
    fillprefixums(k)

    if n == k:
        print(1)
    else:
        for i in range(k + 1, n + 1):
            # print('i:',i)
            for j in range(1, i - k + 1):
                # print('j:', j)
                # print(prefixsums[i - j])
                dp[i][j] = (sum1(i - j, 0, j - 1), sum0(i - j, j + 1, n))
                # print(dp[i][j])
            # print('\n')
            fillprefixums(i)

        # for i in range(n + 1):
        #     print(*dp[i])

        ans = 0
        for j in range(n + 1):
            ans = (ans + dp[n][j][0] + dp[n][j][1] + 1000000007) % 1000000007
        print(ans)


main()
