#include <iostream>
#include <vector>
using namespace std;


int main()
{
    int n, k;
    cin >> n >> k;
    vector<vector<pair<long long int, long long int>>> prefixsums;
    vector<vector<pair<long long int, long long int>>> dp;
    for (int i=0; i<n+1; ++i) {
        dp.push_back(vector<pair<long long int, long long int>>(n + 1, make_pair<long long int, long long int>(0, 0)));
        prefixsums.push_back(vector<pair<long long int, long long int>>(n + 1,make_pair<long long int,  long long int>(0, 0)));
    }
    dp[k][k] = make_pair(1, 1);
    for (int j=1; j<n+1; ++j) {
        prefixsums[k][j] = make_pair(
            (prefixsums[k][j - 1].first + dp[k][j].first) % 1000000007,
            (prefixsums[k][j - 1].second + dp[k][j].second) % 1000000007
        );
    }

    if (n == k) {
        cout << '1';
    }
    else {
        for (int i=k+1; i<n+1; ++i) {
            for (int j=1; j<i-k+1; ++j) {
                dp[i][j] = make_pair(
                    (prefixsums[i - j][j - 1].second - prefixsums[i - j][0].second + 1000000007) % 1000000007,
                    (prefixsums[i - j][n].first - prefixsums[i - j][j].first + 1000000007) % 1000000007
                );
            }
            for (int j=1; j<n+1; ++j) {
                prefixsums[i][j] = make_pair(
                    (prefixsums[i][j - 1].first + dp[i][j].first) % 1000000007,
                    (prefixsums[i][j - 1].second + dp[i][j].second) % 1000000007
                );
            }
        }
        long long int ans=0;
        for (int j=0; j<n + 1; ++j) {
            ans = (ans + dp[n][j].first + dp[n][j].second) % 1000000007;
        }
        cout << ans;
    }
    return 0;
}
