#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <math.h>
using namespace std;

int main()
{
    long long n, k, i, j, a, b, p = 1e9 + 7, res = 0, l;
    long long pref[50][50], post[50][50];
    pair <long long, long long> d[50][50];
    cin >> n >> k;
    for (i = 0; i <= n; i++)
    {
        for (j = 0; j <= n; j++)
        {
            d[i][j] = {0, 0};
        }
    }
    d[k][k] = {1, 1};
    for (i = k; i <= n; i++)
    {
        if (i > k)
        {
            for (j = 1; j < i && i - j >= k; j++)
            {
                d[i][j].first = pref[i - j][j - 1];
                d[i][j].second = post[i - j][j + 1];
            }
        }
        pref[i][0] = 0;
        for (j = 1; j <= n; j++)
        {
            pref[i][j] = (pref[i][j - 1] + d[i][j].second) % p;
        }
        post[i][i + 1] = 0;
        for (j = n; j >= 1; j--)
        {
            post[i][j] = (post[i][j + 1] + d[i][j].first) % p;
        }
    }
    if (n == k)
    {
        cout << 1;
    }
    else
    {
        for (i = 1; i <= n; i++)
        {
            res += d[n][i].first + d[n][i].second;
            res %= p;
        }
        cout << res;
    }
    return 0;
}
