#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <set>
#include <map>
#include <algorithm>

#define int long long

using namespace std;

int32_t main() {
    int n, k;
    cin >> n >> k;
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (n + 1, vector<int>(2, 0)));
    for(int i = 0; i < n + 1; i ++) {
        dp[i][i][0] = 1;
        dp[i][i][1] = 1;
    }
    for(int i = 1; i < n + 1; i ++) {
        for(int j = 1; j < n + 1; j ++) {
            if(j < i) {
                for (int k = j + 1; k <= i - j; k++) {
                    dp[i][j][1] += dp[i - j][k][0];
                }
                for(int k = j - 1; k > 0; k --) {
                    dp[i][j][0] += dp[i - j][k][1];
                }
            }
        }
    }
    if(k == n) {
        cout << 1 << endl;
        return 0;
    }
    cout << dp[n][k][0] + dp[n][k][1] << endl;
}