#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)
//char ALLOC_MEM[480 * 1024 * 1024];
int ALLOC_POS = 0;
#include <cstddef>
#include <cstring>
/*inline void* operator new(size_t n) {
    void* res = (void*) (ALLOC_MEM + n);
    ALLOC_POS += n;
    memset(res, 0, n);
    return res;
}



inline void operator delete(void*) noexcept {

}*/

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

using ll = long long;

int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}

#define all(x) x.begin(), x.end()
vector<vector<int>> req_ids;

template<typename T>
struct MinStack {
    vector<pair<T, T>> v;
    void push (T x) {
        T m = x;
        if (!v.empty()) {
            m = min(m, v.back().second);
        }
        v.emplace_back(x, m);
    }
    T pop() {
        T ret = v.back().first;
        v.pop_back();
        return ret;
    }

    T get() {
        return v.back().second;
    }
};

template<typename T>
struct MinQueue {
    MinStack<T> head, tail;
    void rebuild() {
        while (!head.v.empty()) {
            tail.push(head.pop());
        }
    }

    void push(T x) {
        head.push(x);
    }

    void pop() {
        if (tail.v.empty()) {
            rebuild();
        }
        tail.pop();
    }

    T get() {
        if (tail.v.empty()) {
            return head.get();
        }
        T res = tail.get();
        if (!head.v.empty()) {
            res = min(res, head.get());
        }
        return res;
    }
};

const ll TAMB = 100000;

ll solve_small(ll a, ll b, ll c) { // large blocks, few steps
    ll ans = 0;
    while (a != b) {
        ll bl_end = a;
        if (a % c == 0) {
            bl_end += c - 1;
        } else {
            bl_end -= a % c;
            bl_end += c - 1;
        }
        if (bl_end == a) {
            ++ans;
            a += 2;
            continue;
        }
        ll targ = min(b, bl_end);
        ll dist = targ - a;
        ll dans = (dist - 1) / 2 + 1;
        if (dist == 0) dans = 0;
        ans += dans;
        a = targ;
    }
    return ans;
}
ll solve_large(ll a, ll b, ll c) {
   ll ans =0 ;
    ll bl_len = (c-1)/2+1;
    while (true) {
        ll r = a % c;
        if (r == c - 1) break;
        if (r == c-2) {
            ++ans;
            ++a;
            break;
        }
        ++ans;
        a += 2;
    }
    ll t = (b-a) / c;
    a += t*c;
    ans += t*bl_len;
    while (a != b) {
        int d = min<ll>(2, b - a);
        a += d;
        ++ans;
    }
    return ans;
}


const ll MOD = 1'000'000'007;

inline void ckmod(ll& a) {
    if (a >= MOD) {
        a-= MOD;
    }
}

void entry(int test_id) {
    (void) test_id;
   int N, K;
   scanf("%d %d", &N, &K);
   if (N ==K) {
       printf("1\n");
       return;
   }
    vector<vector<vector<ll>>> dp_pref(N+1, vector<vector<ll>>(N+2, vector<ll>(2)));

    for (int k = 1; k <= N; ++k) {
        for (int i = k+1; i <= N+1; ++i) {
            dp_pref[k][i][0] = dp_pref[k][i][1] = 1;
        }
    }
    for (int n = 1; n <= N; ++n) {
        for (int k = 1; k <= n; ++k) {
            for (int f : {0 , 1}) {
                int l, r;
                if (f == 1) {
                    l = 1;
                    r = k;
                } else {
                    l = k+1;
                    r =n+1;
                }
                r = min(r, n - k + 1);
                ll t2 = 0;
                if (l < r) {

                    t2 = dp_pref[n - k][r][1 - f] + MOD - dp_pref[n - k][l][1 - f];
                }
                ckmod(t2);
                dp_pref[n][k+1][f] += dp_pref[n][k][f] + t2;
                ckmod(dp_pref[n][k+1][f]);
            }
        }
    }
    ll ans = dp_pref[N][K+1][0] + dp_pref[N][K+1][1] - dp_pref[N][K][0] - dp_pref[N][K][1] + 2*MOD;
    ckmod(ans);
    ckmod(ans);
    ckmod(ans);
    ckmod(ans);
    printf("%lld\n", ans);
}