#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)
//char ALLOC_MEM[480 * 1024 * 1024];
int ALLOC_POS = 0;

#include <cstddef>
#include <cstring>
/*inline void* operator new(size_t n) {
    void* res = (void*) (ALLOC_MEM + n);
    ALLOC_POS += n;
    memset(res, 0, n);
    return res;
}



inline void operator delete(void*) noexcept {

}*/

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

using ll = long long;

int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}

#define all(x) x.begin(), x.end()

struct Kuhn {
    int n, m;
    vector<int> maplr, maprl;
    vector<vector<int>> g;
    vector<int> color;

    Kuhn(int n, int m) : n(n), m(m) {
        maplr.resize(n, -1);
        maprl.resize(m, -1);
        color.resize(n, -1);
        cur_color = 0;
    }

    int cur_color;

    int dfs(int v) {
        if (cur_color == color[v]) return 0;
        color[v] = cur_color;
        for (int w : g[v]) {
            if (maprl[w] == -1) {
                maprl[w] = v;
                return 1;
            }
        }
        for (int w : g[v]) {
            if (dfs(maprl[w])) {
                maprl[w] = v;
                return 1;
            }
        }
        return 0;
    }

    int run() {
        int ans = 0;
        for (int v = 0; v < n; ++v) {
            ans += dfs(v);
            cur_color++;
        }
    }
};

void entry(int test_id) {
    (void) test_id;
    int n, k;
    scanf("%d %d\n", &n, &k);
    Kuhn kuhn(n / 2, n / 2);
    vector<vector<int>> a(n, vector<int>(k));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            int x;
            scanf("%d", &x);
            a[i][j] = x;
        }
    }
    vector<vector<int>> klass(n, vector<int>(k));
    for (int j = 0; j < k; ++j) {
        vector<int> p0(n);
        for (int i = 0; i < n; ++i) {
            p0[i] = i;
        }
        sort(all(p0), [&](int t1, int t2) {
            return a[t1][j] < a[t2][j];
        });
        for (int i = 0; i < n / 2; ++i) {
            klass[p0[i]][j] = 0;
        }
        for (int i = n / 2; i < n; ++i) {
            klass[p0[i]][j] = 1;
        }
    }
    vector<int> hsh(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            hsh[i] = 2*hsh[i] + klass[i][j];
        }
    }
    vector<vector<int>> with_hash(1 << k);
    for (int i = 0; i < n; ++i) {
        with_hash[hsh[i]].push_back(i);
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < (1 << (k-1)); ++i) {
        int co = (1<<k)-i-1;
        if (with_hash[i].size() != with_hash[co].size()) {
            printf("NO\n");
            return;
        }
        for (int j = 0; j < with_hash[i].size(); ++j) {
            ans.emplace_back(with_hash[i][j], with_hash[co][j]);
        }
    }
    printf("YES\n");
    for (auto p : ans) {
        printf("%d %d\n", p.first+1, p.second+1);
    }

}