#include <iostream>
#include <vector>

using namespace std;

const long long mod = 1000000007;

int main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);
    long long n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    vector <vector <pair <long long, long long>>> dp(n);
    vector <vector <pair <long long, long long>>> ps(n);
    for (int i = 0; i < n; i++) {
        dp[i].resize(n);
        ps[i].resize(n);
        dp[i][i] = {1, 1};
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j) {
                dp[i][j] = {0, 0};
            }
            if (j < i) {
                dp[i][j].first = (dp[i][j].first + ps[i - j - 1][j - 1].second) % mod;
                dp[i][j].second = (dp[i][j].second + (ps[i - j - 1][n - 1].first - ps[i - j - 1][j].first)) % mod;
            }
            if (j == 0) {
                ps[i][j].first = dp[i][j].first;
                ps[i][j].second = dp[i][j].second;
            } else {
                ps[i][j].first = (ps[i][j - 1].first + dp[i][j].first) % mod;
                ps[i][j].second = (ps[i][j - 1].second + dp[i][j].second) % mod;
            }
        }
    }
    cout << (dp[n - 1][k - 1].first + dp[n - 1][k - 1].second) % mod;
    return 0;
}
