#include <iostream>

using namespace std;

#define int long long

const int MAXN = 505, mod = 1e9 + 7;

int n, m, k;
int dp[MAXN][MAXN];

signed main() {
	cin >> n >> m >> k;

	for (int i = 0; i <= k; ++i) {
		dp[0][i] = 1;
	}

	for (int i = 1; i < n; ++i) {
		for (int j = 0; j <= k; ++j) {
			for (int p = 0; p <= k; ++p) {
				if ((p & j) == p) {
					dp[i][j] += dp[i - 1][p];
					dp[i][j] %= mod;
					if (dp[i][j] < 0) dp[i][j] += mod;
				}
			}
		}
	}

	int ans = 0;
	for (int i = 0; i <= k; ++i) {
		ans += dp[n - 1][i];
	}
	cout << ans << endl;
	return 0;
}