#include <iostream>

using namespace std;

#define int long long

const int MOD = 1791791791;
const int MAXN = 5005;

int n, k;
int dp[MAXN][MAXN], sum[MAXN];

signed main() {
	cin >> n >> k;
	dp[k][k] = 1;
	sum[k] = 1;

	for (int ns = k + 1; ns <= n; ++ns) {
		for (int ps = k; ps < ns; ++ps) {
			int nk = ns - ps;
			dp[ns][nk] += sum[ps] - dp[ps][nk];
		}

		for (int nk = 1; nk <= n; ++nk) {
			sum[ns] += dp[ns][nk];
		}
	}

	cout << sum[n] << endl;
	return 0;
}