#include <iostream>

using namespace std;

const long long MOD = 1000 * 1000 * 1000 + 7;
const int MAXN = 5005;

long long n, k;
long long sum[MAXN][MAXN][2];

signed main() {
	cin >> n >> k;
	for (int nk = k; nk <= n; ++nk) {
		sum[k][nk][0] = 1;
		sum[k][nk][1] = 1;
	}

	for (int ns = k + 1; ns <= n; ++ns) {
		for (int nk = 1; nk <= ns; ++nk) {
			int ps = ns - nk;
			sum[ns][nk][0] = (sum[ps][n][1] - sum[ps][nk][1]) % MOD;
			if (sum[ns][nk][0] < 0) sum[ns][nk][0] += MOD;

			sum[ns][nk][1] = sum[ps][nk - 1][0] % MOD;
			if (sum[ns][nk][1] < 0) sum[ns][nk][1] += MOD;
		}
		for (int nk = 1; nk <= n; ++nk) {
			sum[ns][nk][0] = (sum[ns][nk - 1][0] + sum[ns][nk][0]) % MOD;
			if (sum[ns][nk][0] < 0) sum[ns][nk][0] += MOD;

			sum[ns][nk][1] = (sum[ns][nk - 1][1] + sum[ns][nk][1]) % MOD;
			if (sum[ns][nk][0] < 0) sum[ns][nk][0] += MOD;
		}
	}

	if (n == k) cout << 1 << endl;
	else cout << (sum[n][n][0] + sum[n][n][1]) % MOD << endl;
	return 0;
}