#include <bits/stdc++.h>
using namespace std;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define len(v) (v).size()
#define sz(v) (v).size()
#define x first
#define y second
#define int long long
#define vi vector<int>
#define vvi vector<vector<int>>

int n;
vi C, M;
vvi G;
int ans = 0;

bool read() {
    cin >> n;
    G.resize(n + 1);
    M.resize(n+1, -1);
    for (int i = 1; i <= n; ++i) {
        int a; cin >> a;
        if (a != -1)
            G[a].push_back(i);
    }
    return 1;
}

bool dfs(int v, int f) {
    bool circle=false, res=false;
    for (auto x : G[v]) {
        if (x == f) circle = true;
        else if (M[x] != -1) res |= M[x];
        else if (dfs(x, f)) circle = true;
        else res |= M[x];
    }
    res = !res;
    if (circle) {
        if (res) C.back()++;
        else C.push_back(0);
    }
    else ans += res;
    M[v] = res;
    return circle;
}

void solve() {
    for (int i = 1; i <= n; ++i) {
        if (M[i] == -1) {
            C.clear();
            C.push_back(0);
            dfs(i, i);
            if (C.size() == 1) ans += C[0]/2;
            else if (C.size() > 1) {
                C[0] += C.back();
                for (int i = 0; i < C.size() - 1; ++i)
                    ans += (C[i] + 1)/2;
            }
        }
    }

    cout << ans;
}

void init() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

signed main() {
    init();
    read();
    solve();
    cout.flush();
}
