#include <iostream>
#include <vector>

using ll = int64_t;
const ll MOD = 1000000007;


int main(){
	ll n,k; std::cin>>n>>k;
	std::vector<std::vector<std::vector<ll>>> dp(n+1,std::vector<std::vector<ll>>(n+1,std::vector<ll>(2,0)));
	
	if(k == n){
		std::cout<<1<<std::endl;
		return 0;
	}

	dp[k][k][1] = 1;
	dp[k][k][0] = 1;
	dp[k][0][0] = 1;
	for(int s=k+1;s<=n;s++){
		for(int a=1;a<=n;a++){
			if(s-a > 0){
				if(a == 1)
					dp[s][a][1] = 0;
				else
					dp[s][a][1] = (dp[s-1][a-1][1] + dp[s-a][a-1][0])%MOD;
				if(a == n)
					dp[s][a][0] = 0;
				else
					dp[s][a][0] = (dp[s-1][a-1][0] - dp[s-a][a][1] + MOD)%MOD;
				dp[s][0][0] = dp[s][0][0] + dp[s][a][1];
			}
		}
	}
	
	ll ans = 0;
	for(int a=1;a<=n;a++)
		ans = (ans + dp[n][a][0] + dp[n][a][1])%MOD;
	
	std::cout<<ans<<std::endl;
}
