#include <bits/stdc++.h>

#define f first
#define s second
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define ll long long
#define ld long double
#define eb emplace_back
#define mp make_pair

using namespace std;

int ans = 0;

void bt(int n, int last, int k, int f = -1) {
    if (n == 0) {
        if (f == -1 || last == f) {
            ++ans;
        }
        return;
    }
    for (int i = last; i <= k; ++i) {
        if ((i & last) == last) {
            bt(n - 1, i, k, f);
        }
    }
}

const int MOD = 1e9 + 7;

string conv(ll t) {
    string s;
    while (t) {
        s += char((t & 1ll) + '0');
        t >>= 1;
    }
    reverse(all(s));
    return s;
}

struct mint {
    int x = 0;

    mint() {}

    mint(int y) : x(y) {}

    mint operator+(mint y) {
        int t = x + y.x;
        if (t >= MOD) {
            t -= MOD;
        }
        return t;
    }

    void operator+=(mint y) {
        x += y.x;
        if (x >= MOD) {
            x -= MOD;
        }
    }

    mint operator*(mint y) {
        return 1ll * x * y.x % MOD;
    }

    void operator*=(mint y) {
        x = 1ll * x * y.x % MOD;
    }
};

/*mint fpow(mint a, int p) {
    //cout << a.x << ' ' << p << endl;
    mint res(1), mod(a.x);
    while (p) {
        if (p & 1) {
            res *= mod;
        }
        p >>= 1;
        mod *= mod;
    }
    return res;
}*/

ll fpow(ll a, int p) {
    //cout << a << ' ' << p << endl;
    ll res = 1, mod = a;
    while (p) {
        if (p & 1) {
            res *= mod;
            res %= MOD;
        }
        p >>= 1;
        mod *= mod;
        mod %= MOD;
    }
    return res;
}

ll dp2[101][101][101] = {};  /// length, number, quantity
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    /*for (int n = 1; n <= 3; ++n) {
        for (int k = 0; k <= 8; ++k) {
            ans = 0;
            bt(n, 0, k);
            cout << '!' << n << ' ' << k << ' ' << ans << '\n';
            ans = 0;
            for (int k1 = 0; k1 <= k; ++k1) {
                int ans2 = ans;
                bt(n, 0, k1, k1);
                cout << k1 << ' ' << ans - ans2 << '\n';
            }
            cout << '@' << ans << '\n';
        }
    }
    cout.flush();*/
    int n, m;
    ll k;
    cin >> n >> m >> k;
    if (k == 0 && m == 0) {
        cout << 1;
        return 0;
    }
    if (m == 0) {
        //int t = __builtin_popcountll(k);
        string s = conv(k);
        //cout << s << endl;
        const int L = 65;
        ll dp[sz(s) + 1][L][2] = {};  /// length, bits, flag
        dp[0][0][1] = 1;
        for (int p = 1; p <= sz(s); ++p) {
            for (int k = 0; k < L; ++k) {
                dp[p][k][0] += dp[p - 1][k][0];
                dp[p][k + 1][0] += dp[p - 1][k][0];
                if (s[p - 1] == '0') {
                    dp[p][k][1] += dp[p - 1][k][1];
                }
                else {
                    dp[p][k][0] += dp[p - 1][k][1];
                    dp[p][k + 1][1] += dp[p - 1][k][1];
                }
                dp[p][k][0] %= MOD;
                dp[p][k + 1][0] %= MOD;
                dp[p][k][1] %= MOD;
                dp[p][k + 1][1] %= MOD;
            }
        }
        //cout << '!' << endl;
        ll ans = 0;
        for (int k = 0; k < L; ++k) {
            ans += (dp[sz(s)][k][0] + dp[sz(s)][k][1]) % MOD * fpow(n, k) % MOD;
            ans %= MOD;
        }
        cout << ans;
        return 0;
    }
    vector<pii> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i].f >> a[i].s;
    }
    //dp2[0][0][0] = 1;
    for (int i = 0; i <= k; ++i) {
        dp2[1][i][1] = 1;
    }
    for (int i = 2; i <= n; ++i) {
        for (int t = 0; t <= k; ++t) {
            int s = t;
            while (1) {
                if (s == t) {
                    int last = -1;
                    for (int w = 0; w < m; ++w) {
                        if (a[w].s == i) {
                            last = max(a[w].f, last);
                        }
                    }
                    for (int q = 1; q <= min(i - 1, i - last - 1); ++q) {
                        dp2[i][t][q + 1] += dp2[i - 1][s][q];
                        dp2[i][t][q + 1] %= MOD;
                        //cout << i << ' ' << t << ' ' << dp2[i][t][q + 1] << '\n';
                    }
                }
                else {
                    for (int q = 1; q <= i - 1; ++q) {
                        dp2[i][t][1] += dp2[i - 1][s][q];
                        dp2[i][t][1] %= MOD;
                        //cout << i << ' ' << t << ' ' << s << ' ' << dp2[i][t][1] << '\n';
                    }
                }
                if (s == 0) {
                    break;
                }
                s = ((s - 1) & t);
                //cout << s << ' ' << t << '\n';
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= 100; ++i) {
        for (int j = 0; j <= 100; ++j) {
            ans += dp2[n][i][j];
            ans %= MOD;
        }
    }
    cout << ans;
    return 0;
}

