#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <set>

using namespace std;

typedef long long ll;

int main() {
    int n;
    cin >> n;
    vector<unordered_set<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x != -1) {
            g[i].insert(x - 1);
            g[x - 1].insert(i);
        }
    }
    set<pair<int, int>> s;
    for (int i = 0; i < n; ++i) {
        s.insert({g[i].size(), i});
    }
    vector<bool> used(n);
    int ans = 0;
    while (!s.empty()) {
        auto cv = *s.begin();
        s.erase(s.begin());
        if (used[cv.second]) {
            continue;
        }
        used[cv.second] = true;
        ans++;

        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                for (int nv : g[cv.second]) {
                    used[nv] = true;
                    s.erase({g[i].size(), i});
                    g[i].erase(nv);
                    s.insert({g[i].size(), i});
                }
            }
        }
    }
    cout << ans << endl;
}