#include <bits/stdc++.h>
#include <stdint.h>
#include <string.h>

using namespace std;

int n;

int* arr;
char* colors;
vector<int>* tree;

int pick(){
  int min = n+1;
  int res = -1;
  for(int i = 0; i < n; i++){
    if(colors[i]==0 && tree[i].size()<min){
      min = tree[i].size();
      res = i;
    }
  }
  return res;
}

int pick(vector<int> v){
  int min = n+1;
  int res = -1;
  for(auto i : v){
    if(colors[i]==0 && tree[i].size()<min){
      min = tree[i].size();
      res = i;
    }
  }
  return res;
}

int rec(int i,bool color){
  // cout << "rec(" << i << ", " << color << ")\n";

  colors[i] = color|2;
  int p = pick(tree[i]);
  if(p<0)return color;

  return color+rec(p,!color);
}

int main(){
  cin >> n;

  arr = new int[n];
  for(int i = 0; i < n; i++){
    cin >> arr[i];
    arr[i]--;
  }
  tree = new vector<int>[n];
  colors = new char[n];
  for(int i = 0; i < n; i++){
    colors[i] = 0;
    int e = arr[i];
    if(e < 0)continue;
    tree[i].push_back(e);
    tree[e].push_back(i);
  }
  delete[] arr;

  int res = 0;

  while(1){
    int t = pick();
    if(t==-1)break;
    res += rec(t,true);
  }

  cout << res;

  delete[] tree;
  delete[] colors;
  cout << "\n";
  return 0;
}