#include <bits/stdc++.h>
#include <stdint.h>
#include <string.h>

using namespace std;

#define max(a,b) (a>b?a:b)
#define min(a,b) ((a)<(b)?(a):(b))

int n;

int* arr;
char* colors;
vector<int>* tree;

int rec(int i,bool color,char polarity){
  colors[i] = polarity;
  int res = color;
  for(int i = 0; i < n; i++){
    if((colors[i]&polarity) != 0)continue;
    res += rec(i,!color,polarity);
  }

  // cout << "rec(" << i << ", " << color << ") = "<< res <<"\n";
  return res;
}

int main(){
  cin >> n;

  arr = new int[n];
  for(int i = 0; i < n; i++){
    cin >> arr[i];
    arr[i]--;
  }
  tree = new vector<int>[n];
  colors = new char[n];
  for(int i = 0; i < n; i++){
    colors[i] = 0;
    int e = arr[i];
    if(e < 0)continue;
    tree[i].push_back(e);
    tree[e].push_back(i);
  }
  delete[] arr;

  int res = 0;

  for(int i = 0; i < n; i++){
    if(colors[i]!=0)continue;
    int a = rec(i,true,1);
    int b = rec(i,false,2);
    res += max(a,b);
  }

  cout << res;

  delete[] tree;
  delete[] colors;
  cout << "\n";
  return 0;
}