#include <bits/stdc++.h>
#include <stdint.h>
#include <string.h>

using namespace std;

// #define max(a,b) (a>b?a:b)
// #define min(a,b) ((a)<(b)?(a):(b))

int n;

int* arr;
char* colors;
vector<int>* tree;

int rec(int i,bool color){
  colors[i] = color|0x82;
  int res = color;
  for(auto e : tree[i]){
    if((colors[e]&2) != 0){
      if(color && (colors[e]&1)){
        colors[i] &= ~3;
        return 0;
      }
      continue;
    }
    if(!color){
      int a = rec(e,true);
      int b = rec(e,false);
      res += max(a,b);
    }else{
      res += rec(e,false);
    }
  }

  colors[i] &= ~2;
  // cout << "rec(" << i+1 << ", " << color << ") = "<< res <<"\n";
  return res;
}

void getRootVectorRec(vector<int>& v,int i,int d){
  v.push_back(0);
  for(int e : tree[i]){
    v[d]++;
    getRootVectorRec(v,e,d+1);
  }
}

vector<int> getRootVector(int i){
  vector<int> res;
  res.push_back(1);
  getRootVectorRec(res,i,1);
  return res;
}

int main(){
  cin >> n;

  arr = new int[n];
  for(int i = 0; i < n; i++){
    cin >> arr[i];
    arr[i]--;
  }

  vector<int> roots;

  tree = new vector<int>[n];
  colors = new char[n];
  for(int i = 0; i < n; i++){
    colors[i] = 0;
    int e = arr[i];
    if(e < 0){
      roots.push_back(i);
      continue;
    }
    // tree[i].push_back(e);
    tree[e].push_back(i);
  }
  delete[] arr;

  int res = 0;

  if(n>20){
    for(int i : roots){
      auto t = getRootVector(i);
      if(t.size()&1)t.push_back(0);
      int a = 0,b = 0;
      bool c = false;
      for(int i = 0; i < t.size(); i+=2){
        int da = t[i];
        int db = t[i+1];
        if(c){
          if( max(a-t[i-2]+db,b-t[i-1]+da) > max(a+da,b+db) ){
            a += db-t[i-2];
            b += da-t[i-1];
            c = false;
          }
        }else{
          c = true;
        }
        if(c){
          a += da;
          b += db;
        }
      }
      res += max(a,b);
    }
  }else{
    
    for(int i = 0; i < n; i++){
      if(colors[i]!=0)continue;
      int a = rec(i,true);
      int b = rec(i,false);
      res += max(a,b);
    }
  }

  cout << res;

  delete[] tree;
  delete[] colors;
  cout << "\n";
  return 0;
}