#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 100;

vector <int> g[MAXN];

vector <bool> us(MAXN, false), cirk(MAXN, false);

int dp[MAXN][2];

void DFS(int v)
{
    us[v] = true;
    dp[v][1] = 1;
    for (auto it : g[v])
    {
        DFS(it);
        dp[v][1] += dp[it][0];
        dp[v][0] += max(dp[it][1], dp[it][0]);
    }
}

int k = -1;

void GFS(int v, int p = -1)
{
    us[v] = true;
    dp[v][1] = 1;
    for (auto it : g[v])
    {
        if (it == p)
            continue;
        GFS(it, p);
        if (cirk[it])
            continue;
        dp[v][1] += dp[it][0];
        dp[v][0] += max(dp[it][1], dp[it][0]);
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector <int> v(n + 1);
    for (int i = 1; i <= n; i++)
    {
        cin >> v[i];
        g[v[i]].push_back(i);
    }
    if (n <= 20)
    {
        int k = (1 << n), ans = 0;
        for (int i = 0; i < k; i++)
        {
            vector <bool> s(n+1, false);
            int g = i, y = 0;
            for (int j = 1; j <= n; j++)
            {
                if (g % 2)
                {
                    s[j] = true;
                    y++;
                }
                g /= 2;
            }
            bool t = true;
            for (int j = 1; j <= n; j++)
            {
                if (v[j] == -1)
                    continue;
                if (s[j] && s[v[j]])
                    t = false;
            }
            if (t)
                ans = max(ans, y);
        }
        cout << ans;
        return 0;
    }
    int ans = 0;
    for (int i = 1; i <= n; i++)
    {
        if (v[i] == -1)
        {
            DFS(i);
            ans += max(dp[i][0], dp[i][1]);
        }
    }
    for (int i = 1; i <= n; i++)
    {
        if (us[i])
            continue;
        int k = i;
        while (1)
        {
            us[k] = true;
            if (us[v[k]])
            {
                break;
            }
            else
            {
                k = v[k];
            }
        }
        int t = k;
        vector <int> fr;
        while (1)
        {
            fr.push_back(t);
            t = v[t];
            if (t == k)
                break;
        }
        for (auto it : fr)
            cirk[it] = true;
        GFS(fr[0], fr[0]);
        dp[fr[0]][1] = 0;
        for (int i = 1; i < fr.size(); i++)
        {
            dp[fr[i]][1] += dp[fr[i-1]][0];
            dp[fr[i]][0] += max(dp[fr[i-1]][0], dp[fr[i-1]][1]);
        }
        ans += max(dp[fr[fr.size() - 1]][0], dp[fr[fr.size() - 1]][1]);
    }

    cout << ans;
    return 0;
}
