 #include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define forn(i,a,b)for(int i=a;i<=b;++i)
#define dbg_var(x) cout << #x << ": " << x << endl;
template<typename T>
void dbg_vector(const vector<T>&v)
{
	forn(i,0,v.size()-1)cout<<v[i]<<' ';
	cout<<endl;
}
void dbg(){cout<<endl;}
template<typename Head,typename... Tail>
void dbg(Head H,Tail... T)
{
	cerr << H << ' ';
	dbg(T...);
}

int n;
vector<vector<int> >g;
vector<int>used;
vector<int>color;

pair<int,int> bfs(int i)
{
	queue<int>q;
	q.push(i);
	used[i]=true;
	color[i]=0;
	int cnt_0=1,cnt_1=0;
	while(!q.empty())
	{
		int v=q.front();
		//dbg_var(v);
		q.pop();
		for(int to:g[v])
		{
			if(!used[to])
			{
				q.push(to);
				used[to]=true;
				color[to]=1-color[v];
				if(color[to]==0)cnt_0++;
				else cnt_1++;
			}
		}
	}
	return {cnt_0,cnt_1};
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	//bool case_1=true;

	cin>>n;
	g.resize(n+1),used.resize(n+1),color.resize(n+1);
	forn(i,1,n)
	{
		int a;cin>>a;
		if(a!=-1)
		{
			g[i].push_back(a);
			g[a].push_back(i);
		}
	}

	if(n>20)case_1=false;

	if(case_1)
	{
		int ans=0;
		for(int mask=0;mask<(1<<n);++mask)
		{
			//dbg_var(mask);
			int res=__builtin_popcount(mask);
			//dbg_var(res);
			bool flag=true;
			for(int i=0;i<n;++i)
			{
				if(! (mask & (1<<(i-1))) )continue;
				for(int j:g[i])
				{
					if( mask & (1<<(j-1)) )
					{
						flag=false;
						goto label;
					}
				}
			}
			label:
			if(flag)ans=max(ans,res);
		}
		cout<<ans<<endl;
		return 0;
	}

	int ans=0;
	forn(i,1,n)
	{
		if(!used[i])
		{
			auto res=bfs(i);
			ans+=max(res.first,res.second);
		}
	}
	cout<<ans<<endl;
}
/*

*/