 #include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define forn(i,a,b)for(int i=a;i<=b;++i)
#define dbg_var(x) cout << #x << ": " << x << endl;
template<typename T>
void dbg_vector(const vector<T>&v)
{
	forn(i,0,v.size()-1)cout<<v[i]<<' ';
	cout<<endl;
}
void dbg(){cout<<endl;}
template<typename Head,typename... Tail>
void dbg(Head H,Tail... T)
{
	cerr << H << ' ';
	dbg(T...);
}

int n;
vector<vector<int> >g;
vector<set<int> >gst;
vector<int>used;
vector<int>color;
vector<int>is_cut;

pair<int,int> dfs(int i,int p)
{
	//dbg_var(i);
	used[i]=true;
	pair<int,int>res={0,0};
	color[i]=p;
	if(p==0)res.first++;
	else res.second++;
	for(int j:g[i])
	{
		if(used[j] || is_cut[j])continue;
		auto res_=dfs(j,1-p);
		res.first+=res_.first;
		res.second+=res_.second;
	}
	for(int j:g[i])
	{
		if(is_cut[j])continue;
		if(color[j]==color[i])
		{
			if(color[i]==0)
				res.first--;
			else
				res.second--;
		}
	}
	return res;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	bool case_1=false;

	cin>>n;
	gst.resize(n+1),g.resize(n+1),used.resize(n+1),color.resize(n+1),is_cut.resize(n+1);
	map<pair<int,int>,bool>was;
	forn(i,1,n)
	{
		int a;cin>>a;
		if(a!=-1)
		{
			gst[i].insert(a);
			gst[a].insert(i);
		}
	}
	forn(i,1,n)
	{
		for(int x:gst[i])g[i].push_back(x);
		if(g[i].size()>2)is_cut[i]=true;
	}

	if(n>20)case_1=false;

	if(case_1)
	{
		int ans=0;
		for(int mask=0;mask<(1<<n);++mask)
		{
			//dbg_var(mask);
			int res=__builtin_popcount(mask);
			//dbg_var(res);
			bool flag=true;
			for(int i=0;i<n;++i)
			{
				if(! (mask & (1<<(i-1))) )continue;
				for(int j:g[i])
				{
					if( mask & (1<<(j-1)) )
					{
						flag=false;
						goto label;
					}
				}
			}
			label:
			if(flag)ans=max(ans,res);
		}
		cout<<ans<<endl;
		return 0;
	}

	int ans=0;
	forn(i,1,n)
	{
		if(!used[i] && !is_cut[i])
		{
			auto res=dfs(i,0);
			ans+=max(res.first,res.second);
		}
	}
	cout<<ans<<endl;
}
/*

*/