//#include "pch.h"
#include <iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

#define int long long

const int mod = 1e9 + 7;
const int MAXN = 5001;
int dp1[MAXN][MAXN];
int dp0[MAXN][MAXN];

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	if (n == k)
	{
		cout << 1;
		return 0;
	}
	dp0[k][k] = 1;
	dp1[k][k] = 1;
	for (int i = k + 1; i <= n; i++)
	{
		dp1[k][i] = 1;
		dp0[k][i] = 1;
	}
	for (int i = k + 1; i <= n; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			if (j >= i)
			{
				dp1[i][j] = dp1[i][j - 1];
				dp0[i][j] = dp0[i][j - 1];
			}
			else
			{
				dp1[i][j] = (dp0[i - j][j - 1] + dp1[i][j - 1]) % mod;
				dp0[i][j] = (dp1[i - j][n] - dp1[i - j][j] + dp0[i][j - 1] + mod) % mod;
			}
		}
	}
	cout << (dp1[n][n] + dp0[n][n]) % mod;
} 

