//#include "pch.h"
#include <iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

#define int long long

vector<vector<int>> g;
vector<vector<int>> dp;
int n;
vector<int> a;
int ans = 0;

void dfs(int v)
{
	if (g[v].size() == 0)
	{
		dp[v][0] = 0;
		dp[v][1] = 1;
		return;
	}
	int t0 = 0;
	int t1 = 0;
	for (auto u : g[v])
	{
		dfs(u);
		t0 += max(dp[u][1], dp[u][0]);
		t1 += dp[u][0];
	}
	dp[v][0] = t0;
	dp[v][1] = t1 + 1;
}

void f(vector<int> vec)
{
	if (vec.size() == n)
	{
		int b = 1;
		for (int i = 0; i < n; i++)
		{
			if (vec[i] == 1 && a[i] != -2 && vec[a[i]] == 1)
			{
				b = 0;
			}
		}
		if (b == 1)
		{
			int v = 0;
			for (int i = 0; i < n; i++)
			{
				v += vec[i];
			}
			ans = max(v, ans);
		}
	}
	else
	{
		vec.push_back(0);
		f(vec);
		vec.back() = 1;
		f(vec);
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	if (n <= 20)
	{
		a.resize(n);
		for (int i = 0; i < n; i++)
		{
			cin >> a[i];
			a[i]--;
		}
		vector<int> y;
		f(y);
		cout << ans;
		return 0;
	}
	vector<bool> used(n);
	dp.resize(n, vector<int>(2));
	g.resize(n);
	for (int i = 0; i < n; i++)
	{
		int t;
		cin >> t;
		if (t == -1)
		{
			continue;
		}
		g[t - 1].push_back(i);
		used[i] = 1;
	}
	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			dfs(i);
			ans += max(dp[i][0], dp[i][1]);
		}
	}
	cout << ans;
}