//#include "pch.h"
#include <iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

#define int long long

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	vector<vector<int>> a(n, vector<int>(k));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < k; j++)
		{
			cin >> a[i][j];
		}
	}
	if (n <= 10)
	{
		vector<int> vec;
		for (int i = 0; i < n; i++)
		{
			vec.push_back(i);
		}
		while (next_permutation(vec.begin(), vec.end()))
		{
			bool l = 1;
			for (int i = 0; i < n; i++)
			{
				if (vec[i] == i || vec[vec[i]] != i)
				{
					l = 0;
					break;
				}
			}
			if (l == 0)
			{
				continue;
			}
			bool b = 1;
			for (int i = 0; i < k; i++)
			{
				int mn = -1e9;
				int mx = 1e9;
				for (int j = 0; j < n; j++)
				{
					int a1 = a[j][i];
					int a2 = a[vec[j]][i];
					mn = max(mn, min(a1, a2)) ;
					mx = min(mx, max(a1, a2 ));
				}
				if (mx < mn)
				{
					b = 0;
					break;
				}
			}
			if (b == 1)
			{
				cout << "YES" << "\n";
				vector<int> used(n);
				for (int i = 0; i < n; i++)
				{
					if (!used[i])
					{
						used[i] = 1;
						used[vec[i]] = 1;
						cout << i + 1 << " " << vec[i] + 1 << "\n";
					}
				}
				return 0;
			}
		}
		cout << "NO";
	}
	else if (k == 1)
	{
		vector<pair<int, int>> vec;
		for (int i = 0; i < n; i++)
		{
			vec.push_back({ a[i][0], i });
		}
		sort(vec.begin(), vec.end());
		if (n % 2 == 1)
		{
			cout << "NO";
		}
		else
		{
			vector<pair<int, int>> ans;
			for (int i = 0; i < n; i++)
			{
				ans.push_back({ vec[i].second, vec[n - 1 - i].second });
			}
			sort(ans.begin(), ans.end());
			cout << "YES" << "\n";
			for (int i = 0; i < ans.size(); i++)
			{
				cout << ans[i].first << " " << ans[i].second << "\n";
			}
		}
	}
}
