#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cmath>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define popb pop_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

int n, m;
vector<int> a,b;

signed solve2();
signed main() {
	cin >> n >> m;
	a.resize(m);
	b.resize(n);
	for (auto &i : a)
		cin >> i;
	for (auto &i : b)
		cin >> i;
	
	solve2();

	return 0;
}

signed solve2() {
	vector<int> c;
	int pn = 0, pm = 0;
	for ( ; pn < n && pm < m; ) {
		// cout << a[pm] << " " << b[pn] << endl;
		if (a[pm] != b[pn]) {
			while (pn < n && a[pm] != b[pn]) {
				c.pb(b[pn]);
				++pn;
			}
		}
		else {
			while (pm < m && a[pm] == b[pn]) {
				c.pb(a[pm]);
				++pm;
			}
			++pn;
		}
	}
	// cout << pm + 1 << " " << pn + 1 << endl;
	while (pm < m) {
		c.pb(a[pm]);
		++pm;
	}
	// for (int i = 0; i < sz(c); ++i) {
	// 	cout << c[i] << " ";
	// }
	// cout << endl;
	// return 0;

	vector<int> help(sz(c), -1);
	vector<int> tttmp(n + 1, -1);
	for (int i = 0; i < sz(c); ++i) {
		if (tttmp[c[i]] != -1) {
			help[tttmp[c[i]]] = i;
		}
		tttmp[c[i]] = i;
	}

	// for (int i = 0; i < sz(c); ++i) {
	// 	cout << i << " " << help[i] << endl;
	// }
	// cout << endl;

	vector<int> ans;
	int last = n;
	int ptr = n;

	for (int i = 0; i < sz(c); ++i) {
		int p = -1;
		// for (int j = i + 1; j < sz(c); ++j) {
		// 	if (c[i] == c[j]) {
		// 		p = j;
		// 		break;
		// 	}
		// }
		p = help[i];
		// cout << c[i] << " " << help[i] << endl;
		if (p == -1) {
			ans.pb(n);
			--last;
		}
		else {
			if (ptr <= i) ptr = last;
			ans.pb(min(min(p - i, ptr), max(last, 1LL)));
			--ptr;
			// ans.pb(min(p - i, max(last, 1LL)));
			// --last;
		}
		// cout << ptr << " " << last << endl;
	}

	cout << sz(ans) << endl;
	for (int i = 0; i < sz(ans); ++i) {
		cout << ans[i] << " ";
	}

	return 0;
}