#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

vector<int> g, ag;
vector<int> ts;
vector<int> used;

void dfs(int v) {
	used[v] = true;
	int u = g[v];
	if (u != -1 && !used[u]) dfs(u);
	ts.pb(v);
}

signed main() {

	int n;
	cin >> n;
	g.resize(n);
	ag.resize(n, -1);
	used.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> g[i];
		if (g[i] != -1)  {
			--g[i];
			ag[g[i]] = i;
		}
	}

	for (int i = 0; i < n; ++i) {
		if (used[i]) continue;
		dfs(i);
	}

	reverse(all(ts));
	fill(all(used), false);

	// for (auto &i : ts) {
	// 	cout << i + 1 << " ";
	// }
	// cout << endl;

	int ans = 0;
	for (auto &v : ts) {
		int u = g[v];
		if (u != -1 && used[u]) continue;
		if (ag[v] != -1 && used[ag[v]]) continue;
		++ans;
		used[v] = true;
		// cout << v + 1 << endl;
	}

	cout << ans << endl;

	return 0;
}