#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

vector<int> g;
vector<vector<int>> ag;
vector<int> ts, cycle;
vector<int> used, iscyc;

vector<vector<int>> dp;
void solve();
void appcycle(int v) {
	int cur = v;
	do {
		cycle.pb(cur);
		cur = g[cur];
	}
	while (cur != v && cur != -1);
	
	// for (auto &i : cycle) {
	// 	cout << i + 1 << " ";
	// }
	// cout << endl << endl;
	// return ;
	solve();

	cycle.clear();
}

void dfs(int v) {
	// cout << v + 1 << endl;
	used[v] = 1;
	int u = g[v];
	if (u != -1) {
		if (used[u] == 2) goto lasa;
		if (used[u] == 1) {
			appcycle(u);
		}
		else {
			dfs(u);
		}
	}
	else {
		appcycle(v);
	}
	lasa:;
	used[v] = 2;
}

void dfs2(int v) {
	cycle.pb(v);
	used[v] = true;
	int u = g[v];
	if (u == -1) return;
	if (used[u]) return;
	dfs2(u);
}

void dfs3(int v) {
	dp[v][0] = 0;
	dp[v][1] = 1;

	int a = 0, b = 0;

	for (auto &u : ag[v]) {
		if (iscyc[u]) continue;
		dfs3(u);
		a += max(dp[u][0], dp[u][1]);
		b += dp[u][0];
	}

	dp[v][0] += a;
	dp[v][1] += b;

	// cout << v + 1 << " :  " << dp[v][0] << " | " << dp[v][1] << endl;
}

int gans = 0;

void solve() {
	fill(all(iscyc), false);
	for (auto &v : cycle) {
		iscyc[v] = 1;
	}

	for (auto &v : cycle) {
		dfs3(v);
	}

	int ans1 = 0, ans2 = 0, ans3 = 0;

	if (sz(cycle) == 1) {
		gans += max(dp[cycle[0]][0], dp[cycle[0]][1]);
	}
	else if (sz(cycle) % 2 == 0) {
		for (int i = 0; i < sz(cycle); ++i) {
			ans1 += dp[cycle[i]][1 - (i & 1)];
			ans2 += dp[cycle[i]][i & 1];
		}
		gans += max(ans1, ans2);
	}
	else {
		for (int i = 0; i < sz(cycle) - 1; ++i) {
			ans1 += dp[cycle[i]][1 - (i & 1)];
			ans2 += dp[cycle[i]][i & 1];
		}
		int kek = max(ans1, ans2) + dp[cycle.back()][0];
		ans1 -= dp[cycle[0]][1];
		ans1 += dp[cycle[0]][0];
		ans1 += dp[cycle.back()][1];
		kek = max(kek, ans1);
		gans += kek;
	}
}

signed main() {
	int n;
	cin >> n;
	g.resize(n);
	dp.resize(n, vector<int>(2));
	ag.resize(n);
	used.resize(n);
	iscyc.resize(n);
	
	for (int i = 0; i < n; ++i) {
		cin >> g[i];
		if (g[i] != -1)  {
			--g[i];
			ag[g[i]].pb(i);
		}
	}

	for (int i = 0; i < n; ++i) {
		if (used[i]) continue;
		dfs(i);
	}

	cout << gans << endl;

	return 0;
}