#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long

using namespace std;

ll mod = 1e9 + 7;

int main() {
	int n, k;
	cin >> n >> k;
	int more[5001][5001];
	int less[5001][5001];
	more[0][0] = 1;
	less[0][0] = 1;
	vector<vector<int> > prefm(n + 1);
	vector<vector<int> > prefl(n + 1);
	for (int sum = 1; sum <= n; sum++) {
		for (int turn = 1; turn <= sum; turn++) {
			if (turn == sum) {
				more[sum][turn] = 1;
				less[sum][turn] = 1;
				continue;
			}
			//-----more------
			// [turn + 1, sum - turn]
			int L, R;
			L = turn + 1;
			R = sum - turn;
			if (L > R) more[sum][turn] = 0;
			else {
				more[sum][turn] = prefl[sum - turn][R] - prefl[sum - turn][L - 1];
				more[sum][turn] = (more[sum][turn] % mod + mod) % mod;
			}
			//----less-------
			//[1, min(sum)]
			L = 1;
			R = min(sum - turn, turn - 1);
			if (L > R) less[sum][turn] = 0;
			else {
				less[sum][turn] = prefm[sum - turn][R] - prefm[sum - turn][L - 1];
				less[sum][turn] = (less[sum][turn] % mod + mod) % mod;
			}
		}
		prefm[sum].push_back(0);
		for (int i = 1; i <= sum; i++) {
			ll val = (prefm[sum][i - 1] + more[sum][i]) % mod;
			prefm[sum].push_back(val);
		}
		prefl[sum].push_back(0);
		for (int i = 1; i <= sum; i++) {
			ll val = (prefl[sum][i - 1] + less[sum][i]) % mod;
			prefl[sum].push_back(val);
		}
	}
	if (n != k) cout << (more[n][k] + less[n][k]) % mod << endl;
	else cout << more[n][k] << endl;
}