/*#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("Ofast")*/

#include <bits/stdc++.h>

#define endl "\n"
#define pii pair<int,int>
//#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e9;
const double EPS = 1e-10;
const int Q = 31;
const int P = 1e9 + 9;


void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
}


void show(vector<int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector <int>> arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}


struct node
{
    node *left, *right;
    int l, r;
    int sum;
    node()
    {
        left = right = nullptr;
        l = r = -1;
        sum = 0;
    }
};

node* build(vector<int>& data, node* root, int l, int r)
{
    root = new node();

    if (l == r)
    {
        root->sum = data[l];
    }
    else
    {
        int m = (l + r) / 2;
        root->left = build(data, root->left, l, m);
        root->right = build(data, root->right, m + 1, r);
        root->sum = root->left->sum + root->right->sum;
    }

    root->l = l;
    root->r = r;

    return root;
}

int query(node* root, int l, int r)
{
    if (root->l >= l && root->r <= r)
        return root->sum;
    if (root->l > r || root->r < l)
        return 0;

    return query(root->left, l, r) + query(root->right, l, r);
}

void change(node* root, int ind, int val)
{
    if (root->r < ind || root->l > ind)
        return;
    if (root->l == root->r)
    {
        root->sum = val;
        return;
    }

    change(root->left, ind, val);
    change(root->right, ind, val);
    root->sum = root->left->sum + root->right->sum;
}





int main()
{
    hello();

    int n, m;
    cin >> n >> m;
    vector <int> seq(m);

    for (int i = 0; i < m; ++i)
        cin >> seq[i];

    vector <int> ind(n);
    for (int i = 0; i < n; ++i)
        cin >> ind[i];

    if (ind[0] != seq[0])
    {
    cout << n * 2 - 1 << endl;
        for (int i = 0; i < n - 1; ++i)
            cout << n - i << " ";
        for (int i = 0; i < m; ++i)
            cout << n << endl;

    }
    else
    {
    cout << n << endl;
        for (int i = 0; i < m; ++i)
                cout << n << endl;
    }
}
