'''BBBBBBBB'''

# k > 0
def case1(k):
	# (t + 1)^2 > k >= t^2
	t = int(k ** 0.5)

	if t**2 == k:
		return t

	def f(k, t):
		return (t + k/t)/2
	while int(f(k, t)) != f(k, t):
		t -= 1
	return int(f(k, t))

# k < 0
def case2(k):
	# (t + 1)^2 > k >= t^2
	t = int(abs(k) ** 0.5)

	if t**2 == -k:
		return 0
	t += 1

	def f(k, t):
		return (t + k/t)/2
	while int(f(k, t)) != f(k, t):
		t -= 1
	return int(f(k, t))

def answer(k):
	if k == 0:
		return 0
	elif k % 4 == 2:
		return 'none'
	elif k > 0:
		return abs(case1(k))
	elif k < 0:
		return abs(case2(k))

def stupid_finder(k):
	t = 1
	while k < 0 or int(k ** 0.5) ** 2 != k:
		k += t
		t += 2
		# print('K :{}'.format(k))
	return k

print(answer(int(input())))
# for k in range(0, 1000):
# 	if k % 4 != 2:
# 		if answer(k) < 0 or stupid_finder(k) != answer(k)**2:
# 			print(k, stupid_finder(k), answer(k))