// Экспедиция.cpp: определяет точку входа для консольного приложения.
//

//#include "stdafx.h"
#include <vector>
#include <iostream>
#include <algorithm>
#include <math.h>
#include <string>
#include <set>
#include <map>
using namespace std;
// 0 белый ...1 черный
void dfs(vector<int> &used, int &black, int &white, int cv, int v, vector<vector<int>> gr)
{
	for (int i = 0; i < gr[v].size(); i++)
	{
		if (used[gr[v][i]] != 1)
		{
			used[gr[v][i]] = 1;
			if (cv == 0)
				black++;
			else
				white++;
			dfs(used, black, white, !cv, gr[v][i], gr);
		}
	}
}

int main()
{
	int n;
	cin >> n;
	vector<vector<int>> gr(n+1);
	for (int i = 1; i <= n; i++)
	{
		int a;
		cin >> a;
		if (a != -1)
		{
			gr[i].push_back(a);
			gr[a].push_back(i);
		}
	}
	vector<int> used(n + 1);
	int answ = 0;
	for (int i = 1; i <= n; i++)
	{
		int white = 0, black = 0;
		if (used[i] == 0)
		{
			used[i] = 1;
			white++;
			dfs(used, black, white, 0, i, gr);
		}
		answ += max(black, white);
	}
	cout << answ;
	return 0;
}

