// Экспедиция.cpp: определяет точку входа для консольного приложения.
//

//#include "stdafx.h"
#include <vector>
#include <iostream>
#include <algorithm>
#include <math.h>
#include <string>
#include <set>
#include <map>
using namespace std;
// 0 белый ...1 черный
void dfs(vector<int> &used, int v, int pr, vector<vector<int>> gr, vector<vector<int>> &dp)
{
	if (gr[v].size() == 0)
	{
		dp[v][0] = 1;
		dp[v][1] = 0;
		return;
	}
	if (gr[v].size() == 1 && gr[v][0] == pr)
	{
		dp[v][0] = 1;
		dp[v][1] = 0;
		return;
	}
	for (int i = 0; i < gr[v].size(); i++)
	{
		if (used[gr[v][i]] != 1 && gr[v][i]!=pr )
		{
			used[gr[v][i]] = 1;
			dfs(used, gr[v][i], pr, gr, dp);
			dp[v][0] += dp[gr[v][i]][1];
			dp[v][1] += max(dp[gr[v][i]][1],dp[gr[v][i]][0]);
		}
	}
	dp[v][0]++;
	

}
struct v
{
	int white, black;
};
int cou(vector<v> &tr)
{
	vector<int> dp0(tr.size());
	vector<int> dp1(tr.size());
	dp0[0] = tr[0].white;
	dp1[0] = tr[0].black;
	for (int i = 1; i < tr.size() - 1; i++)
	{
		dp1[i] = tr[i].black + max(dp1[i - 1], dp0[i - 1]);
		dp0[i] = tr[i].white + dp1[i - 1];
	}
	dp1[tr.size() - 1] = tr[tr.size()-1].black+ max(dp1[tr.size() - 2], dp0[tr.size() - 2]);

	dp0[0] = 0;
	dp1[0] = tr[0].black;
	for (int i = 1; i < tr.size() - 1; i++)
	{
		dp1[i] = tr[i].black + max(dp1[i - 1], dp0[i - 1]);
		dp0[i] = tr[i].white + dp1[i - 1];
	}
	dp0[tr.size() - 1] = tr[tr.size() - 1].white + dp1[tr.size() - 2];
	return max(dp0[tr.size() - 1], dp1[tr.size() - 1]);
}
int main()
{
	int n;
	cin >> n;
	vector<vector<int>> gr(n+1);
	vector<int> son(n + 1);
	vector<vector<int>> dp(n + 1, vector<int>(2));
	for (int i = 1; i <= n; i++)
	{
		int a;
		cin >> a;
		son[i] = a;
		if (a != -1)
		{
			
			gr[a].push_back(i);
		}
	}
	vector<int> used(n + 1);
	int answ = 0;
	for (int i = 1; i <= n; i++)
	{
		if (used[i] == 0)
		{
			set<int> gone;
			int w = -1, q = -1;
			for (int j = i;;)
				if (gone.find(j) == gone.end())
				{
					gone.insert(j);
					if (son[j] != -1)
						j = son[j];
					else
					{
						q = j;
						break;
					}
				}
				else
				{
					w = j;
					break;
				}
			gone.clear();
			if (w != -1)
			{
				vector<v> tr;
				for (int j = son[w];; j = son[j])
				{
					used[j] = 1;
					dfs(used, son[j], j, gr, dp);
					v help;
					help.white = dp[son[j]][0];
					help.black = dp[son[j]][1];
					tr.push_back(help);
					if (j == w)
						break;
				}
				answ += cou(tr);
			}
			else
			{
				used[q] = 1;
				dfs(used, q, -1, gr, dp);
				answ += max(dp[q][0], dp[q][1]);
			}
		}
		
	}
	cout << answ;
	return 0;
}

