#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

const long long MOD = 1000 * 1000 * 1000 + 9;

long long binpow(long long n, long long a) {
    if (a == 0)
        return 1;
    if (a == 1)
        return n;
    if (a % 2 == 0) {
        long long rr = binpow(n, a / 2);
        rr = (rr * rr) % MOD;
        return rr;
    }
    return binpow(n, a - 1);
}

int main()
{
    long long n, m, k;
    cin >> n >> m >> k;
    if (m == 0)
        cout << binpow(k, n);
}
