#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

inline long long count(long long n) {
    return n / 2 + n % 2;
}



long long solve(long long a, long long b, long long c) {
    long long ans = 0;
    long long cnt = ((a - 1) / c + 1) * c;
    if (cnt < b)
        ans += count(cnt - a - 1);
    long long k = b / c - a / c;
    if (k > 1)
        ans += (k - 1) * count(c);
    if (cnt < b)
        ans += count(b - (k - 1) * c - (cnt - 1));
    else
        ans += count(b - a);
    return ans;
}

long long dp[20];

long long solve1(long long a, long long b, long long c) {
    for (int i = 0; i < 20; ++i)
        dp[i] = 1000000;
    dp[a] = 0;
    for (int i = a; i < b; ++i) {
        if ((i + 2) % c)
            dp[i + 2] = min(dp[i + 2], dp[i] + 1);
        if ((i + 1) % c)
            dp[i + 1] = min(dp[i + 1], dp[i] + 1);
    }
    return dp[b];
}

int main()
{
    long long a, b, c;
    cin >> a >> b >> c;
    cout << solve(a, b, c);
   // solve(1, 5, 3);
   /* for (int i = 1; i < 16; ++i) {
        for (int j = i + 1; j < 16; ++j) {
            for (int k = 2; k < 16; ++k) {
                if ((i % k == 0) || (j % k == 0))
                    continue;
                cout << i << ' ' << j << ' ' << k << '\n';
                if (solve(i, j, k) != solve1(i, j, k)) {
                    cout << solve(i, j, k) << ' ' << solve1(i, j, k);
                    exit(0);
                }
            }
        }
    }*/
}
