#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <assert.h>
#include <cassert>
#include <cmath>
#include <math.h>
#include <time.h>
#include <ctime>
#define int long long
#define double long double

using namespace std;

const int sz = 3e5, inf = 1e15;
pair<int, int> tree[4 * sz];
int mod[4 * sz];

void rc(int v)
{
	mod[2 * v] += mod[v], mod[2 * v + 1] += mod[v];
	mod[v] = 0;
	tree[v].first = min(tree[2 * v].first + mod[2 * v], tree[2 * v + 1].first + mod[2 * v + 1]);
	if (tree[v].first == tree[2 * v].first + mod[2 * v])
		tree[v].second = tree[2 * v].second;
	else
		tree[v].second = tree[2 * v + 1].second;
}

void push(int v, int l, int r, int x, int pl)
{
	if (l + 1 == r)
	{
		tree[v] = { x + mod[v], l };
		return;
	}
	int m = (l + r) / 2;
	if (pl < m)
		push(2 * v, l, m, x, pl);
	else
		push(2 * v + 1, m, r, x, pl);
	rc(v);
}

void in(vector<int> &a, int cnt, int num)
{
	vector<int> b;
	int i = 0;
	while (cnt)
	{
		b.push_back(a[a.size() - 1]);
		a.pop_back();
		cnt--;
	}
	a.push_back(num);
	reverse(b.begin(), b.end());
	for (int i : b)
		a.push_back(i);
}

signed main()
{
	freopen("input.txt", "r", stdin);
	//for (int i = 0; i < 4 * sz; i++)
		//tree[i] = { -inf, 0 }, mod[i] = 0;
	int n, m;
	cin >> n >> m;
	vector<int> a(m), b(n), st(m, 0);
	//vector<vector<int>> num(m);
	for (int i = 0; i < m; i++)
	{
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		b[i]--;
		//push(1, 0, sz, b[i], i);
	}
	vector<int> ans;
	bool b0 = true, b1 = true;
	if (n == m)
	{
		for (int i = 0; i < n; i++)
			if (a[0] != b[0])
				b0 = false;
		for (int i = 0; i < n; i++)
			if (a[i] != b[n - i - 1])
				b1 = false;
	}
	else b0 = false, b1 = false;
	if (b0)
	{
		cout << n << "\n";
		for (int i = 0; i < n; i++)
			cout << n << " ";
	}
	else if (b1)
	{
		cout << 2 * n - 1 << "\n";
		for (int i = 0; i < n - 1; i++)
			cout << n - i << " ";
		for (int i = 0; i < n; i++)
			cout << n << " ";
	}
	else if ((n <= 2000) && (m <= 2000))
	{
		reverse(b.begin(), b.end());
		for (int i = 0; i < m; i++)
		{
			while (b[b.size() - 1] != a[i])
			{
				int now = b[b.size() - 1];
				vector<int> pl(4e5, 0);
				for (int i = 0; i < b.size(); i++)
					pl[b[i]] = i;
				b.pop_back();
				int j = i +1, max_el = 0;
				while (a[j] != now)
				{
					if (j == m) break;
					max_el = max(max_el, pl[j]);
					j++;
					if (j == m) break;
				}
				if (j == m)
				{
					in(b, n - 1, now);
					ans.push_back(n);
				}
				else
				{
					in(b, max_el, now);
					ans.push_back(max_el + 1);
				}
			}
			int now = b[b.size() - 1];
			vector<int> pl(n);
			for (int i = 0; i < b.size(); i++)
				pl[b[i]] = i;
			b.pop_back();
			int j = i + 1, max_el = 0;
			while ((j < m) && (a[j] != now))
			{
				max_el = max(max_el, pl[j]);
				j++;
			}
			if (j == m)
			{
				in(b, n, now);
				ans.push_back(n);
			}
			else
			{
				in(b, max_el + 1, now);
				ans.push_back(max_el + 1);
			}
		}
	}
	return 0;
}