#include <bits/stdc++.h>

using namespace std;
#define int long long
vector<bool> used;
vector<vector<int>> g;

void dfs(int v) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
}


const int MOD = 1e9 + 7;
int32_t main()
{
    int n, m, k, t, x, y, a, b, c;
    cin >> n >> k;
    vector<vector<int>> dp1(n + 1, vector<int>(n + 1));
    vector<vector<int>> dp2(n + 1, vector<int>(n + 1));
    dp1[k][k] = 1;
    dp2[k][k] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j < i; j++) {
            for (int l = 1; l < j && l <= i - j; l++) {
                dp1[i][j] += dp2[i - j][l];
                dp1[i][j] %= MOD;
            }
            for (int l = j; l <= i - j; l++) {
                dp2[i][j] += dp1[i - j][l];
                dp2[i][j] %= MOD;
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += dp1[n][i];
        if (i != n) ans += dp2[n][i];
        ans %= MOD;
    }
    cout << ans << endl;
}
