#include <bits/stdc++.h>

using namespace std;


vector<vector<int>> a;

bool gen(int n, int k, vector<pair<int, int>>p, vector<bool> used) {
    if (p.size() == n / 2) {
        for (int i = 0; i < k; i++) {
            int l = -1e9 - 1, r = 1e9 + 1;
            for (int j = 0; j < n / 2; j++) {
                l = max(l, min(a[p[j].first][i], a[p[j].second][i]));
                r = min(r, max(a[p[j].first][i], a[p[j].second][i]));
            }
            if (l > r) return false;
        }
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; i++) {
            cout << p[i].first + 1 << " " << p[i].second + 1 << endl;
        }
        return true;
    }
    int left = 0;
    while (!used[left]) left++;
    used[left] = false;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            used[i] = false;
            p.push_back({left, i});
            if (gen(n, k, p, used)) return true;
            p.pop_back();
            used[i] = true;
        }
    }
    return false;
}


int main()
{
    int n, k, x;
    cin >> n >> k;
    if (k == 1) {
        vector<vector<int>> a;
        for (int i = 0; i < n; i++) {
            cin >> x;
            a.push_back({x, i + 1});
        }
        sort(a.begin(), a.end());
        cout << "YES" << endl;;
        for (int i = 0; i < n / 2; i++) {
            cout << a[i][1] << " " << a[i + n / 2][1] << endl;
        }
        return 0;
    }
    a.resize(n, vector<int>(k));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
        }
    }
    vector<bool> used(n, true);
    if (!gen(n, k, {}, used)) cout << "NO" << endl;
    return 0;
}
