#include<bits/stdc++.h>

using namespace std;
#define pb push_back
#define all(a) a.begin(), a.end()
using ll = long long int;

const int maxn = 300000;

int used[maxn] = {0}, cols[maxn], used2[maxn] = {0};
int ams[2], isc = -1;

void DFS(vector<int> g[], int v, int p, int cl, int ccl)
{
    used[v] = cl;
    cols[v] = ccl;
    ams[ccl]++;
    for(int u : g[v])
    {
        //cout << v + 1 << " " << u + 1 << " " << used[u] << " " << cl << "\n";
        if(used[u] == 0) DFS(g, u, v, cl, 1 - ccl);
        else if(used[u] == cl && p != u && cols[u] == ccl)
        {
            if(isc == -1) isc = u;
        }
    }
}

void PTHF(vector<int> g[], int v, vector<int> &pth)
{
    used2[v] = 1;
    pth.pb(v);
    for(int u : g[v])
    {
        if(used2[u] == 0) PTHF(g, u, pth);
    }
}
struct tr
{
    int b, w;
    tr(int _b = 0, int _w = 0) : b(_b), w(_w) {}
};
void DFST(vector<int> g[], int v, tr &t, int ccl)
{
    used2[v] = 1;
    if(ccl == 0) t.b++;
    else t.w++;
    for(int u : g[v])
    {
        if(used2[u] == 0) DFST(g, u, t, 1 - ccl);
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> g[n], og[n];
    for(int i = 0; i < n; i++)
    {
        int u;
        cin >> u;
        if(u == -1) continue;
         og[i].pb(u - 1);
        if(og[u - 1].size() > 0 && og[u - 1][0] == i)
        {
            continue;
        }
        g[i].pb(u - 1);
        g[u - 1].pb(i);
    }
    /*for(int i = 0; i < n; i++)
    {
        for(int v : g[i]) cout << v << " ";
        cout << "\n";
    }*/
    //cout << "\n";
    int col = 1, ans = 0;
    for(int i = 0; i < n; i++)
    {
        if(used[i] > 0) continue;
        //cout << i << " ";
        ams[0] = 0;
        ams[1] = 0;
        isc = -1;
        DFS(g, i, -1, col, 0);
        //cout << isc << " ";
        col++;
        if(isc == -1)
        {
           // cout << ams[0] << " " << ams[1] << "\n";
            ans += max(ams[0], ams[1]);
        }
        else
        {
            int res = 0;
            vector<int> path;
            PTHF(og, isc, path);
            tr trs[path.size()];
            for(int i = 0; i < path.size(); i++)
            {
                DFST(g, path[i], trs[i], 0);
            }
            int bd = trs[0].b - trs[0].w + trs[path.size() - 1].b - trs[path.size() - 1].w;
            int bi = n;
            for(int j = 0; j < path.size() - 1; j++)
            {
                if(trs[j].b - trs[j].w + trs[j + 1].b - trs[j + 1].w < bd)
                {
                    bd = trs[j].b - trs[j].w + trs[j + 1].b - trs[j + 1].w;
                    bi = j;
                }
            }
            if(bi == n)
            {
                for(int j = 0; j < path.size(); j++)
                {
                    if(j % 2 == 0)
                    {
                        res += trs[j].w;
                    }
                    else
                    {
                        res += trs[j].b;
                    }
                }
            }
            else
            {
                for(int j = bi; j >= 0; j--)
                {
                    if(j % 2 == bi % 2)
                    {
                        res += trs[j].w;
                    }
                    else
                    {
                        res += trs[j].b;
                    }
                }
                for(int j = bi + 1; j < path.size(); j++)
                {
                    if(j % 2 == (bi + 1) % 2)
                    {
                        res += trs[j].w;
                    }
                    else
                    {
                        res += trs[j].b;
                    }
                }
            }
            //cout << res << "\n";
            ans += res;
        }
    }
   // cout << "\n";
    cout << ans;
}
