#include<bits/stdc++.h>

using namespace std;
#define pb push_back
#define all(a) a.begin(), a.end()
using ll = long long int;

const int maxn = 300000;

int used[maxn] = {0}, cols[maxn], used2[maxn] = {0}, dp[maxn][2], udp[maxn] = {0};
int ams[2], isc = -1;

void DFS(vector<int> g[], int v, int p, int cl, int ccl)
{
    used[v] = cl;
    cols[v] = ccl;
    ams[ccl]++;
    for(int u : g[v])
    {
        //cout << v + 1 << " " << u + 1 << " " << used[u] << " " << cl << "\n";
        if(used[u] == 0) DFS(g, u, v, cl, 1 - ccl);
        else if(used[u] == cl && p != u)
        {
            if(isc == -1) isc = u;
        }
    }
}
void DPFS(vector<int> g[], int v)
{
    udp[v] = 1;
    int bval = 0, wval = 0;
    for(int u : g[v])
    {
        if(udp[u] == 0)
        {
            DPFS(g, u);
            bval += dp[u][1];
            wval += max(dp[u][0], dp[u][1]);
        }
    }
    dp[v][0] = bval + 1;
    dp[v][1] = wval;
}
void PTHF(vector<int> g[], int v, vector<int> &pth)
{
    udp[v] = 1;
    used2[v] = 1;
    pth.pb(v);
    for(int u : g[v])
    {
        if(used2[u] == 0) PTHF(g, u, pth);
    }
}
struct tr
{
    int b, w;
    tr(int _b = 0, int _w = 0) : b(_b), w(_w) {}
};
void DFST(vector<int> g[], int v, tr &t, int ccl)
{
    used2[v] = 1;
    if(ccl == 0) t.b++;
    else t.w++;
    for(int u : g[v])
    {
        if(used2[u] == 0) DFST(g, u, t, 1 - ccl);
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> g[n], og[n];
    for(int i = 0; i < n; i++)
    {
        int u;
        cin >> u;
        if(u == -1) continue;
         og[i].pb(u - 1);
        if(og[u - 1].size() > 0 && og[u - 1][0] == i)
        {
            continue;
        }
        g[i].pb(u - 1);
        g[u - 1].pb(i);
    }
    /*for(int i = 0; i < n; i++)
    {
        for(int v : g[i]) cout << v << " ";
        cout << "\n";
    }*/
    //cout << "\n";
    int col = 1, ans = 0;
    for(int i = 0; i < n; i++)
    {
        if(used[i] > 0) continue;
      //  cout << i << " ";
        ams[0] = 0;
        ams[1] = 0;
        isc = -1;
        DFS(g, i, -1, col, 0);
        //cout << isc << " ";
        col++;
        if(isc == -1)
        {
           // cout << "TR ";
            DPFS(g, i);
           //  cout << dp[i][0] << " " << dp[i][1] << "\n";
            ans += max(dp[i][0], dp[i][1]);
        }
        else
        {
            //cout << "CYC  ";
            int res = 0;
            vector<int> path;
            PTHF(og, isc, path);
            int trs[path.size()][2];
            for(int i = 0; i < path.size(); i++)
            {
                DPFS(g, path[i]);
                trs[i][0] = dp[path[i]][0];
                trs[i][1] = dp[path[i]][1];
                res += max(trs[i][0], trs[i][1]);
            }
            //cout << res << " res\n";
            int tk[path.size()] = {0};
            int colr = 0, flg = 0;
            int ams[n] = {0};
            for(int j = 0; j < path.size(); j++)
            {
                if(trs[j][0] > trs[j][1])
                {
                    if(flg == 0)
                    {
                        colr++;
                        flg = 1;
                    }
                    tk[j] = colr;
                    ams[colr - 1]++;
                }
                else
                {
                    flg = 0;
                }
            }
            /*for(int i = 0; i < path.size(); i++)
            {
                cout << tk[i] << " ";
            }
            cout << "\n";*/
            for(int j = 1; j < colr - 1; j++)
            {
                res -= ams[j] / 2;
            }
            if(tk[path.size() - 1] > 0 && tk[0] > 0)
            {
                if(colr == 1)
                {
                    //cout << "NOPE";
                    int dd = path.size() / 2 + ((path.size() % 2) == 1);
                    res -= dd;
                }
                else
                {

                    int d = ams[0] + ams[colr - 1];
                    res -= d / 2;
                }
            }
            else
            {
                res -= ams[0] / 2;
                if(colr > 1) res -= ams[colr - 1] / 2;
            }
            ans += res;
        }
    }
   // cout << "\n";
    cout << ans;
}
