#include <bits/stdc++.h>
#define int long long
using namespace std;

const int inf = (int)1e9;

struct art {
    int val[7];
};

int f(int n) {
    int res = 1;
    for (int i = 2; i <= n; ++i) res *= i;
    return res;
}

bool cmp(pair<art, int> a, pair<art, int> b) {
    return a.first.val[0] < b.first.val[0];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        vector<pair<art, int>> a(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < k; ++j) {
                cin >> a[i].first.val[j];
            }
            a[i].second = i;
        }
        sort(a.begin(), a.end(), cmp);
        cout << "YES\n";
        for (int i = 0; i < n / 2; ++i) cout << a[i].second + 1 << " " << a[n - i - 1].second + 1 << "\n";
        return 0;
    }
    vector<art> a(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> a[i].val[j];
        }
    }
    vector<int> per(n);
    for (int i = 0; i < n; ++i) {
        per[i] = i;
    }
    vector<int> ans(n);
    bool found = false;
    for (int _ = 0; _ < f(n); ++_) {
        bool debug = true;
        int d1[6] = {0, 3, 1, 5, 2, 4};
        for (int i = 0; i < n; ++i) {
            if (per[i] != d1[i]) debug = false;
        }
        if (debug) {
            cout << "hey\n";
        }
        vector<pair<int, int>> check(k);
        for (int i = 0; i < k; ++i) {
            check[i].first = -inf;
            check[i].second = inf;
        }
        for (int i = 0; i < n; i += 2) {
            for (int j = 0; j < k; ++j) {
                int t1 = min(a[per[i]].val[j], a[per[i + 1]].val[j]), t2 = max(a[per[i]].val[j], a[per[i + 1]].val[j]);
                check[j].first = max(check[j].first, min(t1, t2));
                check[j].second = min(check[j].second, max(t1, t2));
            }
        }
        bool ok = true;
        for (int i = 0; i < k; ++i) {
            if (check[i].first > check[i].second) {
                ok = false;
            }
        }
        if (ok) {
            found = true;
            for (int i = 0; i < n; ++i) ans[i] = per[i];
            break;
        }
        next_permutation(per.begin(), per.end());
    }
    if (!found) {
        cout << "NO\n";
        return 0;
    }
    cout << "YES\n";
    for (int i = 0; i < n; i += 2) {
        cout << ans[i] + 1 << " " << ans[i + 1] + 1 << "\n";
    }
    return 0;
}
