#include <iostream>

using namespace std;

int sqrt(int a) {
    int l = 0, r = a + 1, m;
    while (r > l + 1) {
        m = (l + r) / 2;
        if ((m * m) > a) r = m;
        else l = m;
    }
    return l;
}

int main() {
    int k;
    cin >> k;
    int r = sqrt(k);
    if (r * r == k) cout << r << endl;
    else {
        r = 2 * sqrt(abs(k));
        for (int a = 1; a < r; ++a) {
            int d = k + (a - 1) * (a - 1);
            int sd = sqrt(d);
            if (sd * sd == d) {
                cout << sd << endl;
                return 0;
            }
        }
    }
    cout << "none" << endl;
    return 0;
}