#include <iostream>
#pragma GCC optimize "O3"

using namespace std;

long long sqrt(long long a) {
    long long l = 0, r = a + 1, m;
    while (r > l + 1) {
        m = (l + r) / 2;
        if ((m * m) > a) r = m;
        else l = m;
    }
    return l;
}

int main() {
    long long k;
    cin >> k;
    long long r = sqrt(k);
    if (r * r == k) cout << r << endl;
    else {
        for (long long b = 1; b < 2000000; ++b) {
            long long d = b * b - k;
            if (d < 0) continue;
            long long sd = sqrt(d);
            if (sd * sd == d) {
                cout << b << endl;
                return 0;
            }
        }
        cout << "none" << endl;
    }
    return 0;
}