#include <bits/stdc++.h>

using namespace std;

void dfs (int v, bool used[], vector <vector <int>> graph, int *am, bool del[])
{
    used[v] = 1;

    (*am)++;

    for (auto u : graph[v])
    {
        if (used[u] == 0 && del[u] == 0)
        {
            dfs (u, used, graph, am, del);
        }
    }
}

int main()
{
    int n;

    cin >> n;

    vector <vector <int>> graph;

    graph.resize (n);

    int a;

    int edges = 0;

    bool del[n];
    int deg[n];

    bool used[n];

    for (int i = 0; i < n; i++)
    {
        used[i] = 0;
    }

    for (int i = 0; i < n; i++) del[i] = 0;

    for (int i = 0; i < n; i++)
    {
        cin >> a;

        if (a != -1)
        {
            graph[i].push_back (a - 1);
            graph[a - 1].push_back (i);

            edges++;
        }
    }

     for (int i = 0; i < n; i++)
        {
            deg[i] = graph[i].size();
        }

    /////////////////////////////////////////

    for (int i = 0; i < n; i++)
    {
        if (deg[i] == 1 && del[i] == 0)
        {
            del[graph[i][0]] = 1;
            deg[i] = 0;

            for (auto u : graph[graph[i][0]]) deg[u]--;

            i = 0;
        }
    }

    int am = 0;

    int ans = 0;

    for (int i = 0; i < n; i++)
    {
        if (del[i] == 0 && used[i] == 0)
        {
            dfs (i, used, graph, &am, del);

            //cout << am << endl;
        }

        if (am%2 == 0) ans += am/2;
        if (am == 1) ans += 1;
        if (am%2 == 1) ans += (am - 1)/2;

        am = 0;
    }

    cout << ans;

}
