#include <bits/stdc++.h>

using namespace std;
//*
typedef long long ll;

const ll Mod = 1E9 + 7;

struct three{
    int a, b, c;
    three(){}

    three(int a, int b, int c){
        this->a = a;
        this->b = b;
        this->c = c;
    }
};

bool operator <(three a, three b){
    return pair<pair<int, int>, int> (pair<int, int> (a.a, a.b), a.c) < pair<pair<int, int>, int> (pair<int, int> (b.a, b.b), b.c);
}

ll bynary_pow(ll base, ll p){
    if (p == 0){
        return 1;
    }
    if (p%2){
        ll t = bynary_pow(base, p/2);
        return ((t * t) % Mod * base) % Mod;
    } else {
        ll t = bynary_pow(base, p/2);
        return (t * t) % Mod;
    }
}

inline ll divv(ll a, ll b){
    return (bynary_pow(b, Mod - 2) * a) % Mod;
}

inline ll c(vector<ll> fact, ll n, ll k){
    return divv(divv(fact[n], fact[k]), fact[n - k]);
}

ll get_start(vector<ll> &pow, vector<ll> &fact, ll before, ll place, int k, int j){
    //cerr << "-" << before << " " << place << " " << k << " " << j << " ?" << c(fact, place, j) << "\n";

    if (j < 0 || j > place){
        return 0;
    }
    if (before + pow[place] - 1 < k && place != 0){
        return c(fact, place, j);
    } else if (before > k){
        return 0;
    }
    if (place == 0){
        return 1;
    }
    return (get_start(pow, fact, before, place - 1, k, j) + get_start(pow, fact, before + pow[place - 1], place - 1, k, j - 1)) % Mod;
}
//*/
int main(){
    //cout << 1;//*
    int n, m, k;
    cin >> n >> m >> k;
    //cout << n << " " << m << " " << k << "\n";
    vector<ll> pow(61);
    vector<ll> fact(61);
    pow[0] = 1; fact[0] = 1;
    for (int i = 1; i < 61; ++i){
        pow[i] = (pow[i - 1] * 2) % Mod;
        fact[i] = (fact[i - 1] * i) % Mod;
    }
    //cout << bynary_pow(1, 3) << "\n";
    ll log = 0, step = 1;
    for (int i = 0; step <= k; ++i){
        step = step * 2;
        log++;
    }
    log++;
    vector<three> event(2);
    event[0] = three(0, -1, -1); event[1] =  three(n - 1, 1E8, 1E8);
    for (int i = 0; i < m; ++i){
        int l, r;
        cin >> l >> r;
        event.push_back(three(l, 1, r));
        event.push_back(three(r, 0, 1));
    }
    sort(event.begin(), event.end());

    vector<vector<int> > dp(2 * m + 2, vector<int> (log, 0));/*
    for (int i = 0; i < log; ++i){
        dp[0][i] = get_start(pow, fact, 0, log, k, i);
    } //*/
    for (int i = 0; i <= k; ++i){
        int c = 0, j = i;
        while (j > 0){
            if (j%2) {
                c++;
            }
            j = j/2;
        }
        dp[0][c]++;
    }//*
    //cerr <<"l" << log << " ";
    map<int, int> ind;
    for (int i = 0; i < 2 * m + 2; ++i){
        ind[event[i].a] = i;
    }
    //for (int j = 0; j < log;)
    for (int i = 1; i < 2 * m + 2; ++i){
        //cerr << "q ";
        for (int j = log - 1; j >= 0; --j){
            for (int j1 = log - 1; j1 >= j; --j1){
                //cerr << "w " << j << " " << j1 << " " << dp[i - 1][j1] << " " << c(fact, j1, j) << " " << event[i].a - event[i - 1].a << " " << j1 - j << " " << bynary_pow(event[i].a - event[i - 1].a, j1 - j) << "\n";
                dp[i][j] += dp[i - 1][j1] * c(fact, j1, j) * bynary_pow(event[i].a - event[i - 1].a, j1 - j);
                dp[i][j] = dp[i][j] % Mod;
            }
        }
        //cerr << "w \n";
        if (event[i].b == 0){
            for (int j = 0; j < log; ++j){
                dp[i][j] -= dp[ind[event[i].c]][j];
            }
        }
    }/*
    for (int i = 0; i < 2 * m + 2; ++i){
        for (int j = 0; j < log; ++j){
            cerr << dp[i][j] << "; ";
        }
        cerr << "\n";
    }//*/
    //cerr << "t \n";
    ll rt = 0;
    for (int i = 0; i < log; ++i){
        //cerr << "u ";
        rt += dp.back()[i];
        rt = rt % Mod;
    }
    cout << rt; //*/
}
