// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

const ll MAX_N = 5'001;
const ll MOD = 1'000'000'007;
ll dp[MAX_N][MAX_N][2];

inline void solve() {
	ll n, k;
	cin >> n >> k;
	if (n == k) {
		cout << 1 << endl;
		return;
	}
	dp[k][k][1] = dp[k][k][0] = 1;
	for (ll i = k; i <= n; ++i) {
		for (ll j = 1; j <= n; ++j) {
			for (ll q = 1; q + i <= n; ++q) {
				if (q > j) {
					dp[i + q][q][1] = (dp[i + q][q][1] + dp[i][j][0]) % MOD;
				}
				if (q < j) {
					dp[i + q][q][0] = (dp[i + q][q][0] + dp[i][j][1]) % MOD;
				}
			}
		}
	}
	ll res = 0;
	for (ll i = 0; i <= n; ++i) {
		res = (res + dp[n][i][0] + dp[n][i][1]) % MOD;
	}
	cout << res << endl;
}

int32_t main() {
	start();
	solve();
	return 0;
}
