#include <iostream>
#include <vector>

using namespace std;

const int MOD = 1e9 + 7;

int n, m, k;

vector<vector<int> > dp;

inline int dfs(int v, int d){
    if (dp[v][d] != -1){
        return dp[v][d];
    }
    if (d == n - 1){
        return 1;
    }
    int ans = dfs(0, d + 1);
    /*if (v != 0){
        ans = (ans + dfs(v, d + 1)) % MOD;
    }*/
    for (int sub = v; sub > 0; sub = (sub - 1) & v){
        ans += dfs(sub, d + 1);
        ans %= MOD;
    }
    dp[v][d] = ans;
    return ans;
}

int main()
{
    cin >> n >> m >> k;
    dp.resize(k + 1, vector<int>(n, -1));
    int ans = 0;
    for (int i = 0; i <= k; i++){
        ans = (ans + dfs(i, 0)) % MOD;
    }
    cout << ans << endl;
    return 0;
}
