#include <iostream>
#include <vector>

using namespace std;

int findNext(vector<int> arr, int start, int num) {
	//cout << start << " " << num << endl;
	for (int i = start; i < arr.size(); i++) {
		if (arr[i] == num) {
			//cout << "Find: " << i << endl;
			return i;
		}
	}
	//cout << "Find: " << -1 << endl;
	return -1;
}

int afterAll(vector<int> preceding, int firstInd, int lastInd, vector<int> nums, int num) {
	if (firstInd >= lastInd) {
		return 0;
	}

	/*int res = 0, counter = 0;
	vector<bool> found;
	for (int i = firstInd; i < lastInd; i++) {
		found.push_back(false);
	}

	while (true) {
		for (int i = firstInd; i < lastInd; i++) {
			if (nums[res] == preceding[i] && !found[i - firstInd]) {
				found[i - firstInd] = true;
				counter++;
				if (counter == lastInd - firstInd) {
					//cout << "Aft: " << res << endl;
					return res;
				}
			}
		}
		res++;
		if (res >= nums.size()) {
			//cout << "Aft: " << res << endl;
			return res - 1;
		}
	}*/
	int res = 0;
	for (int i = firstInd; i < lastInd; i++) {
		int index = findNext(nums, 0, preceding[i]);
		if (index > res) {
			res = index;
		}
	}
	return res;
}

void move(vector<int> &arr, int ind) {
	int temp = arr[0];
	for (int i = 1; i <= ind; i++) {
		arr[i - 1] = arr[i];
	}
	arr[ind] = temp;
}

void output(vector<int> arr) {
	for (int i = 0; i < arr.size(); i++) {
		cout << arr[i];
		if (i < arr.size() - 1) {
			cout << " ";
		}
	}
	cout << endl;
}

int main() {
	int n, m, i, j, temp, currentB = 0;
	vector<int> bs;
	vector<int> as;
	vector<int> acts;
	bool gotCor = false;

	cin >> m >> n;
	for (i = 0; i < n; i++) {
		cin >> temp;
		bs.push_back(temp);
	}
	for (i = 0; i < m; i++) {
		cin >> temp;
		as.push_back(temp);
	}

	while (currentB < n || gotCor) {
		gotCor = false;
		i = findNext(bs, currentB, as[0]);
		if (i == -1) {
			acts.push_back(m);
			move(as, m - 1);
			//cout << "Current: ";
			//output(as);
			//cout << "B: " << currentB << endl;
			continue;
		}
		if (i == currentB) {
			gotCor = true;
			if (bs[currentB + 1] == as[0]) {
				acts.push_back(1);
			}
			currentB++;
			continue;
		}
		j = afterAll(bs, currentB, i, as, as[0]);
		acts.push_back(j + 1);
		move(as, j);
		//cout << "Current: ";
		//output(as);
		//cout << "B: " << currentB << endl;
	}

	cout << acts.size() << endl;
	output(acts);

	return 0;
}