#include <iostream>
#include <vector>

using namespace std;

/*void output(vector<long> arr) {
	for (long i = 0; i < arr.size(); i++) {
		cout << arr[i];
		if (i != arr.size() - 1) {
			cout << " ";
		}
	}
	cout << endl;
}*/

int main() {
	long n, i, current, node;
	cin >> n;
	vector<bool> marked(n, false);
	vector<long> level(n, 0);
	vector<vector<long>> edges(n);
	vector<long> stackNodes;
	bool mustDecrease;
	long withOdd, withEven;
	long result = 0;

	for (i = 0; i < n; i++) {
		vector<long> temp;
		edges[i] = temp;
	}
	for (i = 0; i < n; i++) {
		cin >> current;
		if (current != -1) {
			edges[i].push_back(current - 1);
			edges[current - 1].push_back(i);
		}
	}

	for (current = 0; current < n; current++) {
		if (marked[current]) {
			continue;
		}
		if (edges[current].size() == 0) {
			result++;
			continue;
		}

		withOdd = 0;
		withEven = 0;
		stackNodes.clear();
		stackNodes.push_back(current);
		mustDecrease = false;
		while (stackNodes.size() > 0) {
			node = stackNodes[stackNodes.size() - 1];
			stackNodes.pop_back();
			if (marked[node]) {
				continue;
			}
			if (level[node] % 2 == 0) {
				withEven++;
			} else {
				withOdd++;
			}
			
			for (i = 0; i < edges[node].size(); i++) {
				if (level[edges[node][i]] != 0) {
					if (!marked[node]) {
						mustDecrease = ((level[node] - level[edges[node][i]]) % 2 == 0);
					}
					continue;
				} else {
					level[edges[node][i]] = level[node] + 1;
					stackNodes.push_back(edges[node][i]);
				}
			}

			marked[node] = true;

			//cout << node << "-" << level[node] << ":" << withOdd << " " << withEven << endl;
			//output(stackNodes);
		}

		result += max(withOdd, withEven) - (mustDecrease ? 1 : 0);
		//cout << "R: " << result << endl;
	}

	cout << result << endl;
	return 0;
}