#include <bits/stdc++.h>

using namespace std;

#define int long long
int n;
vector<int> tree;

void add(int k, int x) {
    k += n;
    tree[k] += x;
    for (k /= 2; k >= 1; k /= 2) {
        tree[k] = tree[2 * k] + tree[2 * k + 1];
    }
}

//[a; b]
int sum(int a, int b) {
    a += n;
    b += n;
    int sum = 0;
    while (a <= b) {
        if (a % 2 == 1) {
            sum += tree[a++];
        }
        if (b % 2 == 0) {
            sum += tree[b--];
        }
        a /= 2;
        b /= 2;
    }
    return sum;
}

int bsearch(int sl, int sr, bool f(int)) {
    while (sr - sl > 1) {
        int m = (sl + sr) / 2;
        if (f(m)) {
            sl = m;
        } else {
            sr = m;
        }
    }
    return sl;
}

int MAXN = 1e6;

vector<int> sums(MAXN);
int ind;
int k;

void gen() {
    for (int i = 1; i < MAXN; ++i) {
        sums[i] = sums[i - 1] + 2 * i - 1;
    }
}

bool f(int i) {
    return sums[i] - sums[ind] <= k;
}

signed main() {
    gen();
    cin >> k;
    bool les = k < 0;
    k = abs(k);
    if (k == 0) {
        cout << 0;
        return 0;
    }
    for (int i = 0; i < MAXN; ++i) {
        ind = i;
        int ind2 = bsearch(i, MAXN, f);
        if (sums[ind2] - sums[ind] == k) {
            if (les) {
                cout << i;
            } else {
                cout << ind2;
            }
            return 0;
        }
    }
    cout << "none";

    return 0;
}