#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int MOD = 1e9 + 7;

void solve1(int n, int k) {
	int res = 0;
	vector<vector<int>> d(2, vector<int>(k + 1, 0));
	d[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j <= k; ++j) {
			d[i % 2][j] = 0;
			for (int q = 0; q <= j; ++q) {
				if ((q & j) == q) {
					d[i % 2][j] = (d[i % 2][j] + d[1 - i % 2][q]) % MOD;
				}
			}
		}
	}
	for (int i = 0; i <= k; ++i) {
		res = (res + d[n % 2][i]) % MOD;
	}
	cout << res << endl;
}

int main() {
	int n, m, l, r;
	ll k;
	cin >> n >> m >> k;
	vector<pair<int, int>> a(m);
	for (int i = 0; i < m; ++i) {
		cin >> l >> r;
		a[i].first = l - 1;
		a[i].second = r - 1;
	}
	if (m == 0){
        solve1(n, k);
	} else {
        cout << 0 << endl;
	}
	return 0;
}
