#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

using Artefact = std::vector<int>;
struct Segment
{
    int x, y;
    Segment(int x_, int y_) : x(x_), y(y_)
    {
    }
    Segment operator&(const Segment& other) const
    {
        Segment a = *this;
        Segment b = other;
        if (a.x > b.x)
            std::swap(a, b);
        return Segment(b.x, a.y);
    }
};

int main(int argc, char const *argv[])
{
    int n, k;
    std::cin >> n >> k;
    std::vector<Artefact> artefacts(n, Artefact(k));
    for (auto &art : artefacts) {
        for (auto &param : art) {
            std::cin >> param;
        }
    }

    if (k == 1)
    {
        std::vector<int> art_ind(n);
        for (int i = 0; i < n; ++i)
            art_ind[i] = i;
        std::sort(art_ind.begin(), art_ind.end(), [artefacts](int i, int j)
            {
                return artefacts[i].front() < artefacts[j].front();
            });
        std::cout << "YES" << '\n';
        for (int i = 0; i < n / 2; ++i)
        {
            std::cout << art_ind[i] + 1 << " " << art_ind[n - i - 1] + 1 << '\n';
        }
    }
    else
    {
        for (int mask = 0; mask < (1<<n); ++mask)
        {
            
        }
    }
    
    
    return 0;
}