#include <iostream>
#include <vector>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#define int long long
#define all(a) a.begin(), a.end()

using namespace std;

int n, k;

void main1() {
    vector<vector<int>> a(n, vector<int> (k, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
    }
    vector<int> mask(n);
    for (int i = 0; i < n; ++i) {
        mask[i] = i;
    }
    do {
        bool ok = true;
        for (int j = 0; j < k; ++j) {
            int l = -2 * 1e9;
            int r = 2 * 1e9;
            for (int i = 0; i < n; i += 2) {
                l = max(l, min(a[mask[i]][j], a[mask[i + 1]][j]));
                r = min(r, max(a[mask[i]][j], a[mask[i + 1]][j]));
            }
            if (l > r) {
                ok = false;
            }
        }
        if (ok) {
            cout << "YES\n";
            for (int i = 0; i < n; i += 2) {
                cout << mask[i] + 1 << " " << mask[i + 1] + 1 << endl;
            }
            return;
        }
    } while (next_permutation(all(mask)));
    cout << "NO\n";
    return;
}

signed main()
{
    cin >> n >> k;
    if (n <= 20) {
        main1();
    }
    return 0;
}
