#define _USE_MATH_DEFINES
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;

const int inf = 1e9;
ostream& operator << (ostream& s, vector<int>& a) {
	for (auto i : a) {
		if (i == inf) cout << "inf ";
		else cout << i << " ";
	}
	cout << '\n';
	return s;
}

int n, m;
vector<vector<int>> dat;
vector<int> a, pos;

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	cin >> n >> m;
	a.resize(m);
	pos.resize(n + 1);
	dat.resize(n + 1);

	vector<int> ans;

	for (int i = 0; i < m; i++) {
		cin >> a[i];
		dat[a[i]].push_back(i + 1);
	}
	for (auto &i : dat) {
		i.push_back(inf);
	}

	for (int i = 1; i <= n; i++) {
		int k;
		cin >> k;
		pos[k] = i;
	}
	int cnt = 1;

	while (cnt <= m) {

		int now = -1;
		for (int j = 1; j <= n; ++j) {
			if (pos[j] == 1) {
				now = j;
			}
		}
		if (now == -1) cout << "error\n";

		int kek = lower_bound(dat[now].begin(), dat[now].end(), cnt) - dat[now].begin();
		if (dat[now][kek] == cnt) {
			cnt++;
			kek++;
		}
		kek = dat[now][kek];
		int pos_now = 1;

		for (int i = 1; i <= n; i++) {
			if (i == now) continue;

			int smth = lower_bound(dat[i].begin(), dat[i].end(), cnt) - dat[i].begin();

			if (dat[i][smth] < kek) {
				pos_now = max(pos_now, pos[i]);
			}
		}

		ans.push_back(pos_now);

		for (int i = 1; i <= n; i++) {
			if (pos[i] <= pos_now) pos[i]--;
		}
		pos[now] = pos_now;
	}

	cout << ans.size() << '\n' << ans;

//	system("pause");
	return 0;
}