#define _USE_MATH_DEFINES
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;

const int inf = 1e9;
ostream& operator << (ostream& s, vector<long long>& a) {
	for (auto i : a) {
		if (i == inf) cout << "inf ";
		else cout << i << "\n";
	}
	cout << '\n';
	return s;
}

long long n, m, k, ans = 0, mod = 1e9 + 7;
vector<long long> pow2;

long long lazy(int x) {  // return 2^x
	if (pow2[x] == 0){
		
		if (x % 2 == 1) {
			pow2[x] = (lazy(x - 1) * 2) % mod;
		}
		else {
			auto kek = lazy(x / 2);
			pow2[x] = (kek*kek) % mod;
		}
	}

	return pow2[x];
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	cin >> n >> m >> k;
	pow2.resize(n + 1, 0);
	pow2[0] = 1;

	if (m) while (1);

	int ans = k + 1;
	long long kek = 1;
	for (int i = 0; kek < k; i++) {
		auto two_n = lazy(n);
		ans = ans + ((((kek % mod - 1 + mod) % mod) * (two_n - 1)) % mod + 1) % mod;
		kek *= 2;
	}

	cout << ans;

	//system("pause");
	return 0;
}