#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <random>
#include <ctime>
#include <deque>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;

int n, ans = 1;
int cnt = -1;
const int inf = 1e9;
ostream& operator << (ostream& s, vector<int>& a) {
	for (auto i : a) {
		if (i == inf) cout << "inf ";
		else cout << i << " ";
	}
	cout << '\n';
	return s;
}

vector<int> kek, rnd;

void best_solve_ever() {
	cnt = rand() % (n - 1) + 2;
	rnd = kek;
	random_shuffle(rnd.begin(), rnd.end());
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	cin >> n;


	if (n <= 20) {
		vector<vector<int>> gr(n + 1, vector<int>(n + 1, 0));
		for (int i = 1; i <= n; i++) {
			int a;
			cin >> a;
			if (a == -1) continue;
			gr[i][a] = 1;
			gr[a][i] = 1;
		}

		kek.resize(n);
		for (int i = 1; i <= n; i++) {
			kek[i - 1] = i;
		}

		while (clock() < 0.9 * CLOCKS_PER_SEC) {
			best_solve_ever();

			bool fl = false;
			for (int i = 0; i < cnt && !fl; i++) {
				for (int j = i + 1; j < cnt && !fl; j++) {
					if (gr[rnd[i]][rnd[j]] == 1 || gr[rnd[j]][rnd[i]] == 1) {
						fl = true;
					}
				}
			}

			if (!fl) {
				ans = max(ans, cnt);
			}
		}

		cout << ans << '\n';
	}
	else {
		cout << (n + 1) / 2;
	}

//	system("pause");
	return 0;
}