#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <random>
#include <ctime>
#include <deque>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;

int n, k;
const int inf = 1e9 + 7;
vector<int> dat, rnd;
ostream& operator << (ostream& s, vector<int>& a) {
	for (auto i : a) {
		if (i == inf) cout << "inf ";
		else cout << i << " ";
	}
	cout << '\n';
	return s;
}

void kek() {
	rnd = dat;
	random_shuffle(rnd.begin(), rnd.end());
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	cin >> n >> k;

	if (k == 1) {
		vector<pair<int, int>> kek(n);
		for (int i = 1; i <= n; i++) {
			cin >> kek[i - 1].first;
			kek[i - 1].second = i;
		}

		sort(kek.begin(), kek.end());
		cout << "YES\n";
		for (int i = 0; i < n / 2; i++) {
			cout << kek[i].second << " " << kek[i + n / 2].second << '\n';
		}
	}
	else {
		dat.resize(n);
		rnd.resize(n);
		for (int i = 0; i < n; i++) {
			dat[i] = i;
		}

		vector<vector<int>> art(n, vector<int>(k));
		for (int i = 0; i < n; i++){
			for (int j = 0; j < k; j++) {
				cin >> art[i][j];
			}
		}

		while (clock() < 0.9 * CLOCKS_PER_SEC) {
			kek();

			bool fl = true;
			vector<pair<int, int>> smth(k, { -inf, inf });

			for (int i = 0; i < n && fl; i += 2) {
				for (int j = 0; j < k; j++) {
					pair<int, int> now = { min(art[rnd[i]][j], art[rnd[i + 1]][j]), max(art[rnd[i]][j], art[rnd[i + 1]][j]) };
					smth[j] = { max(smth[j].first, now.first), min(smth[j].second, now.second) };

					if (smth[j].first > smth[j].second) {
						fl = false;
						break;
					}
				}
			}

			if (fl) {
				cout << "YES\n";
				for (int i = 0; i < n; i += 2) {
					cout << rnd[i] + 1 << " " << rnd[i + 1] + 1 << '\n';
				}
				return 0;
			}
		}

		cout << "NO";
	}

	//system("pause");
	return 0;
}