#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;

int* arr;
int* a;
long long int m, n;

void build(int L = 0, int R = m - 1, int id = 1) {
	if (L == R) arr[id] = 1;
	else {
		int M = (L + R) / 2;
		build(L, M, id * 2);
		build(M + 1, R, id * 2 + 1);
		arr[id] = arr[id * 2] + arr[id * 2 + 1];
	}
}

int find(int L = 0, int R = m - 1, int id = 1) {
	if (L == R) {
		//assert(arr[id] == 1);
		arr[id] = 0;
		return L;
	}
	int M = (R + L) / 2;
	if (arr[id * 2] > 0) {
		arr[id]--;
		return find(L, M, id * 2);
	}
	else {
		arr[id]--;
		return find(M + 1, R, id * 2 + 1);
	}
}

int main() {
	scanf("%lld %lld", &n, &m);
	a = new int[m];
	int* b = new int[n];
	bool* used = new bool[n];
	for (int i = 0; i < m; i++) {
		scanf("%d", &a[i]);
		a[i]--;
	}
	for (int i = 0; i < n; i++) {
		scanf("%d", &b[i]);
		b[i]--;
		used[i] = false;
	}
	int cnt = m;
	vector<vector<int>> res(n, vector<int>());
	vector<int> q;
	int pos = 0;
	arr = new int[m * 4];
	build();
	for (int i = 0; i < m; i++) {
		if (!used[a[i]]) {
			while (true) {
				int j = find();
				if (b[j] == a[i]) break;
				cnt++;
				res[b[j]].push_back(pos++);
				q.push_back(b[j]);
				used[b[j]] = true;
			}
		}
		used[a[i]] = true;
		res[a[i]].push_back(pos++);
		q.push_back(a[i]);
	}
	printf("%d\n", cnt);
	int* sz = new int[n];
	for (int i = 0; i < n; i++) sz[i] = 0;
	for (int i = 0; i < (int)q.size(); i++) {
		int v = q[i];
		if (sz[v] + 1 >= res[v].size()) printf("%d ", n);
		else {
			int c = 0;
			bool* vis = new bool[n];
			for (int j = 0; j < n; j++) vis[j] = false;
			for (int j = res[v][sz[v]] + 1; j < res[v][sz[v] + 1]; j++) {
				if (!vis[q[j]]) {
					vis[q[j]] = true;;
					c++;
				}
			}
			sz[v]++;
			printf("%d ", c + 1);
		}
	}
	system("pause");
	return 0;
}