#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <assert.h>

using namespace std;

long long int mod = 1000000007;

int n, k;

struct inf {
	long long int* sum;
	inf() {
		sum = new long long  int[4 * n + 4];
		for (int i = 0; i < 4 * n + 4; i++) sum[i] = 0;
	}
	long long int get(int l, int r, int L = 1, int R = n, int id = 1) {
		if (L > r || R < l) return 0;
		if (L >= l && R <= r) return sum[id];
		int M = (R + L) / 2;
		return get(l, r, L, M, id * 2) + get(l, r, M + 1, R, id * 2 + 1);
	}
	void set(int pos, int val, int L = 1, int R = n, int id = 1) {
		if (L > pos || R < pos) return;
		if (L == R) {
			sum[id] = val;
		}
		else {
			int M = (R + L) / 2;
			set(pos, val, L, M, id * 2);
			set(pos, val, M + 1, R, id * 2 + 1);
			sum[id] = sum[id * 2] + sum[id * 2 + 1];
			sum[id] %= mod;
		}
	}
};

int main() {
	scanf("%d %d", &n, &k);
	if (n == k) {
		printf("1");
		system("pause");
		return 0;
	}
	long long int*** dp = new long long int**[n + 1];
	inf** dp2 = new inf*[n + 1];
	for (int i = 0; i <= n; i++) {
		dp[i] = new long long int*[n + 1];
		dp2[i] = new inf[2];
		for (int j = 0; j <= n; j++) {
			dp[i][j] = new long long int[2];
			dp[i][j][0] = 0;
			dp[i][j][1] = 0;
		}
	}
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	dp2[k][0].set(k, 1);
	dp2[k][1].set(k, 1);
	for (int i = k + 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (j > i) break;
			dp[i][j][0] = dp2[i - j][1].get(1, j - 1);
			dp[i][j][1] = dp2[i - j][0].get(j + 1, n);
			dp[i][j][0] %= mod;
			dp[i][j][1] %= mod;
			dp2[i][0].set(j, dp[i][j][0]);
			dp2[i][1].set(j, dp[i][j][1]);
		}
	}
	long long int res = 0;
	for (int j = 1; j <= n; j++) {
		res += dp[n][j][0] + dp[n][j][1];
	}
	res %= mod;
	printf("%lld", res);
	system("pause");
	return 0;
}