#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <assert.h>

using namespace std;

long long int mod = 1000000007;

int n, k;

struct node {
	node* l;
	node* r;
	int s;
	bool L;
	bool R;
	node() {
		L = false;
		R = false;
		s = 0;
	}
};
struct inf {
	node sum;
	int get(int l, int r, node& now, int L = 1, int R = n) {
		if (L > r || R < l) return 0;
		if (L >= l && R <= r) return now.s;
		int M = (R + L) / 2;
		if (!now.L) {
			now.L = true;
			now.l = new node;
		}
		if (!now.R) {
			now.R = true;
			now.r = new node;
		}
		return (get(l, r, *(now.l), L, M) + get(l, r, *(now.r), M + 1, R)) % mod;
	}
	void set(int pos, int val, node& now, int L = 1, int R = n) {
		if (L > pos || R < pos) return;
		if (L == R) {
			now.s = val;
		}
		else {
			if (!now.L) {
				now.L = true;
				now.l = new node;
			}
			if (!now.R) {
				now.R = true;
				now.r = new node;
			}
			int M = (R + L) / 2;
			set(pos, val, *(now.l), L, M);
			set(pos, val, *(now.r), M + 1, R);
			now.s = (now.l)->s + (now.r)->s;
			now.s %= mod;
		}
	}
};

int main() {
	scanf("%d %d", &n, &k);
	if (n == k) {
		printf("1");
		system("pause");
		return 0;
	}
	long long int*** dp = new long long int**[n + 1];
	inf** dp2 = new inf*[n + 1];
	for (int i = 0; i <= n; i++) {
		dp[i] = new long long int*[n + 1];
		dp2[i] = new inf[2];
		for (int j = 0; j <= n; j++) {
			dp[i][j] = new long long int[2];
			dp[i][j][0] = 0;
			dp[i][j][1] = 0;
		}
	}
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	dp2[k][0].set(k, 1, dp2[k][0].sum);
	dp2[k][1].set(k, 1, dp2[k][1].sum);
	for (int i = k + 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (j > i) break;
			dp[i][j][0] = dp2[i - j][1].get(1, j - 1, dp2[i - j][1].sum);
			dp[i][j][1] = dp2[i - j][0].get(j + 1, n, dp2[i - j][0].sum);
			dp[i][j][0] %= mod;
			dp[i][j][1] %= mod;
			dp2[i][0].set(j, dp[i][j][0], dp2[i][0].sum);
			dp2[i][1].set(j, dp[i][j][1], dp2[i][1].sum);
		}
	}
	long long int res = 0;
	for (int j = 1; j <= n; j++) {
		res += dp[n][j][0] + dp[n][j][1];
	}
	res %= mod;
	printf("%lld", res);
	system("pause");
	return 0;
}