#pragma GCC optimize ("Ofast")
//#pragma GCC optimize ("enroll-loops")
#pragma GCC optimize ("fast-math")
//#pragma GCC target ("sse, sse2, sse3, ssse3, sse4, abm, avx, mmx, tune=native")
#include <bits/stdc++.h>
#define int long long
using namespace std;

const int N = 5179;

const int MOD = 1e9 + 7;

int n, k;

const vector<int> steps = {1, -1};

int dp[N][2][N];

inline int get(int sum, bool f, int l, int r) {
	return ((dp[sum][f][r] - dp[sum][f][l - 1]) % MOD + MOD) % MOD;
}

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k;
	if (n == k) {
		cout << 1 << endl;
		return 0;
	}

	dp[n - k][0][k] = 1;
	dp[n - k][1][k] = 1;
	for (int i = 1; i <= n; i++) {
		dp[n - k][0][i] += dp[n - k][0][i - 1];
		dp[n - k][1][i] += dp[n - k][1][i - 1];
	}

	for (int sum = n - k - 1; sum >= 0; sum--) {
		for (int b = 0; b < 2; b++) {
			for (int lst = 1; lst <= n; lst++) {
				if (sum + lst <= n) {
					if (b == 0) {
						dp[sum][b][lst] = get(sum + lst, b ^ 1, lst + 1, n);
					} else {
						dp[sum][b][lst] = get(sum + lst, b ^ 1, 1, lst - 1);
					}
				}
				
				dp[sum][b][lst] += dp[sum][b][lst - 1];
				dp[sum][b][lst] %= MOD;
				//cout << "dp[" << sum << "][" << b << "][" << lst << "] = " << dp[sum][b][lst] << endl;
			}
		}
	}

	int ans = get(0, 1, 1, n);
	ans += get(0, 0, 1, n);
	ans %= MOD;
	cout << ans << endl;
}