#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
//#pragma comment(linker, "/stack:100000000")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;


long long ans = 0, n, x, y;

vector<bool> used;
vector<long long> m;
vector<vector<long long>> gf;
set<pair<pair<long long, long long>, long long>> s;

void dfs(long long v, long long color = 1)
{
	used[v] = true;
	m[v] = color;
	long long to, i;
	if (color == 1)
		++x;
	else
		++y;
	for (i = 0; i < gf[v].size(); ++i)
	{
		to = gf[v][i];
		if (color == 1)
		{
			if (used[to] == false)
				dfs(to, 2);
			else
			{
				if (m[to] == m[v])
				{
					s.insert({ {min(v, to), max(v, to)}, 1 });
				}
			}
		}
		else
		{
			if (used[to] == false)
				dfs(to, 1);
			else
			{
				if (m[to] == m[v])
					s.insert({ {min(v, to), max(v, to)}, 2 });
			}
		}
	}
}

void get_ans()
{
	gf.resize(n);
	long long i;
	//set<pair<long long, long long>> qs;
	for (i = 0; i < n; ++i)
	{
		if (m[i] != -2)
		{
			//qs.insert({ i, m[i] });
			//qs.insert({ m[i], i });
			gf[i].push_back(m[i]);
			gf[m[i]].push_back(i);
		}
	}
	for (i = 0; i < n; ++i)
	{
		if (!used[i])
		{
			x = 0, y = 0;
			s.clear();
			dfs(i);
			for (auto it : s)
			{
				if (it.second == 1)
					--x;
				else
					--y;
			}
			ans += max(x, y);
		}
	}
}
//13
//2 3 1 5 6 12 8 7 10 11 12 9 6
int main()
{
	long long i;
	cin >> n;
	used.resize(n, false);
	m.resize(n);
	for (i = 0; i < n; ++i)
	{
		cin >> m[i];
		--m[i];
	}
	get_ans();
	system("pause");
	return 0;
}