#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <vector>
#include <cmath>
#include <ctime>
#include <map>
#include <set>
using namespace std;

long long mod = 1000000007;
vector<vector<vector<long long> > > kek1;

long long kek(int n, int v, bool vc){
    //cout << n << ' ' << v << ' ' << vc << '=' << kek1[n][v][vc] << endl;
    if(kek1[n][v][vc]!=-1)
        return kek1[n][v][vc];
    long long ans = 0;
    int st = (vc?(v+1):1), fn = (vc?(n+1):min(v, n+1));
    for(int i = st; i<fn; i++)
        ans += kek(n-i, i, vc^1);
    //cout << n << ' ' << v << ' ' << vc << ' ' << ans << endl;
    kek1[n][v][vc] = ans%mod;
    return ans%mod;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, v;
    cin >> n >> v;
    kek1.resize(n+1, vector<vector<long long> >(n+1, vector<long long>(2, -1)));
    for(int i = 0; i<=n; i++)
        kek1[0][i] = {1, 1};
    if(n-v==0)
        cout << 1;
    else
        cout << (kek(n-v, v, 0)+kek(n-v, v, 1))%mod;

    return 0;
}
