#include<bits/stdc++.h>
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define len(a) (int) (a).size()
#define endl '\n'
using namespace std; void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}

const int maxn = 300000 + 7;

vector<int> g[maxn], tree[maxn * 2];
int cyc_num[maxn];


int used[maxn * 2];

vector<int> st, cycle;

void dfs(int v, int p = -1){
    used[v] = 1;
    st.push_back(v);
    for (auto u : g[v]){
        if (!used[u]) {
            dfs(u, v);
        }
        else if (u != p) {
            for (int i = len(st) - 1; i >= 0; --i){
                cycle.push_back(st[i]);
                if (st[i] == u)
                    break;
            }
        }
    }
    st.pop_back();
    used[v] = 2;
}

int dp[maxn][2];

const int inf = (int) 1e9 + 7;



void dfs_k(int v) {
    used[v] = true;
    dp[v][0] = dp[v][1] = 0;
    int bst = 0;
    for (auto u : g[v]){
        if (!used[u]){
            dfs_k(u);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += max(dp[u][0], dp[u][1]);
            bst = max(bst, (dp[u][0] + 1) - max(dp[u][0], dp[u][1]));
        }
    }
    dp[v][1] += bst;
    // cout << v << ' ' << dp[v][0] << ' ' << dp[v][1] << endl;
}



void solve(){
    int n; cin >> n;
    forn (v, n){
        int u; cin >> u; u--;
        if (u != -2){
            g[u].push_back(v);
            g[v].push_back(u);
        }

    }
    int ans = 0; int cnt = 0;
    forn (v, n){
        cyc_num[v] = -1;
    }



    forn (v, n){
        if (!used[v]){
            cycle.clear();
            dfs(v);
            if (!cycle.empty()) {
                ans += len(cycle) / 2;
                if (len(cycle) % 2 == 0){
                    for (auto i : cycle)
                        cyc_num[i] = -2;
                }
                else {
                    for (auto i : cycle)
                        cyc_num[i] = cnt + n;
                    cnt++;
                }
            }
        }
    }
    forn (v, n){
        for (auto u : g[v]){
            if (cyc_num[v] == -2 && cyc_num[u] == -2)
                continue;
            if (cyc_num[v] == -2 || cyc_num[u] == -2){
                tree[v].push_back(u);
                continue;
            }
            if (cyc_num[v] == -1 && cyc_num[u] == -1){
                tree[v].push_back(u);
                tree[u].push_back(v);
                continue;
            }
            if (cyc_num[v] != -1 && cyc_num[u] != -1){
                continue;
            }
            if (cyc_num[v] == -1){
                tree[v].push_back(cyc_num[u]);
            }
            else {
                tree[cyc_num[v]].push_back(cyc_num[u]);
            }
        }
    }
    n += cnt;
    /*
    forn (v, n) {
        cout << v << " : ";
        for (auto u : g[v])
            cout << u << " ";
        cout << endl;
    }*/


    forn (i, n) used[i] = false;
    forn (v, n){
        if (!used[v]){
            dfs_k(v);
            ans += max(dp[v][0], dp[v][1]);
        }
    }
    cout << n - ans << endl;
}