#include<bits/stdc++.h>
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define len(a) (int) (a).size()
#define endl '\n'
using namespace std; void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}

const int maxn = 300000 + 7;
vector<int> g[maxn], tree[maxn], st, cycle, comp;
int tin[maxn], timer = 0, used[maxn];

void dfs(int v, int p = -1){
    used[v] = 1;
    comp.push_back(v);
    tin[v] = timer++;
    st.push_back(v);
    for (auto u : g[v]){
        if (!used[u]) {
            dfs(u, v);
        }
        else if (u != p && tin[u] < tin[v]) {
            for (int i = len(st) - 1; i >= 0; --i){
                cycle.push_back(st[i]);
            }
        }
    }
    st.pop_back();
    used[v] = 2;
}



int used2[maxn], dp[maxn][2];
int sz[maxn];

int dfs_k(int v) {
    used2[v] = true;
    dp[v][0] = dp[v][1] = 0;
    sz[v] = 1;
    int bst = 0;
    for (auto u : tree[v]){
        if (!used2[u]) {
            dfs_k(u);
            sz[v] += sz[u];
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += max(dp[u][0], dp[u][1]);
            bst = max(bst, (dp[u][0] + 1) - max(dp[u][0], dp[u][1]));
        }
    }
    dp[v][1] += bst;
    return max(dp[v][1], dp[v][0]);
}



void solve(){
    int n; cin >> n;


    vector<pair<int, int>> edges;
    forn (v, n){
        int u; cin >> u; u--;
        if (u != -2)
            edges.push_back({min(v, u), max(v, u)});


    }
    edges.resize(unique(all(edges)) - edges.begin());
    for (auto e : edges){
        g[e.first].push_back(e.second);
        g[e.second].push_back(e.first);
    }
    int ans = 0;
    forn (v, n){
        if (!used[v]){
            cycle.clear(); comp.clear(); dfs(v);
            if (!cycle.empty()) {
                auto cycle_copy = cycle; sort(all(cycle_copy));
                for (auto u1 : comp){
                    for (auto u2 : comp){
                        if (binary_search(all(cycle_copy), u1) && binary_search(all(cycle_copy), u2)){
                            continue;
                        }
                        tree[u1].push_back(u2);
                    }
                }
                int add = 0;
                for (auto i : cycle){
                    dfs_k(i);
                    ans += (sz[i] - 1) - dp[i][0];
                    if (sz[i] - dp[i][1] > (sz[i] - 1) - dp[i][0])
                        add = 1;
                }
                if (len(cycle) % 2 == 0){
                    ans += len(cycle) / 2;
                }
                else {
                    ans += len(cycle) / 2 + add;
                }
            }
            else {
                for (auto u1 : comp){
                    for (auto u2 : g[u1]) {
                        tree[u1].push_back(u2);

                    }
                }
                ans += len(comp) - dfs_k(v);
            }
        }
    }
    cout << ans << endl;
}