#include <iostream>
#include <cmath>

using namespace std;

const long long INF = 1e18;

int main() {
    long long k;
    cin >> k;
    long long x = INF, m;
    if (k == 0) {
        cout << 0;
        return 0;
    } else if (k > 0) {
        long long r = (long long) sqrt(k) + 3;
        for (int p = 1; p < r; ++p) {
            if ((k / p) * p == k && (k / p - p) % 2 == 0) {
                cerr << (k / p + p) / 2 << " " << (k / p - p) / 2 << ",  ";
                if (x > (k / p + p) / 2) {
                    x = (k / p + p) / 2;
                    m = (k / p - p) / 2;
                }
            }
        }
        cerr << "\n";
        if (x == INF) {
            cout << "none";
        } else {
            cout << x;
        }
        cerr << " " << m;
    } else {
        k = -k;
        long long r = (long long) sqrt(k) + 3;
        for (int p = 1; p < r; ++p) {
            if ((k / p) * p == k && (k / p - p) % 2 == 0) {
                if (x > (k / p - p) / 2) {
                    x = (k / p - p) / 2;
                    m = (k / p + p) / 2;
                }
            }
        }
        if (x == INF) {
            cout << "none";
        } else {
            cout << x;
        }
    }
    return 0;
}
