#include <iostream>

using namespace std;

const int MAXN = 5005, MOD = 1e9 + 7;

int d[MAXN][MAXN][2];

int main() {
    int n, k;
    cin >> n >> k;

    for (int s = 1; s < n + 5; ++s) {
        d[s][s][0] = 1;
        d[s][s][1] = 0;
    }

    for (int s = 1; s <= n; ++s) {
        for (int l = 1; l <= s; ++l) {
            //cerr << s << " " << l << "\n";
            int sum = 0;

            if (s < l) {
                continue;
            }

            for (int i = 1; i < l; ++i) {
                sum += d[s - l][i][1];
                if (s - l == i) {
                    sum += d[s - l][i][0];
                }
                sum %= MOD;
            }
            d[s][l][0] += sum;
            //cerr << d[s][l][0] << ", ";

            sum = 0;
            for (int i = l + 1; i <= s - l; ++i) {
                sum += d[s - l][i][0];
                sum %= MOD;
            }
            d[s][l][1] += sum;
            //cerr << d[s][l][1] << "\n";
        }
    }

    cout << (d[n][k][0] + d[n][k][1]) % MOD;

    return 0;
}
