#include <iostream>

using namespace std;

const long long MAXN = 5005, MOD = 1e9 + 7;

long long d[MAXN][MAXN][2];

void take_mod(long long & x) {
    x -= (x / MOD) * MOD;
}

int main() {
    long long n, k;
    cin >> n >> k;

    for (long long s = 1; s < n + 5; ++s) {
        d[s][s][0] = 1;
        d[s][s][1] = 0;
    }

    for (long long s = 1; s <= n; ++s) {
        for (long long l = 1; l <= s; ++l) {
            //cerr << s << " " << l << "\n";
            long long sum = 0;

            if (s < l) {
                continue;
            }

            for (long long i = 1; i < l; ++i) {
                sum += d[s - l][i][1];
                if (s - l == i) {
                    sum += d[s - l][i][0];
                }
                take_mod(sum);
            }
            d[s][l][0] += sum;
            take_mod(d[s][l][0]);
            //cerr << d[s][l][0] << ", ";

            sum = 0;
            for (long long i = l + 1; i <= s - l; ++i) {
                sum += d[s - l][i][0];
                take_mod(sum);
            }
            d[s][l][1] += sum;
            take_mod(d[s][l][1]);
            //cerr << d[s][l][1] << "\n";
        }
    }

    long long ans = d[n][k][0] + d[n][k][1];
    take_mod(ans);
    cout << ans;

    return 0;
}
