#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <fstream>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7, INF = 1e18;

mt19937_64 MyRand(0);
vector<ll> TopSort, p;
vector<bool> used;

void dfs(ll v) {
	used[v] = true;
	if (p[v] != -2) if(!used[p[v]])  dfs(p[v]);
	TopSort.push_back(v);
}

int main() {
	ll n;
	cin >> n;
	p.resize(n);
	used.resize(n);
	vector<ll> Used(n);
	ll ans = 0;
	for (auto &i : p) cin >> i;
	for (auto &i : p) i--;
	for (ll i = 0; i < n; i++) if (!used[i]) dfs(i);
	for (ll j = n - 1; j > -1; j--) {
		ll i = TopSort[j];
		if (Used[i] == 2) continue;
		if (p[i] != -2) if (Used[p[i]] == 1) continue;
		ans++;
		Used[i] = 1;
		if (p[i] != -2) Used[p[i]] = 2;
	}
	cout << ans;
}

