#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <fstream>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7, INF = 1e18;

mt19937_64 MyRand(0);
vector<ll> TopSort, p;
vector<vector<ll> > g;
vector<bool> used;

void dfs(ll v) {
	used[v] = true;
	//if (p[v] != -2) if(!used[p[v]])  dfs(p[v]);
	for (auto i : g[v])
		if (!used[i]) dfs(i);
	TopSort.push_back(v);
}

int main() {
	ll n;
	cin >> n;
	p.resize(n);
	used.resize(n);
	g.resize(n);
	vector<ll> Used(n);
	ll ans = 0;
	for (ll i = 0; i < n; i++) {
		ll prev;
		cin >> prev;
		p[i] = --prev;
		if (prev != -2) g[prev].push_back(i);
		if (prev != -2) g[i].push_back(prev);
	}
	for (ll i = 0; i < n; i++) if (!used[i]) dfs(i);
	for (ll j = 0; j < n; j++) {
		ll i = TopSort[j];
		if (Used[i] == 2) continue;
		if (p[i] != -2) if (Used[p[i]] == 1) continue;
		ans++;
		Used[i] = 1;
		if (p[i] != -2) Used[p[i]] = 2;
	}
	cout << ans;
}

