

#include "pch.h"
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>


using namespace std;


void DFS(vector<vector<int>> &a, vector<int> &v, vector<int> &color, int k) {
	for (int i : a[k]) {
		if (v[i] == 0) {
			v[i] = 1;
			color.push_back(i);
			DFS(a, v, color, i);
		}
	}
}


int main()
{
	int n;
	cin >> n;
	vector<vector<int>> a(n, vector<int>(0, 0));
	vector<vector<int>> color(0, vector<int>(0, 0));
	vector<int> v(n, 0), ord;
	for (int i = 0; i < n; ++i) {
		int j;
		cin >> j;
		if (j == -1) continue;
		--j;
		a[i].push_back(j);
		a[j].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		if (v[i] == 0) {
			color.push_back({i});
			v[i] = 1;
			DFS(a, v, color.back(), i);
		}
	}
	
	for (vector<int> c : color) {
		int s = int(c.size());
		if (s > 4) {
			ord.push_back(1);
		}
		else if (s == 1) {
			ord.push_back(1);
		}
		else if (s == 2) {
			ord.push_back(2);
		}
		else if (s == 3) {
			if (int(a[c[1]].size()) == 1 || int(a[c[2]].size()) == 1 || int(a[c[0]].size()) == 1) {
				ord.push_back(1);
			} else {
				ord.push_back(3);
			}
		}
		else if (s == 4) {
			for (int j : c) {
				if (int(a[j].size()) == 3) {
					if (!(a[j][0] == a[j][1] || a[j][0] == a[j][2] || a[j][1] == a[j][2])) {
						ord.push_back(2);
					}
				}
			}
		}
	}
	/*for (vector<int> c : color) {
		for (int i : c) {
			cout << i << " ";
		}
		cout << endl;
	}
	cout << "---" << endl;*/
	int maxel = 0, sum = 0;
	for (int k : ord) {
		sum += k;
		maxel = max(maxel, k);
	}
	if (2 * maxel > sum) {
		cout << (n - (maxel - (sum - maxel))) << endl;
	}
	else {
		cout << (n / 2) * 2 << endl;
	}
    //cout << "Hello World!\n"; 
}
