#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include <cmath>
#include <random>
#include <time.h>
#include <queue>

const int INF = 1e9 + 7;
typedef long long ll;

//#define int long long

using namespace std;

int n, m, k;
int cnt = 0;

vector<pair<int, int>> all;

vector<int> cur;
void gen()
{
    if (cur.size() == n)
    {
        for (auto x : all)
            if (cur[x.first] == cur[x.second])
                return;
        ++cnt;
        return;
    }
    for (int y = 0; y <= k; ++y)
    {
        bool ok = true;
        for (int t = 0; t < (int)cur.size() && ok; ++t)
            if ((cur[t] & y) != cur[t])
                ok = false;
        if (ok)
        {
            cur.push_back(y);
            gen();
            cur.pop_back();
        }
    }

}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    mt19937_64 rnd;
    rnd.seed(228);
   // freopen("input.txt", "r", stdin);

    cin >> n >> m >> k;
    for (int i = 0; i < m; ++i)
    {
        int l , r;
        cin >> l >> r;
        --l;
        --r;
        all.push_back({l, r});
    }
    gen();
    cout << cnt << '\n';

    return 0;

}
/*
4 5
4 1 2 4 4
4 3 2 1


*/
