#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include <time.h>

const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
typedef long long ll;

using namespace std;
const int MAXN = 5001;
int d[MAXN][MAXN][2];


#define int long long


int ans1(int n, int k)
{
    for (int i = n; i >= 0; --i)
    {
        for (int j = 0; j <= n; ++j)
        {
            for (int k = 0; k < 2; ++k)
                d[i][j][k] = 0;
        }
    }
    if (k != n)
        d[k][k][0] = 1;
    d[k][k][1] = 1;
    set<pair<pair<int, int>, int>> cur;
    cur.insert({{(k), k}, 0});
    cur.insert({{(k), k}, 1});
    long long ans = 0;
    while (!cur.empty())
    {
        auto x = (*cur.begin());
        cur.erase(cur.begin());
        int all = x.first.first;
        int last = x.first.second;
        bool nextmore = x.second;
        //cout << all << " " << last << " " << nextmore << '\n';
        //cout  << d[all][last][nextmore] << '\n';
        if (nextmore)
        {
            for (int i = last + 1; i + all <= n; ++i)
            {
                d[all + i][i][0] += d[all][last][nextmore];
                if (d[all + i][i][0] >= MOD)
                    d[all + i][i][0] %= MOD;
                if (all + i != n)
                    cur.insert({{(all + i), i}, 0});
            }
        }
        else
        {
            for (int i = 1; i < last && i + all <= n; ++i)
            {
                d[all + i][i][1] += d[all][last][nextmore];
                if (d[all + i][i][1] >= MOD)
                    d[all + i][i][1] %= MOD;
                if (all + i != n)
                    cur.insert({{(all + i), i}, 1});
            }
        }
    }
    for (int j = 0; j <= n; ++j)
    {
        for (int k = 0; k < 2; ++k){
            ans += d[n][j][k];
            if (ans >= MOD)
                ans %= MOD;
        }
    }
    return ans;// << '\n';

}

int ans2(int n, int k)
{
    for (int i = n; i >= 0; --i)
    {
        for (int j = 0; j <= n; ++j)
        {
            for (int k = 0; k < 2; ++k)
                d[i][j][k] = 0;
        }
    }
    if (k != n)
        d[n - k][k][0] = 1;
    d[n - k][k][1] = 1;
    set<pair<pair<int, int>, int>> cur;
    cur.insert({{-( n - k), k}, 0});
    cur.insert({{-(n - k), k}, 1});
    long long ans = 0;
    while (!cur.empty())
    {
        auto x = (*cur.begin());
        cur.erase(cur.begin());
        int all = -x.first.first;
        int last = x.first.second;
        bool nextmore = x.second;
       // cout << all << " " << last << " " << nextmore << '\n';
        if (nextmore)
        {
            for (int i = last + 1; i <= all; ++i)
            {
                d[all - i][i][0] += d[all][last][nextmore];
                if (d[all - i][i][0] >= MOD)
                    d[all - i][i][0] %= MOD;
                if (all + i != 0)
                    cur.insert({{-(all - i), i}, 0});
            }
        }
        else
        {
            for (int i = 1; i < last && i <= all; ++i)
            {
                d[all - i][i][1] += d[all][last][nextmore];
                if (d[all - i][i][1] >= MOD)
                    d[all - i][i][1] %= MOD;
                if (all - i != 0)
                    cur.insert({{-(all - i), i}, 1});
            }
        }
    }
    for (int j = 0; j <= n; ++j)
    {
        for (int k = 0; k < 2; ++k){
            ans += d[0][j][k];
            if (ans >= MOD)
                ans %= MOD;
        }
    }
    return ans;// << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    //freopen("input.txt", "r", stdin);
    srand(time(0));

    int n, k;
    cin >> n >> k;
    cout << ans2(n, k) << "\n";
    return 0;
    for (int i = 0; i < 200; ++i)
    {
        n = rand() % 10 + 1;
        k = rand() % n + 1;
        n = 9;
        k = 2;
        //cout << n << " " << k << '\n';
        //if (ans1(n, k) != ans2(n, k))
        {
            cout << n << " " << k<< '\n';
            cout << ans1(n, k) << " " << ans2(n, k) << "\n";
            return 0;
        }
    }





    return 0;
}
