#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include <time.h>

const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
typedef long long ll;

using namespace std;


vector<vector<int>> g;

vector<int> used;
vector<int> tsort;
int n;

void dfs(int v)
{
    used[v] = true;
    for (int u : g[v])
    {
        if (!used[u])
        dfs(u);
    }
    tsort.push_back(v);
}

void dfs2(int v)
{
    used[v] = true;
    for (int u : g[v])
    {
        used[u] = true;
    }
}

//#define int long long
int res()
{
    int cnt = 0;
    used.clear();
    used.resize(n);
    for (int i = 0; i < n; ++i)
    {
        if (!used[i])
        {
            ++cnt;
            dfs2(i);
        }
    }
    return cnt;
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    //freopen("input.txt", "r", stdin);
    srand(time(0));
    cin >> n;
    g.resize(n);
    used.resize(n);
    for (int i = 0; i< n; ++i)
    {
        int u;
        cin >> u;
        --u;
        if (u == -2)
            continue;
        g[u].push_back(i);
    }
    for (int i = 0; i< n; ++i)
    {
        if (!used[i])
            dfs(i);
    }
    reverse(tsort.begin(), tsort.end());
    int cnt = 0;
    used.clear();
    used.resize(n);
    for (int i = 0; i < n; ++i)
    {
        if (!used[tsort[i]])
        {
            ++cnt;
            dfs2(tsort[i]);
        }
    }
    cout << cnt << '\n';

    return 0;
}
