#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>

using namespace std;

int main()
{
    int n, k;
    cin >> n >> k;
    vector<vector<int> > A(n, vector<int>(k));
    for (int i=0; i<n; i++){
        for (int j=0; j<k; j++){
            cin >> A[i][j];
        }
    }
    if (k==1){
        vector<pair<int, int> > B;
        for (int i=0; i<n; i++){
            B.push_back(make_pair(A[i][0], i+1));
        }
        sort(B.begin(), B.end());
        cout << "YES" << endl;
        int uk1 = 0, uk2 = n-1;
        while (uk1<uk2){
            cout << B[uk1].second << " " << B[uk2].second << endl;
            uk1++;
            uk2--;
        }
    }
    else{
        vector<vector<pair<int, int> > > B(k);
        for (int i=0; i<n; i++){
            for (int j=0; j<k; j++){
                B[j].push_back(make_pair(A[i][j], i+1));
            }
        }
        for (int j=0; j<k; j++){
            sort(B[j].begin(), B[j].end());
        }

        vector<pair<int, int> > ans;
        vector<queue<int> > Q(1<<k);
        vector<int> W(n);
        for (int j=0; j<k; j++){
            for (int i=0; i<n; i++){
                W[i]*=2;
            }
            for (int i=n/2; i<n; i++){
                W[B[j][i].second-1]++;
            }

            /*for (int i=0; i<n; i++){
                cout << W[i] << " ";
            }
            cout << endl;*/
        }

        for (int i=0; i<n; i++){
            Q[W[i]].push(i+1);
        }
        bool q = true;
        vector<bool> E(n);
        /*for (int i=0; i<(1<<k); i++){
            cout << Q[i].size() << " " << Q[i].front() << "   ";
        }
        cout << endl;*/
        for (int i=0; i<n; i++){
            if (E[i]) continue;
            if (Q[(1<<k)-W[i]-1].size()==0){
                q = false;
                break;
            }
            ans.push_back(make_pair(Q[(1<<k)-W[i]-1].front(), Q[W[i]].front()));
            E[i] = true;
            E[Q[(1<<k)-W[i]-1].front()] = true;
            //cout << "W[i]: " << Q[W[i]].front() << ", (1<<k)...: " << Q[(1<<k)-W[i]-1].front() << endl;
            Q[(1<<k)-W[i]-1].pop();
            Q[W[i]].pop();
            //cout << "~W[i]: " << Q[W[i]].front() << ", ~(1<<k)...: " << Q[(1<<k)-W[i]-1].front() << endl;

        }
        /*for (int i=0; i<n; i++){
            cout << W[i] << " ";
        }
        cout << endl;*/
        if (q){
            cout << "YES" << endl;
            for (int i=0; i<n/2; i++){
                cout << ans[i].first << " " << ans[i].second << endl;
            }
        }
        else{
            cout << "NO" << endl;
        }
    }
}

