#include <bits/stdc++.h>

using namespace std;

//#define int long long

int m;
int sq;
vector <vector <int> > oc;
vector <int> DEC;

int count_sizes(int j) {
    int ans = 0;
    for (int i = 0; i < j - 1; ++i) ans += oc[i].size();
    return ans;
}

void rebuild(vector <int> tmp) {
    for (int i = 0; i < m; ++i) {
        if (tmp[i] == -1) break;
        oc[i / sq][i % sq] = tmp[i];
    }
    for (int i = 0; i < oc.size(); ++i) {
        int mi = m + 1;
        for (int j = 0; j < oc[i].size(); ++j) {
            mi= min(mi, oc[i][j]);
        }
        DEC[i] = mi;
    }
}

void split() {
    vector <int> tmp(m, -1);
    int zh = 0;
    for (int i = 0; i < oc.size(); ++i) {
        for (int j = 0; j < oc[i].size(); ++j) {
            tmp[zh] = oc[i][j];
            ++zh;
        }
    }
    oc.clear();
    rebuild(tmp);
}

void solve() {
    int n;
    cin >> m >> n;
    sq = sqrt(m);
    DEC.resize(m / sq);
    oc.resize(m / sq);
    vector <queue <int> > vh(m);
    int a[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        vh[a[i] - 1].push(i);
    }
    for (int i = 0; i < m; ++i) {
        int tmp;
        cin >> tmp;
        oc[i / sq].push_back(vh[tmp].front());
    }
    split();
    int id = 0, j = 0, anssize = 0;
    int ans[2 * n - 1];
    while (id < n) {
        if (oc[0].size() == 0) {
            split();
        }
        int tv = oc[0][0];
        oc[0].erase(oc[0].begin());
        vh[tv].pop();
        if (vh[tv].size() == 0) {
            ans[anssize] = m;
            ++anssize;
        }
        else {
            for (int j = m / sq - 1; j >= 0; --j) {
                if (vh[tv].front() > DEC[j]) {
                    for (int i = 0; i < oc[j].size(); ++i) {
                        if (vh[tv].front() > vh[oc[j][i]].front()) {
                            ans[anssize] = count_sizes(j) + i;
                            ++anssize;
                            oc[j].insert(oc[j].begin() + i + 1, vh[tv].front());
                            break;
                        }
                    }
                    break;
                }
            }
        }
    }
    cout << anssize << " ";
    for (int i = 0; i < anssize; ++i) cout << ans[i] << " ";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

