#include <bits/stdc++.h>

using namespace std;

#define int long long

vector <vector <int> > g;
vector <int> color;
vector <int> check;
int cnt = 0;
vector <int> vers;

void dfs1(int v) {
    check[v] = 1;
    vers.push_back(v);
    for (int i = 0; i < g[v].size(); ++i) {
        int u = g[v][i];
        if (check[u] == 0) dfs1(u);
    }
}

void dfs(int v, int cl) {
    //cout << v << " " << cl << " " << "!\n";
    if (cl == -1) color[v] = 1;
    else {
        bool check = 0;
        for (int i = 0; i < g[v].size(); ++i) {
            int u = g[v][i];
            if (color[u] == 1) {
                check = 1;
                break;
            }
        }
        if (check) color[v] = 2;
        else color[v] = 1;
    }
    if (color[v] == 1) ++cnt;
    for (int i = 0; i < g[v].size(); ++i) {
        int u = g[v][i];
        if (color[u] == -1) dfs(u, color[v]);
    }
}

void solve() {
    int n;
    cin >> n;
    g.resize(n);
    color.resize(n, -1);
    check.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        int v;
        cin >> v;
        --v;
        if (v != -2) {
            g[i].push_back(v);
            g[v].push_back(i);
        }
    }
    int ans1 = 0;
    for (int i = 0; i < n; ++i) {
        if (check[i] == 0) {
            //cout << i << "\n";
            dfs1(i);
            int ans = 0;
            for (int j = 0; j < vers.size(); ++j) {
                dfs(vers[j], -1);
                //cout << vers[j] << " " << cnt << "\n";
                ans = max(ans, cnt);
                cnt = 0;
                for (int k = 0; k < n; ++k) color[k] = -1;
            }
            ans1 += ans;
        }
    }
    cout << ans1;
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    solve();
    return 0;
}
