#include <bits/stdc++.h>
using namespace std;

#define FAST ios_base::sync_with_stdio(false); \
             cin.tie(nullptr); \
             cout.tie(nullptr)

#define ll long long

const int MOD = 1e9 + 7;
struct mint
    {
    ll val;

    mint (long long value)
        {
        val = value%MOD;
        }

    mint ()
        {
        val = 0;
        }

    void operator= (mint over)
        {
        val = over.val;
        }

    void operator= (ll value)
        {
        val = value%MOD;
        }

    mint operator+ (mint over)
        {
        return mint(val + over.val);
        }

    void operator+= (mint over)
        {
        val = (val + over.val)%MOD;
        }

    mint operator- (mint over)
        {
        return mint(val + MOD - over.val);
        }

    void operator-= (mint over)
        {
        val = (val + MOD - over.val)%MOD;
        }

    mint operator* (mint over)
        {
        return mint(val*over.val);
        }

    void operator*= (mint over)
        {
        val = (val*over.val)%MOD;
        }

    mint operator^ (ll grad)
        {
        if (grad == 0) return mint(1);

        mint answer = (*this)^(grad/2);
        answer*= answer;

        if (grad & 1) answer*= (*this);

        return answer;
        }

    mint operator^ (mint grad)
        {
        return (*this)^(grad.val);
        }
    };

long long n, m, k, a, b, c, tmp;

vector<ll> data;

mint ans;

int main()
    {
    FAST;

    cin >> n >> m >> k;

    ::data.resize(n);
    for (int i = 0; i < n; ++i)
        {
        ::data[i] = -1;
        }
    for (int i = 0; i < m; ++i)
        {
        cin >> a >> b;
        --a;
        --b;

        if (a > b) swap(a, b);
        if (::data[b] == 1 || ::data[b] > a) ::data[b] = a;
        }

    if (m == 0 && n <= 500 && k <= 500)
        {
        mint dt[500][501];

        for (int i = 0; i <= k; ++i)
            {
            dt[0][i] = 1;
            }

        for (int i = 1; i < n; ++i)
            {
            for (int j = 0; j <= k; ++j)
                {
                for (int l = 0; l <= j; ++l)
                    {
                    //cout << l << " " << j << " " << (l&j) << endl;

                    if ((l&j) == l)
                        {
                        dt[i][j]+= dt[i-1][l];
                        //cout << l << " " << j << endl;
                        }
                    }
                }
            }

        for (int i = 0; i <= k; ++i)
            {
            ans+= dt[n-1][i];
            }
        }



    cout << ans.val;
    }


