#include <iostream>
#include <vector>
#include <cstring>

using namespace std;

typedef long int i64;
typedef long unsigned int u64;
typedef int i32;
typedef unsigned int u32;

u32 nb(u64 a) {
    u32 n = 0;
    for (int i = 0; i < 64; i++) {
        if ((1 << i) & a) {
            n++;
        }
    }
    return n;
}

int main() {
   int n, m, k;
   cin >> n >> m >> k;
   u32 arr[k+1], narr[k+1];
   for (int i = 0; i <= k; i++) {
       arr[i] = 1;
   }
   int sarr[k+1];
   for (int i = 1; i < n; i++) {
       narr[0] = 1;
       memset(sarr, 0, sizeof(sarr));
       for (int j = 0; j <= k; j++) {
           sarr[nb(j)] = (sarr[nb(j)] + arr[j]) % 1000000007;
       }
       for (int j = 1; j <= k; j++) {
           sarr[j] = (sarr[j] + sarr[j-1]) % 1000000007;
       }
       for (int j = 1; j <= k; j++) {
           narr[j] = (narr[j] + sarr[j]) % 1000000007;
       }
       memcpy(arr, narr, sizeof(arr));
   }
   i64 s = 0;
   for (int i = 0; i <= k; i++) {
       s = (s + arr[i]) % 1000000007;
   }
   cout << s << endl;
}
