import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        long n = sc.nextLong();
        if (n % 4 == 2 || n % 4 == -2) System.out.println("none");
        else if (n <= 100000 && n >= -100000) {
            long a, b;
            if (n < 0) a = (long)Math.sqrt(-n - 1) + 1;
            else a = 0;
            for (;;a++) {
                b = (long)Math.sqrt(a*a + n);
                if (b*b == a*a + n) {
                    System.out.println(b);
                    break;
                }
            }
        } else if (n > 0) {
            // solving L^2 + 2AL = N for biggest L possible
            // If we do, (L + A)^2 = N + A^2
            long l;
            for (l = (long)Math.sqrt(n + 1) + 1; l > 0; l--) {
                long a = n / (2 * l) - l / 2;
                if (l * l + l * a * 2 == n) {
                    //System.out.println(a + " " + l);
                    break;
                }
            }
            System.out.println(l - l / 2 + n / (2 * l));
        }
    }
}
