import java.util.*;

public class Main {
    private static int dfsearch(int cur, int len, int ans, Set<Integer> s, List<Integer> l) {
        if (cur > len) return ans;
        int next = l.get(cur - 1);
        if (s.contains(cur)) return 0;

        boolean k = s.contains(next);
        if (!k && next != -1) s.add(next);
        int a = dfsearch(cur + 1, len, ans + 1, s, l);
        if (!k) s.remove(next);
        int b = dfsearch(cur + 1, len, ans, s, l);

        return Math.max(a, b);
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt(), i;
        Set<Integer> s = new HashSet<>();
        List<Integer> l = new ArrayList<>();

        for (i = 0; i < n; i++)
            l.add(sc.nextInt());

        if (n < 22)
            System.out.println(dfsearch(1, n, 0, s, l));
        else {
            int c = 0;
            for (i = 0; i < n; i++)
                l.add(sc.nextInt());
            for (i = n - 1; i >= 0; i--) {
                if (s.contains(i))
                    continue;
                c++;
                s.add(l.get(i));
            }
            System.out.println(c);
        }
    }
}
