#include <iostream>
#include <unordered_set>
#include <vector>
#include <algorithm>

using namespace std;
int dfgen(unordered_set<int>* s) {
    int i;
    for (i = 0; s->count(i); i++)
        s->erase(i);
    s->emplace(i);
    return i;
}

int dfsearch(int len, int* probs) {
    unordered_set<int> s;
    int c = 0;
    bool bad;
    while (dfgen(&s) < len) {
        bad = false;
        for (int i : s)
            if (s.count(probs[i] - 1))
                bad = true;

        if (bad) continue;
        c = max(c, (int)s.size());
    }
    return c;
}

int main() {
    int n, i, q;
    cin >> n;
    unordered_set<int> s;
    int* l = new int[n];

    for (i = 0; i < n; i++)
        cin >> l[i];
    if (n < 22)
        cout << (dfsearch(n, l));
    //else if (n > 180000)
        //cout << ((n + 1) / 2);
    else {
        int c = 0;
        for (i = n - 1; i >= 0; i--) {
            if (s.count(i + 1))
                continue;
            c++;
            s.emplace(l[i]);
        }
        cout << c;
    }

    delete[] l;
}