#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define sz(s) signed(s.size())
#define ft first
#define sd second
#define all(s) s.begin(),s.end()
#define rall(s) s.rbegin(),s.rend()

#define int long long

const int R = 1e9 + 7;

int n, k;

vector< vector<int> > dp[2];

int get(int t, int sum, int prev) {
	if (sum == n) { return 1; }
	// cout << t << " " << sum << " " << prev << endl;
	if (dp[t][sum][prev] != -1) return dp[t][sum][prev];
	dp[t][sum][prev] = 0;
	if (t == 0) {
		for (int i = 1; i < prev && i + sum <= n; ++i) {
			dp[t][sum][prev] += get(t ^ 1, sum + i, i);
			if (dp[t][sum][prev] > R) dp[t][sum][prev] -= R;
		}
	} else {
		for (int i = prev + 1; i + sum <= n; ++i) {
			dp[t][sum][prev] += get(t ^ 1, sum + i, i);
			if (dp[t][sum][prev] > R) dp[t][sum][prev] -= R;
		}

	}
	return dp[t][sum][prev];
}

void solve() {
	cin >> n >> k;
	if (n == k) {
		cout << 1 << endl;
		return;
	}
	dp[0].resize(n + 1, vector<int>(n + 1, -1));
	dp[1].resize(n + 1, vector<int>(n + 1, -1));
	cout << get(1, k, k) + get(0, k, k) << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}