#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define sz(s) signed(s.size())
#define ft first
#define sd second
#define all(s) s.begin(),s.end()
#define rall(s) s.rbegin(),s.rend()
// #define int long long

vector< vector<int> > g;
vector<int> col, p;

int get(int v) { return  (p[v] == v ? v : p[v] = get(p[v])); }
void unite(int a, int b) { 

	// /cout << "ff" << a << " " << b << endl;
	p[get(a)] = get(b);
}

int dfs(int v, int c) {
	col[v] = c;
	int cnt = 1;
	for (int to : g[v]) {
		if (col[to] == -1)
		cnt += dfs(to, c ^ 1);
	}
	return cnt;
}

void solve() {
	int n;
	cin >> n;
	p.resize(n);
	col.resize(n, -1);
	g.resize(n);
	iota(all(p), 0);
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];

		if (a[i] == -1) continue;
		--a[i];
		unite(i, a[i]);
		g[i].pb(a[i]);
		g[a[i]].pb(i);
	}
	vector<int> s(n), cnt(n);
	for (int i = 0; i < n; ++i) {
		if (col[i] == -1) {
			s[get(i)] = dfs(i, 0);
			// /cout << s[get(i)] << " " << col[i] << endl;
		}
		cnt[get(i)] += col[i];
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		ans += max(cnt[i], s[i] - cnt[i]);
	}
	cout << ans << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}