// B.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

const int mod = 1000000007;

int main()
{
	int n, k;
	cin >> n >> k;
	vector<vector<int> > dp0(n + 1, vector<int>(n + 1));
	vector<vector<int> > dp1(n + 1, vector<int>(n + 1));
	dp0[k][k] = 1, dp1[k][k] = 1;
	for (int j = 0; j < n; j++) {
		dp0[k][j + 1] += dp0[k][j];
		dp0[k][j + 1] %= mod;
	}
	for (int j = n; j >= 1; j--) {
		dp1[k][j - 1] += dp1[k][j];
		dp1[k][j - 1] %= mod;
	}
	for (int i = k + 1; i <= n; i++) {
		for (int j = 1; j <= i; j++) {
			dp1[i][j] += dp0[i - j][j - 1];
			dp1[i][j] %= mod;
			if (j < n) {
				dp0[i][j] += dp1[i - j][j + 1];
				dp0[i][j] %= mod;
			}
		}
		for (int j = 0; j < n; j++) {
			dp0[i][j + 1] += dp0[i][j];
			dp0[i][j + 1] %= mod;
		}
		for (int j = n; j >= 1; j--) {
			dp1[i][j - 1] += dp1[i][j];
			dp1[i][j - 1] %= mod;
		}
	}
	int ans = (dp0[n][n] + dp1[n][0]) % mod;
	if (n == k) {
		ans = (ans + mod - 1) % mod;
	}
	cout << ans << endl;
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
