// C.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int> > g;
vector<int> p, vs, dp0, dp1;
vector<vector<int> > comps;
vector<int> used;
int timer = 0;

void dfs(int u) {
	comps.back().push_back(u);
	used[u] = 1;
	for (int v : g[u]) {
		if (!used[v]) {
			dfs(v);
		}
	}
}

void calc_dp(int u, int c, int col) {
	//cout << "entered " << u << endl;
	used[u] = timer;
	dp1[u] = 1, dp0[u] = 0;
	for (int v : g[u]) {
		if (used[v] < timer) {
			calc_dp(v, c, col);
			dp1[u] += dp0[v];
			dp0[u] += max(dp1[v], dp0[v]);
		}
	}
	for (int v : g[u]) {
		if (v == vs[c]) {
			if (col == 1) dp1[u] = -1e9;
		}
	}
	//cout << "u = " << u << endl;
	//cout << dp0[u] << ' ' << dp1[u] << endl;
}

int main()
{
	ios::sync_with_stdio(0);
	int n;
	cin >> n;
	g.resize(n), used.resize(n), p.resize(n);
	for (int i = 0; i < n; i++) {
		int j;
		cin >> j;
		if (j != -1) {
			g[j - 1].push_back(i);
			g[i].push_back(j - 1);
			p[i] = j - 1;
		}
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			comps.push_back({});
			vs.push_back(-1);
			dfs(i);
			int u = i;
			for (int j = 0; j < (int)comps.back().size(); j++) {
				if (p[u] == -1) break;
				u = p[u];
			}
			vs.back() = u;
		}
	}
	dp0.resize(n), dp1.resize(n);
	used.assign(n, -1);
	int ans = 0;
	for (int i = 0; i < (int)vs.size(); i++) {
		calc_dp(vs[i], i, 0);
		timer++;
		//cout << "lol" << endl;
		int ans0 = dp0[vs[i]];
		calc_dp(vs[i], i, 1);
		timer++;
		int ans1 = dp1[vs[i]];
		//cout << ans0 << ' ' << ans1 << endl;
		ans += max(ans0, ans1);
	}
	cout << ans << endl;
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
