#include <iostream>
#include <vector>

using namespace std;

pair<int, int> get_tree(vector<int>* backs, int i, int bl1, int bl2)
{
    int sum1 = 0;
    int sum2 = 0;
    for(int j : backs[i])
        if(j != bl1 && j != bl2)
        {
            pair<int, int> x = get_tree(backs, j, -1, -1);
            sum1 += max(x.first, x.second);
            sum2 += x.first;
        }
    return make_pair(sum1, sum2 + 1);
}

int main()
{
    int n;
    cin >> n;
    int p[n];
    for(int i = 0; i < n; i++)
    {
        cin >> p[i];
        p[i]--;
    }
    vector<int> backs[n];
    for(int i = 0; i < n; i++)
        if(p[i] >= 0)
            backs[p[i]].push_back(i);
    int where[n];
    vector<vector<int> > loops;
    for(int i = 0; i < n; i++)
        where[i] = 0;
    for(int i = 0; i < n; i++)
    {
        vector<int> loop;
        int cur = i, start;
        while(where[cur] == 0)
        {
            where[cur] = 1;
            if(p[cur] < 0)
                goto end;
            cur = p[cur];
            if(where[cur] == 2)
                goto end;
        }
        if(where[cur] == 2)
            continue;
        start = cur;
        do
        {
            loop.push_back(cur);
            cur = p[cur];
        }
        while(cur != start);
        loops.push_back(loop);
    end:
        cur = i;
        while(cur >= 0 && where[cur] != 2)
        {
            where[cur] = 2;
            cur = p[cur];
        }
    }
    int ans = 0;
    for(vector<int>& loop : loops)
    {
        vector<int> dyna[4];
        dyna[0].resize(loop.size());
        dyna[1].resize(loop.size());
        dyna[2].resize(loop.size());
        dyna[3].resize(loop.size());
        pair<int, int> x1 = get_tree(backs, loop[0], loop[1], loop.back());
        dyna[0][0] = x1.first;
        dyna[1][0] = x1.second;
        dyna[2][0] = x1.first;
        dyna[3][0] = 0;
        for(int i = 1; i < loop.size(); i++)
        {
            pair<int, int> x = get_tree(backs, loop[i], loop[i - 1], loop[(i + 1) % loop.size()]);
            dyna[0][i] = max(dyna[0][i - 1], dyna[1][i - 1]) + x.first;
            dyna[1][i] = dyna[0][i - 1] + x.second;
            dyna[2][i] = max(dyna[2][i - 1], dyna[3][i - 1]) + x.first;
            dyna[3][i] = dyna[2][i - 1] + x.second;
        }
        ans += max(dyna[0].back(), max(dyna[2].back(), dyna[3].back()));
    }
    for(int i = 0; i < n; i++)
        if(p[i] < 0)
        {
            pair<int, int> x = get_tree(backs, i, -1, -1);
            ans += max(x.first, x.second);
        }
    cout << ans << endl;
    return 0;
}
