#include<set>
#include<map>
#include<list>
#include<cmath>
#include<vector>
#include<random>
#include<utility>
#include<iostream>
#include<iterator>
#include<algorithm>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    int n, ans = 0;
    cin >> n;

    vector<int> g(n);

    for (int i = 0; i < n; i++)
    {
        cin >> g[i];
        --g[i];
    }

    bool flag = true;

    for (int i = 1; i < n; i++)
    {
        flag = flag && (g[i] == i - 1);
    }

    if (flag)
    {
        cout << (n + 1) / 2;
        return 0;
    }

    for (int mask = 0; mask < 1 << n; mask++)
    {
        int cnt = 0;
        bool flag = true;
        for (int j = 0; j < n;  j++)
        {
            if ((mask >> j) & 1)
            {
                ++cnt;
                if (g[j] != -1 && ((mask >> g[j]) & 1))
                {
                    flag = false;
                    break;
                }
            }
        }

        if (flag)
        {
            ans = max(ans, cnt);
        }
    }

    cout << ans;
}