#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <string>

using namespace std;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

typedef long long ll;

long long n;
vector<int> graph[300001];
long long c[400000];
long long v, e, bl, wh;
ll dp[400000][2];

void dfs(int i)
{
    //cout << i << endl;
    c[i] = 1;
    v++;
    //dp[i][1] = 1;
    for (int j = 0; j < graph[i].size(); j++)
    {
        int u = graph[i][j];
        if (c[u] == 0)
        {
            dfs(u);
            e++;
            //dp[i][0] += max(dp[u][0], dp[u][1]);
            //dp[i][1] += dp[u][0];
        }
    }
}

void dfs2(int i)
{
    //cout << i << endl;
    c[i] = 2;
    dp[i][1] = 1;
    for (int j = 0; j < graph[i].size(); j++)
    {
        int u = graph[i][j];
        //cout << u << " " << c[u] << endl;
        if (c[u] == 1)
        {
            //cout << '!' << endl;
            dfs2(u);
            dp[i][0] += max(dp[u][0], dp[u][1]);
            dp[i][1] += dp[u][0];
        }
    }
}

long long solve(int i)
{
    v = 0;
    e = 0;
    bl = 0, wh = 0;
    dfs(i);
    if (e == v - 1)
    {
        dfs2(i);
        return max(dp[i][0], dp[i][1]);
    }
    return 0;
}

int main()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int a;
        cin >> a;
        if (a == -1)
            continue;
        graph[a].push_back(i);
        graph[i].push_back(a);
    }
    long long ans = 0;
    for (int i = 1; i <= n; i++)
    {
        if (c[i] == 0)
        {
            ans += solve(i);
        }
    }
    cout << ans;
    return 0;
}
