#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

typedef long long ll;

int n, k;
int a[50][20];
vector<int> perm;
int used[400];

void check()
{
    int t = 1;
    for (int j = 0; j < k; j++)
    {
        vector<pair<ll, ll> > segments;
        for (int i = 0; i < n; i += 2)
        {
            segments.push_back({a[perm[i]][j], a[perm[i + 1]][j]});
        }
        ll mina1 = - 1e9 - 7;
        ll maxa1 = 1e9 + 7;
        for (int i = 0; i < n / 2; i++)
        {
            mina1 = max(mina1, min(segments[i].first, segments[i].second));
            maxa1 = min(maxa1, max(segments[i].first, segments[i].second));
        }
        if (mina1 > maxa1)
        {
            t = 0;
            return;
        }
    }
    if (t)
    {
        cout << "YES\n";
        for (int i = 0; i < perm.size(); i++)
        {
            cout << perm[i] + 1 << " ";
            if (i % 2 == 1)
                cout << "\n";
        }
        exit(0);
    }
}

void rec(int x)
{
    if (x == 0)
    {
        check();
    }
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
        {
            used[i] = 1;
            for (int k = 0; k < n; k++)
            {
                if (!used[k])
                {
                    used[k] = 1;
                    perm.push_back(i);
                    perm.push_back(k);
                    rec(x - 1);
                    perm.pop_back();
                    perm.pop_back();
                    used[k] = 0;
                }
            }
            used[i] = 0;
        }
    }
}

int main()
{
    cin >> n >> k;
    if (k == 1)
    {
        vector<pair<int, int> > ds;
        for (int j = 0; j < n; j++)
        {
            int a;
            cin >> a;
            ds.push_back({a, j + 1});
        }
        sort(ds.begin(), ds.end());
        cout << "YES\n";
        for (int j = 0; j < n / 2; j++)
        {
            cout << ds[j].second << " " << ds[n - j - 1].second << "\n";
        }
        return 0;
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < k; j++)
        {
            cin >> a[i][j];
        }
    }
    rec(n / 2);
    cout << "NO";
    return 0;
}
