#include <bits/stdc++.h>

#define int long long
#define double long double
#define pr pair
#define vc vector
#define fs first
#define sc second
#define pb push_back
#define endd endl; return 0;
#ifdef LOCAL
#define cerr cout
#else
#define cerr if (0) cout
#endif
#define print(x) for (const auto &kek : x) { cerr << kek << ' '; } cerr << endl;

typedef long long ll;

using namespace std;

const int N = 1e5 + 5;
const int MOD = 1e9 + 7;

int isqr(int n) {
    if (n < 0) {
        return -1;
    }
    int l = 0, r = n + 1;
    while (r - l > 1) {
        int mid = (l + r) >> 1;
        if (mid * mid > n) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return l;
}

int isdd(int n) {
    if (n < 0) {
        return -1;
    }
    int k = sqrt(n);
    if (k * k == n) {
        return k;
    }
    k += 1;
    if (k * k == n) {
        return k;
    }
    k -= 2;
    return k;
}

int solve(int k) {
    int ans = 1e18;
    for (int i = 1; i * i <= abs(k); ++i) {
        if (abs(k) % i == 0) {
            int y = (i + k / i) / 2;
            int x = (k / i - y);
            if (y > 0 && x * x + k == y * y) {
                ans = min(ans, y);
            }
            y = (i + k / i) / 2;
            x = (i - y);
            if (y > 0 && x * x + k == y * y) {
                ans = min(ans, y);
            }
        }
    }
    return (ans == 1e18 ? -1 : ans);
}

int sotr(int k) {
    int ans = 1e18;
    k = abs(k);
    for (int i = 1; i * i <= abs(k); ++i) {
        if (abs(k) % i == 0) {
            int x = (i + k / i) / 2;
            int y = (k / i - x);
            cerr << x << ' ' << y << endl;
            cerr << x - y << ' ' << x + y << endl;
            cerr << i << ' ' << k / i << endl << endl;
            if (y > 0 && x * x - k == y * y) {
                ans = min(ans, y);
            }
            x = (i + k / i) / 2;
            y = (i - x);
            cerr << x << ' ' << y << endl;
            cerr << x - y << ' ' << x + y << endl;
            if (y > 0 && x * x - k == y * y) {
                ans = min(ans, y);
            }
        }
    }
    return (ans == 1e18 ? -1 : ans);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    // cout.precision(6); cout << fixed;
#ifdef LOCAL
    freopen("test.txt", "r", stdin);
#endif
    int k;
    cin >> k;
    srand(time(0));
    //k = -rand() % (int) 200;
    if (k == 0) {
        cout << 0 << endd;
    }
    cerr << k << endl;
    int ans = 1e18;
    //int si = (k < 0 ? -1 : 1);
    if (k < 0) {
        ans = sotr(k);
    } else {
        ans = solve(k);
    }
    if (ans == -1) {
        cout << "none\n";
    } else {
        cout << ans << endl;
    }
    cerr << endd;
    for (int x = 0; x <= abs(k); ++x) {
        //cerr << x << ' ' << x * x + k << endl;
        int root = isdd(x * x + k);
        //cerr << root << endl;
        if (root == -1) {
            continue;
        }
        if (root * root == x * x + k) {
            cerr << "ans: ";
            cout << root << endd;
        }
    }
    cout << "none";
    return 0;
}