#include <iostream>
#include <vector>
#include <algorithm>
#include <list>

typedef long long ll;

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<int> orders(m);
    for (int i = 0; i < m; i++)
    {
        cin >> orders[i];
        orders[i]--;
    }

    vector<int> cards(n);
    list<int> cardslist;
    for (int i = 0; i < n; i++)
    {
        cin >> cards[i];
        cards[i]--;
        cardslist.insert(cardslist.end(), cards[i]);
    }

    if (n == m)
    {
        bool flag = true;
        for (int i = 0; i < n; i++)
            if (orders[i] != cards[i])
                flag = false;

        if (flag)
        {
            cout << n << endl;
            for (int i = 0; i < n; i++)
                cout << n << " ";
            return 0;
        }

        flag = true;
        for (int i = 0; i < n; i++)
            if (orders[i] != cards[n - i - 1])
                flag = false;

        if (flag)
        {
            cout << 2 * n - 1 << endl;
            for (int i = n; i > 1; i--)
                cout << i << " ";
            for (int i = 0; i < n; i++)
                cout << n << " ";
            return 0;
        }
    }

    int cur = 0;
    int ans = 0;
    while (cur < m)
    {
        int x = *cardslist.begin();
        cardslist.erase(cardslist.begin());
        cardslist.insert(cardslist.end(), x);
        if (orders[cur] == x)
            cur++;
        ans++;
    }

    cout << ans << endl;
    for (int i = 0; i < ans; i++)
        cout << n << " ";

    return 0;
}