#include <bits/stdc++.h>

#define INT_INF (int)(2 * 1e9)
#define LL_INF  (ll)(2 * 1e18)

#define __LOCAL
#define FAST_IO ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 
#endif

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAX_N = 300111;

vector<int> g[MAX_N];
int n, dp[MAX_N][2];
bool used[MAX_N];

void dfs(int v)
{
	used[v] = true;

	dp[v][0] = 0;
	dp[v][1] = 1;

	for(auto u: g[v])
	{
		if(!used[u])
		{
			dfs(u);

			dp[v][0] += dp[u][1];
			dp[v][1] += dp[u][0];
		}
	}
}

void solve()
{
	cin >> n;

	for(int i = 0; i < n; ++i)
	{
		int a;
		cin >> a;
		--a;

		if(a >= 0)
		{
			g[i].push_back(a);
			g[a].push_back(i);
		}
	}

	int ans = 0;

	for(int v = 0; v < n; ++v)
	{
		if(!used[v])
		{
			dfs(v);

			ans += max(dp[v][0], dp[v][1]);
		}
	}

	cout << ans << endl;
}

int main()
{
	FAST_IO;
	solve();

	return 0;
}