#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <functional>

using namespace std;

const long long mod = 1000000007;

int main() {
	int n, k;
	cin >> n >> k;
	if (k == n) {
		cout << 1;
		return 0;
	}
	vector <vector <long long>> arr1(n + 1, vector <long long>(n + 1, 0));
	vector <vector <long long>> arr2(n + 1, vector <long long>(n + 1, 0));

	for (int i = k; i < n; i++) {
		arr1[k][i] = 1;
	}

	for (int i = k; i >= 1; i--) {
		arr2[k][i] = 1;
	}

	for (int x = k + 1; x <= n; x++) {
		for (int i = 1; i < n; i++) {
			arr1[x][i] = arr1[x][i - 1];
			if (x <= i) {
				continue;
			}
			arr1[x][i] += arr2[x - i][i + 1];
		}
		for (int i = n - 1; i >= 1; i--) {
			arr2[x][i] = arr2[x][i + 1];
			if (x <= i) {
				continue;
			}
			arr2[x][i] += arr1[x - i][i - 1];
		}
	}

	cout << arr1[n][n - 1] + arr2[n][1];
//	system("pause");
	return 0;
}