#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

#define endl "\n"

using namespace std;

void hello() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	cout.setf(ios::fixed);
	cout.precision(2);
}

long long get_sum(long long n) {
	n += (n - 1);
	long long s1 = n * (n + 1) / 2;
	n /= 2;
	long long s2 = n * (n + 1) / 2;
	return s1 - 2 * s2;  
}

int main() {
	hello();

	long long k;
	cin >> k;

	long long l = -1, r = 1e9;
	
	while (l < r - 1) {
		long long n = (r + l) / 2;
		long long s = get_sum(n);
		if (k + s >= 0)
			r = n;
		else 
			l = n;
	}

	long long start = r;
	for (long long i = start; i <= 1e8; ++i) {
		long long elem = get_sum(i) + k;
		long long tmp = (long long)sqrt(elem);
		if (tmp * tmp == elem) {
			cout << tmp << endl;
			return 0;
		}
	}

	cout << "none" << endl;
	
	return 0;
}