#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

#define endl "\n"

using namespace std;

void hello() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	cout.setf(ios::fixed);
	cout.precision(2);
}

long long get_sum(long long n) {
	n += (n - 1);
	long long s1 = n * (n + 1) / 2;
	n /= 2;
	long long s2 = n * (n + 1) / 2;
	return s1 - 2 * s2;  
}

int main() {
	hello();

	long long k;
	cin >> k;

	long long l = -1, r = 1e9;
	
	while (l < r - 1) {
		long long n = (r + l) / 2;
		long long s = get_sum(n);
		if (k + s >= 0)
			r = n;
		else 
			l = n;
	}

	long long K = k + get_sum(r);
	long long c = (long long)sqrt(K);
	if (c * c == K) {
		cout << c << endl;
		return 0;
	}
	int tmp = (2 * r + 1) / 2;

	for (int i = 0; i <= 1e8; ++i) {
		long long sum = get_sum(i);
		if (2 * i + 1 == K + 2 * i * tmp) {
			cout << (long long)sqrt(K + 2 * i + sum) << endl;
			return 0;
		}
	}

	cout << "none" << endl;
	
	return 0;
}