#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

#define endl "\n"

using namespace std;

void hello() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	cout.setf(ios::fixed);
	cout.precision(2);
}

long long get_sum(long long n) {
	n += (n - 1);
	long long s1 = n * (n + 1) / 2;
	n /= 2;
	long long s2 = n * (n + 1) / 2;
	return s1 - 2 * s2;  
}

const long long INF = 1e18;

int main() {
	hello();

	long long k;
	cin >> k;

	if (k >= 0) {
		if (k == 0) {
			cout << 0 << endl;
			return 0;
		}

		long long minb = INF;
		
		for (long long d = 1; d * d <= k; ++d) 
			if (k % d == 0) {
				long long d1 = d, d2 = k / d;
				if ((d2 + d1) % 2 == 0)
				 	minb = min(minb, (d2 + d1) / 2);
			}
		if (minb == INF)
			cout << "none" << endl;
		else 
			cout << minb << endl;
		
	}
	else {
		long long minb = INF;
		k = -k;
		for (long long d = 1; d * d <= k; ++d) 
			if (k % d == 0) {
				long long d1 = d, d2 = k / d;
				
				if ((d2 - d1) % 2 == 0)
				 	minb = min(minb, (d2 - d1) / 2);
			}
		if (minb == INF)
			cout << "none" << endl;
		else 
			cout << minb << endl;
	}
	return 0;
}