#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void hello() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
}

const int MOD = 1e9 + 7;

int main() {
	hello();

	int n, k;
	cin >> n >> k;

	if (n == k) {
		cout << 1 << endl;
		return 0;
	}

	vector<vector<vector<int> > > dp(n + 1, vector<vector<int> >(n + 1, vector<int>(2)));

	vector<vector<vector<int> > > prefix(n + 1, vector<vector<int> >(2, vector<int>(n + 1)));

	dp[k][k][0] = 1;
	dp[k][k][1] = 1;

	for (int i = k; i <= n; ++i) {
		prefix[k][0][i] = 1;
		prefix[k][1][i] = 1;
	}

	for (int sum = k + 1; sum <= n; ++sum)
		for (int num = 1; num <= n; ++num) 
			if (sum - num >= 0) {
				for (int flag = 0; flag <= 1; ++flag) 
					if (flag == 0) {
						dp[sum][num][flag] = prefix[sum - num][1][num - 1];
						prefix[sum][flag][num] = (prefix[sum][flag][num - 1] + dp[sum][num][flag]) % MOD;
					}
					else {
						dp[sum][num][flag] = prefix[sum - num][0][n] - prefix[sum - num][0][num];
						prefix[sum][flag][num] = (prefix[sum][flag][num - 1] + dp[sum][num][flag]) % MOD;
					}
			}
			else {
				prefix[sum][0][num] = prefix[sum][0][num - 1];
				prefix[sum][1][num] = prefix[sum][1][num - 1];
			}

	int ans = 0;
	for (int num = 1; num <= n; ++num)
		ans = (ans + dp[n][num][0] + dp[n][num][1]) % MOD;

	cout << ans << endl;
 
	return 0;
}

// 137529165
