#pragma GCC target("tune=native")
#include <bits/stdc++.h>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;

namespace trandom {
    struct random {
        u32 seed = chrono::high_resolution_clock::now().time_since_epoch().count() ^ (u32)(make_unique<i32>().get() - (i32 *)0);
        mt19937 engine;
        uniform_int_distribution<i32> dist;

        random(i32 l = numeric_limits<i32>::min(), i32 r = numeric_limits<i32>::max()):
            engine(seed),
            dist(l, r) {

        }

        i32 operator() () {
            return dist(engine);
        }
    } next;
}

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "w", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);

    i64 k;
    cin >> k;

    if (k == 0) {
        cout << 0 << endl;
    } else if (k % 2 == 0) {
        cout << "none" << endl;
    } else {
        if (k > 0) {
            i64 n = (k + 1) / 2;
            cout << n << endl;
        } else {
            i64 n = (-k + 1) / 2;
            cout << n - 1 << endl;
        }
    }
}