#pragma GCC target("tune=native")
#include <algorithm>
#include <vector>
#include <cassert>
#include <iostream>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "w", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);

    i32 n;
    cin >> n;

    i32 k;
    cin >> k;

    assert(k == 1);

    vector<i32> a(n);

    for (i32 i = 0; i < n; ++i) {
        cin >> a[i];
    }

    sort(a.begin(), a.end());

    if (a[n / 2 - 1] <= a[n / 2]) {
        cout << "YES" << endl;
        for (i32 i = 0; i < n / 2; ++i) {
            cout << i + 1 << " " << n - i << '\n';
        }
        cout << flush;
    } else {
        cout << "NO" << endl;
    }
}