#include "bits/stdc++.h"

using namespace std;

void check (int* M, int* Is, int* Bad, int n);
int Tree (int* M, int* Is, int* Bad, int n);
int check_tree (int* M, int n);int Circle (int* M, int* Is, int* Bad, int n);
void Clear (int* M, int* Is, int* Bad, int n);

int main ()
{
    int n = 0;
    cin >> n;
    int* M = new int [n];
    int* Bad = new int [n];
    int* Is = new int [n];


    for (int i = 0; i < n; i++)
    {
        M[i] = 0;
        Bad[i] = 0;
        Is[i] = 1;
    }

    for (int i = 0; i < n; i++)
    {
        cin >> M[i]; if (M[i] != -1) M[i] --;
        if (M[i] != -1) Bad[M[i]] = 1;
    }



    cout << Circle (M, Is, Bad, n);

    return 0;
}

int check_tree (int* M, int n)
    {
        int x = 0;
    for (int i = 0; i < n; i++)
    {
        x = i;
        while (1)
        {
            if (M[x] == -1) break;
            if (M[x] == i) return i;
            x = M[x];
        }
    }
    return -1;
    }

int Circle (int* M, int* Is, int* Bad, int n)
{
    int h = check_tree (M, n);
    int l = M[h];
    if (h == -1) return Tree (M, Is, Bad, n);
    else
    {
        int m = 0,  r = 5, z = 0;

        z = M[h];
        M[h] = -1;
        Is[h] = 0;
        r = Circle (M, Is, Bad, n);
        m = r;
        M[h] = z;
        Clear (M, Is, Bad, n);

        while (h != l)
        {
            z = M[l];
            M[l] = -1;
            Is[l] = 0;
            r = Circle (M, Is, Bad, n);

            if (m < r) m = r;
            M[l] = z;Clear (M, Is, Bad, n);

            l = M[l];
        }

    return r;
    }
}

int Tree (int* M, int* Is, int* Bad, int n)
    {
         int s = 0;
    vector<int> v1;
    vector<int> v2;
    while (1)
    {
        v1.clear ();
        check (M, Is, Bad, n);

        for (int i = 0; i < n; i++)
        {
            if (Bad[i] == 0 && Is[i] == 1) {v1.push_back(i); Is[i] = 0;}
        }

        for (int i = 0; i < v1.size (); i++)
        {
            if (M[v1[i]] != -1) Is[(M[v1[i]])] = 0;
        }

        s+= v1.size ();
        if (v1.size () == 0) break;
    }
    //if (s == 3) for (int i = 0; i < n; i++)cout << M[i] << " ";
    return s;
    }

void check (int* M, int* Is, int* Bad, int n)
{
    for (int i = 0; i < n; i++)
    {
        Bad[i] = 0;
    }
    for (int i = 0; i < n; i++)
    {
        if (Is[i] == 1) if (M[i] != -1) Bad[M[i]] = 1;
    }
}

void Clear (int* M, int* Is, int* Bad, int n)
{
    for (int i = 0; i < n; i++)
    {
        Bad[i] = 0;
        Is[i] = 1;
    }

    for (int i = 0; i < n; i++)
    {
        if (M[i] != -1) Bad[M[i]] = 1;
    }
}
