#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int mod = 1e9 + 7;
int ans = 0;

void gen(int& n, int& m, int& k, int now, vector<uint32_t>& num) {
	if (now == n + 1) {
		++ans;
		if (ans > mod)
			ans = 1;
	}
	else {
		for (uint32_t i = num[now - 1]; i <= k; ++i) {
			uint32_t res = i & num[now - 1];
			if (res == num[now - 1]) {
				num[now] = i;
				gen(n, m, k, now + 1, num);
			}
		}
	}
}

int main() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<uint32_t> num(n + 1);
	num[0] = 0;
	gen(n, m, k, 1, num);
	cout << ans;
}
