#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const uint32_t mod = 1e9 + 7;

uint64_t pow(uint32_t n, uint32_t deg) {
	if (deg == 0)
		return 1;
	if (deg % 2 == 0) {
		uint64_t n2 = pow(n, deg / 2);
		return (n2 * n2) % mod;
	}
	else
		return (n * pow(n, deg - 1)) % mod;
}

int main() {
	uint32_t n, m, k;
	cin >> n >> m >> k;
	uint64_t ans = 0;
	for (uint32_t num = 0; num <= k; ++num) {
		uint32_t digit = 0, cp_num = num;
		while (cp_num) {
			if (cp_num & 1)
				++digit;
			cp_num /= 2;
		}
		ans = (ans + pow(n, digit)) % mod;
	}
	cout << ans;
}
