#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <bitset>

using namespace std;

void sol1(int n, vector<int>& arr) {
	if (n > 20)
		return;
	int best = 0;
	bitset<20> used;
	for (uint32_t mask = 0; mask < (1 << n); ++mask) {
		for (int i = 0; i < 20; ++i)
			used[i] = 0;
		int cnt = 0;
		for (uint32_t i = 0; i < n; ++i)
			if ((mask >> i) & 1) {
				used[i] = 1;
				++cnt;
			}
		bool good = true;
		for (int i = 0; (i < n) && (good); ++i)
			if ((arr[i] != -2) && (used[i] == 1) && (used[arr[i]] == 1))
				good = false;
		if (good && (cnt > best))
			best = cnt;
	}
	cout << best;
	exit(0);
}

void sol2(int n, vector<int>& arr) {
	if (arr[0] != -2)
		return;
	for (int i = 1; i < n; ++i)
		if (arr[i] != i - 1)
			return;
	cout << (n + 1) / 2;
	exit(0);
}

int main() {
	int n;
	cin >> n;
	vector<int> arr(n);
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
		--arr[i];
	}
	sol1(n, arr);
	sol2(n, arr);
}
