#include <bits/stdc++.h>

using namespace std;

vector<int> dp1;
vector<int> dp2;
vector<vector<int>> g;
vector<bool> used;

/*
int [] dp1;
int [] dp2;
ArrayList<Integer> [] g;
boolean [] used;
*/

void dfs(int start) {
    used[start] = true;
    for (int v: g[start]) {
        if (!used[v]) {
            dfs(v);
            dp1[start] += dp2[v];
            dp2[start] += max(dp1[v], dp2[v]);
        }
    }
    dp1[start] += 1;
}



int main() {
    /*
    int n = nextInt();
    dp1 = new int[n];
    dp2 = new int[n];

    g = new ArrayList[n];

    for (int i = 0; i < n; i++) {
        g[i] = new ArrayList<>();
    }
    */

    int n;
    cin >> n;

    dp1 = vector<int>(n);
    dp2 = vector<int>(n);
    g = vector<vector<int>>(n);
    used = vector<bool>(n);


    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        a--;
        if (a < 0) {
            continue;
        }
        g[i].push_back(a);
        g[a].push_back(i);
    }

    //used = new boolean[n];
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
            ans += max(dp1[i], dp2[i]);
        }
    }
    cout << ans;
}
