#include <bits/stdc++.h>

using namespace std;

vector<int> dp1;
vector<int> dp2;
vector<vector<int>> g;
vector<bool> used;


void dfs(int start) {
    used[start] = true;
    for (int v: g[start]) {
        if (!used[v]) {
            dfs(v);
            dp1[start] += dp2[v];
            dp2[start] += max(dp1[v], dp2[v]);
        }
    }
    dp1[start] += 1;
}

vector<bool> sost;

int func(int k, int n) {
    if (k == n) {
        for (int i = 0; i < n; i++) {
            if (!sost[i]) {
                continue;
            }
            for (int v: g[i]) {
                if (sost[v]) {
                    return -1;
                }
            }
        }
        int ans = 0;
        for (int i = 0; i < n; i++) {
            if (sost[i]) {
                ans++;
            }
        }
        return ans;
    }

    int ans = -1;
    sost[k] = false;
    ans = max(ans, func(k + 1, n));
    sost[k] = true;
    ans = max(ans, func(k + 1, n));
    return ans;
}

int answering(int n) {
    sost = vector<bool>(n, false);
    int ans = func(0, n);
    cout << ans;
    return 0;
}

int main() {
    /*
    int n = nextInt();
    dp1 = new int[n];
    dp2 = new int[n];

    g = new ArrayList[n];

    for (int i = 0; i < n; i++) {
        g[i] = new ArrayList<>();
    }
    */

    int n;
    cin >> n;

    dp1 = vector<int>(n);
    dp2 = vector<int>(n);
    g = vector<vector<int>>(n);
    used = vector<bool>(n);


    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        a--;
        if (a < 0) {
            continue;
        }
        g[i].push_back(a);
        g[a].push_back(i);
    }

    if (n <= 20) {
        answering(n);
        return 0;
    }

    //used = new boolean[n];
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
            ans += max(dp1[i], dp2[i]);
        }
    }
    cout << ans;
}
