#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using  namespace std;

//#define DEBUG

int main() {
	int n, k;
	int Q = 1e9 + 7;
	cin >> n >> k;
	if (n == k) {
		cout << 1;
		return 0;
	}
	vector <vector <int>> dp_min(n + 2, vector <int>(n + 2, 0)), dp_max(n + 2, vector <int>(n + 2, 0));
	for (int i = k; i <= n; i++) {
		dp_min[k][i] = 1;
	}
	for (int i = 1; i <= k; i++) {
		dp_max[k][i] = 1;
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= i; j++) {
			dp_min[i][j] += dp_min[i][j - 1] + dp_max[i - j][j + 1];
			dp_min[i][j] %= Q;
		}
		for (int j = i; j >= 1; j--) {
			dp_max[i][j] += dp_max[i][j + 1] + dp_min[i - j][j - 1];
			dp_max[i][j] %= Q;
		}
	}
	int ans = (dp_min[n][n] + dp_max[n][1]) % Q;
	cout << ans;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}