#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <time.h>

using  namespace std;

//#define DEBUG

int semp1(int n, int k) {
	int Q = 1e9 + 7;
	//cin >> n >> k;
	if (n == k) {
		return 1;
	}
	vector <vector <int>> dp_min(n + 2, vector <int>(n + 2, 0)), dp_max(n + 2, vector <int>(n + 2, 0));
	dp_max[k][k] = 1;
	dp_min[k][k] = 1;
	for (int i = k; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			dp_min[i][j] += dp_min[i][j - 1] + (j <= i ? dp_max[i - j][j + 1] : 0);
			dp_min[i][j] %= Q;
		}
		for (int j = n; j >= 1; j--) {
			dp_max[i][j] += dp_max[i][j + 1] + (j <= i ? dp_min[i - j][j - 1] : 0);
			dp_max[i][j] %= Q;
		}
	}
	int ans = (dp_min[n][n] + dp_max[n][1]) % Q;
	return ans;
}

int sempl2(int n, int k) {
	int Q = 1e9 + 7;
	//cin >> n >> k;
	if (n == k) {
		return 1;
	}
	vector <vector <int>> dp_min(n + 1, vector <int>(n + 1, 0)), dp_max(n + 1, vector <int>(n + 1, 0));
	dp_max[k][k] = 1;
	dp_min[k][k] = 1;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= i; j++) {
			for (int k = 0; k <= i; k++) {
				if (j > k) {
					dp_max[i][j] += dp_min[i - j][k];
					dp_max[i][j] %= Q;
				}
				if (j < k) {
					dp_min[i][j] += dp_max[i - j][k];
					dp_min[i][j] %= Q;
				}
			}
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		ans += dp_max[n][i];
		ans %= Q;
		ans += dp_min[n][i];
		ans %= Q;
	}
	return ans;
}

int main() {
	int n, k;
	cin >> n >> k;
	cout << semp1(n, k);
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}