#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

long p;

long n, k;

long k3[10];

vector<vector<long>> a;

vector<pair<long, long>> ans;

vector<long> dp[10000];

vector<vector<long>> c;

vector<vector<vector<long>>> num1;
vector<vector<long>> num2;

bool com1(long i1, long i2) {
	return a[i1][p] < a[i2][p];
}

void sem(long i1, vector<long> &st) {
	if (i1 > 0) {
		for (long i = 0; i < 3; i++) {
			st.push_back(i);
			sem(i1 - 1, st);
			st.pop_back();
		}
	}
	else {
		long sum1 = 0;
		long sum2 = 0;
		for (auto i : st) {
			if (i == 1) {
				sum1++;
			}
			sum2 = sum2 * 3 + i;
		}
		num1[sum1].push_back(st);
		num2[sum1].push_back(sum2);
	}
}

long brek = 0;

void srez(long i1, long j1) {
	for (long i = i1; i <= k; i++) {
		if (dp[num2[i1][j1]].size() == 0) {
			break;
		}
		vector<vector<long>> met(k + 1, vector<long>(0, 0));
		for (long j = 0; j < num1[i].size(); j++) {
			if (dp[num2[i][j]].size() == 0) {
				continue;
			}
			long bul = 0;
			for (long y = 0; y < k; y++) {
				if ((num1[i1][j1][y] == num1[i][j][y]) && (num1[i1][j1][y] != 1)) {
					bul = -1;
					break;
				}
				else if ((num1[i1][j1][y] == num1[i][j][y]) && (num1[i1][j1][y] == 1)) {
					bul++;
				}
			}
			if (bul >= 0) {
				met[bul].push_back(j);
			}
		}
		for (long x = 0; x <= k; x++) {
			for (auto j : met[x]) {
				while ((dp[num2[i1][j1]].size() > 0) && (dp[num2[i][j]].size() > 0)) {
					pair<long, long> pro;
					pro.first = dp[num2[i1][j1]][dp[num2[i1][j1]].size() - 1];
					pro.second = dp[num2[i][j]][dp[num2[i][j]].size() - 1];
					ans.push_back(pro);
					dp[num2[i1][j1]].pop_back();
					dp[num2[i][j]].pop_back();
				}
				if (dp[num2[i1][j1]].size() == 0) {
					break;
				}
			}
			if (dp[num2[i1][j1]].size() == 0) {
				break;
			}
		}
	}
	if (dp[num2[i1][j1]].size() > 0) {
		brek = 1;
	}
}

long sup[10];

bool srav(long a1, long a2) {
	for (long i = 0; i < k; i++) {
		if ((c[a1][i] == c[a2][i]) && (c[a1][i] != 1)) {
			return false;
		}
	}
	return true;
}

bool per(vector<long> &pans, vector<long> &vz) {
	if (pans.size() < n) {
		for (long i = 0; i < n; i++) {
			if (vz[i] == 0) {
				vz[i] = 1;
				pans.push_back(i);
				if (per(pans, vz) == true) {
					return true;
				}
				pans.pop_back();
				vz[i] = 0;
			}
		}
		return false;
	}
	else {
		for (long i = 0; i < n; i = i + 2) {
			if (srav(pans[i], pans[i + 1]) == false) {
				return false;
			}
		}
		return true;
	}
}

int main() {
	k3[0] = 1;
	for (long i = 1; i < 10; i++) {
		k3[i] = 3 * k3[i - 1];
	}
	cin >> n >> k;
	a.resize(n, vector<long>(k, 0));
	vector<vector<long>> ind1(k, vector<long>(n, 0));
	for (long i = 0; i < n; i++) {
		for (long j = 0; j < k; j++) {
			cin >> a[i][j];
			ind1[j][i] = i;
		}
	}
	for (long i = 0; i < k; i++) {
		p = i;
		sort(ind1[i].begin(), ind1[i].end(), com1);
	}
	vector<long> b(k, 0);
	for (long i = 0; i < k; i++) {
		b[i] = a[ind1[i][n / 2 - 1]][i];
		if (a[ind1[i][n / 2 - 1]][i] < a[ind1[i][n / 2]][i]) {
			sup[i] = 1;
		}
	}
	c.resize(n, vector<long>(k, 0));
	for (long i = 0; i < n; i++) {
		long t = 0;
		for (long j = 0; j < k; j++) {
			if (a[i][j] < b[j]) {
				c[i][j] = 0;
			}
			else if (a[i][j] == b[j]) {
				if (sup[j] == 1) {
					c[i][j] = 0;
				}
				else {
					c[i][j] = 1;
				}
			}
			else {
				c[i][j] = 2;
			}
			t = t * 3 + c[i][j];
		}
		dp[t].push_back(i);
	}
	num1.resize(k + 1, vector<vector<long>>(0, vector<long>(k, 0)));
	num2.resize(k + 1, vector<long>(0, 0));
	vector<long> pde1;
	sem(k, pde1);
	if (n <= 10) {
		vector<long> pans;
		pans.push_back(0);
		vector<long> vz(10, 0);
		vz[0] = 1;
		if (per(pans, vz) == false) {
			cout << "NO";
		}
		else {
			cout << "YES\n";
			for (long i = 0; i < n; i = i + 2) {
				cout << pans[i] << ' ' << pans[i + 1] << '\n';
			}
		}
	}
	for (long i = 0; i < k; i++) {
		for (long j = 0; j < num1[i].size(); j++) {
			srez(i, j);
			if (brek == 1) {
				cout << "NO";
				return 0;
			}
		}
	}
	for (long i = 0; i < dp[num2[k][0]].size(); i++) {
		pair<long, long> pro;
		pro.first = dp[num2[k][0]][i];
		pro.first = dp[num2[k][0]][i + 1];
		ans.push_back(pro);
		i++;
	}
	cout << "YES\n";
	for (auto i : ans) {
		cout << i.first + 1 << ' ' << i.second + 1 << '\n';
	}
}