#include <iostream>
#include <vector>
#include <set>

using namespace std;


int n;


void rec(int u, int & res, vector<int> & a, vector<int> result, multiset<int> s)
{
    if (u == n)
    {
        for (int i: result)
        {
            if (s.find(i) != s.end())
            {
                return;
            }
        }

        res = max(res, (int) result.size());
        return;
    }
    result.push_back(u);
    s.insert(a[u]);
    rec(u + 1, res, a, result, s);
    s.erase(s.find(a[u]));
    result.pop_back();
    rec(u + 1, res, a, result, s);
}


int main()
{
    cin >> n;
    if (n > 20)
    {
        cout << n / 2 + n % 2 << endl;
    }
    vector<int> a(n);
    for (int i(0); i < n; ++i)
    {
        int f;
        cin >> f;
        f --;
        a[i] = f;
    }
    int res = 0;
    multiset<int> s;
    rec(0, res, a, {}, s);
    cout << res << endl;
    return 0;
}
