#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<iomanip>
#include<stdlib.h>
#include<math.h>
#include<cmath>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<stack>
#include<ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

ll INF = ll(1e18) * 2;
ll inf = 1e9;
ll MOD = 1e9 + 7;
ld eps = 1e-9;

struct lt {
	lt() {};
	lt(int val, int next) :val(val), next(next) {};
	int val;
	int next = -1;
};


signed main() {
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	vector<int>a(m);
	vector<lt>b(n);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i].val;
		if (i != n - 1) {
			b[i].next = i + 1;
		}
	}
	vector<int>ans;

	vector<int>need(n + 1, 0);
	int p = 0;

	for (int i = 0; i < m; ) {
		int fl = 0;
		while (fl == 0) {
			if (b[p].val == a[i]) {
				i++;
				fl = 1;
			}

			int cur = b[p].val;
			
			int cntneed = 0;
			for (int j = i; j < m && a[j] != cur; j++) {
				if (need[a[j]] == 0) cntneed++;
				need[a[j]] = 1;
			}

			if (cntneed == 0) {
				ans.push_back(1);
				continue;
			}


			int cntans = 1;
			int nt = b[p].next;

			for (int q = b[p].next; q != -1; q = b[q].next) {
				cntans++;
				if (need[b[q].val] == 1) cntneed--;
				need[b[q].val] = 0;
				if (cntneed == 0) {
					ans.push_back(cntans);
					b[p].next = b[q].next;
					b[q].next = p;
					p = nt;
					break;
				}
			}

		}
	}

	cout << ans.size() << '\n';
	for (auto now : ans) {
		cout << now << ' ';
	}


	return 0;
}