#include <bits/stdc++.h>
#define MAX (int)(1e5) + 7
#define INF (int)(1e9) + 7
#define sz(a) (int)((a).size())

using namespace std;

int n, k;
long long ans;
vector<int> v;

void info(vector<int>& v) {
    for (auto &i : v) cout << i << " ";
    cout << endl;
}

long long mod(long long a, long long b) {
    return ((a + b) % (INF) + (INF)) % (INF);
}

bool check() {
    for (int i = 1; i < sz(v) - 1; ++i) {
        if (!((v[i - 1] < v[i] && v[i] > v[i + 1]) || (v[i - 1] > v[i] && v[i] < v[i + 1]))) return false;
    }
    return true;
}

void gen(int sm) {
    if (sm == n) {
        if (check()) ans = mod(ans, 1LL);
    }
    else {
        for (int i = 1; i + sm <= n; ++i) {
            if (i != v[sz(v) - 1]) {
                v.push_back(i);
                gen(sm + i);
                v.pop_back();
            }
        }
    }
}



void start() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int main() {
    start();

    cin >> n >> k;

    v.push_back(k);

    gen(k);

    cout << ans << endl;
}
