#include <bits/stdc++.h>
#define MAX (int)(1e5) + 7
#define INF (int)(1e9) + 7
#define sz(a) (int)((a).size())

using namespace std;

int n;
int ans;
vector<int> used;
vector<int> ms;

void info(vector<int>& v) {
    for (auto &i : v) cout << i << " ";
    cout << endl;
}

void start() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

bool check() {
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            if (ms[i] == - 1) continue;
            if (used[ms[i]]) return false;
        }
    }

    return true;
}

int main() {
    start();

    cin >> n;
    ms.resize(n);
    used.resize(n);

    if (n > 20) {
        cout << (n + 1) / 2 << endl;
        return 0;
    }

    for (int i = 0; i < n; ++i) {
        int u;
        cin >> u;
        if (u != -1) --u;


        ms[i] = u;
    }

    for (int mask = 1; mask <= (1 << (n)) - 1; ++mask) {
        fill(used.begin(), used.end(), 0);
        int cur = 0;

        for (int i = n - 1; i >= 0; --i) {
            if ((mask >> i) & 1) {
                used[i] = 1;
                ++cur;
            }
        }

        if (check()) ans = max(ans, cur);
    }

    cout << ans << endl;
}
