#include <bits/stdc++.h>
#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));
vector <int> steps(1e6);
vector <vector <int> > sparse;

int ind(const vector <int>&num, int x) {
    if (lower_bound(num.begin(), num.end(), x) == num.end()) return -1;
    return lower_bound(num.begin(), num.end(), x) - num.begin();
}

vector <vector <int> > build_sparse(const vector <int>&num) {
    vector <vector <int> > res;
    int n = num.size();
    vector <int> smth;
    for (int i = 0; i < n; i++) {
        smth.push_back(num[i]);
    }
    res.push_back(smth);
    for (int x = 1; x < 20; x++) {
        if ((1 << x) > n) break;
        vector <int> kek;
        for (int j = 0; j < n - (1 << x) + 1; j++) {
            kek.push_back(min(res[x - 1][j], res[x - 1][j + (1 << (x - 1))]));
        }
        res.push_back(kek);
    }
    return res;
}

int get_min(int l, int r) {
    int len = r - l + 1;
    int x = steps[len];
    return min(sparse[len][l], sparse[len][l + (1 << x)]);
}

void precalc() {
    for (int i = 0; i < steps.size(); i++) {
        int l = 0;
        int r = 23;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if ((1 << m) <= i) l = m;
            else r = m;
        }
        steps[i] = l;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    /**precalc();
    int n;
    cin >> n;
    vector <int> num(n);
    cout << steps[13] << "\n";
    for (int i = 0; i < n; i++) cin >> num[i];
    sparse = build_sparse(num);
    for (int i = 0; i < sparse.size(); i++) {
        for (auto el : sparse[i]) cout << el << " ";
        cout << "\n";
    }**/
    int k;
    cin >> k;
    /**int x = 0;
    while (x * x <= 1e16) {
       // cout << x << endl;
        int smth = k + x * x;
        if (smth < 0) {x++; continue;}
        int kek = (int)sqrt(smth);
        if (kek * kek == smth) {
            cout << kek << "\n";
            return 0;
        }
        x++;
    }
    cout << "none\n";**/
    vector <pair <int, int> > num;
    int i = 1;
    while (i * i <= k) {
        if (k % i == 0) {
            num.push_back({i, k / i});
        }
        i++;
    }
    int ans = 1e18;
    for (auto el : num) {
        int p = el.first;
        int q = el.second;
        int sum = p + q;
        if (sum % 2 == 0) {
            int y = sum / 2;
            //cout << y << "fjsdo\n";
            //int kek = sqrt(y);
            ans = min(ans, y);
        }
    }
    if (ans == 1e18)
        cout << "none\n";
    else cout << ans;
    return 0;
}
