#include <bits/stdc++.h>
#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")

using namespace std;

mt19937 rnd(time(nullptr));
vector <int> steps(1e6);
vector <vector <int> > sparse;

int ind(const vector <int>&num, int x) {
    if (upper_bound(num.begin(), num.end(), x) == num.end()) return -1;
    return num[upper_bound(num.begin(), num.end(), x) - num.begin()];
}

vector <vector <int> > build_sparse(const vector <int>&num) {
    vector <vector <int> > res;
    int n = num.size();
    vector <int> smth;
    for (int i = 0; i < n; i++) {
        smth.push_back(num[i]);
    }
    res.push_back(smth);
    for (int x = 1; x < 20; x++) {
        if ((1 << x) > n) break;
        vector <int> kek;
        for (int j = 0; j < n - (1 << x) + 1; j++) {
            kek.push_back(min(res[x - 1][j], res[x - 1][j + (1 << (x - 1))]));
        }
        res.push_back(kek);
    }
    return res;
}

int get_min(int l, int r) {
    int len = r - l + 1;
    int x = steps[len];
    return min(sparse[len][l], sparse[len][l + (1 << x)]);
}

void precalc() {
    for (int i = 0; i < steps.size(); i++) {
        int l = 0;
        int r = 23;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if ((1 << m) <= i) l = m;
            else r = m;
        }
        steps[i] = l;
    }
}

const int mod = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    /**precalc();
    int n;
    cin >> n;
    vector <int> num(n);
    cout << steps[13] << "\n";
    for (int i = 0; i < n; i++) cin >> num[i];
    sparse = build_sparse(num);
    for (int i = 0; i < sparse.size(); i++) {
        for (auto el : sparse[i]) cout << el << " ";
        cout << "\n";
    }**/
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    vector <vector <int> > dp1(n + 3, vector <int> (n + 3, 0));
    vector <vector <int> > dp2(n + 3, vector <int> (n + 3, 0));
    vector <vector <int> > pref2(n + 3, vector <int> (n + 3, 0));
    vector <vector <int> > suff1(n + 3, vector <int> (n + 3, 0));
    dp1[k][k] = 1;
    dp2[k][k] = 1;
    for (int i = k; i <= n; i++) {
        pref2[k][i] = 1;
    }
    for (int i = 1; i <= k; i++) {
        suff1[k][i] = 1;
    }
    for (int i = k + 1; i < dp1.size(); i++) {
        /**for (int p = 0; p < pref2.size(); p++) {
            for (auto el : pref2[p]) cout << el << " ";
            cout << "\n";
        }
        cout << "\n\n";**/
        for (int j = 1; j <= n; j++) {
            if (i - j >= 0) {
                dp1[i][j] += suff1[i - j][j + 1];
                dp1[i][j] %= mod;
                pref2[i][j] += (dp1[i][j] + pref2[i][j - 1]);
                pref2[i][j] %= mod;
            }
        }
        for (int j = n; j >= 1; j--) {
            if (i - j >= 0) {
                dp2[i][j] += pref2[i - j][j - 1];
                dp2[i][j] %= mod;
                suff1[i][j] += (dp2[i][j] + suff1[i][j + 1]);
                suff1[i][j] %= mod;
            }
        }
            /**
            for (int prev = j + 1; prev <= n; prev++) {
                if (i - j >= 0) {
                    dp1[i][j] += dp2[i - j][prev];
                    dp1[i][j] %= mod;
                }
            }
            for (int prev = 1; prev < j; prev++) {
                if (i - j >= 0) {
                    dp2[i][j] += dp1[i - j][prev];
                    dp2[i][j] %= mod;
                }
            }**/
    }
    int ans = 0;
    for (int i = 0; i < dp1[n].size(); i++) {
        ans += dp1[n][i];
        ans %= mod;
        ans += dp2[n][i];
        ans %= mod;
    }
    cout << ans << "\n";
    return 0;
}
