#include <iostream>
#include <cmath>
#include <vector>
#include <assert.h>
using namespace std;

#define int long long


int sq(int a)
{
    int res = sqrt(a);
    while(res * res < a)
        ++res;
    while(res * res > a)
        --res;
    return res;
}

signed main()
{
    int k;
    cin >> k;

    int ans = 1e18;
    for(int n = 1; n < 1e6 + 500; ++n)
    {
        int left = -1e13;
        int right = 1e13;
        while(left + 1 != right)
        {
            int a = (left + right) / 2;
            if((a + n - 1) * n > k)
            {
                right = a;
            }
            else
            {
                left = a;
            }
        }
        int q = (int)sqrt((left / 2) * (left / 2) + k);
        if(q * q == (left / 2) * (left / 2) + k)
        {
            ans = min(ans, q);
        }
    }
    if(ans == 1e18)
        cout << "none";
    else
        cout << ans;
}