#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <algorithm>
#include <assert.h>
using namespace std;

#define int long long




signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> want(m);
    vector<int> b(n);

    for(int i = 0; i < m; ++i) cin >> want[i];
    for(int i = 0; i < n; ++i) cin >> b[i];
    for(int i = 0; i < m; ++i) want[i]--;
    for(int i = 0; i < n; ++i) b[i]--;
    reverse(b.begin(), b.end());
    set<pair<int, int>> freee;
    vector<int> ans(1e6);
    int cur = 0;
    for(int i = 0; i < m; ++i)
    {
        auto it = freee.lower_bound({want[i], -1});
        if(it != freee.end() && it->first == want[i])
        {
            int otv = 0;
            for(auto j : freee)
            {
                if(j.second >= it->second)
                    ++otv;
            }
            ans[it->second] = otv;
            int x = it->first;
            freee.erase(it);
            freee.insert({x, cur++});
        }
        else
        {
            while(b.back() != want[i])
            {
                freee.insert({b.back(), cur++});
                b.pop_back();
            }
            freee.insert({b.back(), cur++});
            b.pop_back();
        }
    }
    cout << cur << '\n';
    for(int i = 0; i < cur; ++i)
    {
        if(ans[i] == 0)
            cout << n << " ";
        else
            cout << ans[i] << " ";
    }
}