//{

#include <bits/stdc++.h>

#define all(x) (x).begin (), (x).end ()
#define rall(x) (x).rbegin (), (x).rend ()

#define LOCAL

using namespace std;

using lli = long long;
using ld = long double;

mt19937 rnd (time (nullptr));

//}

void DFS (vector <vector <int>>& tree, vector <bool>& used, vector <vector <int>>& dp, int v, int p)
{
    used[v] = true;
    dp[v][1] = 1;
    for (int u : tree[v])
    {
        if ((u == p) || (used[u]))
            continue;
        DFS (tree, used, dp, u, v);
        dp[v][1] += dp[u][0];
        dp[v][0] += dp[v][1];
    }
}

inline void Solve ()
{
    int n = 0;
    cin >> n;
    vector <int> data (n);
    bool flag = true;
    for (int i = 0; i < n; i++)
    {
        int p = 0;
        cin >> p;
        p--;
        if (p > i)
        {
            flag = false;
            //break;
        }
    }
    /*if (!flag)
    {
        int result = n / 2 + (n % 2);
        cout << result;
    }*/
    if (flag)
    {
        vector <vector <int>> tree (n);
        for (int i = 0; i < n; i++)
        {
            if (data[i] == -1)
                continue;
            tree[i].push_back (data[i]);
            tree[data[i]].push_back (i);
        }
        vector <vector <int>> dp (n, vector <int> (2));
        vector <bool> used (n);
        int result = 0;
        for (int i = 0; i < n; i++)
        {
            if (!used[i])
            {
                DFS (tree, used, dp, i, -1);
                result += max (result, max (dp[i][0], dp[i][1]));
            }
        }
        cout << result;
    }
    else
    {
        assert (false);
    }
}

signed main ()
{
#ifndef LOCAL
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    cout.tie (nullptr);
#endif
    Solve ();
    return 0;
}
