//{

#include <bits/stdc++.h>

#define all(x) (x).begin (), (x).end ()
#define rall(x) (x).rbegin (), (x).rend ()

#define LOCAL

using namespace std;

using lli = long long;
using ld = long double;

mt19937 rnd (time (nullptr));

//}

vector <vector <lli>> graph, graph_t;
vector <bool> used;
vector <lli> order;
vector <lli> comp;
vector <vector <lli>> buffer;
vector <lli> sz;
vector <vector <lli>> dp;

void DFS1 (lli v)
{
    used[v] = true;
    for (lli u : graph[v])
    {
        if (!used[u])
            DFS1 (u);
    }
    order.push_back (v);
}

void DFS2 (lli v, lli c)
{
    used[v] = true;
    comp[v] = c;
    buffer.back ().push_back (v);
    sz[c]++;
    for (lli u : graph_t[v])
    {
        if (!used[u])
            DFS2 (u, c);
    }
}

void DFS3 (lli v)
{
    dp[v][1] = 1;
    for (lli u : graph[v])
    {
        assert (sz[comp[u]] == 1);
        DFS3 (u);
        dp[v][1] += dp[u][0];
        dp[v][0] += max (dp[u][0], dp[u][1]);
    }
}

inline void Solve ()
{
    lli n = 0;
    cin >> n;
    graph.resize (n);
    graph_t.resize (n);
    used.resize (n);
    comp.resize (n);
    for (lli i = 0; i < n; i++)
    {
        lli p = 0;
        cin >> p;
        if (p == -1)
            continue;
        p--;
        graph[p].push_back (i);
        graph_t[i].push_back (p);
    }

    for (lli i = 0; i < n; i++)
    {
        if (!used[i])
            DFS1 (i);
    }
    reverse (all (order));
    used.assign (n, false);
    lli color = 0;
    for (lli v : order)
    {
        if (!used[v])
        {
            buffer.push_back (vector <lli> ());
            sz.push_back (0);
            DFS2 (v, color);
            color++;
        }
    }

    lli result = 0;
    dp.resize (n, vector <lli> (2));
    for (lli i = 0; i < n; i++)
    {
        if (sz[comp[i]] >= 2)
        {
            //assert (sz[comp[i]] >= 3);
            dp[i][0] = 0;
            dp[i][1] = 1;
            for (lli u : graph[i])
            {
                if (sz[comp[u]] == 1)
                {
                    DFS3 (u);
                    dp[i][1] += dp[u][0];
                    dp[i][0] += max (dp[u][0], dp[u][1]);
                }
            }
        }
        else if ((sz[comp[i]] == 1) && (graph_t[i].empty ()))
        {
            DFS3 (i);
            result += max (dp[i][0], dp[i][1]);
        }
    }

    for (lli i = 0; i < buffer.size (); i++)
    {
        if (buffer[i].size () == 1)
        {
            continue;
        }
        //f, y/n
        vector <vector <lli>> next (2, vector <lli> (2));
        next[0][0] = dp[buffer[i][0]][0];
        next[1][1] = dp[buffer[i][0]][1];
        for (lli j = 1; j < buffer[i].size (); j++)
        {
            lli v = buffer[i][j];
            vector <vector <lli>> next1 (2, vector <lli> (2));
            next1[0][0] = max (next[0][0], next[0][1]) + dp[v][0];
            next1[0][1] = next[0][0] + dp[v][1];
            next1[1][0] = max (next[1][0], next[1][1]) + dp[v][0];
            /*if (((buffer[i].size () == 2) || (buffer[i].size () % 2 != 0)) && (j + 1 == buffer[i].size ()))
            {
                next = next1;
                continue;
            }*/
            next1[1][1] = next[1][0] + dp[v][1];
            next = next1;
        }
        lli ans = max (next[0][0], max (next[0][1], next[1][0]));
        if ((buffer[i].size () == 2) || (buffer[i].size () % 2 != 0))
        {
            result += ans;
            continue;
        }
        ans = max (ans, next[1][1]);
        result += ans;
    }
    cout << result;
}

signed main ()
{
#ifndef LOCAL
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    cout.tie (nullptr);
#endif
    Solve ();
    return 0;
}
