#include <bits/stdc++.h> 
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2")
//#include <ext/pb_ds/assoc_container.hpp>
#define int long long 
#define pb push_back 
#define eb emplace_back 
#define ff first
#define ss second
#define pii pair<int, int>
#define mp make_pair
#define all(x) x.begin(), x.end() 

using namespace std;
typedef long long ll; 
typedef long double ld; 
const int maxn = 1e6 + 7, inf = 1e9, MAXN = 1e6 + 7; 
const double eps = 1e-9;
mt19937 rnd(time(0)); 
int n, m; 
int a[maxn], b[maxn]; 
int id[maxn]; 
int used[maxn]; 
int ord[maxn]; 
int id1[maxn];

struct node {
    int l, r, x; 
    node(int l, int r, int x) : l(l), r(r), x(x) {} 
    node() : l(0), r(0), x(0) {}
};
 
struct Tree {
    vector<node> tree;
    int len = 1;
    vector<int> root; 

    int get(int l, int r, int l1, int r1, int rt) {
        if (l >= l1 && r <= r1) {
            return tree[rt].x;
        } 
        if (max(l, l1) > min(r, r1)) {
            return 0; 
        }
        int t = (l + r) / 2; 
        return get(l, t, l1, r1, tree[rt].l) + get(t + 1, r, l1, r1, tree[rt].r); 
    }

    int add(int l, int r, int l1, int r1, int rt) {
        if (l >= l1 && r <= r1) {
            node p; 
            p.x = 1; 
            tree.pb(p); 
            return tree.size() - 1; 
        }
        if (max(l, l1) > min(r, r1)) {
            return rt;
        }
        int t = (l + r) / 2; 
        int L = add(l, t, l1, r1, tree[rt].l);
        int R = add(t + 1, r, l1, r1, tree[rt].r); 
        node p;
        p.l = L;
        p.r = R;
        p.x = tree[L].x + tree[R].x; 
        tree.pb(p); 
        return tree.size() - 1;
    }

    void build(vector<int> &have) {
        root.resize(have.size() + 1);
        while (len <= have.size()) {
            len <<= 1; 
        }
        tree.resize(len + len - 1); 

        deque<int> cnt[maxn];

        for (int i = 0; i < have.size(); ++i) {
            cnt[have[i]].pb(i);            
            if (cnt[have[i]].size() == 1) {
                tree[i + len - 1].x = 1; 
            }
        }                                   
        for (int i = len - 1; i < tree.size(); ++i) {
            tree[i].l = i; 
            tree[i].r = i;
        }
        for (int i = len - 2; i >= 0; --i) {
            tree[i].l = i * 2 + 1;
            tree[i].r = i * 2 + 2; 
            tree[i].x = tree[i * 2 + 1].x + tree[i * 2 + 2].x; 
        }
        for (int i = 0; i < have.size(); ++i) {
            cnt[have[i]].pop_front();
            if (cnt[have[i]].size()) {
                int id = cnt[have[i]][0]; 
                root[i + 1] = add(0, len - 1, id, id, root[i]);
            } else {
                root[i + 1] = root[i]; 
            }
        }
    }
    int req(int l, int r) {
        return get(0, len - 1, l, r, root[l]); 
    }

};

Tree hui;

vector<node> root;     
 
void solve() {
    cin >> n >> m; 
    for (int i = 0; i < maxn; ++i) {
        ord[i] = n;  
        id1[i] = -1;
    }
    for (int i = 0; i < m; ++i) {
        cin >> a[i]; 
    }
    for (int i = 0; i < n; ++i) {        
        cin >> b[i]; 
        id[b[i]] = i;
    }
    int ans = 0; 
    int lst = 0;
    vector<int> del;
    for (int i = 0; i < m; ++i) {
        if (used[a[i]]) {            
            del.pb(a[i]); 
            ++ans;
            continue; 
        }                        
        int to = id[a[i]];
        for (int j = lst; j <= to; ++j) {
            used[b[j]] = 1; 
            del.pb(b[j]); 
            ++ans;
        }    
        lst = to + 1; 
    }    
    hui.build(del); 

    for (int i = ans - 1; i >= 0; --i) {
        if (id1[del[i]] != -1) {
            root.eb(i, id1[del[i]], i); 
        }        
        id1[del[i]] = i;    
    }
    for (int i = 0; i < root.size(); ++i) {
        int l = root[i].l, r = root[i].r; 
        ord[root[i].x] = hui.req(l, r); 
    }    
    cout << ans << '\n'; 
    for (int i = 0; i < ans; ++i) {
            cout << ord[i] << " ";
        }

}

signed main() {
#ifdef LOCAL 
  freopen("TASK.in", "r", stdin);
  freopen("TASK.out", "w", stdout);
#endif        
    ios_base::sync_with_stdio(false); 
    cin.tie(0);
    cout.precision(20); 
    cout << fixed; 
    solve(); 
    return 0; 
}