/*
    cout << __buitin_cpu_supports("sse") << "\n";
    cout << __buitin_cpu_supports("sse4.1") << "\n";
    cout << __buitin_cpu_supports("avx") << "\n";
    cout << __buitin_cpu_supports("avx2") << "\n";
*/
//__attribute__((aligned(16)))
//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops")
//#pragma GCC target("sse,sse2,ssse3,sse3,sse4.1,sse4.2,avx")
#include <bits/stdc++.h>
#include <immintrin.h>
using namespace std;
#define x first
#define y second
#define left left228
#define right right228
#define prev prev228
#define next next228
#define on on228
const int MAXV = 2000, MAXE = 6e5, MAXN = 2e5 + 7;
struct edge {
    int to, f, c;
};
edge e[MAXE];
vector<int> g[MAXV];
int s, t, ptr;
int prev[MAXV];
int vcnt, fl;
queue<int> q;
bool bfs() {
    q.push(s);
    fill(prev, prev + vcnt, -1);
    prev[s] = -2;
    while (q.size() && prev[t] == -1) {
        int v = q.front();
        q.pop();
        for (int id : g[v]) {
            int u = e[id].to;
            int mx = e[id].c - e[id].f;
            if (mx && prev[u] == -1) {
                prev[u] = id;
                q.push(u);
            }
        }
    }
    while (q.size())
        q.pop();
    if (prev[t] == -1)
        return false;
    vector<int> way;
    int p = t;
    while (prev[p] != -2) {
        way.push_back(prev[p]);
        p = e[prev[p] ^ 1].to;
    }
    int mx = 1e9;
    for (int id : way)
        mx = min(mx, e[id].c - e[id].f);
    for (int id : way) {
        e[id].f += mx;
        e[id ^ 1].f -= mx;
    }
    fl += mx;
    return true;
}
void add_edge(int a, int b, int c) {
    //cout << a << " " << b << " " << c << " " << ptr << endl;
    g[a].push_back(ptr);
    e[ptr++] = {b, 0, c};
    g[b].push_back(ptr);
    e[ptr++] = {a, 0, 0};
}
struct qq {
    int val, id, clr;
};
bool cmp(qq &a, qq &b) {
    return a.val < b.val;
}
bool cmp2(qq &a, qq &b) {
    return a.id < b.id;
}
vector<qq> d[7];
int mask[MAXN];
int lg;
vector<int> parse(int x) {
    vector<int> ans;
    for (int i = 0; i < lg; ++i) {
        ans.push_back(x % 3);
        x /= 3;
    }
    return ans;
}
bool check_masks(int a, int b) {
    vector<int> aa = parse(a);
    vector<int> bb = parse(b);
    for (int i = 0; i < lg; ++i)
        if (aa[i] == bb[i] && aa[i] != 1)
            return false;
    return true;
}
int cnt[2][729];
vector<int> xx[2][729];
vector<pair<int, int>> ans;
void printedge(int a, int b) {
    int x = xx[0][a].back();
    xx[0][a].pop_back();
    int y = xx[1][b].back();
    xx[1][b].pop_back();
    cout << x + 1 << " " << y + 1 << "\n";
}
signed main() {
    ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    lg = k - 1;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            d[j].push_back({x, i, -1});
        }
    for (int i = 0; i < k; ++i) {
        sort(d[i].begin(), d[i].end(), cmp);
        for (int j = 0; j < n; ++j)
            d[i][j].clr = (int)(bool)(j >= n / 2) * 2;
        if (d[i][n / 2].val == d[i][n / 2 - 1].val)
            for (int k = 0; k < n; ++k)
                if (d[i][k].val == d[i][n / 2].val)
                    d[i][k].clr = 1;
    }
    for (int i = 0; i < k; ++i)
        sort(d[i].begin(), d[i].end(), cmp2);
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < k; ++j) {
            mask[i] *= 3;
            mask[i] += d[j][i].clr;
        }
        //cout << d[0][i].clr << " " << i << d[0][i].id << " " << mask[i] << endl;
        cnt[d[0][i].clr / 2][mask[i]]++;
        xx[d[0][i].clr / 2][mask[i]].push_back(i);
    }
    int cntv = 1;
    for (int i = 1; i < k; ++i)
        cntv *= 3;
    s = 0, t = 1, vcnt = cntv * 2 + 2;
    for (int i = 0; i < cntv; ++i)
        for (int j = 0; j < cntv; ++j)
            if (check_masks(i, j))
                add_edge(2 + i, 2 + cntv + j, 1e9);
    for (int i = 0; i < cntv; ++i)
        add_edge(s, 2 + i, cnt[0][i]);
    for (int i = 0; i < cntv; ++i)
        add_edge(2 + cntv + i, t, cnt[1][i]);
    while (bfs())
        continue;
    if (fl == n / 2) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
        return 0;
    }
    for (int v = 2; v < 2 + cntv; ++v)
        for (int id : g[v]) {
            int u = e[id].to;
            if (2 + cntv <= u)
                for (int c = 0; c < e[id].f; ++c)
                    printedge(v - 2, u - 2 - cntv);
        }
    return 0;
}

/*


6 2
8 6
1 5
6 3
3 1
4 7
7 2



4 3
1 -1 -1
2 1 1
3 -1 1
4 1 -1


 */