#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <bitset>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 2e5 + 1;
const int MOD = 1e9 + 7;

void print(vector <int> &a) {
    for (auto i : a) {
        cout << i << " ";
    }
    cout << "\n";
}

int n, m;
ll k, ans = 0;
bitset <80> b;

void p() {
    bool s = 0;
    for (int i = 79; i >= 0; --i) {
        if (b[i]) {
            s = 1;
        }
        if (s) {
            cout << b[i];
        }
    }
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    cin >> n >> m >> k;

    if (m == 0) {
        if (k == 0) {
            cout << 1;
            return 0;
        }

        vector <vector <ll>> dp(n, vector <ll> (k + 1, 0));
        for (int i = 0; i <= k; ++i) {
            dp[0][i] = 1;
        }
        for (int i = 1; i < n; ++i) {
            for (int j = 0; j <= k; ++j) {
                for (int u = 0; u <= j; ++u) {
                    if ((u & j) == u) {
                        dp[i][j] += dp[i - 1][u];
                        dp[i][j] %= MOD;
                    }
                }
            }
        }
        ll ans = 0;
        for (int i = 0; i <= k; ++i) {
            ans += dp[n - 1][i];
            ans %= MOD;
        }
        cout << ans;
    }

    return 0;
}
