#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<int>> bonds;
vector<bool> vis;
vector<int> color;
vector<vector<int>> comp;

void DFS(int v, int p, int c)
{
    vis[v] = true;
    bool gray = false;
    if (p == -1)
    {
        color[v] = 0;
        comp[c][0]++;
    }
    else
    {
        if (color[p] == -1)
        {
            gray = true;
            int col = 0;
            bool fc = false;
            bool fail = false;
            for (int i: bonds[v])
                if (color[i] != -1)
                {
                    if (!fc)
                    {
                        fc = true;
                        col = (color[i]+1)%2;
                    }
                    else
                    {
                        if (col != color[i])
                            fail = true;
                    }
                
                }
            if (fail)
                color[v] = -1;
            else{
                color[v] = col;
                comp[c][col]++;
            }
        }
        for (int i = 0; i < bonds[v].size() && !gray; ++i)
            gray = (color[bonds[v][i]] != -1 && color[p] != color[bonds[v][i]]);
    }
    if (!gray && p != -1 && color[p] != -1)
    {
        color[v] = (color[p] + 1) % 2;
        comp[c][color[v]]++;
    }
    for (int i: bonds[v])
    {
        if (!vis[i])
            DFS(i, v, c);
    }
    
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    bonds.resize(n, vector<int>(0));
    vis.resize(n, false);
    color.resize(n, -1);
    for (int i = 0; i < n; ++i)
    {
        int x;
        cin >> x;
        if (--x != -2)
        {
            bonds[i].push_back(x);
            bonds[x].push_back(i);
        }
    }
    int cnt = -1;
    for (int i = 0; i < n; ++i)
    {
        if (!vis[i])
        {
            comp.push_back(vector<int>(2, 0));
            ++cnt;
            DFS(i, -1, cnt);
        }
    }
    int ans = 0;
    for (int i = 0; i <= cnt; ++i)
        ans += max(comp[i][0], comp[i][1]);
    cout << ans << endl;
    return 0;
}
