#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <sstream>
#include <iomanip>
#include <random>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(20)
#define RANDOM srand(23423)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define eps 1e-9
#define mod 1000000007
#define inf 4000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f first
#define s second
#define shuffle(a) \
	for (int i = 0; i < sz(a); ++i) \
		swap(a[i], a[rand() % sz(a)])

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &a) { return str >> a.f >> a.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }

const ll N = 1e6 + 10;
ll fenv[N];

void add(int r) {
	for (; r < N; r |= r + 1) ++fenv[r];
}

void dec(int r) {
	for (; r < N; r |= r + 1) --fenv[r];
}

ll get(int r) {
	ll ans = 0;
	for (; r >= 0; r = (r & (r + 1)) - 1) ans += fenv[r];
	return ans;
}

ll get(int l, int r) {
	return get(r) - get(l - 1);
}

signed main() {
	FAST; FIXED; RANDOM;
	ll n, m;
	cin >> n >> m;
	vector<ll> a(m), b(n);
	cin >> a >> b;
	for (auto &i : a) --i;
	for (auto &i : b) --i;
	vector<set<int>> pos(n);
	vector<int> need;
	int ptr = 0;
	vector<bool> used(n);
	for (auto i : a) {
		if (used[i]) need.pb(i);
		else if (ptr < n && i == b[ptr]) need.pb(i), ++ptr, used[i] = true;
		else {
			while (ptr < n && b[ptr] != i) need.pb(b[ptr]), ++ptr, used[b[ptr]] = true;
			need.pb(i);
			++ptr;
			used[i] = true;
		}
	}
	used = vector<bool>(n);
	for (int i = 0; i < sz(need); ++i)
		pos[need[i]].insert(i);
	for (int i = 0; i < sz(need); ++i)
		if (!used[need[i]]) {
			used[need[i]] = true;
			add(i);
		}
	vector<int> ans;
	for (auto i : need) {
		dec(*pos[i].begin());
		pos[i].erase(pos[i].begin());
		if (sz(pos[i]) == 0) ans.pb(n);
		else {
			add(*pos[i].begin());
			ans.pb(get(*pos[i].begin()));
		}
	}
	cout << sz(ans) << '\n';
	for (auto i : ans) cout << i << ' ';
	return 0;
}