#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <sstream>
#include <iomanip>
#include <random>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(20)
#define RANDOM srand(23423)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define eps 1e-9
#define mod 1000000007
#define inf 4000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f first
#define s second
#define shuffle(a) \
	for (int i = 0; i < sz(a); ++i) \
		swap(a[i], a[rand() % sz(a)])

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &a) { return str >> a.f >> a.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }

vector<int> a;
vector<int> dp;
vector<int> sumdp;
vector<int> dp1;
vector<int> sumdp1;
vector<bool> used, cycle, usedcycle;
graph G;

void dfs(int v) {
	used[v] = true;
	int suma = 0, sumb = 0;
	for (auto i : G[v]) 
		if (!cycle[i]) { 
			dfs(i);
			suma += dp[i];
			sumb += max(dp[i], dp1[i]);
			sumdp[v] += dp[i];
			sumdp1[v] += dp1[i];
		}
	dp[v] = max(sumdp[v], sumdp1[v]);
	dp1[v] = max(suma + 1, sumb);
	checkmax(dp1[v], dp[v]);
}	

vector<int> cyclevert;
int stop = -1;
bool iscycle = false;

void makecycle(int v) {
	usedcycle[v] = true;
	if (a[v] < 0) {
		cycle[v] = true;
		cyclevert.pb(v);
		return;
	}
	if (usedcycle[a[v]] == true) {
		stop = a[v];
		iscycle = true;
	} else makecycle(a[v]);
	if (iscycle) cyclevert.pb(v), cycle[v] = true;
	if (v == stop) iscycle = false;
}

signed main() {
	FAST; FIXED; RANDOM;
	int n;
	cin >> n;
	dp1 = sumdp1 = dp = sumdp = a = vector<int> (n);
	cin >> a;
	for (auto &i : a) --i;
	int ans = 0;
	G.resize(n);
	used = cycle = usedcycle = vector<bool>(n);
	for (int i = 0; i < n; ++i) 
		if (a[i] >= 0) 
			G[a[i]].pb(i);
	for (int i = 0; i < n; ++i) 
		if (!used[i]) {
			cyclevert.clear();
			int stop = -1;
			bool iscycle = false;
			makecycle(i);
			for (auto j : cyclevert) dfs(j);
			int m = sz(cyclevert);
			if (m == 1) ans += max(dp[cyclevert[0]], dp1[cyclevert[0]]);
			else {
				vector<int> cnt1(m), cnt2(m), cnt3(m), cnt4(m);
				cnt1[0] = dp[cyclevert[0]];
				cnt2[0] = dp1[cyclevert[0]];
				cnt3[1] = dp[cyclevert[1]];
				cnt4[1] = dp1[cyclevert[1]];
				for (int i = 1; i < m; ++i) {
					cnt1[i] = cnt2[i - 1] + dp[cyclevert[i]];
					cnt2[i] = cnt1[i - 1] + dp1[cyclevert[i]];
					checkmax(cnt1[i], cnt1[i - 1]);
					checkmax(cnt2[i], cnt2[i - 1]);
				}
				for (int i = 2; i < m; ++i) {
					cnt3[i] = cnt4[i - 1] + dp[cyclevert[i]];
					cnt4[i] = cnt3[i - 1] + dp1[cyclevert[i]];
					checkmax(cnt3[i], cnt3[i - 1]);
					checkmax(cnt4[i], cnt4[i - 1]);
				}
				ans += max(cnt4.back() + dp[cyclevert[0]], cnt1.back());
			}
		}
	cout << ans;
	return 0;
}