#include <iostream>
#include <cmath>
#include <set>
#include <algorithm>
#include <vector>
using namespace std;
int main()
{
    long long n;
    cin >> n;
    long long k;
    cin >> k;
    if (k == n)
    {
        cout << 1;
        return 0;
    }
    vector<vector<vector<pair<long long, long long>>>> dp(n + 1, vector<vector<pair<long long, long long>>> (n + 1, vector<pair<long long, long long>> (n + 1)));
    dp[1][k][k].first = 1;
    dp[1][k][k].second = 1;
    for (int i = 2; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            for (int ii = j + 1; ii <= n; ii++)
            {
                int summ1 = 0;
                int summ2 = 0;
                for (int jj = 1; jj < j; jj++)
                {
                    summ1 += dp[i - 1][jj][ii - j].second;
                    summ1 %= ((long long)1e9 + 7);
                }
                for (int jj = j + 1; jj <= n; jj++)
                {
                    summ2 += dp[i - 1][jj][ii - j].first;
                    summ2 %= ((long long)1e9 + 7);
                }

                dp[i][j][ii].first = summ1;
                dp[i][j][ii].second = summ2;
            }
        }
    }
    long long ans = 0;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            ans += dp[i][j][n].first;
            ans += dp[i][j][n].second;
            ans %= (long long)(1e9 + 7);
        }
    }
    cout << ans;
}