#include <iostream>
#include <cmath>

using namespace std;

bool is_prime(long long n)
{
    if (n == 0) return true;
    long long i = 2;
    while (i * i <= n)
    {
        if (n % i == 0) return false;
        i++;
    }
    return true;
}

int main()
{
    long long k;
    cin >> k;
    if (k == 0)
    {
        cout << 0 << endl;
        return 0;
    }
    if (k > 0)
    {
        if (!is_prime(k))
        {
            cout << "none" << endl;
            return 0;
        }
        cout << (k - 1) / 2 + 1 << endl;
        return 0;
    }
    else
    {
        k = -k;
        if (!is_prime(k))
        {
            cout << "none" << endl;
            return 0;
        }
        cout << (k - 1) / 2 << endl;
    }
}
