#include <bits/stdc++.h>

using namespace std;

vector <vector <int> > g;
vector <int> used;
vector <int> used1;

int bfs(int v, int c){
    int coun = 0;
    queue <pair<int, int> > q;
    q.push({v, c});
    used[v] = 1;
    while(q.size() != 0){
        int in = q.front().first, in_c = q.front().second; q.pop();
        used[in] = 1;
        if(in_c){
            coun++;
        }
        for(int i = 0; i < g[in].size(); i++){
            int to = g[in][i];
            if(!used[to]){
                q.push({to, 1-in_c});
                used[to] = 1;
            }
        }
    }
    return coun;
}

int bfs1(int v, int c){
    int coun = 0;
    queue <pair<int, int> > q;
    q.push({v, c});
    used1[v] = 1;
    while(q.size() != 0){
        int in = q.front().first, in_c = q.front().second; q.pop();
        if(in_c){
            coun++;
        }
        for(int i = 0; i < g[in].size(); i++){
            int to = g[in][i];
            if(!used1[to]){
                q.push({to, 1-in_c});
                used1[to] = 1;
            }
        }
    }
    return coun;
}

int main()
{
    int n;
    cin >> n;
    g.resize(n);
    used.resize(n, 0);
    used1.resize(n, 0);
    for(int i = 0; i < n; i++){
        int a;
        cin >> a;
        if(a != -1){
            g[i].push_back(a - 1);
            g[a - 1].push_back(i);
        }
    }
    int ans = 0;
    for(int i = 0; i < n; i++){
        if(!used[i]){
            int ma = max(bfs(i, 1), bfs1(i, 0));
            ans += ma;
        }
    }
    cout << ans;
    return 0;
}
