#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < (int)x; i++)
#define rforn(i, x) for (int i = (int)x - 1; i >= 0; i--)

using namespace std;

const int INF = 1e18;

#define Pair pair<node*, node*>

struct node
{
    int x, y, sz;
    int numb;
    node *l, *r;

    node(int _x, int _numb)
    {
        x = _x;
        numb = _numb;
        sz = 1;
        y = rand();
        l = nullptr;
        r = nullptr;
    }
};

int get_size(node* p)
{
    return (p == nullptr ? 0 : p-> sz);
}

void update(node* p)
{
    p-> sz = get_size(p-> l) + get_size(p-> r) + 1;
}

node* merge(node* p1, node* p2)
{
    if (p1 == nullptr)
        return p2;
    if (p2 == nullptr)
        return p1;

    if (p1-> y < p2-> y)
    {
        p2-> l = merge(p1, p2-> l);
        update(p2);
        return p2;
    }
    else
    {
        p1-> r = merge(p1-> r, p2);
        update(p1);
        return p1;
    }
}

Pair split(node* p, int k)
{
    if (p == nullptr)
        return Pair(nullptr, nullptr);

    if (p-> x < k)
    {
        Pair t = split(p-> r, k);
        p-> r = t.ff;
        update(p);
        return Pair(p, t.ss);
    }
    else
    {
        Pair t = split(p-> l, k);
        p-> l = t.ss;
        update(p);
        return Pair(t.ff, p);
    }
}

node* root;

int insert(pii add)
{
    Pair t = split(root, add.ff);
    int ans = get_size(t.ff);
    node* x = new node(add.ff, add.ss);
    root = merge(t.ff, x);
    root = merge(root, t.ss);
    return ans;
}

void erase(pii add)
{
    Pair t = split(root, add.ff + 1);
    Pair t1 = split(t.ff, add.ff);
    root = merge(t1.ff, t.ss);
}

void print(node* p)
{
    if (p == nullptr)
        return;
    print(p-> l);
    cout << p-> x << ' ' << p-> numb << endl;
    print(p-> r);
}

signed main()
{
    //freopen("test.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> a(m), b(n);

    forn (i, m)
        cin >> a[i];
    forn (i, n)
        cin >> b[i];

    queue<int> q;
    forn (i, n)
        q.push(b[i]);

    vector<int> last(n + 1, INF);
    vector<int> nxt(m);
    vector<int> time(n + 1, INF);

    rforn (i, m)
        time[a[i]] = i;

    rforn (i, m)
    {
        nxt[i] = last[a[i]];
        last[a[i]] = i;
    }

    root = nullptr;
    set<pii> current;
    vector<pii> prev(n + 1, {-1, -1});

    vector<int> res;
    int ans = 0;
    int delta = 0;
    for (int i = 0; i < m; )
    {
        //cout << i << endl;
        ans++;
        //cout << current.size() << endl;
        if (current.empty() || current.begin()-> ff != i)
        {
            int numb = q.front();
            q.pop();
            //cout << numb << endl;

            delta++;
            if (time[numb] == i)
            {
                i++;
                time[numb] = nxt[time[numb]];
                //cout << numb << endl;
            }

            current.insert({time[numb], numb});
            res.pb(insert({time[numb], numb}));
            if (time[numb] == INF)
                res.back() = n - 1;
            prev[numb] = {res.size() - 1, delta};
        }
        else
        {
            //cout << "sas" << ' ';
            int numb = current.begin()-> ss;
            //cout << current.begin()-> ff << ' ' << current.begin()-> ss << endl;
            erase(*current.begin());
            current.erase(current.begin());
            time[numb] = nxt[time[numb]];
            current.insert({time[numb], numb});
            res.pb(insert({time[numb], numb}));
            if (time[numb] == INF)
                res.back() = n - 1;

            if (prev[numb] != pii(-1, -1))
            {
                int id = prev[numb].ff;
                int delta1 = prev[numb].ss;
                res[id] += delta - delta1;
            }
            prev[numb] = {res.size() - 1, delta};
            i++;
        }

        //for (pii x : current)
        //    cout << x.ff << ' ' << x.ss << endl;
        //cout << endl;

        //print(root);
        //cout << endl;
        //cout << endl;
    }

    cout << ans << endl;
    forn (i, ans)
        cout << ++res[i] << ' ';
    return 0;
}
