#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < (int)x; i++)
#define rforn(i, x) for (int i = (int)x - 1; i >= 0; i--)

using namespace std;

const int INF = 1e9 + 7;

const int NMAX = 5e3;

int dp[NMAX + 1][NMAX + 2][2];

int n;

int get(int sum, int x, int id)
{
    int ans = 0;
    x++;
    for (; x > 0; x -= x & -x)
        ans = (ans + dp[sum][x][id]) % INF;
    return ans;
}

void add(int sum, int x, int id, int add)
{
    x++;
    for (; x <= n + 1; x += x & -x)
        dp[sum][x][id] = (dp[sum][x][id] + add) % INF;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int k;
    cin >> n >> k;

    if (n == k)
    {
        cout << 1;
        return 0;
    }

    forn (i, n + 1)
    forn (j, n + 2)
        dp[i][j][0] = dp[i][j][1] = 0;

    add(k, k, 0, 1);
    add(k, k, 1, 1);

    for (int sum = k + 1; sum <= n; sum++)
    {
        for (int last = 1; last <= sum; last++)
        {
            int delta1 = get(sum - last, 0, 0);
            int delta2 = get(sum - last, last - 1, 0);
            add(sum, last, 1, (delta2 - delta1 + INF) % INF);

            delta1 = get(sum - last, last, 1);
            delta2 = get(sum - last, sum - last, 1);
            add(sum, last, 0, (delta2 - delta1 + INF) % INF);
        }
    }
    int ans = 0;

    ans = (ans + get(n, n, 0)) % INF;
    ans = (ans + get(n, n, 1)) % INF;
    cout << ans;
    return 0;
}
