#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < (int)x; i++)
#define rforn(i, x) for (int i = (int)x - 1; i >= 0; i--)

#define sz(x) (int)(x).size()

using namespace std;

void solve1(int n)
{
    vector<vector<bool> > g(n, vector<bool>(n, false));
    forn (i, n)
    {
        int a;
        cin >> a;
        if (a == -1)
            continue;
        g[i][a] = true;
        g[a][i] = true;
    }

    int ans = 0;

    for (int mask = 0; mask < (1 << 20); mask++)
    {
        bool ok = true;
        forn (i, n)
        {
            forn (j, n)
            {
                if (((mask >> i) & 1) && ((mask >> j) & 1) && g[i][j])
                    ok = false;
            }
        }
        if (!ok)
            continue;
        int res = 0;
        forn (i, n)
            if ((mask >> i) & 1)
                res++;
        ans = max(ans, res);
    }

    cout << ans;
}

vector<vector<int> > g1;
vector<bool> used1;
vector<vector<int> > dp;

void dfs(int v)
{
    used1[v] = true;

    dp[v][1] = 1;
    dp[v][0] = 0;

    for (int to : g1[v])
    {
        if (!used1[to])
        {
            dfs(to);
            dp[v][1] += dp[to][0];
            dp[v][0] += max(dp[to][0], dp[to][1]);
        }
    }
}

void solve2(int n)
{
    g1.resize(n);
    used1.assign(n, false);
    dp = vector<vector<int> >(n, vector<int>(2, 0));
    forn (i, n)
    {
        int a;
        cin >> a;
        if (a == -1)
            continue;
        g1[i].pb(a - 1);
        g1[a - 1].pb(i);
    }

    int ans = 0;
    for (int v = 0; v < n; v++)
    {
        if (!used1[v])
        {
            dfs(v);
            ans += max(dp[v][0], dp[v][1]);
        }
    }
    cout << ans;
}

signed main()
{
    //freopen("test.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    if (n <= 20)
        solve1(n);
    else
        solve2(n);

    return 0;
}
