#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < (int)x; i++)
#define print(x) for (int i = 0; i < (x).size(); i++) cout << x[i] << ' '; cout << endl;

using namespace std;

const int INF = 1e9 + 7;

void solve1(int n, int k)
{
    vector<pii> a(n, {-1, -1});
    forn (i, n)
    {
        cin >> a[i].ff;
        a[i].ss = i + 1;
    }
    sort(all(a));

    cout << "YES" << endl;
    forn (i, n / 2)
        cout << a[i].ss << ' ' << a[i + n / 2].ss << endl;
}

void solve2(int n, int m, int k)
{
    vector<int> g(k + 1, -1);
    for (int i = 0; i < m; i++)
    {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        g[r] = max(g[r], l);
    }

    vector<vector<vector<int> > > dp(n, vector<vector<int> >(n, vector<int>(k + 1, 0)));

    for (int i = 0; i <= k; i++)
        dp[0][0][i] = 1;

    for (int i = 1; i < n; i++)
    {
        for (int mask = 0; mask <= k; mask++)
        {
            int up;
            if (g[i] == -1)
                up = -1;
            else
                up = g[i];

            for (int j = up + 1; j < n - 1; j++)
            {
                dp[i][j][mask] = (dp[i][j][mask] + dp[i - 1][j][mask]) % INF;
            }

            for (int nxt = mask + 1; nxt <= k; nxt++)
            {
                if ((mask | nxt) == nxt)
                {
                    for (int j = 0; j < n; j++)
                        dp[i][0][nxt] = (dp[i - 1][j][mask] + dp[i][0][nxt]) % INF;
                }
            }
        }
    }

    int ans = 0;
    for (int i = 0; i <= k; i++)
        for (int j = 0; j < n; j++)
           ans = (ans + dp[n - 1][j][i]) % INF;
    cout << ans;
}

signed main()
{
    //freopen("test.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> k >> k;

    solve1(n, k);
    return 0;
}
