#include <iostream>
using namespace std;

int mod = 1000000007;
int const lim = 501;

int plans(int n, int k, bool up, int cgr[lim][lim][2]){
    if (n == 0 || k > n) return 0;
    if (n == k) return 1;
    if (n < lim && cgr[n][k][up] != -1) return cgr[n][k][up];
    int sum = 0;
    if (up){
        for (int i = k + 1; i < n - k + 1; ++i){
            sum += plans(n - k, i, false, cgr);
            sum %= mod;
        }
    }
    else{
        for (int i = 1; i < k; ++i){
            sum += plans(n - k, i, true, cgr);
            sum %= mod;
        }
    }
    if (n < lim) cgr[n][k][up] = sum;
    return sum;
}

int main() {
    int n0, k0;
    cin >> n0;
    cin >> k0;
    int res;
    int gr[lim][lim][2];
    for (int i = 0; i < lim; ++i){
        for (int j = 0; j < lim; ++j){
            gr[i][j][0] = -1;
            gr[i][j][1] = -1;
        }
    }
    if (n0 != k0){
        int upres = plans(n0, k0, true, gr);
        int downres = plans(n0, k0, false, gr);
        res = upres + downres;
        res %= mod;
    }
    else res = 1;
    cout << res << endl;
    return 0;
}