def merge(v1, v2):
    if trees[v1][v1] == trees[v2][v2]:
        for key, value in  trees[v2].items():
            trees[v2][key] = 1 - value
    trees[v1].update(trees[v2])
    for key in trees[v1]:
        trees[key] = trees[v1]


n = int(input())
exc = [-1] + [int(input()) for _ in range(n)]
trees = {}
for i in range(1, n + 1):
    trees[i] = {i:0}
for i in range(1, n + 1):
    if exc[i] == -1:
        continue
    merge(i, exc[i])
res = 0
ids = set()
for tree in trees.values():
    if id(tree) in ids:
        continue
    ids |= {id(tree)}
    tval = list(tree.values())
    res += max(sum(tval), len(tval) - sum(tval))
print(res)