#include <iomanip>
#include <iostream>
#include <ctime>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>

#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <deque>

#define int long long
#define ll long long
#define ld long double
#define ins insert
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define rsz resize
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

using namespace std;

mt19937 gen(time(nullptr));

const int INF = 1e18, P = 1e9 + 7, X = 2007;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int my_pow(int a, int b) {
    if (b == 0) return 1;
    if (b == 1) return a;
    if (b % 2 == 0) {
        int t = my_pow(a, b / 2);
        return (t * t) % P;
    }
    return (my_pow(a, b - 1) * a) % P;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int k;
    cin >> k;
    if (k == 0) {
        cout << 0;
        return 0;
    }
    int ans = INF;
    for (int i = 1; i * i <= abs(k); i++) {
        if (k % i) continue;
        int a = i, b = k / i;
        int x = (a + b) / 2, y = b - x;
        if (x * x == k + y * y) ans = min(abs(x), ans);
        swap(a, b);
        x = (a + b) / 2;
        y = b - x;
        if (x * x == k + y * y) ans = min(abs(x), ans);
    }
    if (ans == INF) cout << "none";
    else cout << ans;
    return 0;
}
