#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define mp make_pair
#define allv(a) a.begin(), a.end()
#define allar(a) a, a + n

#include <iostream>
#include <string>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <forward_list>
#include <functional>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <db, db> pdd;
typedef pair <string, string> pss;

const int inf = 1e9 + 7;
const ll MOD = (ll)1e9 + 7;

const int N = 3e5;
const int CNT = 25;
const int K = 1e7;

const int N2 = 50;
const int K2 = 50;

ll n, m, k;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%lld%lld%lld", &n, &m, &k);
	ll res = 0;
	if (m == 0) {
		vector <int> cnt_one(K + 1);
		vector <vector <ll>> dp(N);
		rep(N, i)
			dp[i].resize(CNT);
		vector <vector <ll>> cnk(CNT);
		rep(CNT, i)
			cnk[i].resize(CNT + 1);
		for (ll i = 1; i <= k; ++i)
			cnt_one[i] = cnt_one[i >> 1] + (i & 1);
		rep(CNT, i) {
			cnk[i][0] = 1;
			for (int j = 1; j <= i; ++j)
				cnk[i][j] = (cnk[i - 1][j] + cnk[i - 1][j - 1]) % MOD;
		}
		fill(allv(dp[0]), 1);
		for (int i = 1; i < n; ++i) {
			rep(CNT, cnt) {
				rep(cnt + 1, cur) {
					dp[i][cnt] += cnk[cnt][cur] * dp[i - 1][cnt - cur];
					dp[i][cnt] %= MOD;
				}
			}
		}
		ll ans = 0;
		rep(k + 1, i) {
			ans += dp[n - 1][cnt_one[i]];
			ans %= MOD;
		}
		printf("%lld", ans);
	}
	else {
		vector <vector <vector <vector <ll>>>> dp(N2);
		rep(N2, i) {
			dp[i].resize(N2);
			rep(N2, j) {
				dp[i][j].resize(K2 + 1);
				rep(K2 + 1, k)
					dp[i][j][k].resize(K2 + 1);
			}
		}
		vector <vector <int>> not_use(N2);
		rep(N2, i)
			not_use[i].resize(N2);

		rep(m, i) {
			int a, b;
			scanf("%d%d", &a, &b); --a; --b;
			not_use[max(a, b)].push_back(min(a, b));
		}
		rep(n, i) {
			rep(k + 1, num)
				dp[i][i][num][num] = 1;
			for (int j = i + 1; j < n; ++j) {
				rep(k + 1, num1) {
					rep(k + 1, num2) {
						rep(num1 + 1, nxt) {
							if ((nxt & num1) == nxt) {
								dp[i][j][num1][num2] += dp[i][j - 1][nxt][num2];
								dp[i][j][num1][num2] %= MOD;
							}
						}
						for (auto elem : not_use[j]) {
							if (elem >= i) {
								dp[i][j][num1][num2] -= dp[elem][j][num1][num1] * dp[i][elem][num1][num2];
								dp[i][j][num1][num2] += MOD * MOD;
								dp[i][j][num1][num2] %= MOD;
							}
						}
					}
				}
			}
		}
		ll ans = 0;
		rep(k + 1, num1) {
			rep(num1 + 1, num2) {
				ans += dp[0][n - 1][num1][num2];
				ans %= MOD;
			}
		}
		printf("%lld", ans);
	}
	return 0;
}