#include <stdio.h>

const long long INF = 1e18;

long long abs1(long long x) {
	return x > 0 ? x : -x;
}

int main() {
	long long k, ans = INF;
	scanf("%lld", &k);
	if (k == 0) {
		printf("0");
		return 0;
	}
	for (long long i = 1; (i * i <= k && k > 0) || (i * i <= -k && k < 0); i++) {
		if (k % i == 0) {
			long long t = k / i - i;
			if (t % 2 == 0 && t >= 0) {
				long long b = t / 2 + i;
				if (b >= 0 && ans > b) {
					ans = b;
				}
			}
			t = -k / i + i;
			if (t % 2 == 0 && t >= 0) {
				long long b = t / 2 - i;
				if (b >= 0 && ans > b) {
					ans = b;
				}
			}
		}
	}
	if (ans == INF) {
		printf("none");
	} else {
		printf("%lld", ans);
	}
	return 0;
}
