#include <bits/stdc++.h>

#define int long long
#define double long double
#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

const int inf = 1e18;
const double eps = 1e-6;

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int n, k;
    cin >> n >> k;
    if (k != 1)
    {
        vector<vector<int>> v(n, vector<int>(k));
        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j < k; ++j)
            {
                cin >> v[i][j];
            }
        }
        vector<int> p(n);
        for (int i = 0; i < n; ++i)
        {
            p[i] = i;
        }
        do
        {
            bool flg = true;
            for (int t = 0; t < k; ++t)
            {
                int l = -inf, r = inf;
                for (int i = 0; i < n; i += 2)
                {
                    int a = p[i], b = p[i + 1];
                    if (v[a][t] > v[b][t])
                    {
                        swap(a, b);
                    }
                    l = max(l, v[a][t]);
                    r = min(r, v[b][t]);
                }
                if (l > r)
                {
                    flg = false;
                }
            }
            if (flg)
            {
                cout << "YES\n";
                for (int i = 0; i < n; i += 2)
                {
                    cout << p[i] + 1 << " " << p[i + 1] + 1 << "\n";
                }
                return 0;
            }
        }while(next_permutation(all(p)));
        cout << "NO";
        return 0;
    }





    vector<pair<int, int>> v;
    for (int i = 0; i < n; ++i)
    {
        int x;
        cin >> x;
        v.pb({x, i});
    }
    sort(all(v));
    cout << "YES\n";
    for (int i = 0; i < n / 2; ++i)
    {
        cout << v[i].ss + 1 << " " << v[n - i - 1].ss + 1 << "\n";
    }
    return 0;
}

/*
6 2
8 6
1 5
6 3
3 1
4 7
7 2

4 3
1 -1 -1
2 1 1
3 -1 1
4 1 -1
*/

