#include <bits/stdc++.h>
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define read(FILENAME) freopen(((string)FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen(((string)FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, const pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
}


template<typename T> istream &operator >> (istream &_in, vector<T> &a) {for (auto &i : a) _in >> i; return _in;}
template<typename T> ostream &operator << (ostream &_out, const vector<T> &a) {
	for (int i = 0; i < a.size(); ++i) {
		if (i) _out << ' ';
		_out << a[i];
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const multiset<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const unordered_set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T1, typename T2> ostream &operator << (ostream &_out, const map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 


template<typename T1, typename T2> ostream &operator << (ostream &_out, const unordered_map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 

#define getchar getchar_unlocked
#define putchar putchar_unlocked

int read_int() {
	int v = 0;
	char c = getchar();
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return v;
}

long long read_long() {
	long long v = 0;
	char c = getchar();
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return v;
}

void print(const string &s) {
	for (auto c : s) {
		putchar(c);
	}
}

void print_int(int v) {
	print(to_string(v));
}

const int p = 1e9 + 7;

int n, m;
long long k;
long long cur[1001];
vector<int> mask[2000];
vector<pair<int, int>> res;

long long cnt = 0;

void solve(int i) {
	if (i == n + 1) {
		for (auto j : res) {
			if (cur[j.x] == cur[j.y]) {
				return;
			}
		}
		++cnt;
		return;
	}
	for (int j : mask[cur[i - 1]]) {
		cur[i] = j;
		solve(i + 1);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	//read("input");
	cin >> n >> m >> k;
	res.resize(m);
	cin >> res;
	for (int i = 0; i <= k; ++i) {
		for (int j = 0; j <= k; ++j) {
			if ((i & j) == i) {
				mask[i].pb(j);
			}
		}
	}
	solve(1);
	cout << cnt % p << endl;
	
}