#include <bits/stdc++.h>
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define read(FILENAME) freopen(((string)FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen(((string)FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, const pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
}


template<typename T> istream &operator >> (istream &_in, vector<T> &a) {for (auto &i : a) _in >> i; return _in;}
template<typename T> ostream &operator << (ostream &_out, const vector<T> &a) {
	for (int i = 0; i < a.size(); ++i) {
		if (i) _out << ' ';
		_out << a[i];
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const multiset<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const unordered_set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T1, typename T2> ostream &operator << (ostream &_out, const map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 


template<typename T1, typename T2> ostream &operator << (ostream &_out, const unordered_map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 

#define getchar getchar_unlocked
#define putchar putchar_unlocked

int read_int() {
	int v = 0;
	char c = getchar();
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return v;
}

long long read_long() {
	long long v = 0;
	char c = getchar();
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return v;
}

void print(const string &s) {
	for (auto c : s) {
		putchar(c);
	}
}

void print_int(int v) {
	print(to_string(v));
}

const int p = 1e9 + 7;
const long long pp = 1LL * p * p;
const int N = 3e5 + 5;
const int LOG = 61;

int sum(int a, int b) {
	a += b;
	return a <= p ? a : a - p;
}

int mul(long long a, int b) {
	return a * b % p;
}

int n, m;
long long k;
int lst[N];
int pref[N][LOG];
int cur[LOG];
long long cnk[LOG][LOG];
int ans[LOG][LOG];
int opt;

int rep;

vector<bool> num;

void solve(int i, int cnt0, bool need = true) {
	if (!need || i == num.size()) {
		int cnt1 = num.size() - i;
		rep = sum(rep, ans[cnt0][cnt1]);
		return;
	}	
	if (num[i]) {
		solve(i + 1, cnt0, false);
		solve(i + 1, cnt0 + 1);
	} else {
		solve(i + 1, cnt0);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	//read("input");	
	for (int i = 0; i < LOG; ++i) {
		cnk[i][0] = cnk[i][i] = 1;
		for (int j = 1; j < i; ++j) {
			cnk[i][j] = sum(cnk[i - 1][j - 1], cnk[i - 1][j]);
		}
	}
	cin >> n >> m >> k;
	for (int i = 0; i < m; ++i) {
		int L, R;
		cin >> L >> R;
		chkmax(lst[R], L + 1);
	}
	pref[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < LOG; ++j) {
			cur[j] = pref[i - 1][j];
		}
		if (opt) {
			for (int j = 0; j < LOG; ++j) {
				cur[j] -= pref[opt - 1][j];
			}
		}
		for (int j = 0; j < LOG; ++j) {
			long long curn = pref[i - 1][j];
			for (int q = 0; q < j; ++q) {
				curn += cnk[j][q] * cur[q];
				if (curn >= pp) curn -= pp;
			}
			pref[i][j] = curn % p;
		}
		chkmax(opt, lst[i]);
	
	}
	for (int j = 0; j < LOG; ++j) {
		cur[j] = pref[n][j];
	}
	if (opt) {
		for (int j = 0; j < LOG; ++j) {
			cur[j] -= pref[opt - 1][j];
		}
	}
	for (int i = 0; i < LOG; ++i) {
		for (int j = 0; j + i < LOG; ++j) {
			for (int q = 0; q <= j; ++q) {
				ans[i][j] = sum(ans[i][j], mul(cnk[j][q], cur[i + q]));
			}
		}
	}
	while (k) {
		num.pb(k & 1);
		k >>= 1;
	}
	reverse(num.begin(), num.end());
	solve(0, 0);
	cout << (rep % p + p) % p << '\n';
}