#include <bits/stdc++.h>
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define read(FILENAME) freopen(((string)FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen(((string)FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, const pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
}


template<typename T> istream &operator >> (istream &_in, vector<T> &a) {for (auto &i : a) _in >> i; return _in;}
template<typename T> ostream &operator << (ostream &_out, const vector<T> &a) {
	for (int i = 0; i < a.size(); ++i) {
		if (i) _out << ' ';
		_out << a[i];
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const multiset<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const unordered_set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T1, typename T2> ostream &operator << (ostream &_out, const map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 


template<typename T1, typename T2> ostream &operator << (ostream &_out, const unordered_map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 

#define getchar getchar_unlocked
#define putchar putchar_unlocked

int read_int() {
	int v = 0;
	char c = getchar();
	if (c > '9') return 0;
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return v;
}

void print(const string &s) {
	for (auto c : s) {
		putchar(c);
	}
}

void print_int(int v) {
	print(to_string(v));
}

const int p = 1e9 + 7;

int sum(int a, int b) {
	a += b;
	return a < p ? a : a - p;
}

int mul(long long a, int b) {
	return a * b % p;
}

int n, k;
int dp[5001][5001][2];

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);	
	// read("input");
	cin >> n >> k;
	if (n == k) {
		cout << 1 << '\n';
		return 0;
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j < i; ++j) {
			dp[i][j][0] = sum(dp[i - j][n][1], p - dp[i - j][j][1]);
			dp[i][j][1] = dp[i - j][j - 1][0];
		}
		dp[i][i][0] = dp[i][i][1] = 1;
		for (int j = 1; j <= n; ++j) {
			dp[i][j][0] = sum(dp[i][j - 1][0], dp[i][j][0]);
			dp[i][j][1] = sum(dp[i][j - 1][1], dp[i][j][1]);
		}
 	}
 	int ans = 0;
 	for (int t = 0; t < 2; ++t) {
 		ans = sum(ans, sum(dp[n][k][t], p - dp[n][k - 1][t]));
 	}
 	cout << ans << '\n';
}