#include <bits/stdc++.h>
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define read(FILENAME) freopen(((string)FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen(((string)FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, const pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
}


template<typename T> istream &operator >> (istream &_in, vector<T> &a) {for (auto &i : a) _in >> i; return _in;}
template<typename T> ostream &operator << (ostream &_out, const vector<T> &a) {
	for (int i = 0; i < a.size(); ++i) {
		if (i) _out << ' ';
		_out << a[i];
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const multiset<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const unordered_set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T1, typename T2> ostream &operator << (ostream &_out, const map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 


template<typename T1, typename T2> ostream &operator << (ostream &_out, const unordered_map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 

#define getchar getchar_unlocked
#define putchar putchar_unlocked

int read_int() {
	int v = 0;
	char c = getchar();
	bool sign = false;
	if (c == '-') {
		sign = true;
		c = getchar();
	}
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return sign ? -v : v;
}

long long read_long() {
	long long v = 0;
	char c = getchar();
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return v;
}

void print(const string &s) {
	for (auto c : s) {
		putchar(c);
	}
}

void print_int(int v) {
	print(to_string(v));
}

const int p = 1e9 + 7;
const long long pp = 1LL * p * p;
const int N = 2e5 + 5;
const int LOG = 61;

int n, k;
int cnt;
int arr[7][N];
int t;

bool cmp(int i, int j) {
	return arr[t][i] < arr[t][j];
}

int clr[N];
vector<int> a;
int check[7];
vector<pair<int, int>> ans;

int cntx[3000];
vector<int> who[3000];
vector<int> w[3000];

int lst;
int uv[1000001];
int c[1000001];
vector<int> edge[N];

void new_edge(int i, int j, int c = 1e9) {
	// cout << i << ' ' << j << ' ';
	// if (c == 1e9) cout << "inf\n";
	// else cout << c << endl;
	edge[i].pb(lst);
	::c[lst] = c;
	uv[lst] = j;
	++lst;
	edge[j].pb(lst);
	::c[lst] = 0;
	uv[lst] = i;
	++lst;
}	

int cntv;
int s;
int it[N];
int dist[N];
int ans_flow;


int dfs(int i, int flow = 1e9) {
	if (flow == 0) return 0;
	if (i == t) return flow;
	for (; it[i] < edge[i].size(); ++it[i]) {
		int id = edge[i][it[i]];
		if (dist[uv[id]] > dist[i]) {
			int ans = dfs(uv[id], min(flow, c[id]));
			if (ans != 0) {
				c[id] -= ans;
				c[id ^ 1] += ans;
				return ans;
			}
		}
	}
	return 0;
}

int bfs() {
	for (int i = 0; i <= t; ++i) {
		dist[i] = 1e9;
		it[i] = 0;
	}
	dist[s] = 0;
	queue<int> que;
	que.push(s);
	while (que.size()) {
		int u = que.front();
		que.pop();
		for (auto id : edge[u]) {
			int v = uv[id];
			if (c[id] != 0 && dist[v] == 1e9) {
				dist[v] = dist[u] + 1;
				que.push(v);
			}
		}
	}
	if (dist[t] == 1e9) return 0;
	int rep = 0;
	while (true) {
		int res = dfs(s);
		if (res == 0) break;
		rep += res;
	}
	// cout << rep << endl;
	return rep;
}

void find_flow() {
	ans_flow = 0;
	while (true) {
		int res = bfs();
		if (res == 0) break;
		ans_flow += res;
	}
}
 
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	// read("input");	
	n = read_int();
	k = read_int();
	for (int i = 0; i < n; ++i) {
		a.pb(i);
		for (int j = 0; j < k; ++j) {
			arr[j][i] = read_int();
		}
	}
	cnt = n;
	sort(a.begin(), a.end(), cmp);
	for (int i = 0; i < n; ++i) {
		clr[a[i]] = i * 2 >= n;
	}
	int cur = 3;
	for (t = 1; t < k; ++t, cur *= 3) {
		sort(a.begin(), a.end(), cmp);
		int id0 = cnt++;
		int id1 = cnt++;
		int M = arr[t][a[n / 2]];
		for (int i : a)	{
			if (arr[t][i] == M) {
				clr[i] += cur;
			} else if (arr[t][i] < M) {
				clr[i] += 0;
			} else {
				clr[i] += cur * 2;
			}
		}
	}

	for (int i = 0; i < cur; ++i) {
		int j = i;
		for (int q = 0; q < k; ++q) {
			w[i].pb(j % 3);
			j /= 3;
		}
	}

	for (int i : a) {
		++cntx[clr[i]];
		who[clr[i]].pb(i);
		// cout << i + 1 << ":" << w[clr[i]] << endl;
	}

    int cnt = 0;
    s = cur * 2;
	t = cur * 2 + 1;
	for (int i = 0; i < cur; ++i) {
		if (cntx[i] == 0) continue;
		for (int j = 0; j < cur; ++j) {
			if (w[j][0] < 2) continue;
			bool OK = true;
			for (int q = 1; q < k; ++q) {
				if (w[j][q] == 1) {
					OK = false;
					break;
				}
				if (w[i][q] == 1) continue;
				if ((w[i][q] == w[j][q]) ^ w[i][0]) {
					OK = false;
					break;
				}
			}
			if (OK) {
				if (w[i][0] == 0) {
					// cout << w[i] << ':' << w[j] << ' ' << j << endl;
					new_edge(i, cur + j);
				} else {
					// cout << w[i] << ':' << w[j] << ' ' << j  << endl;
					new_edge(cur + j, i);
				}
			}
		}
		if (w[i][0] == 0) {
			new_edge(s, i, cntx[i]);
		} else {
			new_edge(i, t, cntx[i]);
		}
	} 
	find_flow();
	for (int i = 0; i <= t; ++i) {
		it[i] = 0;
	}
	if (ans_flow == n / 2) {
		for (int i : a) {
			if (w[clr[i]][0] == 0) {
				int v = clr[i];
				for (;it[v] < edge[v].size(); ++it[v]) {
					int id = edge[v][it[v]];
					if (id & 1) continue;
					if (c[id] != 1e9) {
						v = uv[id];
						++c[id];
						break;
					}
				}
				// cout << i << ' ' << v - cur << ' ' << s - cur << ' ' << t - cur << endl;
				for (;it[v] < edge[v].size(); ++it[v]) {
					int id = edge[v][it[v]];
					if (id & 1) continue;
					if (c[id] != 1e9) {
						v = uv[id];
						++c[id];
						break;
					}
				}
				ans.pb({i, who[v].back()});
				who[v].pop_back();
			}
		}
		print((string)"YES\n");
		for (auto i : ans) {
			print_int(i.x + 1);
			putchar(' ');
			print_int(i.y + 1);
			putchar('\n');
		}
	} else {
		print((string)"NO\n");
	}
}