#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

ll mod = 1e9 + 7;

int main() {
    int n, k;
    cin >> n >> k;
    vector<vector<vector<ll>>> v(n + 2, vector<vector<ll>> (n + 2, vector<ll> (2, 0)));
    v[k][k][0] = 1;
    v[k][k][1] = 1;
    for (int s = k + 1; s <= n; ++s) {
        for (int y = s; y >= 1; --y) {
            for (int z = 1; z < y; ++z) {
                v[s][y][0] = (v[s][y][0] + v[s - y][z][1]) % mod;
            }
        }
        for (int y = 1; y <= s; ++y) {
            for (int z = y + 1; z <= n; ++z) {
                v[s][y][1] = (v[s][y][1] + v[s - y][z][0]) % mod;
            }
        }
    }
    ll ans = 0;
    if (k == n) {
        cout << 1;
        return 0;
    }
    for (int i = 0; i <= n; ++i) {
        ans = (ans + v[n][i][0] + v[n][i][1]) % mod;
    }
    cout << ans;
    return 0;
}

