#pragma GCC(optimize, "Ofast, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <numeric>
#include <functional>
#include <iomanip>
#include <random>
#include <string>
#include <math.h>
#include <bitset>
#define pb push_back
#define pf push_front
#define sz(a) (ll)((a).size())
#define all(a) (a).begin(), (a).end()
#define popb pop_back
#define popf pop_front
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define endl "\n"
#define heap priority_queue
#define hash_set unordered_set
#define hash_map unordered_map
#define ft first
#define sd second
#define die(f) if (f) for (;;) {}
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<ll> vll;
typedef vector<ld> vld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
const ll inf = numeric_limits<ll>::max() / 2;
const ld pi = acosl(-1);
const ld eps = 1e-9;
template<typename T> ll mineq(T& a, T b) { if (a > b) return a = b, 1; return 0; }
template<typename T> ll maxeq(T& a, T b) { if (a < b) return a = b, 1; return 0; }

inline void read(), solve();

signed main() {
	fast;
	read();
	solve();
	return 0;
}

ll n, k;
vector<vll> a;

void getans(vll& ind) {
	for (ll i = 0; i < n; i++) {
		if (ind[ind[i]] != i) {
			return;
		}
	}
	for (ll t = 0; t < k; t++) {
		ll L = -inf, R = inf;
		for (ll i = 0; i < n; i++) {
			ll l = a[i][t], r = a[ind[i]][t];
			if (l > r) {
				swap(l, r);
			}
			maxeq(L, l);
			mineq(R, r);
		}
		if (L > R) {
			return;
		}
	}
	cout << "YES" << endl;
	for (ll i = 0; i < n; i++) {
		if (ind[i] < i) {
			continue;
		}
		cout << i + 1 << " " << ind[i] + 1 << endl;
	}
	exit(0);
}

bool comp1(ll i, ll j) {
	return a[i][0] < a[j][0];
}
bool comp2(ll i, ll j) {
	return a[i][1] > a[j][1];
}

inline void solve() {
	if (k > 1) {
		vll ind(n);
		iota(all(ind), 0);
		do {
			getans(ind);
		} while (next_permutation(all(ind)));
		cout << "NO" << endl;
	}
	else {
		cout << "YES" << endl;
		vector<pll> b;
		for (ll i = 0; i < n; i++) {
			b.pb({ a[i][0], i });
		}
		sort(all(a));
		vector<pll> c = b;
		reverse(all(c));
		for (ll i = 0; i < n / 2; i++) {
			cout << b[i].sd + 1 << " " << c[i].sd + 1 << endl;
		}
	}
}

inline void read() {
	cin >> n >> k;
	a.resize(n);
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < k; j++) {
			ll x;
			cin >> x;
			a[i].pb(x);
		}
	}
}
