#include<bits/stdc++.h>

using namespace std;

int answer = 0;
int n;

vector<int> comp;
vector<bool> used;
vector<bool> used_cycle;
vector<int> hatred;
vector<vector<int>> g;


int loc;
void dfs(int v, bool clr) {
    used[v] = true;
    comp.push_back(v);
    if (clr) {
        loc++;
    }
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u, !clr);
        }
    }
}

int dfs_cycle(int v) {
    used_cycle[v] = true;
    if (hatred[v] == -1) {
        return -1;
    }
    if (used_cycle[hatred[v]]) {
        return v;
    }
    return dfs_cycle(hatred[v]);
}

void solve() {
    int v = dfs_cycle(comp[0]);
    vector<int> kek;
    if (v == -1) {
        answer += max(loc, int(comp.size() - loc));
        return;
    }
    int u = hatred[v];
    kek.push_back(v);
    while (u != v) {
        kek.push_back(u);
        u = hatred[u];
    }
    /*for (auto elem : kek) {
        cout << elem << " ";
    }
    cout << endl;*/
}

int main()
{
    cin >> n;
    hatred.resize(n);
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        x--;
        hatred[i] = x;
        if (x == -2) {
            hatred[i]++;
            continue;
        }
        if (x > i || (x < i && hatred[x] != i)) {
            g[i].push_back(x);
            g[x].push_back(i);
        }
    }

    used.resize(n, false);
    used_cycle.resize(n, false);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            loc = 0;
            comp.clear();
            dfs(i, true);
            /*for (auto elem : comp) {
                cout << elem << " ";
            }
            cout << endl << "//" << endl;*/
            solve();
        }
    }
    cout << answer;
    return 0;
}


