#include <iostream>
#include <vector>
#include <algorithm>
#define pb push_back
#define ll long long
#define all(x) x.begin(), x.end()

using namespace std;


inline void dfs(int v, vector<vector<int>> &g, vector<bool> &used, vector<bool> &col, vector<int> &cnt)
{
	used[v] = 1;

	for (int u : g[v])
	{
		if (used[u] == 0)
		{
			col[u] = !col[v];
			cnt[col[u]]++;
			dfs(u, g, used, col, cnt);
		}
	}
}


int main()
{
	int n;
	cin >> n;
	vector<int> arr(n);
	vector<vector<int>> g(n);

	for (int i = 0; i < n; i++)
	{
		cin >> arr[i];

		if (arr[i] != -1)
		{
			arr[i]--;

			g[i].pb(arr[i]);
			g[arr[i]].pb(i);
		}
	}

	bool good = 1;
	for (int i = 0; i < n; i++)
	{
		if (arr[i] != i - 1)
		{
			good = 0;
			break;
		}
	}

	if (false)
	{
		cout << (n + 1) / 2 << endl;
		return 0;
	}

	vector<bool> used(n), col(n);
	int maxc = 0;

	for (int v = 0; v < n; v++)
	{
		if (used[v] == 1)
			continue;

		vector<int> cnt(2, 0);
		cnt[0]++;
	
		col[v] = 0;
		dfs(v, g, used, col, cnt);

		// cerr << cnt[0] << " " << cnt[1] << endl;
		maxc += max(cnt[0], cnt[1]);
	}

	cout << maxc << endl;

	return 0;
}