#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>
#include <cstring>
#include <string>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}


template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int distance(int x, int y) {
	return (y - x) / 2 + (y - x) % 2;
}

int main() {
	fast_io();
	int a, b, c;
	cin >> a >> b >> c;
	int a1 = c * (a / c + 1) - 1;
	int b1 = b - b % c + 1;
	if (a1 > b1) {
		cout << distance(a, b) << endl;
		return 0;
	}
	int cnt = (b1 - a1 - 2) / c + 1;
	int ans = distance(a, a1) + distance(b1, b);

	ans += cnt;
	ans += (cnt - 1) * (distance(b1, b1 + c - 2));
	cout << ans << endl;
}
