#include <bits/stdc++.h>

using namespace std;

vector<int> perm;
vector<vector<int> > arr;
int n, k;

bool check()
{
    vector<pair<int, int> > cur(k, {-1000000001, 1000000001});
    for (int j = 0; j < k; j++)
    {
        for (int i = 0; i < n; i += 2)
        {
            cur[j].first = max(cur[j].first, min(arr[perm[i]][j], arr[perm[i + 1]][j]));
            cur[j].second = min(cur[j].second, max(arr[perm[i]][j], arr[perm[i + 1]][j]));
        }
        if (cur[j].first > cur[j].second) return false;
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);

    cin >> n >> k;

    if (n <= 10)
    {
        arr.assign(n, vector<int>(k, 0));
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < k; j++)
            {
                cin >> arr[i][j];
            }
        }

        perm.assign(n, 0);
        for (int i = 0; i < n; i++)
            perm[i] = i;

        int maxans = 0;
        vector<pair<int, int> > ans;

        while (true)
        {
            if (check())
            {
                cout << "YES\n";
                for (int j = 0; j < n; j += 2)
                    cout << perm[j] + 1 << " " << perm[j + 1] + 1 << "\n";
                return 0;
            }
            if (!next_permutation(perm.begin(), perm.end()))
            {
                break;
            }
        }

        cout << "NO";
    }
}
