#include <iostream>
#include <vector>
#include <algorithm>
#define x first
#define y second
using namespace std;
const int N = 400;

vector<int> g[N], h[N];
static int clr[N], colors = 0, cnt[N];
static bool used[N];

void dfs(int v, int col)
{
    used[v] = true, clr[v] = col;
    for (int u: h[v])
        if (!used[u])
            dfs(u, col);
}

void check(int n)
{
    bool take[n];
    fill(take, take + n/2, false);
    fill(take + n/2, take + n, true);
    do
    {
        int perm[n/2];
        for (int i = 0; i < n/2; ++i)
            perm[i] = i;
        do
        {
            int lol[n/2];
            for (int i = 0, j = 0; i < n; ++i)
                if (!take[i])
                    lol[j++] = i;
            bool ok = true;
            for (int i = 0, j = 0; i < n; ++i)
                if (take[i])
                    ok &= find(h[i].begin(), h[i].end(), lol[perm[j++]]) != h[i].end();
            if (ok)
            {
                cout << "YES\n";
                for (int i = 0, j = 0; i < n; ++i)
                    if (take[i])
                        cout << i + 1 << ' ' << lol[perm[j++]] + 1 << '\n';
                return;
            }
        }
        while (next_permutation(perm, perm + n/2));
    }
    while (next_permutation(take, take + n));
    cout << "NO";
}

int main()
{
    int n, k;
    cin >> n >> k;
    int a[n][k];
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < k; ++j)
            cin >> a[i][j];
    vector<pair<int,int>> v;
    if (n <= 10)
    {
        /*int c[n];
        for (int i = 0; i < k; ++i)
        {
            for (int j = 0; j < n; ++j)
                c[j] = a[j][i];
            sort(c, c + n);
            v.emplace_back(c[n/2-1], c[n/2]);
        }
        int l = v[0].x, r = v[0].y;
        for (int i = 1; i < k; ++i)
            l = max(l, v[i].x), r = min(r, v[i].y);
        if (l > r)
        {
            cout << "NO";
            return 0;
        }
        for (int i = 0; i < k; ++i)
        {
            v.clear();
            for (int j = 0; j < n; ++j)
                v.emplace_back(a[j][i], j);
            sort(v.begin(), v.end());
            for (int i = 0; i < n/2; ++i)
                for (int j = 0; j < n/2; ++j)
                    if (i != j)
                        g[v[i].y].push_back(v[j].y), g[v[j].y].push_back(v[i].y);
            for (int i = n/2; i < n; ++i)
                for (int j = n/2; j < n; ++j)
                    if (i != j)
                        g[v[i].y].push_back(v[j].y), g[v[j].y].push_back(v[i].y);
        }
        for (int i = 0; i < n; ++i)
        {
            bool lo[n];
            fill(lo, lo + n, false);
            for (int j: g[i])
                lo[j] = true;
            for (int j = 0; j < n; ++j)
                if (i != j && !lo[j])
                    h[i].push_back(j);
        }
        for (int i = 0; i < n; ++i)
            if (!used[i])
                dfs(i, colors++);
        for (int i = 0; i < n; ++i)
            cnt[clr[i]]++;
        for (int i = 0; i < colors; ++i)
        {
            if (cnt[i] % 2)
            {
                cout << "NO";
                return 0;
            }
        }
        check(n);*/
        cout << "NO";
        return 0;
    }
    if (k == 1)
    {
        for (int i = 0; i < n; ++i)
            v.emplace_back(a[i][0], i);
        sort(v.begin(), v.end());
        cout << "YES\n";
        for (int i = 0, j = v.size()-1; i < j; ++i, --j)
            cout << v[i].y + 1 << ' ' << v[j].y + 1 << '\n';
    }
    return 0;
}
