#include <bits/stdc++.h>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

int32_t main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector <int> bad(n, -1);
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        bad[r - 1] = max(bad[r - 1], l - 1);
    }
    vector <vector <int> > dp(n, vector <int>(k + 1, 0));
    for (int i = 0; i<= k; i++)
        dp[0][i] = 1;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j <= k; j++) {
            for (int prev = 0; prev <= j; prev++) {
                if ((prev & j) != prev) continue;
                dp[i][j] += dp[i - 1][prev];
                if (dp[i][j] > mod)
                    dp[i][j] = dp[i][j] % mod;
            }
            if (bad[i] > -1)
                dp[i][j] -= dp[bad[i]][j];
        }
    }
    int ans = 0;
    for (int i = 0; i <= k; i++) {
        ans += dp[n - 1][i];
        if (ans > mod)
            ans = ans % mod;
    }
    cout << ans;
    return 0;
}
