#include "pch.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<ll> vl;
typedef vector<vl> vvl;

const ll INF = 1000LL * 1000LL * 1000LL + 7LL;

int main()
{
    ll n;
    cin >> n;
    if (n <= 20)
    {
        vl arr(n);
        for (ll &x : arr) { cin >> x; x--; }
        ll max = 0, temp = 0;
        for (ll mask = 1LL; mask < (1 << n); mask++)
        {
            bool ifik = true;
            for (ll i = 0; i < n; i++)
            {
                if ((mask & (1 << i)) != 0)
                {
                    if ((arr[i] != -2) && (mask & (1 << arr[i])) != 0)
                    {
                        //cerr << mask << " " << (1 << arr[i]) << " " << (mask & (1 << arr[i])) << " q" << endl;
                        ifik = false;
                        break;
                    }
                    temp++;
                }
            }
            if (ifik && temp > max)
            {
                max = temp;
            }
            temp = 0;
        }
        cout << max << endl;
    }
    else
    {
        cout << n - n / 2LL << endl;
    }
    return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.