#include <iostream>
#include <cmath>
#include <set>
using namespace std;
bool isEq(long double a, long double b)
{
	return abs(a - b) < 0.000001;
}
int main()
{
	long long int k;
	cin >> k;
	if (k == 0)
	{
		cout << 0;
		return 0;
	}
	int root = sqrt(abs(k));
	set<int> sqs;
	for (int x =  -root - 1; x <= root + 1; ++x)
	{
		if (x == 0)
			continue;
		long double ch = k - x * x;
		long double z = 2 * x;
		long double n = ch / z;
		if (isEq(n, (long long int)n))
		{
			sqs.insert(abs(n + x));
			//cout << abs(n + x);
			//system("pause");
			//return 0;
		}

	}
	if (sqs.empty())
		cout << "none";
	else
		cout << (*sqs.begin());
	//system("pause");
	return 0;
}