#include <iostream>
#include <vector>
#include <list>
#include <cmath>
using namespace std;
int max(int a, int b)
{
	return a > b ? a : b;
}
int main()
{
	int n, m;
	cin >> n >> m;
	vector<std::pair<int, int*>> types(m);
	list<std::pair<int, int*>> cards;
	auto getCard = [&cards](int x) mutable -> pair<int, std::list<std::pair<int, int*>>::iterator>
	{
		auto it = cards.begin();
		for (int i = 0; i < x; ++i)
			++it;
		
		return pair<int, std::list<std::pair<int, int*>>::iterator>(it->first, it);
	};
	int amount_of_actions = 0;
	std::vector<int> actions;
	for (int i = 0; i < m; ++i)
		cin >> types[i].first;
	for (int i = 0; i < n; ++i)
	{
		int x;
		cin >> x;
		cards.push_back(std::pair<int, int*>(x, new int (i)));
	}
	for (int i = 0; i < m; ++i)
	{
		auto it = cards.begin();
		for (; it->first != types[i].first; ++it)
			;
		types[i].second = it->second;
	}
	for (int i = 0; i < m; ++i)
	{
		
		int cur_card = getCard(0).first;
		bool achieved = false;
		while(!achieved)
		{
			if (cur_card == types[i].first)
				achieved = true;
			int j = i + 1;
			int min_available_pos = 0;
			for (; j < types.size() && types[j].first != cur_card; ++j)
				min_available_pos = max(min_available_pos, *types[j].second);
			int z = min_available_pos;
			auto zCard = getCard(z);
			if (j < types.size()) {
				
				z = max(min_available_pos, *(types[j - 1].second));
				zCard = getCard(z);
				++z;
			}
			else
			{
				
				z = cards.size();
				zCard = getCard(z - 1);
			}
			if (z == 0)
				++z;
			actions.push_back(z);
			++amount_of_actions;
			cards.insert(++zCard.second, std::pair<int, int*>(cur_card, cards.begin()->second));
			*cards.begin()->second = z - 1;
			
			cards.pop_front();
			auto it = cards.begin();
			for (int cur = 0; cur < z - 1; ++cur, ++it)
				--(*it->second);
			cur_card = getCard(0).first;
		}

	}
	cout << amount_of_actions << endl;
	for (int i = 0; i < amount_of_actions; ++i)
	{
		cout << actions[i] << ' ';
	}
	system("pause");
	return 0;
}