#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define endl '\n'

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	vector<int> a(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
	}

	const int INF = 1e6;
	vector<int> next(m);

	vector<int> last(n + 1, INF);
	for (int i = m - 1; i >= 0; i--) {
		next[i] = last[a[i]];
		last[a[i]] = i;
	}

	vector<int> b(n);
	for (int i = 0; i < n; i++) {
		cin >> b[i];
	}
	vector<int> to(n + 1, INF);
	for (int i = 0; i < m; i++) {
		if (to[a[i]] == INF) {
			to[a[i]] = i;
		}
	}

	int i = 0;
	vector<int> ans;
	vector<bool> used(n + 1);
	while (i < m) {
		used[b[0]] = true;
		int ind = to[b[0]];
		if (ind == INF) {
			ind = n - 1;
			ans.push_back(n);
		}
		else {
			if (b[0] == a[i]) {
				to[b[0]] = next[ind];
				i++;
			}
			if (to[b[0]] == INF) {
				ind = b.size() - 1;
			}
			for (int i = b.size() - 1; i >= 0; i--) {
				if (to[b[i]] <= to[b[0]]) {
					ind = i;
					break;
				}
			}
			ans.push_back(ind + 1);
		}
		int tmp = b[0];
		b.erase(b.begin());
		b.insert(b.begin() + ind, tmp);
	}

	cout << ans.size() << endl;
	for (auto i : ans) {
		cout << i << " ";
	}
}