#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define endl '\n'

using namespace std;

const long long MOD = 1e9 + 7;

void mod(long long& x) {
	x %= MOD;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	long long n, k;
	cin >> n >> k;
	if (k == n) {
		cout << 1;
		return 0;
	}

	vector<vector<vector<long long> > > dp(n + 1, vector<vector<long long> >(n + 1, vector<long long>(2)));
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	for (long long i = 0; i <= n; i++) {
		for (long long k = 1; k <= i; k++) {
			for (long long prev = 1; prev < k; prev++) {
				dp[i][k][1] += dp[i - k][prev][0];
				mod(dp[i][k][1]);
			}
			for (long long prev = k + 1; prev <= n; prev++) {
				dp[i][k][0] += dp[i - k][prev][1];
				mod(dp[i][k][0]);
			}
		}
	}

	long long ans = 0;
	for (long long k = 1; k <= n; k++) {
		ans += dp[n][k][0] + dp[n][k][1];
		mod(ans);
	}
	cout << ans;
}