#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define endl '\n'

using namespace std;

const long long MOD = 1e9 + 7;

void mod(long long& x) {
	x %= MOD;
}

const int MAXON = 5001;
long long dp[MAXON][MAXON][2];
long long pref[MAXON][2][MAXON];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	long long n, k;
	cin >> n >> k;
	if (k == n) {
		cout << 1;
		return 0;
	}

	//vector<vector<vector<long long> > > dp(n + 1, vector<vector<long long> >(n + 1, vector<long long>(2)));
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	//vector<vector<vector<long long> > > pref(n + 1, vector<vector<long long> >(2, vector<long long>(n + 1)));
	for (long long i = k; i <= n; i++) {
		pref[k][0][i]++;
		pref[k][1][i]++;
	}

	for (long long i = k + 1; i <= n; i++) {
		for (long long k = 1; k <= i; k++) {
			dp[i][k][1] = pref[i - k][0][k - 1];
			if (k < n) {
				dp[i][k][0] = pref[i - k][1][n] - pref[i - k][1][k];
			}
			// add(fen[i][1], k, dp[i][k][1], n + 1);
			//add(fen[i][0], k, dp[i][k][0], n + 1);
		}
		for (long long k = 1; k <= n; k++) {
			pref[i][0][k] = pref[i][0][k - 1] + dp[i][k][0];
			mod(pref[i][0][k]);
			pref[i][1][k] = pref[i][1][k - 1] + dp[i][k][1];
			mod(pref[i][1][k]);
		}
	}

	long long ans = 0;
	for (long long k = 1; k <= n; k++) {
		ans += dp[n][k][0] + dp[n][k][1];
		mod(ans);
	}
	cout << ans;
}