#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define endl '\n'

using namespace std;

int kol(int mask) {
	int ans = 0;
	while (mask) {
		ans += mask % 2;
		mask /= 2;
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;
	vector<int> to(n);
	for (int i = 0; i < n; i++) {
		cin >> to[i];
		if (to[i] != -1) {
			to[i]--;
		}
	}

	int ans = 0;
	for (int mask = 0; mask < (1 << n); mask++) {
		bool f = true;
		for (int i = 0; i < n; i++) {
			if (to[i] == -1) continue;
			if ((mask & (1 << i)) && (mask & (1 << (to[i])))) {
				f = false;
				break;
			}
		}
		if (f) {
			ans = max(ans, kol(mask));
		}
	}
	cout << ans;
}