#include <iostream>
#include <vector>
#include <cmath>
#define int long long

int mod = 1e9 + 7;

using namespace std;

main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    long long k;
    cin >> n >> m >> k;
    vector<vector<int>> d(n, vector<int>(k + 1, 0));
    long long ans = 0;
    for (int i = 0; i <= k; i++) {
        d[0][i] = 1;
    }
    for (int i = 1; i < n; i++) {
        for (int j = 0; j <= k; j++) {
            for (int f = j; f <= k; f++) {
                if (((f - j) & j) == 0) {
                    d[i][f] += d[i - 1][j];
                    d[i][f] %= mod;
                }
            }
        }
    }
    for (int i = 0; i <= k; i++) {
        ans += d[n - 1][i];
        ans %= mod;
    }
    cout << ans;
    return 0;
}
