#include <iostream>
#include <vector>

int mod = 1e9 + 7;

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    vector<vector<vector<int>>> d(n + 1, vector<vector<int>>(n + 1, vector<int>(2, 0))); /// ind
    d[k][k][0] = 1;
    d[k][k][1] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            for (int f = j + 1; f <= n - i; f++) {
                d[i + f][f][0] += d[i][j][1] % mod;
                d[i + f][f][0] %= mod;
            }
            for (int f = 1; f < min(j, n - i + 1); f++) {
                d[i + f][f][1] += d[i][j][0] % mod;
                d[i + f][f][1] %= mod;
            }
        }
    }
    long long ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += d[n][i][0];
        ans %= mod;
        ans += d[n][i][1];
        ans %= mod;
    }
    cout << ans;
    return 0;
}
