#include <iostream>
#include <vector>
#include <queue>

int ans = 0;
int n;
int iff = 0;

using namespace std;

bool check(vector<vector<int>> &graph, vector<int> &vec) {
    vector<int> forb(n, 0);
    for (int i = 0; i < vec.size(); i++) {
        forb[vec[i]] = 1;
    }
    for (int i = 0; i < vec.size(); i++) {
        for (auto elem : graph[vec[i]]) {
            if (forb[elem] == 1)
                return false;
        }
    }
    return true;
}

void pereb(vector<vector<int>> &graph, vector<int> taken, int u) {
    if (u == n) {
        if (check(graph, taken)) {
            int sz = taken.size();
            ans = max(ans, sz);
        }
    }
    else {
        pereb(graph, taken, u + 1);
        taken.push_back(u);
        pereb(graph, taken, u + 1);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    vector<vector<int>> graph(n);
    int a;
    for (int i = 0; i < n; i++) {
        cin >> a;
        if (a != -1) {
            if (a != i) {
                iff = 1;
            }
            graph[i].push_back(a - 1);
            graph[a - 1].push_back(i);
        }
    }
    if (n > 20) {
        if (iff == 0) {
            cout << (n + 1) / 2;
            return 0;
        }
        vector<int> used(n, 0);
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                queue<pair<int, int>> bfs;
                int cnt0 = 1, cnt1 = 0;
                bfs.push(make_pair(i, 0));
                used[i] = 1;
                while (!bfs.empty()) {
                    pair<int, int> pa = bfs.front();
                    bfs.pop();
                    for (auto elem : graph[pa.first]) {
                        if (!used[elem]) {
                            if (pa.second == 0) {
                                cnt1++;
                                bfs.push(make_pair(elem, 1));
                            }
                            else {
                                cnt0++;
                                bfs.push(make_pair(elem, 0));
                            }
                            used[elem] = 1;
                        }
                    }
                }
                ans += max(cnt1, cnt0);
            }
        }
        return 0;
    }
    vector<int> help(0);
    pereb(graph, help, 0);
    cout << ans;
    return 0;
}
