#include <iostream>
#include <vector>
#include <map>

using namespace std;

vector<vector<int>> ar;
vector<int> col;
vector<int> col2;
vector<int> col4;
vector<vector<int>> mem;

int dfs(int v)
{
    if (col[v] == 1337)
        return 0;
    col[v] = 1337;
    int r = 0;
    int ans1 = 1;
    int ans2 = 0;
    for (int i = 0; i < ar[v].size(); ++i)
    {
        int to = ar[v][i];
        if (col2[to] == 1337){
            r = 1;
            break;
        }
    }
    if (r == 0){
        for (int i = 0; i < ar[v].size(); ++i)
        {
            int to = ar[v][i];
            if (col[to] == 0)
            {
                col2[v] = 1337;
                ans1 += dfs(to);
                col2[v] = 0;
                col[to] = 0;
            }
        }
    }
    for (int i = 0; i < ar[v].size(); ++i)
    {
        int to = ar[v][i];
        if (col[to] == 0)
        {
            ans2 += dfs(to);
        }
    }
    if (r == 0)
        return max(ans1,ans2);
    else
        return ans2;
}

int dfs1(int v,vector<int> col3)
{
    col[v] = 1;
    int r = 0;
    int ans1 = 1;
    int ans2 = 0;
    for (int i = 0; i < ar[v].size(); ++i)
    {
        int to = ar[v][i];
        if (col2[to] == 1){
            r = 1;
            break;
        }
    }
    if (mem[v][r] != -1)
        return mem[v][r];
    if (r == 0){
        for (int i = 0; i < ar[v].size(); ++i)
        {
            int to = ar[v][i];
            if (col[to] == 0)
            {
                col2[v] = 1;
                ans1 += dfs1(to,col);
                col2[v] = 0;
                col[to] = 0;
            }
        }
    }
    col = col3;
    if (v == 0)
        ans2 = 0;
    for (int i = 0; i < ar[v].size(); ++i)
    {
        int to = ar[v][i];
        if (col[to] == 0)
        {
            col[to] = 1;
            ans2 += dfs1(to,col);
        }
    }
    if (r == 0){
        mem[v][r] = max(ans1,ans2);
        return max(ans1,ans2);
    }
    else{
        mem[v][r] = ans2;
        return ans2;
    }
}

int main()
{
    int n,ans3 = 0,ans = 0;
    cin >> n;
    ar = vector<vector<int>>(n,vector<int>());
    mem = vector<vector<int>>(n,vector<int>(2,-1));
    col = vector<int>(n,0);
    col2 = vector<int>(n,0);
    for (int i = 0; i < n; ++i)
    {
        int a;
        cin >> a;
        if (a != -1){
            ar[i].push_back(a - 1);
            ar[a - 1].push_back(i);
        }
    }
    if (n < 2000){
    for (int i = 0; i < n; ++i)
    {
        if (col[i] == 0){
            col[i] = 1;
            ans3 += dfs1(i,col);
        }
    }
    }
    if (n > 2000)
    {
        for (int i = 0; i < n; ++i)
        {
        if (col[i] == 0){
            col[i] = 1;
            ans += dfs1(i,col);
        }
        }
    }
    cout << max(ans,ans3);
    return 0;
}
