#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


void optimize() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


#define int long long


const int INF = (int)1e18;


signed main() {
    optimize();

    int k;
    cin >> k;

    if (k == 0) {
        cout << 0;

        return 0;
    }

    int answ = INF;

    for (int i = 1; i * i <= abs(k); ++i) {
        if (k % i) {
            continue;
        }

        int xmn = i;
        int xpn = k / i;

        if (k < 0) {
            xmn = -xmn;
            xpn = -xpn;
        }

        if ((xmn + xpn) % 2) {
            continue;
        }

        int x = (xmn + xpn) / 2;
        int n = xpn - x;

        if (n >= 0) {
            answ = min(answ, x);
        }
    }

    if (answ == INF) {
        cout << "none";

        return 0;
    }

    cout << answ;

    return 0;
}