#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


#define int long long


int ppcnt(int x) {
    int res = 0;

    while (x) {
        res += x % 2;

        x >>= 1;
    }

    return res;
}


int log(int x) {
    int i;
    for (i = 0; (1LL << i) <= x; ++i);

    return i - 1;
}


const int M = (int)1e9 + 7;


int m;
vector<pair<int, int>> qs;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;

    cin >> n >> m >> k;

    qs.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> qs[i].first >> qs[i].second;

        --qs[i].first;
        --qs[i].second;
    }

    int pc = ppcnt(k);
    int lg = log(k);

    vector<vector<int>> dp(n, vector<int>(lg + 1));
    for (int i = 0; i <= lg; ++i) {
        dp[0][i] = 1;
    }

    for (int i = 1; i < n; ++i) {
        for (int j = 0; j <= lg; ++j) {
            for (int k = 0; k <= j; ++k) {
                dp[i][j] += dp[i - 1][k];
            }
        }
    }

    vector<vector<vector<int>>> adp(n, vector<vector<int>>(pc + 1, vector<int>(2)));
    for (int i = 0; i < pc; ++i) {
        adp[0][i][0] = 1;
    }

    for (int i = 1; i <= pc; ++i) {
        adp[0][i][1] = 1;
    }

    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < pc; ++j) {
            for (int k = 0; k <= j; ++k) {
                adp[i][j][0] += adp[i - 1][k][0];
            }
        }
    }

    for (int i = 1; i < n; ++i) {
        for (int j = 1; j <= pc; ++j) {
            for (int k = 0; k < j; ++k) {
                adp[i][j][1] += adp[i - 1][k][0];
            }

            for (int k = 0; k <= j; ++k) {
                adp[i][j][1] += adp[i - 1][k][1];
            }
        }
    }

    int answ = 0;
    for (int i = 0; i <= lg; ++i) {
        answ += dp[n - 1][i];
    }

    for (int i = 0; i <= pc; ++i) {
        answ += adp[n - 1][i][1];
    }

    cout << answ;

    return 0;
}