#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


#define int long long


int ppcnt(int x) {
    int res = 0;

    while (x) {
        res += x % 2;

        x >>= 1;
    }

    return res;
}


int log(int x) {
    int i;
    for (i = 0; (1LL << i) <= x; ++i);

    return i - 1;
}


const int M = (int)1e9 + 7;


int m;
vector<pair<int, int>> qs;


const int K = 1000;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;

    cin >> n >> m >> k;

    qs.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> qs[i].first >> qs[i].second;

        --qs[i].first;
        --qs[i].second;
    }

    vector<vector<int>> dp(n, vector<int>(k + 1));
    for (int i = 0; i <= k; ++i) {
        dp[0][i] = 1;
    }

    for (int i = 1; i < n; ++i) {
        for (int j = 0; j <= k; ++j) {
            for (int c = 0; c <= j; ++c) {
                if ((c & j) == c) {
                    dp[i][j] = (dp[i][j] + dp[i - 1][c]) % M;
                }
            }
        }
    }

    int answ = 0;
    for (int i = 0; i <= k; ++i) {
        answ = (answ + dp[n - 1][i]) % M;
    }

    cout << answ;

    return 0;
}