#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const long double EPS = 1e-9;
const long long INF = 1e9;

using namespace std;

long long n, m, k;
vector <int> vec;
vector <vector <int>> rvec;
vector <vector <int>> g;
vector <int> used;
vector <int> smth;
vector <bool> tused;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
vector <int> cur;
vector <vector <int>> anime;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> k;
	vector <vector <vector <int>>> dp(n + 1, vector <vector <int>>(n + 1, vector <int> (2)));
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	if (n == k) {
		cout << 1;
		return 0;
	}
	for (int i = 0; i <= n; ++i) {
		for (int j = 1; j <= i; ++j) {
			for (int k = 0; k < j; ++k) {
				if (i - j >= 0)
					dp[i][j][1] += dp[i - j][k][0];
			}
			for (int k = j + 1; k <= n; ++k) {
				if (i - j >= 0)
					dp[i][j][0] += dp[i - j][k][1];
			}
		}
	}
	ll ans = 0;
	for (int i = 0; i <= n; ++i) {
		ans += dp[n][i][0];
		ans += dp[n][i][1];
	}
	cout << ans << '\n';
/*	for (auto x : dp) {
		for (auto y : x) {
			cout << y[0] << ' ';
		}
		cout << '\n';
	}
	cout << '\n';
	for (auto x : dp) {
		for (auto y : x) {
			cout << y[1] << ' ';
		}
		cout << '\n';
	}*/
	return 0;
}