#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <set>
#include <map>
#define MAXN 100000
#define int long long

using namespace std;

const int mod = 1000000007;
int n, mx, m, k, i, j, c[200][200], b[200][200];
int t[61][MAXN], cnt[MAXN];
bool flag[61][MAXN];
vector <int> h[MAXN];

void push(int v, int tl, int tr, int k){
    if(!flag[k][v])
        return;

    if(tl == tr){
        t[k][v * 2] = t[k][v * 2 + 1] = 0;
        flag[k][v * 2] = flag[k][v * 2 + 1] = 1;
    }

    flag[k][v] = 0;
}

void upd(int v, int tl, int tr, int pos, int k, int sum = 0){
    int m = (tl + tr) / 2;

    //if(k ==2 sum > 0)
    //    cout << v << " " << pos << " " << k << endl;
    push(v, tl, tr, k - 1);
    push(v, tl, tr, k);

    if(tl == tr){
        //if(sum > 0)cout << v << " " << sum << endl;
        if(sum == -123)
            t[k][v] = 1;
        else
            t[k][v] = (t[k][v] + sum) % mod;
        return;
    }

    if(pos <= m)
        upd(v * 2, tl, m, pos, k, sum);
    else
        upd(v * 2 + 1, m + 1, tr, pos, k, sum + t[k - 1][v * 2]);

    t[k][v] = (t[k][v * 2] + t[k][v * 2 + 1]) % mod;
       //         if(t[k][v] > 0)
       //     cout <<k << " " << v << " " << t[k][v] << endl;
}

void upd2(int v, int tl, int tr, int l, int r, int k){
    int m = (tl + tr) / 2;

    push(v, tl, tr, k);

    if(l > r)
        return;

    if(tl == l && tr == r){
        //if(k == 2)
        //   cout << v << " " << tl << " * " << tr << " " << r << endl;
        t[k][v] = 0; flag[k][v] = 1;
        return;
    }

    upd2(v * 2, tl, m, l, min(r, m), k);
    upd2(v * 2 + 1, m + 1, tr, max(l, m + 1), r, k);
    t[k][v] = (t[k][v * 2] + t[k][v * 2 + 1]) % mod;

    //if(k == 2)
    //    cout << k << " " << v << " " << t[k][v] << endl;
}

main(){
   // freopen("input.txt", "r" , stdin);
    ios_base::sync_with_stdio(0);
    cin.tie();

    cin >> n >> m >> mx;

    for(i = 0; i < m; i++){
        int a, b;

        cin >> a >> b;
        a--; b--;

        h[b].push_back(a);
    }

    upd(1, 0, n - 1, 0, 1, -123);

    for(i = 0; i < n; i++){
        int mx = -1;
        for(j = 0; j < h[i].size(); j++)
            mx = max(mx, h[i][j]);

        for(j = 1; j <= 60; j++)
            upd(1, 0, n - 1, i, j);

        for(j = 1; j <= 60; j++)
            upd2(1, 0, n - 1, 0, mx, j);
        //push(1, 0, n - 1, 2);
        //cout << t[2][1] << endl;
    }

    for(i = 0; i <= 60; i++){
        for(j = 0; j <= 60; j++){
            if(j == 0)
                c[i][j] = 1;
            else{
                if(i == 0)
                    c[i][j] = 0;
                else
                    c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % mod;
            }
        }
    }

    b[0][0] = 1;

    for(i = 1; i <= 60; i++){
        for(k = 0; k <= i; k++){
            for(j = 1; j <= i; j++)
                b[i][k] = (b[i][k] + c[i][j] * b[i - j][k - 1]) % mod;
        }

        if(i <= 60)
            push(1, 0, n - 1, i);
    }

    int ans = 0;

    //cout << t[60][1] << endl;
    for(i = 0; i <= mx; i++){
        cnt[i] = cnt[i >> 1] + (i & 1);

        for(j = 1; j <= 60; j++){
            if(!t[j][1])
                continue;

           ans = (ans + t[j][1] * (b[cnt[i]][j] + b[cnt[i]][j - 1])) % mod;
          // if(i == mx)
                //cout << i << " " << j << " " << cnt[i] << " " << t[j][1] << " " << (b[cnt[i]][j] + b[cnt[i]][j - 1]) << endl;
        }
        //cout << '*'<< k << " " << ans << endl;
    }

    cout << ans;

    return 0;
}


//v19.893.790
//Y4osXsHr



















