#include <iostream>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int INF = 1 << 30;
const ll LLINF = 1LL << 60;

template <class T>
istream& operator>>(istream &in, vector<T> &ar) {
    for (int i = 0; i < ar.size(); ++i)
        in >> ar[i];
    return in;
}

template <class T>
ostream& operator<<(ostream &out, vector<T> &ar) {
    for (T x : ar)
        out << x << ' ';
    return out;
}

int main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> d(n, vector<ll>(k + 1, 0));
    for (int i = 0; i <= k; ++i)
        d[0][i] = 1;
    const ll MOD = 1e9 + 7;
    for (int i = 1; i < n; ++i) {
        for (int m = 0; m <= k; ++m) {
            for (int m2 = 0; m2 <= k; ++m2)
                if ((m & m2) == m)
                    d[i][m2] = (d[i][m2] + d[i - 1][m]) % MOD;
        }
        //cout << d[i] << '\n';
    }
    ll sum = 0;
    for (int i = 0; i <= k; ++i)
        sum = (sum + d[n - 1][i]) % MOD;
    cout << sum << '\n';
}
