#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second
#define f(i, n) for (int i = 0; i < (n); i++)

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << "{" << p.x << ", " << p.y << "}";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class T>
ostream &operator<<(ostream &os, const set<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const map<A, B> &v) {
	for (const auto &x : v) {
		os << x << " ";
	}
	return os;
}

void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

void run() {
	ll k;
	cin >> k;
	if (k == 0) {
		cout << 0 << endl;
		return;
	}
	vector<ll> divs;
	for (ll i = 1; i * i <= abs(k); i++) {
		if (abs(k) % i == 0) {
			divs.pb(abs(k) / i);
			divs.pb(-abs(k) / i);
			divs.pb(-i);
			divs.pb(i);
		}
	}
	sort(divs.begin(), divs.end());
	divs.resize(unique(divs.begin(), divs.end()) - divs.begin());
	ll rez = 1e18;
	for (ll sub : divs) {
		ll add = k / sub;
		if ((add - sub) % 2 != 0) continue;
		ll b = (add - sub) / 2;
		ll n = sub + b;
		if (n < 0) continue;
		rez = min(rez, n);
	}
	if (rez == 1e18) {
		cout << "none" << endl;
	} else {
		cout << rez << endl;
	}
}