#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <math.h>
#include <fstream>
#include <iomanip>

#define ll long long
#define ull unsigned long long
#define ld long double
#define u_map unordered_map
#define mp make_pair
#define pb push_back

using namespace std;

const int MOD = 1000000007;

int main() {
	int n, k;
	cin >> n >> k;
	if (n == k) {
		cout << 1;
		return 0;
	}
	vector<vector<ll>> dp1(n + 1, vector<ll>(n + 1, 0)), dp2(n + 1, vector<ll>(n + 1, 0));
	dp1[n - k][k] = 1;
	dp2[n - k][k] = 1;
	for (int i = n; i >= 0; i--) {
		for (int j = 1; j <= n; j++) {
			if (dp1[i][j] > 0)
				for (int k = j + 1; k <= i; k++)
					dp2[i - k][k] = (dp2[i - k][k] + dp1[i][j]) % MOD;
			if (dp2[i][j] > 0)
				for (int k = j - 1; k > 0; k--)
					if (k <= i)
						dp1[i - k][k] = (dp1[i - k][k] + dp2[i][j]) % MOD;
		}
	}
	ll ans = 0;
	for (int i = 0; i <= n; i++)
		ans = (ans + dp1[0][i]) % MOD;
	for (int i = 0; i <= n; i++)
		ans = (ans + dp2[0][i]) % MOD;
	cout << ans;
	return 0;
}
