#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

inline int myFind(vector<vector<int>>& arr, vector<int> cards, int element);
inline int findPlace(vector<int>& arr, int elem)
{
	for (int i = 0; i < arr.size(); i++)
		if (arr[i] == elem) return i;
	return 0;
}

int main()
{
	ios::sync_with_stdio(false);
	int n = 0, m = 0;
	cin >> n >> m;

	vector<int> goods(m), cardds(n), places;
	vector<vector<int>> cards(n);
	for (int i = 0; i < m; i++)
	{
		cin >> goods[i];
		goods[i]--;
		cards[goods[i]].push_back(i);
	}

	for (int i = 0; i < n; i++)
	{
		cin >> cardds[i];
		cardds[i]--;
		cards[i].push_back(500000);
	}


	bool ok = false;
	if (n == m)
	{
		ok = true;
		for (int i = 0; i < n; i++)
		{
			if (goods[i] != cardds[n - i - 1]) { ok = false; break; }
		}
	}

	if (ok)
	{
		cout << 2 * n - 1 << endl;
		for (int i = 0; i < n - 1; i++) cout << n - i << " ";
		for (int i = 0; i < n; i++)     cout << n << " ";
	}
	else
	{
		
		int place = 0, j = 0, insertPlace = 0;
		for (int i = 0; i < m; i++)
		{
			place = findPlace(cardds, goods[i]);
			for (j = 0; j < place; j++)
			{
				insertPlace = myFind(cards, cardds, cards[cardds[0]][0]);
				places.push_back(insertPlace);
				cardds.insert(cardds.begin() + insertPlace + 1, cardds[0]);
				cardds.erase(cardds.begin());
			}

			cards[cardds[0]].erase(cards[cardds[0]].begin());
			insertPlace = myFind(cards, cardds, cards[cardds[0]][0]);
			places.push_back(insertPlace);
			cardds.insert(cardds.begin() + insertPlace + 1, cardds[0]);
			cardds.erase(cardds.begin());
		}

		cout << places.size() << endl;
		for (int i = 0; i < places.size(); i++)
			cout << places[i] + 1 << " ";
	}
		
	//system("pause");
	return 0;
}

inline int myFind(vector<vector<int>>& arr, vector<int> cards, int element)
{
	for (int k = arr.size() - 1; k >= 0; k--)
		if (arr[cards[k]][0] <= element) return k;
	return 1;
}
