#include <bits/stdc++.h>

using namespace std;

#define ALL(x) (x).begin(), (x).end()
#define BALL(x) (x).rbegin(), (x).rend()
#define LAST(x) (x)[(x).size() - 1]

//#define DEBUG
#ifdef DEBUG
ifstream _in("debug.in");
#define cin _in
#endif

//#define int long long
#define endl '\n'
#define INF 1e15+7
const int MOD = 1e9+7;

signed main() {
	ios_base::sync_with_stdio(false);

	int n; cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	if (n <= 20) {
		int mask = 0, mx = 1 << n, ans = 0;
		bool good = true;
		while (mask < mx) {
			good = true;
			for (int i = 0; i < n; ++i) {
				if ((mask & (1 << i)) && a[i] != -1 && (mask & (1 << (a[i] - 1)))) {
					good = false;
					break;
				}
			}
			if (good) {
				ans = max(ans, __builtin_popcount(mask));
			}
			++mask;
		}
		cout << ans << endl;
	} else {
		vector<vector<int>> sons(n);
		for (int i = 0; i < n; ++i) {
			if (a[i] != -1) {
				sons[a[i] - 1].push_back(i);
			}
		}
		vector<bool> used(n, false);
		int ans = 0;
		vector<pair<int, int>> bfs;
		for (int i = 0; i < n; ++i) {
			if (!used[i] && a[i] == -1) {
				bfs.clear();
				bfs.push_back({i, 0});
				used[i] = true;
				int curBFS = 0;
				while (curBFS < bfs.size()) {
					for (auto e : sons[bfs[curBFS].first]) {
						bfs.push_back({e, 1 - bfs[curBFS].second});
						used[e] = true;
					}
					++curBFS;
				}
				vector<int> partial_ans(2, 0);
				for (auto e : bfs) {
					++partial_ans[e.second];
				}
				ans += max(partial_ans[0], partial_ans[1]);
			}
		}
		cout << ans << endl;
	}
}