#include <bits/stdc++.h>

using namespace std;

int find_ans(int mask, vector<int> &lst){
    int n = lst.size();
    for (int i = 0; i < n; i++){
        if ((mask >> i) % 2 && (lst[i] != -1 && (mask >> lst[i]) % 2))
            return -1;
    }
    int ans = 0;
    while (mask > 0){
        if (mask % 2)
            ans++;
        mask /= 2;
    }
    return ans;
}

int count(int n){
    int ans = 1;
    for (int i = 0; i < n; i++)
        ans *= 2;
    return ans;
}

void first_solution(int n, vector<int> &lst){
    int ans = -1, curr;
    int max_mask = count(n);
    for (int mask = 0; mask < max_mask; mask++){
        curr = find_ans(mask, lst);
        ans = max(ans, curr);
    }
    cout << ans;
}

void second_solution(int n){
    cout << (n + 1) / 2;
}

void dfs(int i, vector<vector<int>> &graph, int &cnt1, int &cnt2, bool f, vector<bool> &used){
    used[i] = true;
    if (f)
        cnt1++;
    else
        cnt2++;
    for (int el : graph[i]){
        dfs(el, graph, cnt1, cnt2, !f, used);
    }
}

void third_solution(int n, vector<int> &lst){
    int ans = 0;
    vector<vector<int>> graph(n);
    for (int i = 0; i < n; i++){
        if (lst[i] != -1)
            graph[lst[i]].push_back(i);
    }
    lst.clear();
    vector<bool> used(n);
    for (int i = 0; i < n; i++)
        if (!used[i]){
            int cnt1 = 0, cnt2 = 0;
            dfs(i, graph, cnt1, cnt2, true, used);
            //cout << cnt1 << " " << cnt2 << endl;
            ans += max(cnt1, cnt2);
        }
    cout << ans;
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> lst(n);
    for (int i = 0; i < n; i++){
        cin >> lst[i];
        if (lst[i] != -1)
            lst[i]--;
    }
    if (n <= 20){
        first_solution(n, lst);
        return 0;
    }
    bool ok = true;
    for (int i = 0; i < n; i++)
        if (lst[i] != i - 1){
            ok = false;
            break;
        }
    if (ok){
        second_solution(n);
        return 0;
    }
    if (1)
        third_solution(n, lst);
    return 0;
}