#pragma GCC optimise("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 5011;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif
int n, k;
int dp[MAXN][MAXN][2];
int pref[MAXN][MAXN][2];
int mod = (1e9 + 7);

void init() {
	memset(dp, 0, sizeof(dp));
}

void solve() {
	init();
	if (n == k) {
		cout << 1 << '\n';
		return;
	}
  	for (int i = 0; i < MAXN; i++) {
  		dp[i][i][0] = dp[i][i][1] = 1;
  	}
	for (int sum = 1; sum <= n; sum++) {
		for (int last = 1; last <= n; last++) {
			if (last > sum) {
				continue;
			}
			if (1) {
				for (int lst = 1; lst < last; lst++) {
					dp[sum][last][0] += dp[sum - last][lst][1];
					dp[sum][last][0] %= mod;
				}
				for (int lst = last + 1; lst <= sum; lst++) {
					dp[sum][last][1] += dp[sum - last][lst][0];
					dp[sum][last][0] %= mod;
				}
			}
			else {
				dp[sum][last][0] = pref[sum - last][last][1];
				dp[sum][last][1] = pref[sum - last][last + 1][0];
			}
		}
		for (int i = 1; i <= n; i++) {
			pref[sum][i][1] = pref[sum][i - 1][1] + dp[sum][i][1]; 
			pref[sum][i][1] %= mod;
		}
		for (int i = n; i > 0; i--) {
			pref[sum][i][0] = pref[sum][i + 1][0] + dp[sum][i][0]; 
			pref[sum][i][0] %= mod;
		}
	}		
	cout << (dp[n][k][0] + dp[n][k][1]) % mod << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("B.in", "r", stdin);
		freopen("B.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> k) {
		solve();
	}
}