//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,avx2,mmx,popcnt,abm,tune=native")
//#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector")

//#include <bits/stdc++.h>
#include <iostream>
#include <algorithm>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
#include <chrono>
#include <iterator>
#include <climits>

using namespace std;

mt19937 Random(time(NULL));

map<pair<int, int>, int> memo;
int recur(int n, bool is_less, int u) {
    if (n == 0)
        return 1;
    int ans = 0;
    if (is_less) {
        if (memo.find({n, -u}) != memo.end())
            return memo[{n, -u}];
        for (int t = max(1, u - n); u - t > 0; t++) {
            ans += recur(n - u + t, 0, u - t);
        }
        memo[{n, -u}] = ans;
    } else {
        if (memo.find({n, u}) != memo.end())
            return memo[{n, u}];
        for (int t = 1; n >= u + t && u + t > 0; t++) {
            ans += recur (n - u - t, 1, u + t);
        }
        memo[{n, u}] = ans;
    }
    return ans;
}

int main() {
    int n, k;
    cin >> n >> k;
    if (n == k)
        cout << 1;
    else
        cout << recur(n - k, 0, k) + recur(n - k, 1, k);
}