#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma comment(linker, "/STACK:256000000")
vector<vector<int>>g;
vector<int>par;
vector<int>used;
vector<int>dist;
vector<int>in;
bool z = 0;
int c = -1;
void find(int v) {
	for (auto u : g[v]) {
		if (!used[u]) {
			par[u] = v;
			used[u] = 1;
			find(u);
		}
		else {
			if (z == 0 && par[v] != u) {
				par[u] = v;
				z = 1;
				c = u;
			}
		}
	}
}
int cnt1 = 0;
int cnt2 = 0;
vector<int>no;
void dfs(int v) {
	for (auto u : g[v]) {
		if (in[u] == 0 && dist[u] == -1) {
			dist[u] = dist[v] + 1;
			if (dist[u] % 2 == 1) {
				cnt1++;
			}
			else {
				cnt2++;
			}
			dfs(u);
		}
	}
}
void dfs2(int v) {
	for (auto u : g[v]) {
		if (dist[u] == -1) {
			dist[u] = dist[v] + 1;
			if (dist[u] % 2 == 1) {
				cnt1++;
			}
			else {
				cnt2++;
			}
			dfs2(u);
		}
	}
	
}
signed main() {
	int n;
	cin >> n;
	g.resize(n);
	par.resize(n, -1);
	used.resize(n);
	no.resize(n);
	dist.resize(n, -1);
	in.resize(n);
	map<pair<int, int>, int>mp;
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		if (x == -1) {
			continue;
		}
		x--;
		if (mp[{ min(x, i), max(x, i) }] == 0) {
			g[x].push_back(i);
			g[i].push_back(x);
		}
		mp[{ min(x, i), max(x, i) }] = 1;
	}
	int ans = 0;
	vector<int>d(n, -1);
	for (int q = 0; q < n; q++) {
		if (!used[q]) {
			used[q] = 1;
			find(q);
			if (c == -1) {
				dist[q] = 0;
				dfs2(q);
				ans += max(cnt1, cnt2 + 1);
				continue;
			}
			int u = par[c];
			while (u != c) {
				in[u] = 1;
				u = par[u];
			}
			in[c] = 1;
			u = par[c];
			while (u != c) {
				dist[u] = 0;
				cnt1 = 0;
				cnt2 = 0;
				dfs(u);
				if (cnt1 > cnt2) {
					no[u] = 1;
					ans += cnt1;
				}
				else {
					ans += cnt2;
				}
				u = par[u];
			}
			dist[u] = 0;
			cnt1 = 0;
			cnt2 = 0;
			dfs(u);
			if (cnt1 > cnt2) {
				no[u] = 1;
				ans += cnt1;
			}
			else {
				ans += cnt2;
			}
			u = par[c];
			while (no[u] == 0 && u != c) {
				u = par[u];
			}
			int k = 0;
			if (no[u] == 0) {
				d[u] = 0;
				k++;
			}
			int c = u;
			while (par[u] != c) {
				if (no[par[u]] == 0) {
					d[par[u]] = d[u] + 1;
					if (d[par[u]] % 2 == 0) {
						k++;
					}
				}
				u = par[u];
			}
			ans += k;
		}
	}
	cout << ans;
	return 0;
}