//#pragma optimization level 3
#pragma GCC optimize("Ofast, no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize ("fast-math")
#include<bits/stdc++.h>

#define pb push_back
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(), v.rend()
#define F first
#define S second
#define mp make_pair
#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const int MAXN = 2e5;
const int mod = 1e9 + 7;

vector<int>g[300200];
bool used[300200];
int color[300200];
void dfs(int v)
{
    used[v] = true;
    bool is = true;
    for(int i = 0; i < g[v].size(); ++i)
    {
        int to = g[v][i];
        if (!used[to])
            dfs(to);
    }
    for(int i = 0; i < g[v].size(); ++i)
    {
        int to = g[v][i];
        is &= (color[to] == 0);
    }
    if (is)
    {
        color[v] = 1;
    }
    return;
}




signed main()
{
    cin.tie(0);
    cin.sync_with_stdio(0);
    cout.tie(0);
    cout.sync_with_stdio(0);
    int n;
    cin >> n;
    bool kek = true;
    for(int i = 0; i < n; ++i)
    {
        int aa;
        cin >> aa;
        if (i == 0 && aa != -1)
            kek = false;
        else if (i != 0)
            kek &= (aa == i);
        if (aa != -1)
        {
            --aa;
            g[aa].pb(i);
            g[i].pb(aa);
        }
    }
    if (kek)
    {
        cout << (n + 1) / 2 << endl;
        return 0;
    }
    int ans = 1;
    for(int i = 0; i < n; ++i)
    {
        dfs(i);
        for(int j = 0; j < n; ++j)
        {
            if (!used[j])
            {
                dfs(j);
            }
        }
        int cnt = 0;
        for(int j = 0; j < n; ++j)
        {
            if (color[j] == 1)
                ++cnt;
        }
        for(int j = 0; j < n; ++j)
        {
            color[j] = 0;
            used[j] = false;
        }
        ans = max(ans, cnt);
        if (clock() > CLOCKS_PER_SEC * 0.96)
        {
            cout << ans << endl;
            return 0;
        }
    }
    cout << ans << endl;
    return 0;
}
