#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unroll-all-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt")

#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<int> a;
vector<int> b;
vector<int> ans;

void solve() {
	vector<int> pos(n);
	for (int i = 0; i < n; ++i)
		pos[b[i]] = i;
	for (int i = 0; i < m; ++i) {
		while (b[0] != a[i]) {
			// for (auto q : b) cout << q << ' '; cout << endl;
			int found = 0;
			int maxx = 0;
			int cur = b[0];
			for (int t = i; t < m; ++t) {
				if (a[t] == cur) {
					found = 1;
					break;
				}
				maxx = max(maxx, pos[a[t]]);
			}
			if (!found) maxx = n - 1;
			ans.push_back(maxx + 1);
			for (int t = 0; t < maxx; ++t)
				b[t] = b[t + 1];
			b[maxx] = cur;
			for (int t = 0; t < n; ++t)
				pos[b[t]] = t;
		}
		int found = 0;
		int maxx = 0;
		int cur = b[0];
		for (int t = i + 1; t < m; ++t) {
			if (a[t] == cur) {
				found = 1;
				break;
			}
			maxx = max(maxx, pos[a[t]]);
		}
		if (!found) maxx = n - 1;
		ans.push_back(maxx + 1);
		for (int t = 0; t < maxx; ++t)
			b[t] = b[t + 1];
		b[maxx] = cur;
		for (int t = 0; t < n; ++t)
			pos[b[t]] = t;
	}
	cout << ans.size() << endl;
	for (int i : ans) cout << i << ' '; cout << endl;
}

void solve1() {
	for (int i = 0; i < n; ++i)
		ans.push_back(n);
	cout << ans.size() << endl;
	for (int i : ans) cout << i << ' '; cout << endl;
}

void solve2() {
	for (int i = 0; i < n - 1; ++i)
		ans.push_back(n - i);
	for (int i = 0; i < n; ++i)
		ans.push_back(n);
	cout << ans.size() << endl;
	for (int i : ans) cout << i << ' '; cout << endl;
}

void solve3() {
	vector<int> pos(n);
	for (int i = 0; i < n; ++i)
		pos[b[i]] = i;
	for (int i = 0; i < m; ++i) {
		while (b[0] != a[i]) {
			// for (auto q : b) cout << q << ' '; cout << endl;
			int found = 0;
			int maxx = 0;
			int cur = b[0];
			for (int t = i; t < m; ++t) {
				if (a[t] == cur) {
					found = 1;
					break;
				}
				maxx = max(maxx, pos[a[t]]);
			}
			if (!found) maxx = n - 1;
			ans.push_back(maxx + 1);
			for (int t = 0; t < maxx; ++t)
				b[t] = b[t + 1];
			b[maxx] = cur;
			for (int t = 0; t < n; ++t)
				pos[b[t]] = t;
		}
		int cur = b[0];
		ans.push_back(n);
		for (int t = 0; t < n - 1; ++t)
			b[t] = b[t + 1];
		b[n - 1] = cur;
		for (int t = 0; t < n; ++t)
			pos[b[t]] = t;
	}
	cout << ans.size() << endl;
	for (int i : ans) cout << i << ' '; cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	a.resize(m);
	b.resize(n);

	for (int i = 0; i < m; ++i) {
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		b[i]--;
	}

	bool case1 = true;
	for (int i = 0; i < n; ++i)
		if (a[i] != b[i]) {
			case1 = false;
			break;
		}

	bool case2 = true;
	for (int i = 0; i < n; ++i)
		if (a[i] != b[n - i - 1]) {
			case2 = false;
			break;
		}

	bool case3 = true;
	vector<bool> used(n);
	for (int i = 0; i < m; ++i) {
		if (used[a[i]]) {
			case3 = false;
			break;
		}
		used[a[i]] = true;
	}

	if (case1)
		solve1();
	else if (case2)
		solve2();
	else if (case3)
		solve3();
	else
		solve();
}