#include <iostream>
#include <vector>
using namespace std;

int paintingdfs(int v, vector<vector<int>>&gr, vector<bool>&used, vector<int> &paint, int color) {
    used[v] = true;
    paint[v] = color;
    for (size_t j=0; j<gr[v].size(); ++j) {
        if (!used[gr[v][j]]) {
            paintingdfs(j, gr, used, paint, 1 - color);
        }
    }
}

int main()
{
    int n;
    cin >> n;
    bool second, third;
    second = third = true;
    vector<bool> used(n, false);
    vector<vector<int>> gr(n, vector<int>());
    vector<int> paint(n, 0);
    for (int i = 0; i<n; ++i) {
        int k;
        cin >> k;
        if ((i==0 && k!= -1) || (i!=0 && k != i)) {
            second = false;
        }
        if (k > i) {
            third = false;
        }
        if (k!= -1) {
            gr[k-1].push_back(i);
            gr[i].push_back(k-1);
        }
    }
    if (second) {
        cout << (n+1)/2;
    }
    else if (third) {
        paintingdfs(0, gr, used, paint, 0);
        int ans;
        for (int i=0; i<n; ++i) {
            ans += paint[i];
        }
        if (ans < n - ans) {
            cout << n - ans;
        }
        else {
            cout << ans;
        }
    }
}
