#include <iostream>
#include <vector>
#include <string>
#include <math.h>

#define int long long

using namespace std;

const int INF = 1e12;

bool check1(vector<int> & in, vector<int> & orders) {
    for(int i = 0; i < in.size(); i ++) {
        if(in[i] != orders[i]) {
            return false;
        }
    }
    return true;
}

bool check2(vector<int> & in, vector<int> & orders) {
    for(int i = 0; i < in.size(); i ++) {
        if(in[i] != orders[in.size() - 1 - i]) {
            return false;
        }
    }
    return true;
}

int32_t main() {
    int n, m;
    cin >> n >> m;
    vector<int> in1(n);
    vector<int> in2(m);
    for(int i = 0; i < m; i ++) {
        cin >> in2[i];
    }
    for(int i = 0; i < n; i ++) {
        cin >> in1[i];
    }
    if(n == m && check1(in1, in2)) {
        cout << n << endl;
        for(int i = 0; i < n; i ++) {
            cout << n << ' ';
        }
        cout << endl;
    }
    else if(n == m && check2(in1, in2)) {
        cout << 2 * n - 1 << endl;
        for(int i = 0; i < n - 1; i ++) {
            cout << n - i << ' ';
        }
        for(int i = 0; i < n; i ++) {
            cout << n << ' ';
        }
        cout << endl;
    }
}
