#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <set>
#include <map>
#include <algorithm>

#define int long long

using namespace std;

int32_t main() {
    int n, k;
    cin >> n >> k;
    if(n <= 10) {
        vector<pair<int, vector<int>>> a(n, make_pair(0, vector<int>(0)));
        for(int i = 0; i < n; i ++) {
            a[i] = make_pair(i, vector<int> (k));
            for(int j = 0; j < k; j ++) {
                cin >> a[i].second[j];
            }
        }
        vector<int> in(n, 0);
        for(int i = 0; i < n; i ++) {
            in[i] = i;
        }
        while(next_permutation(in.begin(), in.end())) {
            bool flag = false;
            for(int i = 0; i < n; i ++) {
                if(i != in[in[i]] || in[i] == i) {
                    flag = true;
                    break;
                }
            }
            if(!flag) {
                bool flag2 = false;
                for(int i = 0; i < k; i ++) {
                    int left = -1e9;
                    int right = 1e9;
                    flag = false;
                    for (int j = 0; j < n; j ++) {
                        left = max(left, min(a[j].second[i], a[in[j]].second[i]));
                        right = min(right, max(a[j].second[i], a[in[j]].second[i]));
                    }
                    if(left > right) {
                        flag2 = true;
                        break;
                    }
                }
                if(!flag2) {
                    cout << "YES" << endl;
                    set<int> c;
                    for(int i = 0; i < n; i ++) {
                        if (c.find(i) == c.end()) {
                            cout << i + 1 << ' ' << in[i] + 1 << endl;
                            c.emplace(in[i]);
                        }
                    }
                    return 0;
                }
            }
        }
        cout << "NO" << endl;
        return 0;
    }
    if(k == 1) {
        vector<pair<int, int> > in(n);
        for(int i = 0; i < n; i ++) {
            cin >> in[i].first;
            in[i].second = i;
        }
        sort(in.begin(), in.end());
        cout << "YES" << endl;
        for(int i = 0; i < n / 2; i ++) {
            cout << in[i].second + 1 << ' ' << in[i + n / 2].second + 1 << endl;
        }
    }
    else {
        cout << "NO" << endl;
    }
    return 0;
}