#include <bits/stdc++.h>
using namespace std;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define len(v) (v).size()
#define sz(v) (v).size()
#define x first
#define y second
#define int long long
#define vi vector<int>
#define vvi vector<vector<int>>

int n, k;
vvi up, down;
const int MOD = 1e9 + 7;
const int MAXN = 5000 + 1;

bool read() {
    cin >> n >> k;
    up.resize(MAXN, vector<int>(MAXN, 0));
    down.resize(MAXN, vector<int>(MAXN, 0));
    return 1;
}

void solve() {
    for (int i = 0; i <= n; ++i) {
        for (int j = 1; j < i; ++j) {
            up[i][j] = down[i][j] = 0;
            for (int k = 0; k < j; ++k)
                down[i][j] = (down[i][j] + up[i - j][k]) % MOD;

            for (int k = j + 1; k + j <= i; ++k)
                up[i][j] = (up[i][j] + down[i - j][k]) % MOD;
        }

        up[i][i] = down[i][i] = 1;
    }

    int ans = up[n][k];
    if (n != k) {
        ans = (ans + down[n][k]) % MOD;
    }
    cout << ans;
}

void init() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

signed main() {
    init();
    read();
    solve();
    cout.flush();
}
