#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 26;
const int P = 1e9 + 7;
int k;

vector<vector<int> > c(MAXN, vector<int> (MAXN, 0));

vector<int> CNT(MAXN, -1);

int cnt1(int x)
{
    if (CNT[x] != -1) return CNT[x];
    vector<int> all;
    int cop = k;
    while (cop)
    {
        all.push_back(cop & 1);
        cop >>= 1;
    }
    CNT[x] = c[all.size()][x];
    reverse(all.begin(), all.end());
    int alr = 0;
    for (int i = 0; i < all.size(); ++i)
    {
        if (all[i] == 1)
        {
            ++alr;
            continue;
        }
        if (x - alr - 1 < 0) break;
        CNT[x] -= c[all.size() - i - 1][x - alr - 1];
    }
    return CNT[x];
}

int cnt(int x)
{
    if (CNT[x] != -1) return CNT[x];
    CNT[x] = 0;
    for (int i = 0; i <= k; ++i)
    {
        int tmp = 0;
        int cop = i;
        while (cop)
        {
            tmp += cop & 1;
            cop >>= 1;
        }
        if (tmp == x) ++ CNT[x];
    }
    return CNT[x];
}

signed main()
{
    c[0][0] = 1;
    for (int i = 1; i < MAXN; ++i)
    {
        c[i][0] = 1;
        for (int j = 1; j <= i; ++j)
            c[i][j] = (c[i - 1][j] + c[i - 1][j - 1]) % P;
    }
    int n, m;
    cin >> n >> m >> k;
    if (m > 0)
{

    vector<int> p(n, -1);
    for (int i = 0; i < m; ++i)
    {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        p[r] = max(p[r], l);
    }
    {
        int mx = -1;
        for (int i = 0; i < p.size(); ++i)
        {
            if (p[i] == -1) continue;
            if (mx >= p[i]) p[i] = -1;
            else mx = p[i];
        }
    }
    vector<vector<int> > dp(n, vector<int> (MAXN));
    for (int j = 0; j < MAXN; ++j) dp[0][j] = 1;
    vector<deque<pair<int, int> > > all(MAXN);
    vector<int> sum(MAXN);
    int last = -1;
    for (int i = 1; i < n; ++i)
    {
        for (int j = 0; j < MAXN; ++j)
        {
            for (int k = 0 ; k <= j; ++k)
            {
                dp[i][j] += dp[i - 1][k] * c[j][k];
                dp[i][j] %= P;
            }
            if (p[i] != -1)
            {
                while (all[j].size() && all[j].front().first <= p[i])
                {
                    sum[j] -= all[j].front().second;
                    all[j].pop_front();
                }
                dp[i][j] -= dp[p[i]][j] - sum[j];
                all[j].push_back({i, dp[p[i]][j] - sum[j]});
                sum[j] = dp[p[i]][j];
            }
            dp[i][j] %= P;
            if (dp[i][j] < 0) dp[i][j] += P;
        }
        if (p[i] != -1) last = i;
    }
    if (false)
    {
        cout << "dp - " << endl;
        for (int i = 0; i < dp.size(); ++i)
        {
            for (int j = 0; j < dp[i].size(); ++j) cout << dp[i][j] << " ";
            cout << endl;
        }
    }
    int res = 0;
    for (int i = 0; i < MAXN; ++i)
    {
        res += cnt(i) * dp.back()[i];
        res %= P;
    }
    if (res < 0) res += P;
    cout << res << endl;
}
else
{
    vector<int> p(n, -1);
    for (int i = 0; i < m; ++i)
    {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        p[r] = max(p[r], l);
    }
    {
        int mx = -1;
        for (int i = 0; i < p.size(); ++i)
        {
            if (p[i] == -1) continue;
            if (mx >= p[i]) p[i] = -1;
            else mx = p[i];
        }
    }
    vector<vector<int> > dp(n, vector<int> (MAXN));
    for (int j = 0; j < MAXN; ++j) dp[0][j] = 1;
    vector<deque<pair<int, int> > > all(MAXN);
    vector<int> sum(MAXN);
    int last = -1;
    for (int i = 1; i < n; ++i)
    {
        for (int j = 0; j < MAXN; ++j)
        {
            for (int k = 0 ; k <= j; ++k)
            {
                dp[i][j] += dp[i - 1][k] * c[j][k];
                dp[i][j] %= P;
            }
            dp[i][j] %= P;
            if (dp[i][j] < 0) dp[i][j] += P;
        }
        if (p[i] != -1) last = i;
    }
    if (false)
    {
        cout << "dp - " << endl;
        for (int i = 0; i < dp.size(); ++i)
        {
            for (int j = 0; j < dp[i].size(); ++j) cout << dp[i][j] << " ";
            cout << endl;
        }
    }
    int res = 0;
    for (int i = 0; i < MAXN; ++i)
    {
        res += cnt(i) * dp.back()[i];
        res %= P;
    }
    if (res < 0) res += P;
    cout << res << endl;
}
}
