#include <iostream>
#include <vector>

using namespace std;

int main() {
	long long n, k;

	cin >> n >> k;

	if (k == n) {
		cout << 1;
	}
	else {
		vector<vector<pair<long long, long long>>> dp(n + 1, vector<pair<long long, long long>>(n + 1, { 0, 0 }));

		dp[k][k].first = 1;
		dp[k][k].second = 1;

		for (long long i = k + 1; i <= n; i++) {
			for (long long j = 1; j <= i - k; j++) {

				for (long long z = j + 1; z <= i - j; z++) {

					dp[i][j].second += dp[i - j][z].first;
					dp[i][j].second %= ((long long)1e9 + 7);
				}

				for (long long q = 1; q < j; q++) {

					dp[i][j].first += dp[i - j][q].second;
					dp[i][j].first %= ((long long)1e9 + 7);
				}
			}
		}

		long long ans = 0;

		for (long long j = 1; j <= n; j++) {
			ans += dp[n][j].first;

			ans %= ((long long)1e9 + 7);

			ans += dp[n][j].second;

			ans %= ((long long)1e9 + 7);
		}

		cout << ans;

	}


	system("pause");
}