#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>

typedef long long lol;

#define MOD 1000000007
#define MAX 5050

int dp[MAX][MAX][2], bottom_sum[MAX][MAX], top_sum[MAX][MAX];

using namespace std;

int main()
{
	int n, k;
	cin >> n >> k;
	dp[1][1][0] = 1;
	dp[1][1][1] = 1;
	bottom_sum[1][1] = 0;
	top_sum[1][1] = 0;
	for (int i = 2; i < MAX; i++)
	{
		dp[1][i][0] = 0;
		dp[1][i][1] = 0;
		bottom_sum[1][i] = 1;
		top_sum[1][i] = 0;
		dp[i][i][0] = 1;
		dp[i][i][1] = 1;
	}
	for (int i = 2; i < MAX; i++)
	{
		for (int j = 1; j < i; j++)
		{
			dp[i][j][0] = top_sum[i - j][j];
			dp[i][j][1] = bottom_sum[i - j][j];
		}
		for (int j = i + 1; j < MAX; j++)
		{
			dp[i][j][0] = 0;
			dp[i][j][1] = 0;
		}
		bottom_sum[i][1] = 0;
		for (int j = 2; j < MAX; j++)
		{
			bottom_sum[i][j] = (bottom_sum[i][j - 1] + dp[i][j - 1][0]) % MOD;
		}
		top_sum[i][MAX - 1] = 0;
		for (int j = MAX - 2; j >= 1; j--)
		{
			top_sum[i][j] = (top_sum[i][j + 1] + dp[i][j + 1][1]) % MOD;
		}
	}
	if (k < n)
	{
		cout << dp[n][k][0] + dp[n][k][1];
	}
	else cout << 1;
	return 0;
}