#include <bits/stdc++.h>

#define f first
#define s second
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define ll long long
#define ld long double
#define eb emplace_back
#define mp make_pair

using namespace std;

const int MOD = 1e9 + 7;
const int N = 505;

//ll dp[N][N][2];  /// sum, last, trend
//ll sum[N][N][2];

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    vector<vector<int>> dp0(n + 1), dp1(n + 1), sum0(n + 1), sum1(n + 1);
    for (int i = k; i <= n; ++i) {
        dp0[i].resize(i + 1);
        dp1[i].resize(i + 1);
        sum0[i].resize(i + 1);
        sum1[i].resize(i + 1);
        if (i == k) {
            //cout << k << ' ' << sz(dp[1]) << endl;
            dp1[k][k] = 1;
            dp0[k][k] = 1;
        }
        else {
            for (int j = 1; j <= i - k; ++j) {
                dp1[i][j] = sum0[i - j][min(j - 1, i - j)];
                dp0[i][j] = (sum1[i - j][i - j] - sum1[i - j][min(i - j, j)] + MOD) % MOD;
            }
        }
        for (int j = 1; j <= i; ++j) {
            sum0[i][j] = (sum0[i][j - 1] + dp0[i][j]) % MOD;
            sum1[i][j] = (sum1[i][j - 1] + dp1[i][j]) % MOD;
        }
    }
    ll ans = 0;
    for (int i = 0; i <= n; ++i) {
        ans += dp0[n][i] + dp1[n][i];
    }
    cout << ans % MOD;
    return 0;
}

