#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>

using namespace std;

typedef long long ll;

ll check(ll q, ll k) {
    bool flag = k > 0;
    k = max(k, -k);
    k /= q;
    if (q % 2 == 0) {
        return -1;
    }
    if (k < (q + 1) / 2) {
        return -1;
    }
    k -= (q + 1) / 2;
    if (k % 2 == 1) {
        return -1;
    }

    if (flag) {
        return k / 2 + q;
    }
    return k / 2;
}

int main() {
    ll k;
    cin >> k;
    if (k == 0) {
        cout << 0 << endl;
        return 0;
    }
    ll ans = 1e13;
    for (ll i = 1; i * i <= abs(k); ++i) {
        if (k % i == 0) {
            ll res = check(i, k);
            if (res != -1) {
                ans = min(res, ans);
            }

            res = check(k / i, k);
            if (res != -1) {
                ans = min(res, ans);
            }
        }
    }

    ll res = check(k, k);
    if (res != -1) {
        ans = min(res, ans);
    }

    if (ans > 1e12) {
        cout << "none" << endl;
    }
    else {
        cout << ans << endl;
    }
}