#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <set>

using namespace std;

typedef long long ll;

int main() {
    int n;
    cin >> n;
    vector<unordered_set<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x != -1) {
            g[i].insert(x - 1);
            g[x - 1].insert(i);
        }
    }
    set<pair<int, int>> s;
    for (int i = 0; i < n; ++i) {
        s.insert({g[i].size(), i});
    }
    vector<bool> used(n);
    int ans = 0;
    while (!s.empty()) {
        auto cv = *s.begin();
        s.erase(s.begin());
        if (used[cv.second]) {
            continue;
        }
        used[cv.second] = true;
        ans++;

        for (int nv : g[cv.second]) {
            used[nv] = true;
            for (int nnv : g[nv]) {
                if (used[nnv]) {
                    continue;
                }
                s.erase({g[nnv].size(), nnv});
                g[nnv].erase(nv);
                s.insert({g[nnv].size(), nnv});
            }
        }
    }
    cout << ans << endl;
}