#include <bits/stdc++.h>
#include <stdint.h>
#include <string.h>

using namespace std;

#define max(a,b) (a>b?a:b)
#define min(a,b) ((a)<(b)?(a):(b))

int n;

int* arr;
char* colors;
vector<int>* tree;

int rec(int i,bool color,char polarity){
  colors[i] = polarity|color;
  int res = color;
  for(auto e : tree[i]){
    if((colors[e]&polarity) != 0){
      if(color && (colors[e]&1)){
        colors[i] = polarity;
        return 0;
      }
      continue;
    }
    res += rec(e,!color,polarity);
  }

  cout << "rec(" << i+1 << ", " << color << ") = "<< res <<"\n";
  return res;
}

int main(){
  cin >> n;

  arr = new int[n];
  for(int i = 0; i < n; i++){
    cin >> arr[i];
    arr[i]--;
  }

  vector<int> roots;
  vector<int> roots_a;
  vector<int> roots_b;

  auto depth = new pair<int,bool>[n];
  tree = new vector<int>[n];
  colors = new char[n];
  for(int i = 0; i < n; i++){
    colors[i] = 0;
    int e = arr[i];
    if(e < 0){
      depth[i].first = roots.size()+1;
      depth[i].second = 0;
      roots.push_back(i);
      roots_a.push_back(0);
      roots_b.push_back(1);
      continue;
    }
    if(depth[e].first){
      depth[i].first = depth[e].first;
      depth[i].second = !depth[e].second;
      if(depth[i].second){
        roots_a[depth[i].first-1]++;
      }else{
        roots_b[depth[i].first-1]++;
      }
    }
    tree[i].push_back(e);
    tree[e].push_back(i);
  }
  delete[] arr;

  int res = 0;

  for(int i = 0; i < roots.size(); i++){
    // cout << roots_a[i]<<' '<<roots_b[i]<<'\n';
    res += max(roots_a[i],roots_b[i]);
  }

  // for(int i = 0; i < n; i++){
  //   if(colors[i]!=0)continue;
  //   int a = rec(i,true,2);
  //   int b = rec(i,false,4);
  //   res += max(a,b);
  // }

  cout << res;

  delete[] tree;
  delete[] colors;
  cout << "\n";
  return 0;
}