#include <bits/stdc++.h>
#include <stdint.h>
#include <string.h>

using namespace std;

// #define max(a,b) (a>b?a:b)
// #define min(a,b) ((a)<(b)?(a):(b))

int n;

int* arr;
char* colors;
vector<int>* tree;

int rec(int i,bool color,char polarity){
  colors[i] = polarity|color;
  int res = color;
  for(auto e : tree[i]){
    if((colors[e]&polarity) != 0){
      if(color && (colors[e]&1)){
        colors[i] = polarity;
        return 0;
      }
      continue;
    }
    if(!color){
      int a = rec(e,true,polarity);
      int b = rec(e,false,polarity);
      res += max(a,b);
    }else{
      res += rec(e,!color,polarity);
    }
  }

  // cout << "rec(" << i+1 << ", " << color << ") = "<< res <<"\n";
  return res;
}

void getRootVectorRec(vector<int>& v,int i,int d){
  v.push_back(0);
  for(int e : tree[i]){
    v[d]++;
    getRootVectorRec(v,e,d+1);
  }
}

vector<int> getRootVector(int i){
  vector<int> res;
  res.push_back(1);
  getRootVectorRec(res,i,1);
  return res;
}

int main(){
  cin >> n;

  arr = new int[n];
  for(int i = 0; i < n; i++){
    cin >> arr[i];
    arr[i]--;
  }

  tree = new vector<int>[n];
  colors = new char[n];
  for(int i = 0; i < n; i++){
    colors[i] = 0;
    int e = arr[i];
    if(e < 0){
      continue;
    }
    // tree[i].push_back(e);
    tree[e].push_back(i);
  }
  delete[] arr;

  int res = 0;

  for(int i = 0; i < n; i++){
    if(colors[i]!=0)continue;
    int a = rec(i,true,2);
    int b = rec(i,false,4);
    res += max(a,b);
  }

  cout << res;

  delete[] tree;
  delete[] colors;
  cout << "\n";
  return 0;
}