from collections import deque
def bfs(i):
    c1 = 1
    c2 = 0
    visited[i] = True
    q = deque()
    q.append(i)
    color[i] = 1
    while q:
        v = q.popleft()     
        for j in neib[v]:
            if not visited[j]:
                visited[j] = True
                q.appendleft(j)
                color[j] = 3 - color[v]
                if color[j] == 1:
                    c1 += 1
                else:
                    c2 += 1
    global ans
    ans += max(c1, c2)


n = int(input())
neib = [[] for i in range(n)]
for i in range(n):
    a = int(input())
    if a != -1:
        neib[i].append(a - 1)
        neib[a - 1].append(i)
visited = [False] * n
color = [0] * n
ans = 0
for i in range(n):
    if not visited[i]:
        bfs(i)
print(ans)

    
    