#include <iostream>
#include <cmath>

using namespace std;

long long sign(long long k)
{
    return k < 0 ? -1 : 1;
}

long long scnd(long long k)
{
    if(k == 0) {
        return 0;
    }
    long long a = round(sqrt(llabs(k)));
    long long b = k / a;
    while (a > 0 && (a * b != k || a * (2 * ((b - a) / 2) + a) != k)) {
        a -= sign(k);
        b = k / a;
    }
    if (a * b == k) {
        long long l = a;
        long long f = (b - a) / 2 * sign(k);
        if(l * (2 * f * sign(k) + l) == k)
            return llabs(f + l * sign(k));
        else
            return -1;
    } else {
        return -1;
    }
}

int main() {
    long long k;
    cin >> k;
    cout << scnd(k);
    return 0;
}
