#include <bits/stdc++.h>


#define int long long


using namespace std;


void warp()
{
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


bool ok(vector<vector<int> > &stat, vector<int> &partner)
{
    int n = stat.size(), k = stat[0].size();
    //for (int i = 0; i < n; i++) cout << partner[i] << " ";
    //cout << endl;
    for (int j = 0; j < k; j++)
    {
        int low = stat[0][j], high = stat[partner[0]][j];
        if (high < low) swap(high, low);
        vector<bool> used(n);
        used[0] = true;
        used[partner[0]] = true;
        for (int i = 0; i < n; i++)
        {
            if (used[i]) continue;
            int l = stat[i][j], r = stat[partner[i]][j];
            if (r < l) swap(l, r);
            low = max(low, l);
            high = min(high, r);
        }
        //cout << j << " " << low << " " << high << endl;
        if (low > high) return false;
    }
    return true;
}


bool gen(vector<vector<int> > &stat, vector<int> &partner)
{
    int n = stat.size(), k = stat[0].size();
    int i = 0;
    while (i < n && partner[i] != -1) i++;
    if (i == n) return ok(stat, partner);
    for (int j = i + 1; j < n; j++)
    {
        if (partner[j] != -1) continue;
        partner[j] = i;
        partner[i] = j;
        if (gen(stat, partner)) return true;
        partner[i] = -1;
        partner[j] = -1;
    }
    return false;
}


void dumbSolve(vector<vector<int> > &stat)
{
    int n = stat.size(), k = stat[0].size();
    vector<int> partner(n, -1);
    if (gen(stat, partner))
    {
        cout << "YES" << endl;
        for (int i = 0; i < n; i++)
        {
            if (partner[i] == -1) continue;
            cout << i + 1 << " " << partner[i] + 1 << endl;
            partner[partner[i]] = -1;
            partner[i] = -1;
        }
    }
    else cout << "NO" << endl;
}


void sortSolve(vector<vector<int> > &stat)
{
    int n = stat.size();
    vector<pair<int, int> > tmp;
    for (int i = 0; i < n; i++)
    {
        tmp.push_back(make_pair(stat[i][0], i));
    }
    sort(tmp.begin(), tmp.end());
    cout << "YES" << endl;
    for (int i = 0; i < n / 2; i++)
    {
        cout << i + 1 << " " << n - i << endl;
    }
}


signed main()
{
    //warp();
    int n, k;
    cin >> n >> k;
    vector<vector<int> > stat(n, vector<int> (k));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < k; j++)
        {
            cin >> stat[i][j];
        }
    }
    if (n <= 10) dumbSolve(stat);
    else if (k == 1) sortSolve(stat);
    return 0;
}
