#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define forn(i,a,b)for(int i=a;i<=b;++i)
#define dbg_var(x) cout << #x << ": " << x << endl;
template<typename T>
void dbg_vector(const vector<T>&v)
{
	forn(i,0,v.size()-1)cout<<v[i]<<' ';
	cout<<endl;
}
void dbg(){cout<<endl;}
template<typename Head,typename... Tail>
void dbg(Head H,Tail... T)
{
	cerr << H << ' ';
	dbg(T...);
}

const ll MOD=1e9+7;

int n,k;
vector<vector<int> >a;
vector<vector<int> >g;

bool check(int i,int j)
{
	int l=min(a[i][0],a[j][0]);
	int r=max(a[i][1],a[j][1]);

	forn(t,1,k-1)
	{
		int l_=min(a[i][t],a[j][t]);
		int r_=max(a[i][t],a[j][t]);
		if((r_< l) || (l_ > r))return false;
		l=max(l,l_);
		r=min(r,r_);
	}

	return true;
}

vector<int>used,mt;
bool kuhn(int i)
{
	if(used[i])return false;
	used[i]=true;
	for(int j:g[i])
	{
		if(mt[j]==-1 || kuhn(mt[j]))
		{
			mt[j]=i;
			return true;
		}
	}
	return false;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin>>n>>k;
	a=vector<vector<int> >(n,vector<int>(k)),g.resize(n);
	used.resize(n);
	mt.assign(n,-1);
	forn(i,0,n-1)
	{
		forn(j,0,k-1)
		{
			cin>>a[i][j];
		}
	}
	forn(i,0,n-1)
	{
		forn(j,i+1,n-1)
		{
			if(check(i,j))
			{
				//dbg(i+1,j+1);
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	forn(i,0,n-1)
	{
		if(!used[i])
		{
			kuhn(i);
		}
	}
	forn(i,0,n-1)
	{
		if(mt[i]==-1)
		{
			cout<<"NO"<<endl;
			return 0;
		}
	}
	cout<<"YES"<<endl;
	vector<int>was(n);
	forn(i,0,n-1)
	{
		if(was[i])continue;
		cout<<(i+1)<<' '<<(mt[i]+1)<<endl;
		was[mt[i]]=true;
	}
}
/*
6 2
8 6
1 5
6 3
3 1
4 7
7 2
*/

/*
4 3
1 -1 -1
2 1 1
3 -1 1
4 1 -1
*/