#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cmath>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define popb pop_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

signed main() {

	// for (int k = 0; k < 10; ++k) {
	// 	for (int i = 0; i < 10; ++i) {
	// 		if ((int) sqrt(i * i + k) * (int) sqrt(i * i + k) == i * i + k) {
	// 			cout << "|" << i * i + k << "| ";
	// 			continue;
	// 		}
	// 		cout << i * i + k << " ";
	// 	}
	// 	cout << endl;
	// }

	int k;
	cin >> k;

	int sqrtk = (int) sqrtl(k);
	if (sqrtk * sqrtk == k) {
		cout << 0 << endl;
		return 0;
	}

	const int INF = (int) 1e18;
	int ans = INF;

	for (int i = 1; i * i <= k; ++i) {
		if (k % i == 0) {
			int p = i, q = k / i;
			if (abs(p - q) % 2 != 0) {
				continue;
			}
			int x = (p > q ? (p - q) / 2 : (q - p) / 2);

			int a2 = x * x + k;
			if (a2 < 0) continue;
			int a = (int)sqrtl(a2);
			if (a * a == a2) {
				ans = min(ans, a);
			}
		}
	}

	int p, q, x, a2, a;
	for (int i = 1; i * i <= abs(k); ++i) {
		if (k % i == 0) {
			p = -i, q = -k / i;
			if (abs(p - q) % 2 != 0) {
				continue;
			}
			x = (p > q ? (p - q) / 2 : (q - p) / 2);

			a2 = x * x + k;
			if (a2 < 0) goto lasa;
			a = (int)sqrtl(a2);
			if (a * a == a2) {
				ans = min(ans, a);
			}
			//////////////
			lasa:;
			p = i, q = k / i;
			if (abs(p - q) % 2 != 0) {
				continue;
			}
			x = (p > q ? (p - q) / 2 : (q - p) / 2);

			a2 = x * x + k;
			if (a2 < 0) continue;
			a = (int)sqrtl(a2);
			if (a * a == a2) {
				ans = min(ans, a);
			}
		}
	}

	if (ans == INF) {
		cout << "none" << endl;
	}
	else {
		cout << ans << endl;
	}

	return 0;
}