#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <ctime>
#include <cmath>
#include <cstdio>
#include <iomanip>

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define RAND srand(time(0));
#define FIXED cout << fixed << setprecision(8);

#define pb push_back
#define popb pop_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

int n, m;
vector<int> a,b;
signed solve1();
signed solve2();
signed main() {
	cin >> n >> m;
	a.resize(m);
	b.resize(n);
	for (auto &i : a)
		cin >> i;
	for (auto &i : b)
		cin >> i;

	if (n == m) {
		bool flag, fflag;
		flag = fflag = false;
		for (int i = 0; i < n; ++i) {
			if (a[i] != b[i]) {
				flag = true;
				break;
			}
		}
		if (flag) {
			for (int i = 0; i < n; ++i) {
				if (a[i] != b[n - i - 1]) {
					fflag = true;
					break;
				}
			}
			if (fflag) {
				solve2();
			}
			else {
				solve1();
			}
		}
		else {
			solve1();
		}
	}
	else {
		solve2();
	}

	return 0;
}

signed solve1() {
	vector<int> ans;
	if (a[0] == b[0]) {
		ans.insert(ans.end(), n, n);
	}
	else {
		for (int i = 0; i < n; ++i) {
			ans.pb(n - i);
		}
		ans[n - 1] = n;
		ans.insert(ans.end(), n - 1, n);
	}

	cout << ans.size() << endl;
	for (auto &i : ans) {
		cout << i << " ";
	}
	return 0;
}

signed solve2() {
	vector<int> c;
	int pn = 0, pm = 0;
	for ( ; pn < n && pm < m; ) {
		if (a[pm] != b[pn]) {
			while (pn < n && a[pm] != b[pn]) {
				c.pb(b[pn]);
				++pn;
			}
		}
		else {
			c.pb(a[pm]);
			++pn, ++pm;
		}
	}
	while (pm < m) {
		c.pb(a[pm]);
		++pm;
	}
	// for (int i = 0; i < sz(c); ++i) {
	// 	cout << c[i] << " ";
	// }
	// cout << endl;

	vector<int> help(sz(c), -1);
	vector<int> tttmp(n + 1, -1);
	for (int i = 0; i < sz(c); ++i) {
		if (tttmp[c[i]] != -1) {
			help[tttmp[c[i]]] = i;
		}
		tttmp[c[i]] = i;
	}

	// for (int i = 0; i < sz(c); ++i) {
	// 	cout << i << " " << help[i] << endl;
	// }
	// cout << endl;

	vector<int> ans;
	int last = n;

	for (int i = 0; i < sz(c); ++i) {
		int p = -1;
		// for (int j = i + 1; j < sz(c); ++j) {
		// 	if (c[i] == c[j]) {
		// 		p = j;
		// 		break;
		// 	}
		// }
		p = help[i];
		if (p == -1) {
			ans.pb(n);
			--last;
		}
		else {
			ans.pb(min(p - i, last));
		}
	}

	cout << sz(ans) << endl;
	for (int i = 0; i < sz(ans); ++i) {
		cout << ans[i] << " ";
	}

	return 0;
}