#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int cnt = 0;

void dfs(int now, vector<int> &used, vector<vector<int> > &graph) {
	cnt++;
	used[now] = 1;
	for (auto elem : graph[now]) {
		if (used[elem] == 0) dfs(elem, used, graph);
	}
}

int main(){
	int n;
	cin >> n;
	vector<vector<int> > graph(n);
	int x;
	for (int i = 0; i < n; i++) {
		cin >> x;
		if (x == -1) continue;
		x--;
		graph[i].push_back(x);
		graph[x].push_back(i);
	}
	int ans = 0;
	vector<int> used(n);
	for (int i = 0; i < n; i++) used[i] = 0;
	for (int i = 0; i < n; i++) {
		cnt = 0;
		if (used[i] == 1) continue;
		dfs(i, used, graph);
		ans += (cnt - 1) / 2 + 1;
	}
	cout << ans << endl;
	//cin >> ans;

}