#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#define endl "\n"
#define pii pair<int,int>
//#define int long long

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e9;
const double EPS = 1e-10;
const int Q = 31;
const ll P = 1e9 + 7;


void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
}


void show(vector<int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<pii>& arr)
{
    for (auto i : arr)
        cout << i.first << " " << i.second << "    ";
    cout << endl;
}
void show(vector<vector <int>> arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}
void show(vector<vector <pii>> arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}



signed main()
{
    hello();

    int n, k;
    cin >> n >> k;

    if (n == k)
    {
        cout << 1 << endl;
        return 0;
    }


    pii dp[n + 1][n + 1];
    pii tsum[n + 1][n + 1];
    for (int i = 0; i < n + 1; ++i)
        for (int j = 0; j < n + 1; ++j)
            dp[i][j] = tsum[i][j] = {0, 0};

    dp[k][k] = {1, 1};

    for (int i = 1; i <= n; ++i)
    {
        for (int k = 1; k <= n; ++k)
        {
            if (i - k <= 0)
                break;

            if (k > i)
            {
                dp[i][k].first = tsum[i - k][i].second;
            }
            else
            {
                dp[i][k].first = tsum[i - k][k - 1].second;
                dp[i][k].second = ((ll)tsum[i - k][i - 1].first - tsum[i - k][k].first + P * P) % P;
            }
            /*for (int j = 1; j <= n; ++j)
            {
                if (j >= i)
                    break;

                if (j < k)
                    dp[i][k].first = (dp[i][k].first + dp[i - k][j].second) % P;
                if (j > k)
                    dp[i][k].second = (dp[i][k].second + dp[i - k][j].first) % P;
            }*/
        }

        for (int j = 1; j <= n; ++j)
            tsum[i][j] = {((ll)tsum[i][j - 1].first + (ll)dp[i][j].first) % P, ((ll)tsum[i][j - 1].second + (ll)dp[i][j].second) % P};
    }

    //show(dp);



    int res = 0;
    for (int i = 1; i <= n; ++i)
    {
        res += dp[n][i].first + dp[n][i].second;
        res %= P;
    }
    cout << res << endl;

}
