#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define f   first
#define s   second

typedef pair<int, int> pr;
const int INF = (1 << 30);
int cnt = 0;
vector<int> ress;

struct Node {
    int* ind;
    int* pos;
    int* time;
    bool operator < (Node a) const {
        return *(this->pos) < *a.pos;
    }
};

struct box {
    int ind;
    int pos;
    int time;
    bool operator < (const box &a) const {
        if (this->pos == a.pos)
            return this->time < a.time;
        return this->pos < a.pos;
    }
};


vector<int> a;
vector<int> b;
set<box> h;
vector<box> h1;
vector<queue<int> > g;

void repl(box need) {
    auto e = *h.begin();
    auto was = e;
    h.erase(h.begin());
    if (h.empty()) {
        ++cnt;
        ress.push_back(1);
        return;
    }
    int ind = e.time + 1;
    g[e.ind].pop();
    if (g[e.ind].empty()) {
        auto e1 = h.end();
        --e1;
        box nn = *e1;
        e.pos = nn.pos + 1;
        h1[e.ind] = e;
        if (e.pos != was.pos) {
            ++cnt;
            ress.push_back(e.pos - was.pos);
        }
        return;
    }
    e.time = g[e.ind].front();
    set<box> dd;
    for (; ind < e.time; ++ind) {
        dd.insert(h1[a[ind]]);
    }
    if (dd.empty()) {
        ++e.pos;
        h1[e.ind] = e;
        h.insert(e);
        auto t = h.find(e);
        ++t;
        while (t != h.end()) {
            auto t1 = t;
            ++t;
            auto now = *t1;
            h.erase(t1);
            ++now.pos;
            h.insert(now);
        }
        if (e.pos != was.pos) {
            ++cnt;
            ress.push_back(e.pos - was.pos);
        }
        return;
    }
    auto e1 = dd.end();
    --e1;
    box nn = *e1;
    e.pos = nn.pos + 1;
    h1[e.ind] = e;
    h.insert(e);
    auto t = h.find(e);
    ++t;
    while (t != h.end()) {
        auto t1 = t;
        ++t;
        auto now = *t1;
        h.erase(t1);
        ++now.pos;
        h.insert(now);
    }
    if (e.pos != was.pos) {
        ++cnt;
        ress.push_back(e.pos - was.pos);
    }
}

void repl1(box need) {
    auto e = *h.begin();
    box was = e;
    h.erase(h.begin());
    if (e.time == INF) {
        auto e1 = h.end();
        --e1;
        box nn = *e1;
        e.pos = nn.pos + 1;
        h1[e.ind] = e;
        h.insert(e);
        auto t = h.find(e);
        ++t;
        while (t != h.end()) {
            auto t1 = t;
            ++t;
            auto now = *t1;
            h.erase(t1);
            ++now.pos;
            h.insert(now);
        }
        if (e.pos != was.pos) {
            ++cnt;
            ress.push_back(e.pos - was.pos);
        }
        return;
    }
    int ind = e.time;
    set<box> dd;
    for (; ind >= need.time; --ind) {
        dd.insert(h1[a[ind]]);
    }
    if (dd.empty()) {
        ++e.pos;
        h1[e.ind] = e;
        h.insert(e);
        auto t = h.find(e);
        ++t;
        while (t != h.end()) {
            auto t1 = t;
            ++t;
            auto now = *t1;
            h.erase(t1);
            ++now.pos;
            h.insert(now);
        }
        if (e.pos != was.pos) {
            ++cnt;
            ress.push_back(e.pos - was.pos);
        }
        return;
    }
    auto e1 = dd.end();
    --e1;
    box nn = *e1;
    e.pos = nn.pos + 1;
    h1[e.ind] = e;
    h.insert(e);
    auto t = h.find(e);
    ++t;
    while (t != h.end()) {
        auto t1 = t;
        ++t;
        auto now = *t1;
        h.erase(t1);
        ++now.pos;
        h.insert(now);
    }
    if (e.pos != was.pos) {
        ++cnt;
        ress.push_back(e.pos - was.pos);
    }
}

void move(int i) {
    int need = a[i];
    auto need1 = h1[need];
    while (true) {
        auto e = *h.begin();
        if (e.ind == need)
            break;
        repl1(need1);
    }
    repl(need1);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    a.resize(m);
    h1.resize(n);
    b.resize(n);
    g.resize(n);
    // multiset<int> q;
    for (int i = 0; i < m; ++i) {
        int c;
        cin >> c;
        --c;
        a[i] = c;
        g[c].push(i);
    }
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        --c;
        b[i] = c;
        if (g[c].empty())
            g[c].push(INF);
        h.insert({ c, i, g[c].front() });
        h1[c] = { c, i, g[c].front() };
    }
    if (n * m < 4 * 1000 * 1000) {
        for (int i = 0; i < m; ++i) {
            move(i);
        }
        cout << cnt << '\n';
        for (auto y : ress)
            cout << y << ' ';
        return 0;
    }
    if (a[0] == b[0]) {
        cout << n << '\n';
        for (int i = 0; i < n; ++i)
            cout << n << ' ';
    }

    return 0;
}