#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <bitset>

using namespace std;

typedef pair<int, int> pr;

const int NN = 3 * 1000 * 100 + 7;
int countt = 0;
int used[NN];
vector<int> g[NN];
vector <vector <int> > comp;

void bfs(int root) {
    used[root] = ++countt;
    queue<int> q;
    q.push(root);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (!used[u]) {
                used[u] = countt;
                q.push(u);
            }
        }
    }
}

set<pr> reb;
const int MM = 20;

int peiebor(int n) {
    long long ans = 0;
    for (int mask = 1; mask < (1 << n); ++mask) {
        vector<int> now;
        bitset<MM> rr = mask;
        for (auto e = 0; e < MM; ++e) {
            if (rr[e])
                now.push_back(e);
        }
        bool fl = true;
        for (int i = 0; i < now.size(); ++i) {
            for (int j = i + 1; j < now.size(); ++j) {
                if (reb.find({ now[i], now[j] }) != reb.end())
                    fl = false;
            }
        }
        if (fl)
            ans = max(ans, (long long)now.size());
    }
    return ans;
}

int main()
{
   long long n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        if (c == -1)
            continue;
        --c;
        reb.insert({ c, i });
        reb.insert({ i, c });
    }
    cout << peiebor(n);
//    solve(3, 1);
   /*for (int i = 5; i <= 10; ++i) {
        for (int j = 1; j <= i; ++j) {
            cout << i << ' ' << j << '\n';
            cout << solve(i, j) << '\n' << '\n';
        }
    }*/
   
}
 