#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cmath>

using namespace std;

vector<int> d;
vector<int> n;

void built(int v, int l, int r) {
	if (r - l == 1) {
		d[v] = n[l];
	}
	else {
		built(v * 2 + 1, l, (l + r) / 2);
		built(v * 2 + 2, (l + r) / 2, r);
		d[v] = d[v * 2 + 1] + d[v * 2 + 2];
	}
}

int ans(int v, int l, int r, int ql, int qr) {
	if (ql >= r || qr <= l) {
		return 0;
	}
	if (ql <= l && qr >= r) {
		return d[v];
	}
	return ans(v * 2 + 1, l, (l + r) / 2, ql, qr) + ans(v * 2 + 2, (l + r) / 2, r, ql, qr);
}

void up(int v, int l, int r, int qi, int z) {
	if (l > qi || r <= qi) {
		return;
	}
	if (r - l == 1) {
		d[v] = z;
	}
	else {
		up(v * 2 + 1, l, (l + r) / 2, qi, z);
		up(v * 2 + 2, (l + r) / 2, r, qi, z);
		d[v] = d[v * 2 + 1] + d[v * 2 + 2];
	}
}

bool cmp(pair<int,int>v1,pair<int,int>v2) {
	return((v1.first / 400 < v2.first / 400) || (v1.first / 400 == v2.first / 400 && v1.second < v2.second));
}

int main() {
	ios_base::sync_with_stdio(false);
	long long n, m;
	cin >> n >> m;
	vector<int> a(m), b(n);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
	}
	int l1 = 0;
	vector<int> d;
	vector<bool> used(n, false);
	for (auto i : a) {
		if (used[i - 1]) {
			d.push_back(i);
		}
		else {
			while (b[l1] != i) {
				used[b[l1] - 1] = true;
				d.push_back(b[l1]);
				l1++;
			}
			used[b[l1] - 1] = true;
			d.push_back(b[l1]);
			l1++;
		}
	}
	cout << d.size() << '\n';
	vector<int> last(n, -1);
	vector<pair<int,int>> r;
	vector<int> tp(d.size(), -1);
	vector<int> ans(d.size(), n);
	int t = 1;
	for (int i = 0; i < d.size();i++) {
		if (last[d[i] - 1] != -1) {
			r.push_back({ last[d[i] - 1] +1, i});
		}
		last[d[i] - 1] = i;
	}
	sort(r.begin(), r.end(), cmp);

	int l = 0, r1 = 0,ty=0;
	vector<int> k(n, 0);
	for (auto i : r) {
		while (r1 < i.second) {
			if (k[d[r1]-1] == 0) {
				ty++;
			}
			k[d[r1]-1]++;
			r1++;
		}
		while (l > i.first) {
			l--;
			if (k[d[l]-1] == 0) {
				ty++;
			}
			k[d[l]-1]++;
		}
		while (r1 > i.second) {
			r1--;
			if (k[d[r1]-1] == 1) {
				ty--;
			}
			k[d[r1]-1]--;
		}
		while (l < i.first) {
			if (k[d[l]-1] == 1) {
				ty--;
			}
			k[d[l]-1]--;
			l++;
		}
		ans[i.first - 1] = ty + 1;
	}
	for (auto i : ans) {
		cout << i << ' ';
	}
	system("pause");
}