#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <assert.h>
#include <cassert>
#include <cmath>
#include <math.h>
#include <time.h>
#include <ctime>
#define int long long
#define double long double

using namespace std;

pair<bool, int> sqr(int num)
{
	if (num < 0) return { false, 0 };
	int l = 0, r = 1e9;
	while (l + 1 < r)
	{
		int m = (l + r) / 2;
		if (m * m > num)
			r = m;
		else
			l = m;
	}
	if (l * l != num) return { false, 0 };
	return { true, l };
}

bool is_(int num)
{
	if (num < 0) return false;
	int s = sqrt(num);
	if (s * s == num) return true;
	return false;
}

signed main()
{
	//freopen("input.txt", "r", stdin);
	int k;
	cin >> k;
	for (int i = 0; i < 1e7; i++)
	{
		int need = i * i + k;
		if (sqr(need).first)
		{
			cout << sqr(need).second;
			return 0;
		}
	}
	cout << "none";
	return 0;
}