#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <assert.h>
#include <cassert>
#define int long long

using namespace std;
const int inf = 1e18 + 5;

signed main()
{
	//freopen("input.txt", "r", stdin);
	int n;
	cin >> n;
	if (n == 0)
	{
		cout << 0;
		return 0;
	}
	vector<int> del;
	for (int d = 1; d <= sqrt(abs(n)); d++)
	{
		if (n % d == 0)
		{
			del.push_back(d);
			del.push_back(-d);
			if (n != d * d)
			{
				del.push_back(n / d);
				del.push_back(-n / d);
			}
		}
	}
	int best_ans = inf;
	for (int f : del)
	{
		int s = n / f;
		if ((s + f) % 2 == 0)
			best_ans = min(best_ans, abs(s + f) / 2);
	}
	if (best_ans == inf)
	{
		cout << "none";
		return 0;
	}
	cout << best_ans;
	return 0;
}