#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <assert.h>
#include <cassert>
#define int long long

using namespace std;

struct go
{
	bool a, b, c;
};

struct cnt
{
	int a, b, c;
};

vector<int> used;
vector<bool> l_used;
vector<go> vert;
vector<int> to;
vector<vector<int>> g;

void dfs(int v)
{
	if (to[v] >= 0)
	{
		if (used[to[v]])
		{
			if (used[to[v]] == 1)
				vert[v].a = false;
			else if (used[to[v]] == 2)
				vert[v].b = false;
			else
				vert[v].c = false;
		}
	}
	int now = 0;
	if (vert[v].a) now = 1;
	else if (vert[v].b) now = 2;
	else
	{
		assert(vert[v].c);
		now = 3;
	}
	used[v] = now;
	if (to[v] >= 0)
	{
		if (used[v] == 1)
			vert[to[v]].a = false;
		else if (used[v] == 2)
			vert[to[v]].b = false;
		else
			vert[to[v]].c = false;
		if (!used[to[v]])
			dfs(to[v]);
	}
}

void l_dfs(int v, vector<int> &arr)
{
	arr.push_back(v);
	l_used[v] = true;
	for (int to : g[v])
		if (!l_used[to])
			l_dfs(to, arr);
}

int solve(int v)
{
	vector<int> arr;
	l_dfs(v, arr);
	for (int v : arr)
		if (!used[v])
			dfs(v);
	int a = 0, b = 0, c = 0;
	for (int v : arr)
	{
		if (used[v] == 1) a++;
		else if (used[v] == 2) b++;
		else
		{
			assert(used[v] == 3);
			c++;
		}
	}
	assert(c <= max(a, b));
	return max(a, b);
}

signed main()
{
	//	freopen("input.txt", "r", stdin);
	int n;
	cin >> n;
	l_used.resize(n, false);
	to.resize(n);
	g.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> to[i];
		to[i]--;
		if (to[i] >= 0)
		{
			g[i].push_back(to[i]);
			g[to[i]].push_back(i);
		}
	}
	vert.assign(n, { true, true, true });
	used.resize(n, 0);
	int ans = 0;
	for (int i = 0; i < n; i++)
		if (l_used[i] == 0)
			ans += solve(i);
	cout << ans;
	return 0;
}