#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define all(v) v.begin(), v.end()
#define x first
#define y second
#define mod 1000000007
#pragma GCC optimize("fast-math")


int32_t main()
{
	int n, k;
	cin >> n >> k;
	vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1, vector<int>(2, 0)));
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	//dpsumm][last]
	//0 - up
	//1 - down
	if (n == k)
	{
		cout << 1;
		return 0;
	}
	if (n > 332) return 2;
	for (int i = k + 1; i <= n; i++)
	{
		for (int j = 1; j <= i; j++)
		{
			if (i == k && j == k) continue;
			for (int l = 1; l <= j; l++)
			{
				dp[i][j][0] += dp[i - j][l][1];
				dp[i][j][0] %= mod;
			}
			for (int l = j + 1; l < n; l++)
			{
				dp[i][j][1] += dp[i - j][l][0];
				dp[i][j][1] %= mod;
			}
		}
	}
	int ans = 0;
	for (int i = 1; i < n; i++)
	{
		ans += dp[n][i][0] + dp[n][i][1];
		ans %= mod;
	}
	cout << ans;
	system("pause");
	return 0;
}








/*
vector<int> rmq;

vector<int> a, b;

void build(int v, int l, int r)
{
if (l + 1 == r)
{
rmq[v] = 0;
return;
}
build(v + v, l, (l + r) / 2);
build(v + v + 1, (l + r) / 2, r);
rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

int get(int v, int l, int r, int ind)
{
if (l == ind && l + 1 == r) return rmq[v];
int m = (l + r) / 2;
if (ind < m) return get(v + v, l, m, ind) + rmq[v];
return get(v + v + 1, m, r, ind) + rmq[v];
}


void update(int v, int l, int r, int tl, int tr)
{
if (tl >= tr) return;
if (tl >= r) return;
if (tr <= l) return;
if (tl <= l && tr >= r)
{
rmq[v]++;
return;
}
int m = (l + r) / 2;
if (tr < m) update(v + v, l, m, tl, tr);
else update(v + v + 1, m, r, tl, tr);
}
*/