// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

bool f(vector<ll>& a, vector<ll>& b) {
	ll f1 = 1, f2 = 1;
	for (ll i = 0; i < (int)a.size(); ++i) {
		if (a[i] < b[i]) {
			f1 = 0;
		}
		if (a[i] > b[i]) {
			f2 = 0;
		}
	}
	return (f1 || f2);
}


vector<vector<ll>> g;
vector<ll> used;
vector<ll> res;

bool dfs_kun(ll v) {
	used[v] = true;
	for (auto u : g[v]) {
		if (res[u] == -1) {
			res[u] = 1;
			return true;
		}
	}
	for (auto u : g[v]) {
		if (used[u]) {
			continue;
		}
		if (dfs_kun(res[u])) {
			res[u] = v;
			return true;
		}
	}
	return false;
}

inline void solve() {
	ll n, k;
	cin >> n >> k;
	vector<vector<ll>> a(n, vector<ll>(k));
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < k; ++j) {
			cin >> a[i][j];
		}
	}
	g.resize(n);
	res.resize(n, -1);
	for (ll i = 0; i < n; ++i) {
		for (ll j = i + 1; j < n; ++j) {
			if (f(a[i], a[j])) {
				g[i].emplace_back(j);
				g[j].emplace_back(i);
			}
		}
	}

	ll cnt = 0;
	for (ll i = 0; i < n; ++i) {
		used.resize(n);
		if (dfs_kun(i)) {
			++cnt;
		}
		used.clear();
	}
	if (cnt == n) {
		cout << "YES" << endl;
		used.resize(n);
		for (ll i = 0; i < n; ++i) {
			if (used[i]) {
				continue;
			}
			used[i] = 1;
			used[res[i]] = 1;
			cout << i + 1 << " " << res[i] + 1 << endl;
		}
	}
	else {
		cout << "NO" << endl;
	}
}

int32_t main() {
	start();
	solve();
	return 0;
}
