// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

vector<ll> kek;

bool f(vector<ll>& a) {
	for (ll i = 0; i < a.size(); ++i) {
		if (a[i] > kek[i]) {
			return false;
		}
	}
	return true;
}

inline void solve() {
	ll n, k;
	cin >> n >> k;
	if (k == 1) {
		cout << "YES" << endl;
		vector<pair<ll, ll>> a(n);
		for (ll i = 0; i < n; ++i) {
			cin >> a[i].first;
			a[i].second = i + 1;
		}
		sort(a.begin(), a.end());
		for (ll i = 0; i < n / 2; ++i) {
			cout << a[n / 2 + i].second << " " << a[n / 2 - i - 1].second << endl;
		}
		return;
	}
	vector<vector<ll>> a(n, vector<ll>(k));
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < k; ++j) {
			cin >> a[i][j];
		}
	}
	for (ll i = 0; i < n; ++i) {
		vector<ll> left, right;
		kek = a[i];
		for (ll j = 0; j < n; ++j) {
			if (a[j] == kek) {
				continue;
			}
			if (f(a[j])) {
				left.emplace_back(j + 1);
			}
			else {
				right.emplace_back(j + 1);
			}
		}
		if (left.size() < right.size()) {
			left.emplace_back(i + 1);
		}
		else {
			right.emplace_back(i + 1);
		}
		if (left.size() == right.size()) {
			cout << "YES" << endl;
			for (ll i = 0; i < n / 2; ++i) {
				cout << left[i] << " " << right[i] << endl;
			}
			return;
		}
	}
	cout << "NO" << endl;
}

int32_t main() {
	start();
	solve();
	return 0;
}
