#include <iostream>
#include <vector>

using namespace std;

int n, k;

vector<vector<vector<int> > > dp;

int check(int now, bool up, int sum){
    if (sum == n){
        return 1;
    }
    if (dp[sum][now][up] != -1){
        return dp[sum][now][up];
    }
    int ans = 0;
    if (up){
        for (int nx = now + 1; sum + nx <= n; nx++){
            ans += check(nx, 0, sum + nx);
        }
    }else{
        for (int nx = 1; nx <= min(n - sum, now - 1); nx++){
            ans += check(nx, 1, sum + nx);
        }
    }
    dp[sum][now][up] = ans;
    return ans;
}

int main()
{
    cin >> n >> k;
    dp.resize(n + 1, vector<vector<int> > (n + 1, vector<int>(2, -1)));
    int ans = check(k, 0, k) + check(k, 1, k);
    if (k == n){
        cout << 1 << endl;
        return 0;
    }
    cout << ans << endl;
    return 0;
}
