#include <iostream>
#include <vector>

using namespace std;

vector<vector<int> > g;
vector<int> used;
vector<int> cycle;
vector<int> us;

int dfs(int v, int take){
    used[v] = true;
    us.push_back(v);
    int ans = take;
    for (auto i : g[v]){
        if (!used[i]){
            ans += dfs(i, 1 - take);
        }
    }
    return ans;
}

vector<int> p;
int start = -1, fin = -1;
void find_cycle(int v, int pr){
    p[v] = pr;
    for (auto i : g[v]){
        if (i == pr){
            continue;
        }
        if (p[i] != -1){
            start = v;
            fin = i;
            break;
        }else{
            find_cycle(i, v);
        }
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n; i++){
        int x;
        cin >> x;
        x--;
        if (x + 2){
            g[x].push_back(i);
            g[i].push_back(x);
        }
    }
    used.resize(n);
    p.resize(n, -1);
    for (int i = 0; i < n; i++){
        if (start == -1 && p[i] == -1){
            find_cycle(i, -1);
        }
    }
    if (start == -1){
        int ans = 0;
        for (int i = 0; i < n; i++){
            if (!used[i]){
                int cur = dfs(i, 1);
                for (auto i : us){
                    used[i] = false;
                }
                cur = max(cur, dfs(i, 0));
                ans += cur;
                us.resize(0);
            }
        }
        cout << ans << endl;
    }else{
        while (start != fin){
            cycle.push_back(start);
            start = p[start];
        }
        cycle.push_back(fin);
        for (auto i : cycle){
            used[i] = true;
        }
        int ans = 0;
        for (auto i : cycle){
            int cur = dfs(i, 1);
            for (auto j : us){
                used[j] = false;
            }
            cur = max(cur, dfs(i, 0));
            us.resize(0);
            ans += cur;
        }
        cout << ans << endl;
    }
    return 0;
}
