#include <bits/stdc++.h>

using namespace std;

#define int long long
int n;
vector<int> tree;

void add(int k, int x) {
    k += n;
    tree[k] += x;
    for (k /= 2; k >= 1; k /= 2) {
        tree[k] = tree[2 * k] + tree[2 * k + 1];
    }
}

//[a; b]
int sum(int a, int b) {
    a += n;
    b += n;
    int sum = 0;
    while (a <= b) {
        if (a % 2 == 1) {
            sum += tree[a++];
        }
        if (b % 2 == 0) {
            sum += tree[b--];
        }
        a /= 2;
        b /= 2;
    }
    return sum;
}

int bsearch(int sl, int sr, bool f(int)) {
    while (sr - sl > 1) {
        int m = (sl + sr) / 2;
        if (f(m)) {
            sl = m;
        } else {
            sr = m;
        }
    }
    return sl;
}

int MAXN = 1e6 + 5;

signed long long k;
bool les;
const int MOD = 1e9 + 7;

signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> dp(k + 1, vector<int>(n + 1, 0));
    for (int i = 0; i <= k; ++i) {
        dp[i][1] = 1;
    }
    for (int i = k; i >= 0; --i) {
        for (int len = 2; len <= n; ++len) {
            for (int j = i; j <= k; ++j) {
                if ((i & j) == i) {
                    dp[i][len] += dp[j][len - 1];
                    if (dp[i][len] >= MOD) {
                        dp[i][len] -= MOD;
                    }
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= k; ++i) {
        ans += dp[i][n];
        if (ans >= MOD) {
            ans -= MOD;
        }
    }
    cout << ans;
    return 0;
}