#include <bits/stdc++.h>

using namespace std;

#define int long long
int n;
vector<int> tree;

void add(int k, int x) {
    k += n;
    tree[k] += x;
    for (k /= 2; k >= 1; k /= 2) {
        tree[k] = tree[2 * k] + tree[2 * k + 1];
    }
}

//[a; b]
int sum(int a, int b) {
    a += n;
    b += n;
    int sum = 0;
    while (a <= b) {
        if (a % 2 == 1) {
            sum += tree[a++];
        }
        if (b % 2 == 0) {
            sum += tree[b--];
        }
        a /= 2;
        b /= 2;
    }
    return sum;
}

int bsearch(int sl, int sr, bool f(int)) {
    while (sr - sl > 1) {
        int m = (sl + sr) / 2;
        if (f(m)) {
            sl = m;
        } else {
            sr = m;
        }
    }
    return sl;
}

int MAXN = 1e6 + 5;
const int MOD = 1e9 + 7;

signed main() {
    int a, b, c;
    cin >> a >> b >> c;

    int last = b / c * c;
    int start = (a / c + 1) * c;
    int cnt = (last - start) / c;
    if ((!(a < last && last < b))
        && (!(a < start && start < b))) {
        cout << (b - a) / 2 + (b - a) % 2;
        return 0;
    }
    int ans = 0;
    int ost = c - a % c;
    int cur = a;
    if (ost % 2 == 0) {
        ost--;
        ans++;
        cur++;
    }
    ans += (ost - 1) / 2;
    cur += (ost - 1);
    int step = c / 2 + c % 2;
    cur = last - 1;
    ans += cnt * step;
    cur += 2;
    ans++;

    int ost2 = b - cur;
    if (ost2 % 2 == 1) {
        cur++;
        ost2--;
        ans++;
    }
    ans += ost2 / 2;
    cout << ans;


    return 0;
}