#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int MOD = 1e9 + 7;

pair<int, int> dfs(vector<vector<int>> &a, int v, vector<bool> &used, bool c) {
	used[v] = true;
	int c1 = c ? 0 : 1;
	int c2 = 1 - c1;
	for (auto e : a[v]) {
		if (!used[e]) {
			auto res = dfs(a, e, used, !c);
			c1 += res.first;
			c2 += res.second;
		}
	}
	return { c1, c2 };
}

int main() {
	int n;
	cin >> n;
	vector<int> a0(n);
	for (int i = 0; i < n; ++i) {
		cin >> a0[i];
		--a0[i];
	}
	vector<vector<int>> a(n);
	for (int i = 0; i < n; ++i) {
		if (a0[i] != -2) {
			a[a0[i]].push_back(i);
		}
	}
	vector<bool> used(n, false);
	int res = 0;
	for (int i = 0; i < n; ++i) {
		if (a0[i] == -2) {
			auto p = dfs(a, i, used, false);
			res += max(p.first, p.second);
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			auto p = dfs(a, i, used, false);
			res += max(p.first, p.second);
		}
	}
	cout << res << endl;
	return 0;
}
