#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int MOD = 1e9 + 7;

void dfs(vector<vector<int>> &a, int v, vector<bool> &used, vector<int> &s, vector<bool> &roots) {
	used[v] = true;
	for (auto u : a[v]) {
		if (!used[u]) {
			dfs(a, u, used, s, roots);
		}
		roots[u] = false;
	}
	s.push_back(v);
	roots[v] = true;
}

void dfs2(vector<vector<int>> &a, int v, vector<bool> &used, vector<pair<int, int>> &d) {
	used[v] = true;
	d[v] = { 1, 0 };
	for (auto u : a[v]) {
		d[v].first += d[u].second;
		d[v].second += max(d[u].first, d[u].second);
	}
}

int main() {
	int n;
	cin >> n;
	vector<int> a0(n);
	for (int i = 0; i < n; ++i) {
		cin >> a0[i];
		--a0[i];
	}
	if (n <= 20){
        int res = 0;
        for (int i = 0; i < (1 << n); ++i){
            int c = 0;
            for (int j = 0; j < n; ++j){
                if ((i & (1 << j)) != 0){
                    if (a0[j] != -2 && (i & (1 << a0[j])) != 0){
                        c = -1;
                        break;
                    } else {
                        ++c;
                    }
                }
            }
            res = max(res, c);
        }
        cout << res << endl;
	} else {
        vector<vector<int>> a(n);
        for (int i = 0; i < n; ++i) {
            if (a0[i] != -2) {
                a[a0[i]].push_back(i);
            }
        }
        vector<int> s;
        vector<bool> used(n, false);
        vector<bool> roots(n, true);
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs(a, i, used, s, roots);
            }
        }
        vector<pair<int, int>> d(n);
        used = vector<bool>(n, false);
        for (int i = 0; i < n; ++i) {
            if (!used[s[i]]) {
                dfs2(a, s[i], used, d);
            }
        }
        int res = 0;
        for (int v = 0; v < n; ++v) {
            if (roots[v]) {
                res += max(d[v].first, d[v].second);
            }
        }
        cout << res << endl;
	}
	return 0;
}
