#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int MOD = 1e9 + 7;

int main() {
	int n, k, q;
	cin >> n >> k;
	if (n <= 10) {
		vector<int> p(n);
		vector<vector<int>> a(n, vector<int>(k));
		for (int i = 0; i < n; ++i) {
			p[i] = i;
			for (int j = 0; j < k; ++j) {
				cin >> a[i][j];
			}
		}
		while (p[0] == 0) {
			next_permutation(p.begin(), p.end());
			vector<pair<int, int>> bounds(k, {-1e9, 1e9});
			for (int i = 0; i < n; i += 2) {
				for (int j = 0; j < k; ++j) {
					int x = a[p[i]][j];
					int y = a[p[i + 1]][j];
					if (x > y) {
						swap(x, y);
					}
					bounds[j] = {max(bounds[j].first, x), min(bounds[j].second, y) };
				}
			}
			bool ok = true;
			for (int j = 0; j < k; ++j) {
				if (bounds[j].first > bounds[j].second) {
					ok = false;
					break;
				}
			}
			if (ok) {
				cout << "YES" << endl;
				for (int i = 0; i < n; i += 2) {
					cout << p[i] + 1 << " " << p[i + 1] + 1 << endl;
				}
				return 0;
			}
		}
		cout << "NO" << endl;
	}
	else {
		vector<vector<pair<int, int>>> a(k, vector<pair<int, int>>(n));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < k; ++j) {
				cin >> q;
				a[j][i] = { q, i };
			}
		}
		vector<int> tmp(n, 0);
		for (int i = 0; i < k; ++i) {
			sort(a[i].begin(), a[i].end());
			for (int j = n / 2; j < n; ++j) {
				tmp[a[i][j].second] |= (1 << i);
			}
		}
		vector<vector<int>> res(1 << k);
		for (int i = 0; i < n; ++i) {
			res[tmp[i]].push_back(i);
		}
		int s = (1 << k) - 1;
		vector<pair<int, int>> p;
		bool ok = true;
		for (int i = 0; i < (1 << k); ++i) {
			while (!res[i].empty()) {
				if (res[s - i].empty()) {
					ok = false;
					break;
				}
				p.push_back({ res[i].back(), res[s - i].back() });
				res[s - i].pop_back();
				res[i].pop_back();
			}
			if (!ok) {
				break;
			}
		}
		if (ok) {
			cout << "YES" << endl;
			for (auto e : p) {
				cout << e.first + 1 << " " << e.second + 1 << endl;
			}
		}
		else {
			cout << "NO" << endl;
		}
	}
	return 0;
}
