#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <queue>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

int main(int argc, char const *argv[])
{
    int a, b, c;
    std::cin >> a >> b >> c;

    const int INF = 2e9;
    std::vector<int> dist(b + 2, INF);
    dist[a] = 0;
    for (int i = a; i < b; ++i)
    {
        if (i % c != 0)
        {
            dist[i + 1] = std::min(dist[i + 1], 1 + dist[i]);
            dist[i + 2] = std::min(dist[i + 2], 1 + dist[i]);
        }
    }

    std::cout << dist[b] << '\n';

    return 0;
}