#include <iostream>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#define int long long

using namespace std;

int main43(int nn, int kk) {
    if (nn == kk) {
        return 1;
    }

    nn++;
    kk++;
    vector<vector<vector<int>>> a(nn, vector<vector<int>> (nn, vector<int> (2, 0)));
    for (int i = 1; i < nn; ++i) {
        a[i][i][0] = 1;
        a[i][i][1] = 1;
    }

    //cout << "crush";
    for (int n = 2; n < nn; ++n) {
        for (int k = 1; k < n; ++k) {
            for (int i = 1; i < k; ++i) {
                a[n][k][0] += a[n - k][i][1];
            }
            for (int i = k + 1; i <= n - k; ++i) {
                a[n][k][1] += a[n - k][i][0];
            }
        }
    }
    return a[nn - 1][kk - 1][0] + a[nn - 1][kk - 1][1];
}

signed main()
{
    int nn, kk;
    cin >> nn >> kk;
    cout << main43(nn, kk);
    return 0;
}
