#include <iostream>
#include <vector>
#include <ctime>
#define int long long

using namespace std;

const int MOD = 1e9 + 7;

int main100_2(int nn, int kk) {
    if (nn == kk) {
        return 1;
    }

    nn++;
    kk++;
    vector<vector<vector<int>>> a(nn, vector<vector<int>> (nn, vector<int> (2, 0)));
    vector<vector<int>> p(nn, vector<int> (nn, 0));
    vector<vector<int>> s(nn, vector<int> (nn + 1, 0));
    for (int i = 1; i < nn; ++i) {
        a[i][i][0] = 1;
        a[i][i][1] = 1;
    }

    for (int i = 1; i < nn; ++i) {
        p[1][i] = p[1][i - 1] + a[1][i][1];
    }
    for (int i = nn - 1; i > 0; --i) {
        s[1][i] = s[1][i + 1] + a[1][i][0];
    }
    for (int n = 2; n < nn; ++n) {
        for (int k = 1; k < n; ++k) {
            if (k != 1) {
                a[n][k][0] = (a[n][k][0] + p[n - k][k - 1]) % MOD;
            }
            if (k + 1 <= n - k) {
                a[n][k][1] = ((a[n][k][1] + s[n - k][k + 1]) % MOD - s[n - k][n - k + 1] + MOD) % MOD;
            }
        }
        for (int k = 1; k < nn; ++k) {
            p[n][k] = (p[n][k - 1] + a[n][k][1]) % MOD;
        }
        for (int k = nn - 1; k >= 0; --k) {
            s[n][k] = (s[n][k + 1] + a[n][k][0]) % MOD;
        }
    }
    return (a[nn - 1][kk - 1][0] + a[nn - 1][kk - 1][1]) % MOD;
}

signed main()
{
    int nn, kk;
    cin >> nn >> kk;
    cout << main100_2(nn, kk);
    return 0;
}
