#include <iostream>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> used;
vector<int> clr;
int clr0, clr1;

void dfs(int v) {
    used[v] = true;
    for (int u: g[v]) {
        if (!used[u]) {
            clr[u] = 1 - clr[v];
            if (clr[u] == 0) {
                clr0++;
            }
            else {
                clr1++;
            }
            dfs(u);
        }
    }
}

signed main()
{
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int ai;
        cin >> ai;
        if (ai != -1) {
            ai--;
            g[i].push_back(ai);
            g[ai].push_back(i);
        }
    }
    clr.resize(n, 0);
    used.resize(n, 0);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            clr0 = 1;
            clr1 = 0;
            dfs(i);
            ans += max(clr0, clr1);
        }
    }
    cout << ans;
    return 0;
}
