#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAX_N = 300009;
vector<int> g[MAX_N];
bool used[MAX_N];
int n;
bool w[MAX_N];
int cnt[MAX_N];

void dfs(int v, vector<int>& c)
{
    c.push_back(v);
    used[v] = true;
    for (int to : g[v])
    {
        if (!used[to])
            dfs(to, c);
    }
}

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        if (a == -1)
            continue;
        a--;
        g[i].push_back(a);
        g[a].push_back(i);
        cnt[i]++;
        cnt[a]++;
    }
    queue<int> q;
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (cnt[i] == 0)
            ans++;
        else if (cnt[i] == 1)
            q.push(i);
    }
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        if (used[v])
            continue;
        used[v] = true;
        bool u = true;
        for (int to : g[v])
        {
            if (w[to])
            {
                u = false;
                break;
            }
        }
        if (u)
        {
            w[v] = true;
            ans++;
        }
        for (int to : g[v])
        {
            cnt[to]--;
            if (cnt[to] == 1)
                q.push(to);
        }
    }
    vector<int> c;
    vector<bool> r;
    for (int v = 0; v < n; v++)
    {
        if (used[v])
            continue;
        c.resize(0);
        r.resize(0);
        dfs(v, c);
        int m = c.size();
        r.resize(m, 1);
        for (int e = 0; e < m; e++)
        {
            int u = c[e];
            bool t = true;
            for (int to : g[u])
            {
                if (w[to])
                {
                    t = false;
                    break;
                }
            }
            if (!t)
                r[e] = false;
        }
        int j = 0;
        while (j < m)
        {
            if (!r[j])
            {
                j++;
                continue;
            }
            int e = 1;
            while (r[(j + e) % m] && e < m)
                e++;
            if (j > 0 || !r[m - 1])
            {
                if (e != m)
                    ans += (e + 1) / 2;
                else
                    ans += m / 2;
            }
            j += e;
        }
    }
    cout << ans;
}
