#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAX_N = 200009;
vector<pair<int, int> > g[1000];
int c[3 * MAX_N];
int f[3 * MAX_N];
int n, k;
int st[7][MAX_N];
int a[MAX_N][7];
int cnt[1000];
vector<int> comp[1000];
pair<int, int> num_comp[MAX_N];
bool used[2][MAX_N];
int s, t;
int inf = 1000 * 1000 * 1000;
int d[1000];
int cnt_v;

bool bfs(int mi)
{
    for (int i = 0; i < 2 * cnt_v + 2; i++)
        d[i] = inf;
    d[s] = 0;
    queue<int> q;
    q.push(s);
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        for (auto to : g[v])
        {
            if (d[to.first] != inf || c[to.second] - f[to.second] < mi)
                continue;
            d[to.first] = d[v] + 1;
            q.push(to.first);
        }
    }
    return d[t] != inf;
}

int dfs(int v, int mi, int cur_mi)
{
    if (v == t)
        return cur_mi;
    for (auto to : g[v])
    {
        if (d[to.first] != d[v] + 1 || c[to.second] - f[to.second] < mi)
            continue;
        int flow = dfs(to.first, mi, min(cur_mi, c[to.second] - f[to.second]));
        if (flow)
        {
            f[to.second] += flow;
            f[to.second ^ 1] -= flow;
            return flow;
        }
    }
    return 0;
}

int dinic()
{
    int flow = 0;
    for (int mi = n / 2; mi >= 1; mi /= 2)
    {
        while (bfs(mi))
        {
            while (true)
            {
                int cur_mi = inf;
                int cur_flow = dfs(s, mi, cur_mi);
                flow += cur_flow;
                if (cur_flow == 0)
                    break;
            }
        }
    }
    return flow;
}

signed main()
{
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    freopen("input.txt", "r", stdin);
    cin >> n >> k;
    for (int i = 0; i < n; i++)
    {
        for (int e = 0; e < k; e++)
        {
            cin >> a[i][e];
            st[e][i] = a[i][e];
        }
    }
    for (int e = 0; e < k; e++)
        sort(st[e], st[e] + n);
    cnt_v = 1;
    for (int i = 0; i < k - 1; i++)
        cnt_v *= 3;
    for (int i = 0; i < n; i++)
    {
        int mask = 0;
        for (int e = k - 1; e >= 1; e--)
        {
            int j = lower_bound(st[e], st[e] + n, a[i][e]) - st[e];
            int u = upper_bound(st[e], st[e] + n, a[i][e]) - st[e];
            mask *= 3;
            if (u <= n / 2)
                mask += 0;
            else if (j >= n / 2)
                mask += 1;
            else
                mask += 2;
        }
        int j = lower_bound(st[0], st[0] + n, a[i][0]) - st[0];
        num_comp[i].second = mask;
        if (j < n / 2)
        {
            num_comp[i].first = 0;
            comp[mask].push_back(i);
            cnt[mask]++;
            //cout << "0 " << mask << "\n";
        }
        else
        {
            num_comp[i].first = 1;
            comp[cnt_v + mask].push_back(i);
            cnt[cnt_v + mask]++;
            //cout << "1 " << mask << "\n";
        }
    }
    int cnt_ed = 0;
    for (int m1 = 0; m1 < cnt_v; m1++)
    {
        if (cnt[m1] == 0)
            continue;
        for (int m2 = 0; m2 < cnt_v; m2++)
        {
            if (cnt[cnt_v + m2] == 0)
                continue;
            int a1 = m1;
            int a2 = m2;
            bool u = true;
            for (int e = 0; e < k - 1; e++)
            {
                int b1 = a1 % 3;
                int b2 = a2 % 3;
                if (b1 <= 1 && b2 <= 1 && b1 == b2)
                {
                    u = false;
                    break;
                }
                a1 /= 3;
                a2 /= 3;
            }
            if (u)
            {
                //cout << m1 << " " << m2 << " " << cnt[m1] << " " << cnt[cnt_v + m2] << "\n";
                g[m1].emplace_back(cnt_v + m2, cnt_ed);
                g[cnt_v + m2].emplace_back(m1, cnt_ed + 1);
                c[cnt_ed] = inf;
                c[cnt_ed + 1] = 0;
                cnt_ed += 2;
            }
            //cout << "\n";
        }
    }
    s = 2 * cnt_v;
    t = 2 * cnt_v + 1;
    for (int i = 0; i < cnt_v; i++)
    {
        if (cnt[i] == 0)
            continue;
        g[s].emplace_back(i, cnt_ed);
        g[i].emplace_back(s, cnt_ed + 1);
        c[cnt_ed] = cnt[i];
        c[cnt_ed + 1] = 0;
        cnt_ed += 2;
    }
    for (int i = cnt_v; i < 2 * cnt_v; i++)
    {
        if (cnt[i] == 0)
            continue;
        g[i].emplace_back(t, cnt_ed);
        g[t].emplace_back(i, cnt_ed + 1);
        c[cnt_ed] = cnt[i];
        c[cnt_ed + 1] = 0;
        cnt_ed += 2;
    }
    /*for (int i = 0; i < 2 * cnt_v + 2; i++)
    {
        if (g[i].empty())
            continue;
        cout << i << ":\n";
        for (auto to : g[i])
            cout << to.first << " " << c[to.second] << "\n";
        cout << "\n";
    }*/
    int flow = dinic();
    //cout << flow << "\n";
    if (flow < n / 2)
    {
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    for (int i = 0; i < cnt_v; i++)
    {
        for (auto to: g[i])
        {
            while (cnt[i] && cnt[to.first])
            {
                cnt[i]--;
                cnt[to.first]--;
                cout << comp[i][cnt[i]] + 1 << " " << comp[to.first][cnt[to.first]] + 1 << "\n";
            }
        }
    }
}
