#pragma GCC optimize("O3")
#include <iostream>
#include <fstream>
#include <utility>
#include <stdio.h>
#include <stdlib.h>
#include <utility>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#define x first
#define y second
#define int long long
#define prev prv

using namespace std;

typedef long double ld;

const int N = 3e5 + 10;
const int SQRT = sqrt(N) + 10;

int n, m, a[N];
vector<int> b;
set<int> blocks[SQRT];
int maxx[SQRT], sz[SQRT];
int pos[N], ind[N];
vector<int> bs[SQRT], prev[N];
vector<int> ans;

inline void fast() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

inline void build() {
    for (int i = 0; i < SQRT; ++i) maxx[i] = -1;
    for (int i = 0; i < m; ++i) {
        blocks[i / SQRT].insert(pos[a[i]]);
        sz[i / SQRT]++;
        maxx[i / SQRT] = max(maxx[i / SQRT], pos[a[i]]);
    }
}

inline void upd(int x, int p) {
    for (int i = 0; i < SQRT; ++i) {
        if (blocks[i].count(pos[x])) {
            if (ind[x] >= prev[x].size()) {
                blocks[i].erase(pos[x]);
                if (!blocks[i].empty())
                    maxx[i] = *blocks[i].rbegin();
                else maxx[i] = -1;
                continue;
            }
            blocks[i].erase(pos[x]);
            blocks[i].insert(p);
            maxx[i] = *blocks[i].rbegin();
        }
    }
    pos[x] = p;
}

inline int get(int l, int r) {
    if (r == -2) return n - 1;
    int cur_l = 0;
    int ans = -1;
    for (int i = 0; i < SQRT; ++i) {
        int cur_r = cur_l + sz[i] - 1;
        if (l <= cur_l && cur_r <= r) {
            ans = max(ans, maxx[i]);
            cur_l += sz[i];
            continue;
        }
        for (int j = max(cur_l, l); j <= min({cur_r, r, m - 1}); ++j) {
            ans = max(ans, pos[a[j]]);
        }
        cur_l += sz[i];
    }
    if (ans == -1) return n - 1;
    return ans;
}

inline void build_b() {
    for (int i = 0; i < n; ++i) {
        bs[i / SQRT].push_back(b[i]);
    }
}

inline bool check(int x) {
    if (ind[x] >= prev[x].size()) return 1;
    return 0;
}

inline void corr(int x) {
    while (ind[x] < prev[x].size() && check(a[prev[x][ind[x]]])) ++ind[x];
}

inline int find_prev(int x) {
    //corr(x);
    if (ind[x] >= prev[x].size()) return -2;
    return prev[x][ind[x]];
}

inline void my_move(int i, int j) {
    ++ind[b[i]];
    int cur = b[i];
    b.erase(b.begin() + i);
    b.insert(b.begin() + j, cur);
    for (int ps = i; ps < j; ++ps) {
        upd(b[ps], pos[b[ps]] - 1);
    }
    upd(cur, j);
    ans.push_back(j + 1);
}

inline bool check1() {
    for (int i = 0; i < n; ++i) {
        if (a[i] != b[i]) return false;
    }
    return true;
}

inline void solve1() {
    cout << n << "\n";
    for (int i = 0; i < n; ++i) {
        cout << n << " ";
    }
    return;
}

inline bool check2() {
    for (int i = 0; i < n; ++i) {
        if (a[i] != b[n - 1 - i]) return false;
    }
    return true;
}

inline void solve2() {
    vector<int> v;
    for (int i = 0; i < n - 1; ++i) {
        v.push_back(n - 1 - i + 1);
    }
    for (int i = 0; i < n; ++i) {
        v.push_back(n);
    }
    cout << v.size() << "\n";
    for (auto el : v) cout << el << " ";
    return;
}

inline void print(vector<int> &b) {
    for (auto el : b) cout << el << " ";
    cout << endl;
}

signed main() {
    fast();
    cin >> n >> m;
    b.resize(n, 0);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    for (int j = 0; j < n; ++j) {
        cin >> b[j];
        pos[b[j]] = j;
    }
    if (n == m && check1()) {
        solve1();
        return 0;
    }
    if (n == m && check2()) {
        solve2();
        return 0;
    }
    for (int i = 1; i < m; ++i) {
        prev[a[i]].push_back(i - 1);
        ind[a[i]] = 0;
    }
    build();
    //build_b();
    for (int i = 0; i < m; ++i) {
        int j = 0;
        while (j < b.size() && b[j] != a[i]) {
            int ind = get(i, find_prev(b[j]));
            my_move(j, ind);
            //print(b);
            //if (j == 0 && ind == 3) break;
            if (j == ind) ++j;
        }
        int ind = get(i, find_prev(b[j]));
        if (j < b.size()) my_move(j, ind);
        //print(b);
    }
    cout << ans.size() << "\n";
    for (auto el : ans) cout << el << " ";
    return 0;
}
