#define _USE_MATH_DEFINES
#pragma optimization_level 3
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <deque>
#include <map>
#include <iomanip>
#include <math.h>
using namespace std;

const int mod = 1e9 + 7;
ostream& operator << (ostream& s, vector<int>& a) {
	for (auto i : a) {
		//if (i == inf) cout << "inf ";
		//else cout << i << " ";
	}
	cout << '\n';
	return s;
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	int n, k;
	cin >> n >> k;

	if (n == k) return cout << 1, 0;

	vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(n + 1));
	dp[n - k][k].first = 1;
	dp[n - k][k].second = 1;

	for (int sum = n - k; sum > 0; sum--) {
		for (int j = 1; j <= n; j++) {

			for (int a = 1; a < j && a <= sum; a++) {
				dp[sum - a][a].first = (dp[sum - a][a].first + dp[sum][j].second) % mod;
			}

			for (int a = j + 1; a <= sum; a++) {
				dp[sum - a][a].second = (dp[sum - a][a].second + dp[sum][j].first) % mod;
			}

		}
	}

	int ans = 0;
	for (int i = 1; i <= n; i++) {
		ans = (ans + dp[0][i].first) % mod;
		ans = (ans + dp[0][i].second) % mod;
	}

	cout << ans;

//	system("pause");
	return 0;
}