#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;

int* arr;
int** mas;
int* a;
int* ps;
long long int m, n, s;

void buildMS(int L = 0, int R = s - 1, int id = 1) {
	mas[id] = new int[R - L + 1];
	if (L == R) {
		mas[id][0] = ps[L];
	}
	else {
		int M = (L + R) / 2;
		buildMS(L, M, id * 2);
		buildMS(M + 1, R, id * 2 + 1);
		int i = 0, j = 0, s1 = M - L + 1, s2 = R - M;
		int S = 0;
		while (i < s1 || j < s2) {
			if (i == s1) mas[id][S++] = mas[id * 2 + 1][j++];
			else if (j == s2) mas[id][S++] = mas[id * 2][i++];
			else if (mas[id * 2][i] < mas[id * 2 + 1][j]) {
				mas[id][S++] = mas[id * 2][i++];
			}
			else mas[id][S++] = mas[id * 2 + 1][j++];
		}
	}
}

int getMore(int l, int r, int x, int L = 0, int R = s - 1, int id = 1) {
	if (L > r || R < l) return 0;
	if (L >= l && R <= r) {
		int S = R - L + 1;
		int bl = -1, br = S;
		while (br - bl > 1) {
			int m = (bl + br) / 2;
			if (mas[id][m] > x) br = m;
			else bl = m;
		}
		return S - br;
	}
	else {
		int M = (R + L) / 2;
		return getMore(l, r, x, L, M, id * 2) +
			getMore(l, r, x, M + 1, R, id * 2 + 1);
	}
}

void build(int L = 0, int R = n - 1, int id = 1) {
	if (L == R) arr[id] = 1;
	else {
		int M = (L + R) / 2;
		build(L, M, id * 2);
		build(M + 1, R, id * 2 + 1);
		arr[id] = arr[id * 2] + arr[id * 2 + 1];
	}
}

int find(int L = 0, int R = n - 1, int id = 1) {
	if (L == R) {
		arr[id] = 0;
		return L;
	}
	int M = (R + L) / 2;
	if (arr[id * 2] > 0) {
		arr[id]--;
		return find(L, M, id * 2);
	}
	else {
		arr[id]--;
		return find(M + 1, R, id * 2 + 1);
	}
}

int main() {
	scanf("%lld %lld", &n, &m);
	a = new int[m];
	int* b = new int[n];
	bool* used = new bool[n];
	for (int i = 0; i < m; i++) {
		scanf("%d", &a[i]);
		a[i]--;
	}
	for (int i = 0; i < n; i++) {
		scanf("%d", &b[i]);
		b[i]--;
		used[i] = false;
	}
	int cnt = m;
	vector<vector<int>> res(n, vector<int>());
	vector<int> q;
	int pos = 0;
	arr = new int[n * 4];
	build();
	for (int i = 0; i < m; i++) {
		if (!used[a[i]]) {
			while (true) {
				int j = find();
				if (b[j] == a[i]) break;
				cnt++;
				res[b[j]].push_back(pos++);
				q.push_back(b[j]);
				used[b[j]] = true;
			}
		}
		used[a[i]] = true;
		res[a[i]].push_back(pos++);
		q.push_back(a[i]);
	}
	printf("%d\n", cnt);
	int* sz = new int[n];
	for (int i = 0; i < n; i++) sz[i] = 0;
	s = q.size();
	ps = new int[s];
	for (int i = 0; i < q.size(); i++) {
		int v = q[i];
		if (sz[v] == 0) ps[i] = -1;
		else ps[i] = res[v][sz[v] - 1];
		sz[v]++;
	}
	mas = new int*[s * 4];
	buildMS();
	for (int i = 0; i < n; i++) sz[i] = 0;
	for (int i = 0; i < (int)q.size(); i++) {
		int v = q[i];
		if (sz[v] + 1 >= res[v].size()) printf("%d ", n);
		else {
			int c = res[v][sz[v] + 1] - res[v][sz[v]] - 1;
			c -= getMore(res[v][sz[v]] + 1, res[v][sz[v] + 1], i);
			sz[v]++;
			printf("%d ", c + 1);
		}
	}
	system("pause");
	return 0;
}