#pragma GCC optimize ("Ofast")
//#pragma GCC optimize ("enroll-loops")
#pragma GCC optimize ("fast-math")
//#pragma GCC target ("sse, sse2, sse3, ssse3, sse4, abm, avx, mmx, tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ll k;

const int INF = 3e7;

inline ll get_sum(ll n) {
	ll ans = (n + 1) * k;
	ans += n * n;
	return ans;
}

bool check(ll n, ll sum) {
	return get_sum(n) <= sum;
} 

ll find_n(ll sum) {
	cout << "find_n " << sum << endl;
	ll L = 0;
	ll R = INF;
	while (R - L > 1) {
		ll m = (L + R) / 2;
		if (check(m, sum)) L = m;
		else R = m;
	}
	cout << "L: " << L << " " << get_sum(L) << endl;
	if (get_sum(L) == sum) return L;
	return -1;
}

ll sum;
ll mn;

map<ll, int> mp;

int main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> k;
	sum += k;
	mn = INF + 1;
	for (ll i = 0; i < INF; i++) {
		sum += max((ll)0, 2 * i - 1) + k;
		mp[sum] = i;
	}

	for (ll i = 0; i < INF; i++) {
		if (mp.find(i * i) != mp.end()) {
			cout << i << endl;
			return 0;
		}
	}

	cout << "none" << endl;
	return 0;
}
