#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
#pragma comment(linker, "/stack:100000000")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<long long> num;
vector<vector<long long>> m;

long long n, k;

void check2(int i1, int i2, vector<vector<long long>> &m)
{
	cout << "YES" << endl;
	cout << 1 << " " << 2 << endl;
}

pair<long long, long long> ntr(long long l1, long long r1, long long l2, long long r2)
{
	if (l1 > r1)
		swap(l1, r1);
	if (l2 > r2)
		swap(l2, r2);
	if (r1 < l2 || r2 < l1)
		return { 2, 1 };
	return { max(l1, l2), min(r1, r2) };
}

bool check()
{
	for (int i = 0; i < k; ++i)
	{
		long long l = m[num[0]][i], r = m[num[0]][i];
		for (int g = 2; g < n; g += 2)
		{
			pair<long long, long long> temp = ntr(l, r, m[num[g]][i], m[num[g + 1]][i]);
			l = temp.first, r = temp.second;
			if (l > r)
				return false;
		}
	}
	cout << "YES" << endl;
	for (int i = 0; i < n; i += 2)
	{
		cout << num[i] + 1 << " " << num[i + 1] + 1 << endl;
	}
	return true;
}

bool flag = false;
vector<bool> used;


bool dfs(int p = 0)
{
	if (p < n)
	{
		for (int i = 0; i < n; ++i)
		{
			if (used[i] == false)
			{
				used[i] = true;
				for (int g = 0; g < n; ++g)
				{
					if (used[g] == false)
					{
						used[g] = true;
						num[p] = i;
						num[p + 1] = g;
						bool f = dfs(p + 2);
						if (f == true)
							return true;
						used[g] = false;
					}
				}
				used[i] = false;
			}
		}
	}
	else
	{
		bool f = check();
		if (f == true)
		{
			flag = true;
			return true;
		}
		else
		{
			return false;
		}
	}
}

int main()
{
	long long i, g;
	cin >> n >> k;
	num.resize(n);
	m.resize(n, vector<long long>(k));
	for (i = 0; i < n; ++i)
	{
		for (g = 0; g < k; ++g)
		{
			cin >> m[i][g];
		}
	}
	if (k == 1)
	{
		vector<pair<int, int>> d(n);
		for (i = 0; i < n; ++i)
		{
			d[i] = { m[i][0], i };
		}
		sort(d.begin(), d.end());
		cout << "YES" << endl;
		for (i = 0; i < n / 2; ++i)
		{
			cout << d[i].second + 1 << " " << d[n - 1 - i].second + 1 << endl;
		}
	}
	else if (n <= 10)
	{
		used.resize(n, false);
		dfs();
		if (flag == false)
		{
			cout << "NO" << endl;
		}
	}
	//system("pause");
	return 0;
}

/*
int ans = 0, n, x, y;

vector<bool> used;
vector<int> m;
vector<vector<int>> gf;
set<pair<pair<int, int>, int>> s;

void dfs(int v, int color = 1)
{
	used[v] = true;
	m[v] = color;
	int to, i;
	if (color == 1)
		++x;
	else
		++y;
	for (i = 0; i < gf[v].size(); ++i)
	{
		to = gf[v][i];
		if (color == 1)
		{
			if (used[to] == false)
				dfs(to, 2);
			else
			{
				if (m[to] == m[v])
				{
					s.insert({ {min(v, to), max(v, to)}, 1 });
				}
			}
		}
		else
		{
			if (used[to] == false)
				dfs(to, 1);
			else
			{
				if (m[to] == m[v])
					s.insert({ {min(v, to), max(v, to)}, 2 });
			}
		}
	}
}

void get_ans()
{
	gf.resize(n);
	int i;
	set<pair<int, int>> qs;
	for (i = 0; i < n; ++i)
	{
		if (m[i] != -2)
		{
			qs.insert({ i, m[i] });
			qs.insert({ m[i], i });
			//gf[i].push_back(m[i]);
			//gf[m[i]].push_back(i);
		}
	}
	for (auto it : qs)
	{
		gf[it.first].push_back(it.second);
	}
	m.resize(n, 0);
	for (i = 0; i < n; ++i)
	{
		if (!used[i])
		{
			x = 0, y = 0;
			s.clear();
			dfs(i);
			for (auto it : s)
			{
				if (it.second == 1)
					--x;
				else
					--y;
			}
			ans += max(x, y);
		}
	}
}
//13
//2 3 1 5 6 12 8 7 10 11 12 9 6
int main()
{
	int i;
	cin >> n;
	used.resize(n, false);
	m.resize(n);
	for (i = 0; i < n; ++i)
	{
		cin >> m[i];
		--m[i];
	}
	get_ans();
	cout << ans;
	system("pause");
	return 0;
}
*/

/*
const int MOD = 1e9 + 7;
int main()	
{
	int k, n, i, g, j;
	cin >> n >> k;
	//vector<vector<vector<int>>> d(n + 1, vector<vector<int>>(n + 1, vector<int>(2, 0)));
	int d[5005][5005][2];
	for (i = 0; i < 5005; ++i)
	{
		for (g = 0; g < 5005; ++g)
		{
			d[i][g][0] = 0;
			d[i][g][1] = 0;
		}
	}
	d[k][k][0] = 1;
	d[k][k][1] = 1;
	int temp;
	for (i = k; i < n; ++i)
	{
		for (g = 1; g <= n; ++g)
		{
			if (d[i][g][0] != 0)
			{
				temp = g - 1;
				if (temp > n - i)
					temp = n - i;
				for (j = temp; j > 0; --j)
				{
					d[i + j][j][1] = (d[i + j][j][1] + d[i][g][0]) % MOD;
				}
			}
			if (d[i][g][1] != 0)
			{
				for (j = g + 1; (i + j) <= n ; ++j)
				{
					d[i + j][j][0] = (d[i + j][j][0] + d[i][g][1]) % MOD;
				}
			}
		}
	}
	int ans = 0;
	for (i = 1; i <= n; ++i)
	{
		ans = (ans + d[n][i][0]) % MOD;
		ans = (ans + d[n][i][1]) % MOD;
	}
	if (n != k)
		cout << ans << endl;
	else
		cout << 1 << endl;
	//system("pause");
	return 0;
}
*/
