#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <vector>
#include <cmath>
#include <ctime>
#include <map>
#include <set>
using namespace std;

vector<char> u, u1, u2;
vector<vector<int> > g;
vector<int> p, dg, h, d;

bool kekec(int a, int b){
    return u2[a]<u2[b];
}

int dfs(int v, int dist = 1){
    //cout << v << endl;
    u[v] = true;
    bool kek = false;
    for(int i = 0; i<g[v].size(); i++){
        if(u[g[v][i]]){
            u2[v] = true;
            kek = true;
            continue;
        }
        if(dfs(g[v][i], dist+1)){
            u2[v] = true;
            kek = true;
        }
    }
    return kek;
}

void dfs1(int v, int p){
    u1[v] = 1;
    h[v] = 2;
    for(int i = 0; i<g[v].size(); i++){
        if(g[v][i]==p)
            continue;
        if(u1[g[v][i]]==0)
            dfs1(g[v][i], v);
        if(h[g[v][i]]!=1)
            h[v] = 1;
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    d.resize(n);
    g.resize(n);
    u.resize(n);
    u1.resize(n);
    u2.resize(n);
    dg.resize(n);
    h.resize(n, 0);
    bool kek = true, kek1 = false;
    for(int i = 0; i<n; i++){
        int a;
        cin >> a;
        if(a==-1&&i)
            kek = false;
        if(a==-1)
            continue;
        a--;
        if(a!=i-1)
            kek = false;
        g[i].push_back(a);
        g[a].push_back(i);
    }
    //cout << kek << ' ' << kek1 << endl;
    vector<int> pg(n);
    for(int i = 0; i<n; i++)
        pg[i] = g[i].size();
    int ans = 0;
    for(int i = 0; i<n; i++){
        if(u[i])
            continue;
        dfs(i);
    }
    for(int i = 0; i<n; i++)
        sort(g[i].begin(), g[i].end(), kekec);
    for(int i = 0; i<n; i++){
        if(u1[i])
            continue;
        dfs1(i, -1);
    }
    for(int i = 0; i<n; i++){
        bool kek = true;
        for(int j = 0; j<g[i].size(); j++){
            if(h[g[i][j]]==2){
                kek = false;
                break;
            }
        }
        if(kek)
            h[i] = 2;
    }
    for(int i = 0; i<n; i++){
        ans += (h[i]==2);
        //cout  << h[i] << ' ';
    }
    cout << ans;

    return 0;
}
/*
4
2 4 2 1

3
2 -1 2

5
5 1 2 3 4

8
2 3 6 2 4 5 5 6

16
2 3 6 2 4 5 5 6 10 11 14 10 12 13 13 14
*/
