#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 3e5 + 5;
const int MAXT = 1e8;
vector <int> a;
vector <int> real_a;
vector <int> b;
int pos[MAXN];
bool used[MAXN];

void cycle(int pos) {
    for (int i = 0; i < pos; ++i) {
        swap(b[i], b[i + 1]);
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    a.resize(m);
    b.resize(n);
    real_a.resize(n);
    for (int i = 0; i < MAXN; ++i) {
        pos[i] = MAXN;
    }
    for (int i = 0; i < m; ++i) {
        cin >> real_a[i];
        pos[real_a[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    bool flag1 = false, flag2 = false;
    if (n == m) {
        flag1 = flag2 = true;
        for (int i = 0; i < n; ++i) {
            if (a[i] != b[i]) {
                flag1 = false;
            }
            if (a[i] != b[n - i - 1]) {
                flag2 = false;
            }
        }
    }
    vector <int> ans;
    int cnt = 0, l = 0, r = 0;
    //cerr << "OK";
    while (true) {
        for (int i = 0; i < MAXN; ++i) {
            used[i] = false;
        }
        l = r;
        while (r < n) {
            //cerr << real_a[r] << " ";
            if (!used[real_a[r]]) {
                used[real_a[r]] = true;
                ++r;
            } else {
                break;
            }
        }
        //cerr << r;
        if (l == r) {
            break;
        }
        a.resize(0);
        for (int i = l; i < r - l; ++i) {
            a.push_back(real_a[i]);
        }
        cerr << l << " " << r << "\n";
        int cur = l;
        while (true) {
            cerr << b[0] << " " << b[1] << " " << b[2] << " " << b[3] << " " << b[4] << "\n";
            if (b[0] == a[cur]) {
                ++cur;
                pos[b[0]] = MAXN;
                cerr << "cur = " << cur << "\n";
                cycle(n - 1);
                //b.push_back(b[0]);
                //b.erase(b.begin());
                ans.push_back(n);
                ++cnt;
                if (cur == r) {
                    break;
                }
                continue;
            }
            int ind = b.size();
            while (pos[b[ind - 1]] > pos[b[0]]) {
                --ind;
            }
            ans.push_back(ind);
            ++cnt;
            //b.insert(b.begin() + ind, b[0]);
            //b.erase(b.begin());
            cycle(ind - 1);
        }
        cerr << "NEWSEG\n";
    }

    cout << cnt << "\n";
    for (auto i : ans) {
        cout << i << " ";
    }

    return 0;
}
