#include<iostream>
#include<vector>

const long long mod = 1000000007;



using namespace std;

int main(void){

    long long N = 0, K = 0;

    cin>>N>>K;

    long long co = N;

    vector<vector<long long> > up(co + 2, vector<long long> (co + 2, 0));

    vector<vector<long long> > down(co + 2, vector<long long> (co + 2, 0));

    vector<vector<long long> > s_up(co + 2, vector<long long> (co + 2, 0));

    vector<vector<long long> > s_down(co + 2, vector<long long> (co + 2, 0));

    for(int i = 1; i <= co; ++i){

        up[i][i] = 1;

        down[i][i] = 1;

    }



    for(int n = 1; n <= co - K; ++n){
        for(int k = 1; k < n; ++k){
            down[n][k] = s_up[n - k][k];

            up[n][k] = s_down[n - k][k];
        }



        long long sum = 0;

        for(int i = 1; i <= co; ++i){
            s_up[n][i] = sum;

            sum += up[n][i];

            if (sum >= mod)
                sum -= mod;
        }



        sum = 0;

        for(int i = co; i > 0; --i){
            s_down[n][i] = sum;

            sum += down[n][i];

            if (sum >= mod)
                sum -= mod;
        }

        //cout<<"hi\n";
    }

    long long ans = 0;

    if (N == K)
        ans = 1;
    else
        ans = (s_up[N - K][K] + s_down[N - K][K])%mod;

    cout<<ans<<"\n";



    /*for(int i = 1; i <= co; ++i){
        for(int j = 1; j <= co; ++j)
            cout<<ans[j][i]<<" ";

        cout<<"\n";
    }*/







    return 0;
}
