#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <fstream>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7;

ll FastPow(ll n, ll a) {
	if (a == 1) return n;
	if (a == 0) return 1;
	if (a % 2 != 0) return (FastPow(n, a - 1) * n) % mod;
	ll x = FastPow(n, a / 2);
	return (x * x) % mod;
}

int main() {
	ll n, m, k;
	cin >> n >> m >> k;
	if (m != 0) {
		cout << 2;
		return 0;
	}
	ll ans = 0;
	for (ll i = 0; i <= k; i++) {
		ll x = 0;
		ll j = i;
		while (j != 0) {
			if (j % 2 != 0)x++;
			j /= 2;
		}
		ans += FastPow(n, x);
		ans %= mod;
	}
	cout << ans;
}

