#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <fstream>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7, INF = 1e18;

mt19937_64 MyRand(0);

int main() {
	ll a, b, c;
	cin >> a >> b >> c;
	vector<ll> dp(b + 1, INF);
	dp[a] = 0;
	for (ll i = a + 1; i <= b; i++) {
		if (i % c == 0) continue;
		dp[i] = 1 + min(dp[i - 1], dp[i - 2]);
	}
	cout << dp[b];
}

