#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <fstream>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7, INF = 1e18;

mt19937_64 MyRand(0);

int main() {
	ll sum, k;
	cin >> sum >> k;
	if (sum == k) {
		cout << 1;
		return 0;
	}
	vector<vector<ll> > dP(sum + 1, vector<ll>(sum + 1)), Dp(sum + 1, vector<ll>(sum + 1));
	Dp[k][k] = 1;
	dP[k][k] = 1;
	for (ll s = k + 1; s <= sum; s++) {
		for (ll x = 1; x < s; x++) {
			for (ll prev = 1; prev < x; prev++) dP[s][x] += Dp[s - x][prev];
			for (ll prev = x + 1; prev <= s - x; prev++) Dp[s][x] += dP[s - x][prev];
			dP[s][x] %= mod;
			Dp[s][x] %= mod;
		}
	}
	ll ans = 0;
	for (auto i : Dp[sum]) ans += i;
	for (auto i : dP[sum]) ans += i;
	cout << ans % mod;
}

