#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <fstream>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7, INF = 1e18;

mt19937_64 MyRand(0);
vector<ll> TopSort, p;
vector<vector<ll> > g;
vector<bool> used;

void dfs(ll v) {
	used[v] = true;
	//if (p[v] != -2) if(!used[p[v]])  dfs(p[v]);
	for (auto i : g[v])
		if (!used[i]) dfs(i);
	TopSort.push_back(v);
}

int main() {
	ll n, k;
	cin >> n >> k;
	vector<ll> type(n);
	vector<vector<pair<ll, ll> > > v(k,vector<pair<ll, ll> >( n));
	for (ll i = 0; i < n; i++)
		for (ll j = 0; j < k; j++) {
			cin >> v[j][i].first;
			v[j][i].second = i;
		}
	for (auto i : v) {
		sort(i.begin(), i.end());
		for (auto &t : type) t *= 2;
		for (ll j = 0; j < i.size() / 2; j++) type[i[j].second] += 1;
	}
	vector<vector<ll> > t(1 << k);
	for (ll i = 0; i < n; i++) t[type[i]].push_back(i);
	for (ll i = 0; i < (1 << k); i++)
		if (t[i].size() != t[(1 << k) - 1 - i].size()) {
			cout << "NO";
			return 0;
	}
	cout << "YES\n";
	for (ll i = 0; i < (1 << (k - 1)); i++)
		for (ll j = 0; j < t[i].size(); j++)
			cout << t[i][j] + 1 << " " << t[(1 << k) - 1 - i][j] + 1<< "\n";
}

