#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <utility>
#include <cassert>
#include <ctime>
#include <vector>
#include <deque>

#pragma warning(disable: 4996)

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, const C& b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, const C& b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 3e5 + 7;

int give[MAXN];
int cart[MAXN];
int inCart[MAXN];
vector<int> res;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		cin >> give[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> cart[i];
		inCart[cart[i]] = i;
	}
	for (int j = 0; j < m; ++j) {
		while (cart[0] != give[j]) {
			//cout << "Cycling...\n";
			int cit = cart[0];
			int mxi = 0;
			int j1 = j;
			for (; j1 < m && give[j1] != cit; ++j1) {
				chkmax(mxi, inCart[give[j1]]);
			}
			res.push_back(mxi);
			for (int i = 0; i < mxi; ++i) {
				cart[i] = cart[i + 1];
				inCart[cart[i]] = i;
			}
			cart[mxi] = cit;
			inCart[cit] = mxi;
			//cout << mxi << '\n';
		}
		int cit = cart[0];
		int mxi = 0;
		int j1 = j + 1;
		for (; j1 < m && give[j1] != cit; ++j1) {
			chkmax(mxi, inCart[give[j1]]);
		}
		res.push_back(mxi);
		for (int i = 0; i < mxi; ++i) {
			cart[i] = cart[i + 1];
			inCart[cart[i]] = i;
		}
		cart[mxi] = cit;
		inCart[cit] = mxi;
		//cout << mxi << '\n';
	}
	cout << res.size() << '\n';
	for (int c : res) {
		cout << c + 1 << ' ';
	}
	cout << '\n';
}

