#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include <cmath>
#include <random>
#include <time.h>

const int INF = 1e3 + 7;
typedef long long ll;

using namespace std;

#define int long long

bool is_sqrt(int n)
{
    if (n < 0)
        return false;
    int x = sqrtl(n + 0.001);
    return x * x == n;
}

int ans(int k)
{
    if (k % 2 == 0 && k % 4 != 0)
    {
        //cout << "none\n";
        return -1;
    }
    for (int i = 0; i <= 1e9; ++i)
    {
        int x = i * i - k;
        if (x < 0)
            continue;
        int y = sqrtl(x + 0.001);
        if (y * y == x)
        {
            //cout << i << '\n';
            return i;
        }
    }
    return -1;
}

int plu(int k)
{
    //cout << k << " " << ans(k) << '\n';
    int t = k;
    int i;
    int last = -1;
    k = t;
    for (i = 2; i * i <= t; ++i)
        if (t % i == 0){
            //cout << i << ' ';
            last = i;
        }
    //cout << '/';
    int next = -1;
    for (; i >= 2 && next == -1; --i)
        if (t % i == 0){
            //cout << t / i << ' ';
            next = t / i;
        }
   //cout << endl;
    //cout << '\n';
    if (last == -1 && next == -1)
        return (k + 1) / 2;
    else if ((last + next) % 2 == 0)
        return (last + next) / 2;
    else
    {
        next = max(next - (int)1e5, 0ll);
        int tt = 1;
        while (!is_sqrt((next + tt)*(next + tt) - k))
        {
            ++tt;
        }
        return next + tt;
    }
}

int minu(int k)
{
    //cout << k << " " << ans(k) << '\n';
    int t = -k;
    int i;
    int last = -1;
    for (i = 2; i * i <= t; ++i)
        if (t % i == 0){
            //cout << i << ' ';
            last = i;
        }
    //cout << '/';
    int next = -1;
    for (; i >= 2 && next == -1; --i)
        if (t % i == 0){
            //cout << t / i << ' ';
            next = t / i;
        }
   //cout << endl;
    //cout << '\n';
    {
        next = max(next - (int)12e6, 0ll);
        int tt = 1;
        while (!is_sqrt((next + tt)*(next + tt) - k))
        {
            ++tt;
        }
        return next + tt;
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    mt19937_64 rnd;
    rnd.seed(228);

    int k;
    cin >> k;
    if (k % 2 == 0 && k % 4 != 0)
    {
        cout << "none\n";
        return 0;
    }
    if (k > 1e5)
        cout << plu(k) << '\n';
    else if (k > -5e6)
        cout << ans(k) << '\n';
    else
        cout << minu(k) << '\n';
    return 0;
/*
    for (int k = -1000; k <= 1000; ++k)
    {
        int cur = k;
        bool ok = false;
        if (cur > 0 && is_sqrt(cur))
        {
            cout << k << " " << sqrt(cur) << '\n';
            ok = true;
        }
        for (int i = 1; i < INF && !ok; i += 2)
        {
            cur += i;
            if (cur > 0 && is_sqrt(cur))
            {
                cout << k << " " << sqrt(cur) << '\n';// << (i + 1) / 2 <<"\n";
                ok = true;
            }
        }
    }
    */

    for (int j = 0; j < 1e2; ++j)
    {
        int k;
        //cin >> k;
        k = -(rnd() % ((int)1e3 + 1));
        if (ans(k) != -1)
        {
            cout << k << ' ';
            cout << ans(k) << " " << minu(k) << "\n";// <<  plu(k) << '\n';
            int i;
            int t = k;
            for (i = 2; i * i <= -t; ++i)
                if (t % i == 0){
                    cout << i << ' ';
                    //last = i;
                }
            cout << '/';
            int next = -1;
            for (; i >= 2; --i)
                if (t % i == 0){
                    cout << -t / i << ' ';
                    next = t / i;
                }
            cout << k;
            cout << endl;
            cout << '\n';
        }
        /*
        int t = k;
        cout << k  << '\n';
        if (ans(k) != -1){
            cout << k << " " << ans(k) << '\n';
            for (int i = 2; i * i <= -k; ++i)
            {
                while (k % i == 0){
                    cout << i << ' ';
                    k /= i;
                }
            }
            cout << k << ' ';
            cout << endl;
            int i;
            int last = -1;
            k = t;
            for (i = 2; i * i <= -t; ++i)
                if (t % i == 0){
                    cout << i << ' ';
                    //last = i;
                }
            cout << '/';
            int next = -1;
            for (; i >= 2; --i)
                if (t % i == 0){
                    cout << t / i << ' ';
                    next = t / i;
                }
            cout << endl;
            cout << '\n';
            /*if (last == -1 && next == -1)
                cout << (k + 1) / 2 << '\n';
            else if ((last + next) % 2 == 0)
                cout << (last + next) / 2 << '\n';
            else
            {
                int tt = 1;
                while (!is_sqrt((next + tt)*(next + tt) - k))
                {
                    ++tt;
                }
                cout << next + tt << '\n';
            }
            cout << endl;*/
       // }
    }


    return 0;
}
