#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include <time.h>

const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
typedef long long ll;

using namespace std;
const int MAXN = 5001;
int d[MAXN][MAXN][2];


//#define int long long

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    //freopen("input.txt", "r", stdin);
    srand(time(0));

    int n, k;
    cin >> n >> k;
    for (int i = n; i >= 0; --i)
    {
        for (int j = 0; j <= n; ++j)
        {
            for (int k = 0; k < 2; ++k)
                d[i][j][k] = 0;
        }
    }
    if (n - k != 0)
        d[n - k][k][0] = 1;
    d[n - k][k][1] = 1;
    set<pair<pair<int, int>, int>> cur;
    cur.insert({{-(n - k), k}, 0});
    cur.insert({{-(n - k), k}, 1});
    long long ans = 0;
    while (!cur.empty())
    {
        auto x = (*cur.begin());
        cur.erase(cur.begin());
        int all = -x.first.first;
        int last = x.first.second;
        bool nextmore = x.second;
        if (nextmore)
        {
            for (int i = last + 1; i <= all; ++i)
            {
                d[all - i][i][0] += d[all][last][nextmore];
                if (d[all - i][i][0] >= MOD)
                    d[all - i][i][0] %= MOD;
                if (all != i)
                    cur.insert({{-(all - i), i}, 0});
            }
        }
        else
        {
            for (int i = 1; i< last && i <= all; ++i)
            {
                d[all - i][i][1] += d[all][last][nextmore];
                if (d[all - i][i][1] >= MOD)
                    d[all - i][i][1] %= MOD;
                if (all != i)
                    cur.insert({{-(all - i), i}, 1});
            }
        }
    }
    for (int j = 0; j <= n; ++j)
    {
        for (int k = 0; k < 2; ++k){
            ans += d[0][j][k];
            if (ans >= MOD)
                ans %= MOD;
        }
    }
    cout << ans << '\n';




    return 0;
}
