#include <iostream>
#include <vector>
#include <set>
#include <string>
using namespace std;

int qpow(int x, int n){
    if (n == 0)
        return  1;
    if (n == 1)
        return x;
    if (n % 2 == 0){
        int p = qpow(x, n/2);
        return p*p;
    }else{
        int p = qpow(x, (n-1)/2);
        return p*p*x;
    }
}

vector <int> used;
vector <vector <int> > V;

void dfs (int v, int k = 1){
    used[v] = k;
    for (int i = 0; i < V[v].size(); ++i){
        if (!used[V[v][i]]){
            dfs(V[v][i], (k == 1 ? 2 : 1));
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    int n = 0;
    cin >> n;
    vector <int> a(n ,0);
    for (int i = 0; i < n; ++i){
        cin >> a[i];
        a[i]--;
    }
    if (n <= 20){
        int rez = 0;
        vector <int> p(n, 0);
        for (int i = 1; i < qpow(2,n); i++){
            int j = 0;
            while (p[j] == 1){
                p[j] = 0;
                j++;
            }
            p[j] = 1;
            set <int> S;
            for (j = 0; j < n; ++j){
                if (p[j])
                    S.insert(j);
            }
            bool flag = 1;
            for (auto i = S.begin(); i != S.end(); ++i){
                flag = flag && (S.find(a[*i]) == S.end());
            }
            if (flag){
                rez = max(rez, (int) S.size());
            }
        }
        cout << rez;
    }else{
        used.assign(n,0);
        V.resize(n);
        for (int i = 0; i < n; ++i){
            if (a[i] == -1)
                continue;
            V[i].push_back(a[i]);
            V[a[i]].push_back(i);
        }
        for (int i = 0; i < n; ++i){
            if (!used[i] && V[i].size() != 0){
                dfs(i);
            }
        }
        int p[3];
        p[0] = 0;
        p[1] = 0;
        p[2] = 0;
        for (int i = 0; i < n; i++)
            p[used[i]]++;
        cout << max(p[0]+p[1], p[0]+p[2]);
    }

    return 0;
}