#include <bits/stdc++.h>

using namespace std;
using lli = long long;

map<lli, lli> matching;
vector<set<lli>> g;
vector<lli> used;
const lli MAXN = 2e5, MAXK = 7;
lli n, k;
lli a[MAXN][MAXK];

bool dfs(lli v){
    for (auto u : g[v]){
        if (matching[u] == -1) {
            matching[u] = v;
            used[v] = u;
            return true;
        }
        else {
            if (matching[u] != v && dfs(matching[u])) {
                matching[u] = v;
                used[v] = u;
                return true;
            }
        }
    }
    return false;
}

void create_g(){
    g.resize(n);
    used.resize(n);
    vector<pair<lli, lli>> sorted(n);
    for (lli i = 0; i < n; i++) sorted[i] = {a[i][0], i};
    sort(sorted.begin(), sorted.end());
    for (lli i = 0; i < n / 2; i++){
        for (lli j = n / 2; j < n; j++){
            g[sorted[i].second].insert(sorted[j].second);
            used[sorted[j].second] = 1;
            used[sorted[i].second] = -1;
        }
        matching[sorted[i].second] = -1;
        matching[sorted[i + n / 2].second] = -1;
    }
    for (lli i = 1; i < k; i++){
        vector<pair<lli, lli>> sor(n);
        for (lli j = 0; j < n; j++) sor[j] = {a[j][i], j};
        sort(sor.begin(), sor.end());
        for (lli j = 0; j < n / 2; j++){
            for (lli q = 0; q < n / 2; q++){
                g[sor[j].second].erase(sor[q].second);
            }
        }
        for (lli j = n / 2; j < n; j++){
            for (lli q = n / 2; q < n; q++){
                g[sor[j].second].erase(sor[q].second);
                g[sor[q].second].erase(sor[j].second);
            }
        }
    }
}

void print(){
    for (lli i = 0; i < n; i++){
        for (auto u : g[i]) cout << u << ' ';
        cout << '\n';
    }
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
    cin >> n >> k;
    for (lli i = 0; i < n; i++){
        for (lli j = 0; j < k; j++){
            cin >> a[i][j];
        }
    }
    if (n % 2 == 0) {
        create_g();
        //print();
        for (lli i = 0; i < n; i++){
            if (used[i] == -1) {
                dfs(i);
                //cout << i << ' ';
            }
        }
        lli cnt = 0;
        for (lli i = 0; i < n; i++){
            if (matching[i] >= 0) cnt++;
        }
        if (cnt == n / 2) {
            cout << "YES\n";
            for (lli i = 0; i < n; i++){
                if (matching[i] >= 0) {
                    cout << min(i, matching[i]) + 1 << ' ' << max(i, matching[i]) + 1 << '\n';
                }
            }
            return 0;
        }
    }
    cout << "NO";
	return 0;
}
/*
6 2
8 6
1 5
6 3
3 1
4 7
7 2
*/
