#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>


#define ll long long
#define pii piar<ll, ll>
#define x first
#define y second
#define ld long double

using namespace std;

const ll NMAX = 611111;
const ll inf = 4e18;

int a[NMAX];
int b[NMAX];

int q[NMAX];
int cntq = 1;

int used[NMAX];

struct vertex
{
	int x, y;
	vertex * l, *r;
	int cnt;
} g[NMAX];

vertex * ls = g + 1;

vertex * nver(int x)
{
	ls->x = x;
	ls->y = rand();
	ls->l = g;
	ls->r = g;
	ls->cnt = 1;
	return ls++;
}

void update(vertex * v)
{
	if (v == g)
		return;
	v->cnt = v->l->cnt + v->r->cnt + 1;
	return;
}

vertex * merge(vertex * l, vertex * r)
{
	if (l == g)
		return r;
	if (r == g)
		return l;
	if (l->y < r->y)
	{
		r->l = merge(l, r->l);
		update(r);
		return r;
	}
	else
	{
		l->r = merge(l->r, r);
		update(l);
		return l;
	}
}

pair<vertex *, vertex *> split(vertex * v, int x)
{
	if (v == g)
		return { g, g };
	if (v->x < x)
	{
		auto w = split(v->r, x);
		v->r = w.first;
		update(v);
		return { v, w.second };
	}
	else
	{
		auto w = split(v->l, x);
		v->l = w.second;
		update(v);
		return { w.first, v };
	}
}

int tim[NMAX];
int tm = -1;

vector<int> ans;

signed main()
{
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cout.precision(10);
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= m; i++)
		cin >> a[i];
	for (int i = 1; i <= n; i++)
		cin >> b[i];
	int j = 1;
	for (int i = 1; i <= m; i++)
	{
		if (used[a[i]])
		{
			q[cntq++] = a[i];
		}
		else
		{
			while (j <= n && b[j] != a[i])
			{
				q[cntq++] = b[j];
				used[b[j]] = 1;
				j++;
			}
			q[cntq++] = a[i];
			used[a[i]] = 1;
			j++;
		}
	}
	vertex * t = g;
	for (int i = cntq - 1; i >= 1; i--)
	{
		if (tim[q[i]] != 0)
		{
			auto w = split(t, tim[q[i]]);
			auto e = split(w.second, tim[q[i]] + 1);
			tim[q[i]] = tm--;
			e.first->x = tim[q[i]];
			ans.push_back(w.first->cnt + 1);
			t = merge(merge(e.first, w.first), e.second);

		}
		else
		{
			tim[q[i]] = tm--;
			vertex * cur = nver(tim[q[i]]);
			ans.push_back(n);
			t = merge(cur, t);
			
		}
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << endl;
	for (int u : ans)
	{
		cout << u << ' ';
	}
	cout << endl;
	return 0;
}