#include <bits/stdc++.h>
using namespace std;

typedef unsigned long long ull;
typedef long long ll;

int M;

struct art{
    int id;
    vector<int> p;
};

bool cmp(art a, art b){
    return a.p[M]<b.p[M];
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n, k;
    cin >> n >> k;
    vector<art> a(n);
    for(int i = 0; i<n; i++){
        a[i].id = i;
        a[i].p.resize(k);
        for(auto &c:a[i].p)
            cin >> c;
    }
    vector<vector<bool>> g(n, vector<bool> (n, 1));
    for(int i = 0; i<k; i++){
        M = i;
        sort(a.begin(), a.end(), cmp);

        int u = n/2-1, v = n/2;
        if (a[u].p[i]==a[v].p[i]) {
            while (u>=0 && a[u].p[i] == a[n / 2].p[i])
                u--;
            while (v<n && a[v].p[i] == a[n / 2].p[i])
                v++;
        }
        for(int x = 0; x<=u; x++)
            for(int y = 0; y<=u; y++)
                g[a[x].id][a[y].id] = 0;
        for(int x = v; x<n; x++)
            for(int y = v; y<n; y++)
                g[a[x].id][a[y].id] = 0;
    }
    vector<int> ans;
    vector<bool> used(n, 0);
    while(true){
        int start = -1;
        for(int i = 0; i<n; i++)
            if (count(g[i].begin(), g[i].end(), 1)==1 && !used[i])
                start = i;
        if (start==-1){
            for(int i = 0; i<n; i++)
                if (count(g[i].begin(), g[i].end(), 1)>0 && !used[i])
                    start = i;
        }
        if (start==-1)
            break;
        while(!used[start]){
            used[start] = 1;
            ans.push_back(start);
            for(int i = 0; i<n; i++)
                if (g[start][i] && !used[i]) {
                    g[start][i]=0;
                    g[i][start]=0;
                    start = i;
                    break;
                }
        }
    }
    if (ans.size()==n){
        cout << "YES\n";
        for(int i = 0; i<n; i+=2)
            cout << ans[i]+1 << " " << ans[i+1]+1 << endl;
    } else
        cout << "NO";
};