#include <bits/stdc++.h>

#ifdef AAA_LOCAL_EXECUTION
    #define db(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbs(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;35m" << x << "\x1b[0m" <<  endl;
    #define dbsx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;35m" << x << "\x1b[0m" << endl;
#else
    #define db(x)
    #define dbx(x)
    #define dbs(x)
    #define dbsx(x)
#endif

using namespace std;

using ll = long long;

__int128 intsqrt(__int128 k)
{
    if (k < 0) {
        throw runtime_error("intsqrt(k < 0)");
    }

    __int128 l = 0, r = k + 1;
    while (r - l > 1) {
        __int128 m = (l + r) / 2;
        if (m * m <= k) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}


int main()
{
    ll _k;
    cin >> _k;
    __int128 k = _k;

    __int128 clim = 8 * intsqrt(abs(k)) + 100;
    
    bool found = false;
    __int128 mint = 999'999'999'999'999LL;
    for (__int128 c = -clim; c <= clim; ++c) {
        if (c == 0) {
            if (k < 0) {
                continue;
            }
            __int128 t = intsqrt(k);
            if (t * t == k) {
                mint = min(mint, t);
                found = true;
            }
            continue;
        }
        if ((k - c*c) % (2 * c) != 0) {
            continue;
        }
        __int128 x = (k - c*c) / (2*c);
        if (x <= 0) {
            continue;
        }
        __int128 sq = k + x * x;
        if (sq <= 0) {
            continue;
        }
        __int128 t = intsqrt(sq);
        if (t * t == sq && t < mint) {
            mint = t;
            found = true;
        }
    }

    if (!found) {
        cout << "none" << endl;
    } else {
        cout << static_cast<ll>(mint) << endl;
    }
}
