#include <bits/stdc++.h>

#ifdef AAA_LOCAL_EXECUTION
    #define db(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbs(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;35m" << x << "\x1b[0m" <<  endl;
    #define dbsx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;35m" << x << "\x1b[0m" << endl;
#else
    #define db(x)
    #define dbx(x)
    #define dbs(x)
    #define dbsx(x)
#endif

using namespace std;

using ll = long long;

const ll MOD = 1'000'000'007;


template <typename T>
ostream& operator<<(ostream& s, const vector<T>& v)
{
    for (auto& i : v) {
        s << i << "\t";
    }
    return s;
}


template <typename T, typename U>
ostream& operator<<(ostream& s, const pair<T, U>& p)
{
    s << "[" << p.first << "," << p.second << "]";
    return s;
}


int main()
{
    ll n, k;
    cin >> n >> k;

    if (n == k) {
        cout << 1 << endl;
        return 0;
    }

    vector<vector<pair<ll, ll>>> d(n+1, vector<pair<ll, ll>>(n+1, {0, 0}));

    d[k][k] = {1, 1};
    for (ll curn = 2; curn <= n; ++curn) {
        for (ll alast = 1; alast <= n; ++alast) {
            ll target_n = curn - alast;
            if (target_n < 1)  {
                continue;
            }
            ll incsum = 0;
            ll decsum = 0;
            for (ll atarg = 1; atarg <= n; ++atarg) {
                if (atarg < alast) {
                    incsum += d[target_n][atarg].first;
                    incsum %= MOD;
                } else {                        
                    decsum += d[target_n][atarg].second;
                    decsum %= MOD;
                }
            }
            d[curn][alast] = {decsum, incsum};
        }
    }
    for (auto& i : d) {
        db(i);
    }

    ll sum = 0;
    for (ll alast = 1; alast <= n; ++alast) {
        sum += d[n][alast].first + d[n][alast].second;
        sum %= MOD;
    }
    cout << sum << endl;
}
