import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Main {
    private static long n, z;
    private static long T = 1000000007;
    private static Map<Long, Long> fxyz, gxyz;

    private static long floor2k(long n) {
        long i = 1;
        while (n >= i)
            i *= 2;
        return i / 2;
    }

    private static long f(long z, long n, long k) {
        long key = z * 5005 * 5005 + n * 5005 + k;
        if (fxyz.containsKey(key)) return fxyz.get(key);

        long answ = 0;
        if (n == 1)
            answ = (z == k ? 1 : 0);
        else if (z > 0)
            for (int i = 1; i <= k - 1; i++)
                answ += g(z - k, n - 1, k - i);
        answ %= T;

        fxyz.put(key, answ);
        //System.out.println("f" + z + "  " + n + "  " + k + "  = " + answ);
        return answ;
    }

    private static long g(long z, long n, long k) {
        long key = z * 5005 * 5005 + n * 5005 + k;
        if (gxyz.containsKey(key)) return gxyz.get(key);

        long answ = 0;
        if (n == 1)
            answ = (z == k ? 1 : 0);
        else if (z > 0)
            for (int i = 1; i <= z - 2*k; i++)
                answ += f(z - k, n - 1, k + i);
        answ %= T;

        gxyz.put(key, answ);
        //System.out.println("g" + z + "  " + n + "  " + k + "  = " + answ);
        return answ;
    }

    private static long solve(long n, long k) {
        if (n == k)
            return 1;

        long answ = 0;
        for (int i = 1; i <= n; i++) {
            answ += f(n, i, k) + g(n, i, k);
        }
        return answ % T;
    }

    public static void main(String[] args) {
        fxyz = new HashMap<>();
        gxyz = new HashMap<>();

        Scanner sc = new Scanner(System.in);
        long n, k;
        n = sc.nextLong();
        k = sc.nextLong();

        System.out.println(solve(n, k));
    }
}