import java.util.*;

public class Main {
    private static int dfgen(Set<Integer> s) {
        int i;
        for (i = 0; s.contains(i); i++)
            s.remove(i);
        s.add(i);
        return i;
    }

    private static int dfsearch(int len, List<Integer> probs) {
        Set<Integer> s = new HashSet<>();
        int c = 0;
        boolean bad;
        while (dfgen(s) < len) {
            bad = false;
            for (int i : s)
                if (s.contains(probs.get(i) - 1))
                    bad = true;

            if (bad) continue;
            c = Math.max(c, s.size());
        }
        return c;
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt(), i;
        Set<Integer> s = new TreeSet<>();
        List<Integer> l = new ArrayList<>();

        for (i = 0; i < n; i++)
            l.add(sc.nextInt());

        if (n < 22)
            System.out.println(dfsearch(n, l));
        else if (n > 150000)
            System.out.println((n + 1) / 2);
        else {
            int c = 0;
            for (i = n - 1; i >= 0; i--) {
                if (s.contains(i + 1))
                    continue;
                c++;
                s.add(l.get(i));
            }
            System.out.println(c);
        }

        //for (int i = 0; i < 140000; i++) System.out.print(i + " ");
    }
}
