#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;
int **arrs;
int *averages;
int n, k;

bool overcalc(int m, pair<int, int>* arr) {
    int i, j;
    if (m * 2 == n) {
        for (i = 0; i < m; i++) {
            for (j = 0; j < k; j++)
                if ((arrs[j][arr[i].first] > averages[j] && arrs[j][arr[i].second] > averages[j]) ||
                        (arrs[j][arr[i].first] < averages[j] && arrs[j][arr[i].second] < averages[j]))
                    break;
            if (j != k) break;
        }
        if (m == i) {
            cout << "YES" << endl;
            for (i = 0; i < m; i++)
                cout << (arr[i].first + 1) << " " << (arr[i].second + 1) << endl;
            return true;
        }
        return false;
    }

    int possibilities[10], x = 0;
    for (i = 0; i < n; i++) {
        for (j = 0; j < m; j++)
            if (arr[j].first == i || arr[j].second == i)
                break;
        if (j == m)
            possibilities[x++] = i;
    }

    for (i = 1; i < x; i++) {
        arr[m] = {possibilities[0], possibilities[i]};
        if (overcalc(m + 1, arr))
            return true;
    }
    return false;
}

int main() {
    int i, j, p = 0, q = 0;
    cin >> n >> k;

    arrs = new int*[k];
    for (i = 0; i < k; i++) arrs[i] = new int[n];
    for (i = 0; i < n; i++) for (j = 0; j < k; j++)
        cin >> arrs[j][i];

    int **morearrs = new int*[k];
    for (i = 0; i < k; i++) morearrs[i] = new int[n + 1];
    for (i = 0; i < n; i++) for (j = 0; j < k; j++)
         morearrs[j][i] = arrs[j][i];
    for (i = 0; i < k; i++) morearrs[i][n] = INT32_MAX;

    averages = new int[k];
    for (i = 0; i < k; i++) {
        nth_element(morearrs[i], morearrs[i] + n/2, morearrs[i] + n);
        averages[i] = morearrs[i][n/2];
    }
    for (i = 0; i < k; i++) delete[] morearrs[i];
    delete[] morearrs;

    if (n < 11) {
        auto *z = new pair<int, int>[n / 2];
        if (!overcalc(0, z))
            cout << "NO";
        delete[] z;
    } else if (k == 1) {
        int *a = new int[n/2], *b = new int[n/2];

        for (i = 0; i < n; i++)
            if (arrs[0][i] < averages[0])
                a[p++] = i + 1;
            else
                b[q++] = i + 1;

        cout << "YES" << endl;
        for (i = 0; i < n / 2; i++)
            cout << a[i] << " " << b[i] << endl;

        delete[] a;
        delete[] b;
    } else if (k == 2) {
        q = 6;
        auto *z = new vector<int>[q];
        int *c = new int[q];
        for (i = 0; i < q; i++)
            c[i] = 0;

        for (i = 0; i < n; i++) {
            p = (arrs[1][i] == averages[1] ? 1 : (arrs[1][i] < averages[1] ? 0 : 2));
            if (arrs[0][i] >= averages[0]) p += 3;
            c[p]++;
            z[p].emplace_back(i + 1);
        }

        if (c[0] + c[1] + c[2] != c[3] + c[4] + c[5]) cout << "NO" << endl;
        else if (c[0] + c[1] < c[5] || c[1] + c[2] < c[3] || c[3] + c[4] < c[2] || c[4] + c[5] < c[0]) cout << "NO" << endl;
        else {
            cout << "YES" << endl;
            for (i = 0; i < min(c[0], c[5]); i++)
                cout << z[0][i] << " " << z[5][i] << endl;
            if (i == c[0])
                for (; i < c[5]; i++)
                    cout << z[1][i - c[0]] << " " << z[5][i] << endl;
            else
                for (; i < c[0]; i++)
                    cout << z[4][i - c[5]] << " " << z[0][i] << endl;

            for (i = 0; i < min(c[2], c[3]); i++)
                cout << z[2][i] << " " << z[3][i] << endl;
            if (i == c[2])
                for (; i < c[3]; i++)
                    cout << z[1][i - c[2]] << " " << z[3][i] << endl;
            else
                for (; i < c[2]; i++)
                    cout << z[4][i - c[3]] << " " << z[2][i] << endl;

            for (i = max(c[2], c[3]) + max(c[0], c[5]); i < n/2; i++) {
                p = z[1].back();
                z[1].pop_back();
                q = z[4].back();
                z[4].pop_back();
                cout << p << " " << q << endl;
            }
        }

        delete[] z;
        delete[] c;
    } else {
        q = 1 << k;
        auto *z = new vector<int>[q];
        int *c = new int[q];
        for (i = 0; i < q; i++)
            c[i] = 0;

        for (i = 0; i < n; i++) {
            p = 0;
            for (j = 0; j < k; j++)
                p = p * 2 + (arrs[j][i] < averages[j] ? 1 : 0);
            c[p]++;
            z[p].emplace_back(i + 1);
        }
        for (j = 0; j < q; j++)
            if (c[q - j - 1] != c[j]) {
                cout << "NO" << endl;
                break;
            }
        if (j == q) {
            cout << "YES" << endl;
            for (i = 0; 2 * i < q; i++)
                for (j = 0; j < c[i]; j++)
                    cout << z[i][j] << " " << z[q - i - 1][j] << endl;
        }

        delete[] z;
        delete[] c;
    }

    for (i = 0; i < k; i++) delete[] arrs[i];
    delete[] arrs;
    delete[] averages;
    return 0;
}