#include <iostream>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>

using namespace std;

const unsigned long long MOD = 1e9 + 7;

unsigned int arr1[5010][5010];
unsigned int arr2[5010][5010];

int main()
{
	int n, k;
	cin >> n >> k;

	unsigned long long ans = 0;

	if (n == k)
	{
		cout << 1;
		return 0;
	}

	for (int i = 0; i < 5010; ++i)
		for (int j = 0; j < 5010; ++j)
		{
			arr1[i][j] = 0;
			arr2[i][j] = 0;
		}

	arr1[k][k] = 1;
	arr2[k][k] = 1;

	for (int i = k; i <= n; ++i)
		for (int j = 1; j <= i; ++j)
		{
			for (int nj = 0; nj < j; ++nj)
			{
				arr1[i][j] += arr2[i - j][nj];
				arr1[i][j] %= MOD;
			}

			for (int nj = j + 1; nj <= n; ++nj)
			{
				arr2[i][j] += arr1[i - j][nj];
				arr2[i][j] %= MOD;
			}
		}

	for (int i = 0; i <= n; ++i)
	{
		ans += arr1[n][i] + arr2[n][i];
		ans %= MOD;
	}

	cout << ans;
	system("pause");
	return 0;
}