#include <iostream>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>

using namespace std;

int g[300010];
int cvet[300010];

long long b = 0, w = 0;

void dfs(int i, int color)
{
	cvet[i] = color + 1;

	if (color == 0)
		w++;
	else
		b++;

	if (g[i] != -2 && cvet[g[i]] == color + 1)
	{
		w = 0;
		b = 0;
		return;
	}
	else
		if (g[i] != -2 && cvet[g[i]] != 0)
			dfs(g[i], (color + 1) % 2);
}

int main()
{
	long long n;

	cin >> n;

	for (int i = 0; i < n; ++i)
	{
		cin >> g[i];
		cvet[i] = 0;
	}

	long long ans = 0;

	for (int i = 0; i < n; ++i)
	{
		if (g[i] != -2 && cvet[i] == 0)
		{
			dfs(i, 0);
			ans += max(b, w);
			b = 0;
			w = 0;
		}
	}

	for (int i = 0; i < n; ++i)
		if (cvet[i] == 0)
			ans++;

	cout << ans;

	system("pause");
	return 0;
}