#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define sz(s) signed(s.size())
#define ft first
#define sd second
#define all(s) s.begin(),s.end()
#define rall(s) s.rbegin(),s.rend()

#define int long long

const int R = 1e9 + 7;

int n, k;
map< tuple<int, int, int>, int > m;

int get(int pos, int sum, int prev, int type) {
	if (sum == n) { return 1; }
	if (m.count({pos, sum, prev})) return m[{pos, sum, prev}];
	int ans = 0;	
	if (type) {
		for (int i = 1; sum + i <= n && i < prev; ++i) {
			ans = (ans + get(pos + 1, sum + i, i, type ^ 1));
			ans %= R;
		}
	} else {
		for (int i = prev + 1; sum + i <= n; ++i) {
			ans = (ans + get(pos + 1, sum + i, i, type ^ 1));
			ans %= R;
		}
	}
	return m[{pos, sum, prev}] = ans;
} 

void solve() {
	cin >> n >> k;
	if (n == k) {
		cout << 1 << endl;
		return;
	}
	int ans = get(1, k, k, 0);
	m.clear();
	ans += get(1, k, k, 1);
	cout << ans % R << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}