#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define sz(s) signed(s.size())
#define ft first
#define sd second
#define all(s) s.begin(),s.end()
#define rall(s) s.rbegin(),s.rend()
// #define int long long

vector< vector<int> > g;
vector<int> dp[2], col;

int dfs(int v) {
	col[v] = 1;
	dp[0][v] = 0;
	dp[1][v] = 1; 
	for (int to : g[v]) {
		if (!col[to]) {
			dp[0][v] += dfs(to);
			dp[1][v] += dp[0][to];
		}
	}
	return max(dp[0][v], dp[1][v]);
}

void solve() {
	int n;
	cin >> n;
	dp[0].resize(n, -1);
	dp[1].resize(n, -1);
	g.resize(n);
	col.resize(n);
	vector<int> a(n);
	vector< pair<int, int> > ee;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];

		if (a[i] == -1) continue;
		--a[i];
		ee.push_back({a[i], i});
		g[i].pb(a[i]);
		g[a[i]].pb(i);
	}
	if (n < 21) {
		int ans = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			int val = __builtin_popcount(mask);
			for (int i = 0; i < sz(ee); ++i) {
				int a, b;
				tie(a, b) = ee[i];
				//cout << a << " " << b << endl;
				if (((mask >> a) & 1) == 1 && ((mask >> b) & 1) == 1) {
					val = 0;
					break;
				}
			}
			ans = max(ans, val);
		}

		cout << ans << endl;
		return;
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		if (!col[i]) {
			ans += dfs(i);
		}
	}
	cout << ans << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}