// D.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <array>
#include <algorithm>

using namespace std;
using ll = long long;

int main()
{
	ios::sync_with_stdio(0);
	int n, k;
	cin >> n >> k;
	vector<vector<int> > a(n, vector<int>(k));
	vector<vector<pair<int, int> > > ind(k);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			int x;
			cin >> x;
			ind[j].push_back({ x, i });
		}
	}
	for (int j = 0; j < k; j++) {
		nth_element(ind[j].begin(), ind[j].begin() + n / 2, ind[j].end());
		int cur1 = ind[j][n / 2].first;
		nth_element(ind[j].begin(), ind[j].begin() + n / 2 - 1, ind[j].end());
		int cur2 = ind[j][n / 2 - 1].first;
		for (int i = 0; i < n; i++) {
			if (cur1 == cur2 && ind[j][i].first == cur1) a[ind[j][i].second][j] = 2;
			else {
				if (ind[j][i].first < cur1) a[ind[j][i].second][j] = 0;
				else a[ind[j][i].second][j] = 1;
			}
		}
	}
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			cout << a[i][j] << ' ';
		}
		cout << endl;
	}*/
	int sz = (1 << k);
	vector<vector<int> > cnt(sz);
	for (int i = 0; i < n; i++) {
		int cur = 0;
		for (int j = 0; j < k; j++) {
			cur = cur * 2 + a[i][j];
		}
		cnt[cur].push_back(i);
	}
	bool ok = 1;
	for (int i = 0; i < sz; i++) {
		if (cnt[i].size() != cnt[(sz - 1) ^ i].size()) {
			ok = 0;
			break;
		}
	}
	if (!ok) {
		cout << "NO" << endl;
		return 0;
	}
	cout << "YES" << endl;
	for (int i = 0; i < sz; i++) {
		if (i > ((sz - 1) ^ i)) continue;
		auto elem1 = cnt[i], elem2 = cnt[(sz - 1) ^ i];
		for (int j = 0; j < (int)elem1.size(); j++) {
			cout << elem1[j] + 1 << ' ' << elem2[j] + 1 << endl;
		}
	}
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
