#pragma GCC optimize("O3", "unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define ld long double
#define INF 1000000000
#define int long long
#define pii pair<int,int>
#define MOD 1000000007

using namespace std;

const int N = 3e5+123;

set<int> se[N];

struct cmp {
    bool operator()(pii a, pii b) {
	return a.second < b.second || a.second == b.second && a.first < b.first;
    }

};

set<pii, cmp> cnts;

void add(int a, int b) {
    cnts.erase ({a, se[a].size()});
    cnts.erase ({b, se[b].size()});
    se[a].insert(b);
    se[b].insert(a);
    cnts.insert({a, se[a].size()});
    cnts.insert({b, se[b].size()});
}

void del(int a, int b) {
    se[a].erase(b);
    se[b].erase(a);
    cnts.erase ({a, se[a].size()+1});
    cnts.insert({a, se[a].size()});
    cnts.erase ({b, se[b].size()+1});
    cnts.insert({b, se[b].size()});
}

void del(int a) {
    vector<int> v;
    for (auto p : se[a])
	v.pb(p);
    for (int p : v) {
	del(p, a);
    }
    cnts.erase({a, se[a].size()});
    cnts.insert({a, INF});
}

void take(int a) {
    vector<int> v;
    for (auto p : se[a])
	v.pb(p);
    for (int p : v) {
	del(p);
    }
    cnts.erase({a, se[a].size()});
    cnts.insert({a, INF});
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
	cnts.insert({i, 0});
    }
    for (int i = 1; i <= n; ++i) {
	int a;
	cin >> a;
	if (a != -1)
	    add(i, a);
    }
    for (int i = 1; i <= n; ++i) {
	pii p = *(cnts.begin());
	//cout << p.first << " " << p.second << endl;
	if (p.second == INF) break;
	take(p.first);
	++ans;
    }
    cout << ans;
    return 0;
}
