#pragma GCC optimize("O3", "unroll-loops")
#include <unordered_set>
#include <iostream>
#include <set>
#include <vector>

#define pb push_back
#define ld long double
#define INF 1000000000
//#define int long long
#define pii pair<int,int>
#define MOD 1000000007

using namespace std;

const int N = 3e5+1;
int i;
unordered_set<int> se[N];

struct cmp {
    bool operator()(const pii& a, const pii& b) const {
	return a.second < b.second || a.second == b.second && a.first < b.first;
    }

};

set<pii, cmp> cnts;

inline void add(int a, int b) {
    se[a].insert(b);
    se[b].insert(a);
    cnts.erase ({a, se[a].size()-1});
    cnts.insert({a, se[a].size()});
    cnts.erase ({b, se[b].size()-1});
    cnts.insert({b, se[b].size()});
}

inline void del(int a, int b) {
    se[a].erase(b);
    se[b].erase(a);
    cnts.erase ({a, se[a].size()+1});
    cnts.insert({a, se[a].size()});
    cnts.erase ({b, se[b].size()+1});
    cnts.insert({b, se[b].size()});
}

inline void del(int a) {
    vector<int> v;
    for (const auto& p : se[a])
	v.pb(p);
    for (i = 0; i < v.size(); ++i) del(v[i], a);
    // for (const auto& p : v) {
    // 	del(p, a);
    // }
    cnts.erase({a, se[a].size()});
    //cnts.insert({a, INF});
}

inline void take(int a) {
    vector<int> v;
    for (const auto& p : se[a])
	v.pb(p);
    //for (i = 0; i < v.size(); ++i) del(v[i]);
    for (const auto& p : v) {
    	del(p);
    }
    //cnts.insert({a, INF});
}

int32_t main() {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    // cout.tie(0);
    int n;
    int i;
    cin >> n;
    //scanf("%d", &n);
    //n = 300000;
    //if (n == 300000) return !(cout << 299999);
    int ans = 0;
    for (i = 1; i <= n; ++i) {
	cnts.insert({i, 0});
    }
    int a;
    for (i = 1; i <= n; ++i) {
	cin >> a;
	//scanf("%d", &a);
	//a = 1;
	if (a != -1)
	    add(i, a);
    }
    int p;
    for (i = 1; i <= n; ++i) {
	if (cnts.size() == 0) break;
	p = (*(cnts.begin())).first;
	//cout << p.first << " " << p.second << endl;
	take(p);
	a = p;
	vector<int> v;
	for (const auto& p : se[a])
	    v.pb(p);
	//for (i = 0; i < v.size(); ++i) del(v[i]);
	for (const auto& p : v) {
	    del(p);
	}
	cnts.erase(cnts.begin());
	++ans;
    }
    cout << ans;
    return 0;
}
