#pragma GCC optimize("O3", "unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define ld long double
#define INF 1000000000
#define pii pair<int,int>
#define MOD 1000000007

using namespace std;

const int N = 3e5+123;

int n, k;

struct st {
    int t, id, type;
};

inline bool cmp(st a, st b) {
    return a.t < b.t || a.t == b.t && a.type > b.type;
}


inline bool check(vector<pii> &v) {
    vector<st> vv;
    for (int i = 0; i < v.size(); ++i) {
	pii p = v[i];
	vv.pb({p.first, i, 1});
	vv.pb({p.second, i, -1});
    }
    sort(vv.begin(), vv.end(), &cmp);
    int open = 0;
    int maxv = 0;
    for (int i = 0; i < vv.size(); ++i) {
	st s = vv[i];
	if (s.type == 1) open++;
	else --open;
	maxv = max(maxv, open);
    }
    if (maxv != v.size()) return 0;
    // for (int i = 0; i < vv.size(); ++i) {
    // 	cout << vv[i].t << " " << vv[i].type << endl;
    // }
    // cout << " a " << endl;
    // for (auto p : v) {
    // 	cout << p.first << " " << p.second << endl;
    // }
    // cout << endl;
    return 1;
}

vector<vector<int>> vev;
inline bool checkk(vector<pair<int, int> > &v) {
    for (int i = 0; i < k; ++i) {
	vector<pii> ve;
	for (int j = 0; j < v.size(); ++j) {
	    int a = vev[v[j].first][i];
	    int b = vev[v[j].second][i];
	    ve.pb({min(a,b), max(a,b)});
	}
	if (!check(ve)) return 0;
    }
    return 1;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    vev.resize(n);
    for (int i = 0; i< n; ++i) vev[i].resize(k);
    vector<int> perm;
    for (int i = 0; i < n; ++i) {
	perm.pb(i);
    }
    for (int i = 0; i < n; ++i) {
	for (int j = 0; j < k; ++j) {
	    cin >> vev[i][j];
	}
    }
    if (n <= 10) {
	do {
	    vector<pair<int, int> > vv;
	    for (int i = 0; i < n-1; i += 2) {
		vv.pb({perm[i], perm[i+1]});
	    }
	    if (checkk(vv)) {
		cout << "YES\n";
		for (int i = 0; i+1 < perm.size(); i += 2) {
		    cout << perm[i] + 1 << " " << perm[i+1] + 1 << '\n';
		}
		return 0;
	    }
	    if (clock() > 5000000) break;
	} while (next_permutation(perm.begin(), perm.end()));
    }
    cout << "NO";
    return 0;
}
