#include <iostream>
#include <vector>

using namespace std;

int solve(int n, int k, int addition)
{
    vector<vector<int> > orig(n + 1, vector<int>(n + 1));
    vector<vector<int> > a = orig, b = orig;
    vector<vector<int> > prefsums = a, postsums = a;
    a[k][k] = 1;
    int ans = 0;
    for(int i = 1; i <= n; i++)
    {
        for(int i = 0; i <= n; i++)
        {
            int cur = 0;
            for(int j = 0; j <= i; j++)
            {
                cur = (cur + a[i][j]) % 1000000007;
                prefsums[i][j] = cur;
            }
            cur = 0;
            for(int j = i; j >= 0; j--)
            {
                cur = (cur + a[i][j]) % 1000000007;
                postsums[i][j] = cur;
            }
        }
        for(int s = 0; s <= n; s++)
            for(int l = 1; l <= s; l++)
            {
                if((i + addition) % 2)
                    b[s][l] = prefsums[s - l][l - 1];
                else
                    b[s][l] = (l != n)?postsums[s - l][l + 1]:0;
            }
        swap(a, b);
        for(int j = 0; j <= n; j++)
            ans = (ans + a[n][j]) % 1000000007;
        if(a == orig)
            return ans;
    }
    return ans;
}

int main()
{
    int n, k;
    cin >> n >> k;
    if(n == k)
    {
        cout << "1\n";
        return 0;
    }
    cout << (solve(n, k, 0) + solve(n, k, 1)) % 1000000007 << endl;
    return 0;
}
