#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <string>

using namespace std;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

typedef long long ll;

int n, k, NN;

const ll mod = 1e9 + 7;
int table[5001][5001][2];

ll get(int n, int k, int increase)
{
    long long res = 0;
    if (n <= 0)
    {
        return 0;
    }
    if (n == k)
    {
        return 1;
    }
    if (table[n][k][increase] != -1)
    {
        return table[n][k][increase];
    }
    //cout << n << " " << k << " " << increase << endl;
    if (increase == 0)
    {
        if (k > 1)
            res = (get(n - 1, k - 1, 0) + get(n - k, k - 1, 1)) % mod;
        //for (int j = 1; j < k; j++)
        //{
        //    res += get(n - k, j, 1);
        //}
    }
    else
    {
        if (k <= n && n <= NN)
            res = (get(n + 1, k + 1, 1)) % mod;
        for (int j = k + 1; j <= k + 1; j++)
        {
            res += get(n - k, j, 0);
        }
    }
    table[n][k][increase] = res % mod;
    //cout << table[n][k][increase] << " " << n << " " << k << " " << increase << endl;
    return res;
}

int main()
{
    cin >> n >> k;
    NN = n;
    for (int i = 0; i <= 5000; i++)
    {
        for (int j = 0; j <= 5000; j++)
        {
            table[i][j][0] = -1;
            table[i][j][1] = -1;
        }
    }
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    cout << (get(n, k, 1) + get(n, k, 0)) % mod;
}
