#include <bits/stdc++.h>

#define double long double
#define pr pair
#define vc vector
#define fs first
#define sc second
#define pb push_back
#define rep(n, i) for (int i = 0; i < n; ++i)
#define all(v) v.begin(), v.end()
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define endd endl; return 0;
#ifdef LOCAL
#define cerr cout
#else
#define cerr if (0) cout
#endif
#define print(x) for (const auto &kek : x) { cerr << kek << ' '; } cerr << endl;

typedef long long ll;

using namespace std;

const int N = 5003;
const int MOD = 1e9 + 7;

bool f = 0;

int slow(int n, int k) {
    int dp[n + 1][n + 1][2];
    rep(n + 1, i) {
        rep(n + 1, j) {
            dp[i][j][0] = dp[i][j][1] = 0;
        }
    }
    dp[0][0][0] = dp[0][0][1] = 1;
    dp[k][k][0] = dp[k][k][1] = 1;
    for (int i = k + 1; i <= n; ++i) {
        for (int j = 1; j <= i; ++j) {
            for (int l = 1; l <= j - 1; ++l) {
                dp[i][j][1] += dp[i - j][l][0];
                dp[i][j][1] %= MOD;
            }
            for (int l = j + 1; l <= n; ++l) {
                dp[i][j][0] += dp[i - j][l][1];
                dp[i][j][0] %= MOD;
            }
        }
    }
    if (f) {
        rep(n + 1, i) {
            rep(n + 1, j) {
                cerr << dp[i][j][0] << "/" << dp[i][j][1] << ' ';
            }
            cerr << endl;
        }
        cerr << endl;
    }
    int ans = 0;
    if (n == k) {
        return 1;
    }
    rep(n + 1, j) {
        ans += dp[n][j][0];
        ans %= MOD;
        ans += dp[n][j][1];
        ans %= MOD;
    }
    return ans;
}

int pref[N][N][2];
int dp[N][N][2];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    // cout.precision(6); cout << fixed;
#ifdef LOCAL
    freopen("test.txt", "r", stdin);
#endif
    int n, k;
    cin >> n >> k;
    rep(N, i) {
        rep(N, j) {
            pref[i][j][0] = pref[i][j][1] = dp[i][j][0] = dp[i][j][1] = 0;
        }
    }
    dp[0][0][0] = dp[0][0][1] = 1;
    dp[k][k][0] = dp[k][k][1] = 1;
    pref[0][0][0] = pref[0][0][1] = 1;
    for (int i = 0; i < k + 1; ++i) {
        for (int j = 1; j <= n; ++j) {
            pref[i][j][0] = pref[i][j - 1][0] + dp[i][j][0];
            pref[i][j][0] %= MOD;
            pref[i][j][1] = pref[i][j - 1][1] + dp[i][j][1];
            pref[i][j][1] %= MOD;
        }
    }
    for (int i = k + 1; i <= n; ++i) {
        for (int j = 1; j <= i; ++j) {
            dp[i][j][1] = (pref[i - j][j - 1][0] - pref[i - j][0][0]) % MOD + MOD;
            dp[i][j][1] %= MOD;
            /*for (int l = 1; l <= j - 1; ++l) {
                dp[i][j][1] += dp[i - j][l][0];
                dp[i][j][1] %= MOD;
            }*/
            dp[i][j][0] = (pref[i - j][n][1] -  pref[i - j][j][1]) % MOD + MOD;
            dp[i][j][0] %= MOD;
            /*for (int l = j + 1; l <= n; ++l) {
                dp[i][j][0] += dp[i - j][l][1];
                dp[i][j][0] %= MOD;
            }*/
            pref[i][j][0] = pref[i][j - 1][0] + dp[i][j][0];
            pref[i][j][0] %= MOD;
            pref[i][j][1] = pref[i][j - 1][1] + dp[i][j][1];
            pref[i][j][1] %= MOD;
            assert(dp[i][j][0] >= 0);
            assert(dp[i][j][1] >= 0);
            assert(pref[i][j][0] >= 0);
            assert(pref[i][j][1] >= 0);
        }
        for (int j = i + 1; j <= n; ++j) {
            pref[i][j][0] = pref[i][j - 1][0] + dp[i][j][0];
            pref[i][j][0] %= MOD;
            pref[i][j][1] = pref[i][j - 1][1] + dp[i][j][1];
            pref[i][j][1] %= MOD;
        }
    }
    if (f) {
        rep(n + 1, i) {
            rep(n + 1, j) {
                cerr << dp[i][j][0] << "/" << dp[i][j][1] << ' ';
            }
            cerr << endl;
        }
        cerr << endl;
        rep(n + 1, i) {
            rep(n + 1, j) {
                cerr << pref[i][j][0] << "/" << pref[i][j][1] << ' ';
            }
            cerr << endl;
        }
    }
    int ans = 0;
    rep(n + 1, j) {
        ans += dp[n][j][0];
        ans %= MOD;
        ans += dp[n][j][1];
        ans %= MOD;
    }
    if (n == k) {
        ans = 1;
    }
#ifdef LOCAL
    int ja = slow(n, k);
    if (ja != ans) {
        cerr << "!!! " << ja << ' ' << ans << endl;
        cerr << n << ' ' << k << endd;
    }
#endif
    cout << ans << endl;

    return 0;
}