#include<iomanip>
#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
int tim = 0;
void dfs(int pred,int v, vector<int>&used, vector<bool> &cicle,vector<vector<int>> &g,vector<int>&in,vector<int>&up,vector<int> &sp) {
    used[v] = true;
    in[v] = tim;
    ++tim;
    int sum = 0;
    up[v] = tim - 1;
    for(int i = 0; i < g[v].size(); ++i) {
        if(g[v][i] == pred) {
            continue;
        }
        if(used[g[v][i]] == 1) {
            up[v] = min(up[v], in[g[v][i]]);
        }
        else {
            dfs(v,g[v][i], used,cicle,g,in,up,sp);
            up[v] = min(up[v],up[g[v][i]]);
        }
        if(cicle[g[v][i]] == true) {
            ++sum;
        }
    }
    if(up[v] < in[v]|| sum >= 2) {
        cicle[v] = true;
        sp.push_back(v);
    }
}
int dfs2(int v, vector<int> &used, vector<bool> &sicle,vector<vector<int>> &g, vector<int> &siz, vector<int>&maximum) {
    used[v] = 2;
    siz[v] = 1;
    maximum[v] = 0;
    int neww = 0;
    for(int i = 0; i < g[v].size(); ++i) {
        if(sicle[g[v][i]] == 1 || used[g[v][i]] == 2) {
            continue;
        }
        else {
            dfs2(g[v][i], used, sicle,g,siz,maximum);
            maximum[v] += maximum[g[v][i]];
            siz[v] += siz[g[v][i]];
        }
    }
    maximum[v] = max(maximum[v], siz[v] - maximum[v]);
    return maximum[v];
}
int find(int v, vector<int> &used, vector<bool> &sicle, vector<vector<int>> &g,vector<int> &in, vector<int>&up) {
    vector<int> sp;
    dfs(-1,v,used,sicle,g,in,up,sp);
    if(sp.size() == 0) {
        return dfs2(v,used,sicle,g,in,up);
    }
    vector<int> col;
    for(int i = 0; i < sp.size(); ++i) {
        col.push_back(dfs2(sp[i], used,sicle,g,in,up));
    }
    int maxstprev = 0;
    int maxstbezprev = 0;
    int maxprev = 0;
    int maxbezprev = 0;
    for(int i = 0; i < col.size(); ++i) {
        if(i == 0) {
            maxstbezprev += col[i];
        }
        else if(i == col.size() - 1) {
            maxbezprev += col[i];
        }
        else {
            maxstbezprev += col[i];
            maxbezprev += col[i];
        }
        swap(maxbezprev,maxprev);
        swap(maxstbezprev,maxstprev);
        if(maxstbezprev > maxstprev) {
            maxstprev = maxstbezprev;
        }
        if(maxbezprev > maxprev) {
            maxprev = maxbezprev;
        }
    }
    return max(max(maxprev,maxbezprev),max(maxstbezprev,maxstprev));
}
int main() {
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();
    int n;
    cin >> n;
    int x;
    vector<vector<int>> g(n);
    for(int i = 0; i < n; ++i) {
        cin >> x;
        if(x != -1) {
            g[i].push_back(x - 1);
            g[x - 1].push_back(i);
        }
    }
    vector<int> used(n, 0);
    vector<int> in(n);
    vector<int> up(n);
    vector<bool> sochl(n);
    int sum = 0;
    for(int i = 0; i < n; ++i) {
        if(used[i] == 0) {
            sum += find(i,used,sochl,g,in,up);
        }
    }
    cout << sum << "\n";
    return 0;
}
