#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

const ll MOD = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m, k;
    cin >> n >> m >> k;

    vector<ll> pow(40, 1);
    for (ll i = 1; i < 40; i++)
        pow[i] = (pow[i - 1] * n) % MOD;

    vector<ll> powb(40, 1);
    for (ll i = 1; i < 40; i++)
        powb[i] = (powb[i - 1] * (n + 1ll)) % MOD;

    ll max = 0;
    ll ones = 0;
    for (ll i = 0; i < 40; i++)
    {
        if (k & (1ll << i))
        {
            max = i;
            ones++;
        }
    }

    ll ans = 0;
    ll put = 0;
    for (ll i = max; i >= 0; i--)
    {
        if (k & (1ll << i))
        {
            ans += powb[ones - put - 1ll] * pow[put];
            ans %= MOD;
            put++;
        }
    }

    ans += pow[ones];
    ans %= MOD;

    cout << ans << endl;

    return 0;
}