#include <bits/stdc++.h>
#define fast_io() cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
#define MAXN 300000

using namespace std;
/*
typedef struct node {
	int y, sz = 1, val = 0;
	int l = -1, r = -1;

	node() {}

	node(int val) : val(val) {
		y = rand();
	}
};

node t[MAXN];

int gsz(int x) {
	return (x == -1 ? 0 : t[x].sz);
}

void upd(int x) {
	t[x].sz = 1 + gsz(t[x].l) + gsz(t[x].r);
}

pair<int, int> split(int x, int k) {
	if (x == -1)
		return {-1, -1};
	int lsz = gsz(t[x].l) + 1;
	if (lsz >= k) {
		auto gg = split(t[x].l, k);
		upd(x);
		t[x].l = gg.second;
		return {gg.first, x};
	} else {
		auto gg = split(t[x].r, k - lsz);
		upd(x);
		t[x].r = gg.first;
		return {x, gg.second};
	}
}

int merge(int l, int r) {
	if (l == -1)
		return r;
	if (r == -1)
		return l;
	if (t[l].y > t[r].y) {
		t[l].r = merge(t[l].r, r);
		upd(l);
		return l;
	} else {
		t[r].l = merge(l, t[r].l);
		upd(r);
		return r;
	}
}

int root = -1;
int mx = 0;

void add_node(int k, int val) {
    auto gg = split(root, k);
    t[mx] = node(val);
    root = merge(gg.first, merge(mx++, gg.second));
}

int get(int k) {
    auto gg = split(root, k);
    auto bb = split(gg.second, 1);
    int torwt = t[bb].val;
    root = merge(gg.first, merge(bb.first, bb.second));
    return torwt;
}*/

vector<int> best;

bool cmp(int a, int b) {
    return best[a] < best[b];
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m), b(n), dpt(n + 1);
    for (int i = 0; i < m; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    //    add_node(i, b[i]);
    }
    vector<int> actions;
    vector<int> pos;
    best = vector<int>(n + 1, 1000000000);
    for (int i = 0; i < m; i++) {
        if (best[a[i]] == 1000000000)
            best[a[i]] = i;
    }
    vector<queue<int> > meets(n + 1);
    for (int i = 0; i < n; i++) {
        meets[a[i]].push(i);
    }
    int rmn = n;
    int ind = 0;
    vector<int> vct;
    for (int i = 0; i < n; i++) {
        if (best[b[i]] == 1000000000) {
            vct.push_back(b[i]);
            actions.push_back(n);
            continue;
        }
        if (a[ind] == b[i]) {
            ++ind;
            meets[b[i]].pop();
            best[b[i]] = meets[b[i]].front();
        }
        int ud = (int)(upper_bound(vct.begin(), vct.end(), b[i], cmp) - vct.begin()) + n - i;
        auto it = upper_bound(vct.begin(), vct.end(), b[i], cmp);
        vector<int> up(1, b[i]);
        vct.insert(it, up.begin(), up.end());
        actions.push_back(ud);
    }
    for (int i = ind; i < m; i++) {
        while (vct.front() != a[i]) {
            int gs = vct.front();
            int mpos = meets[gs].front();
            vct.erase(vct.begin(), vct.begin() + 1);
            int j;
            for (j = 0; j < vct.size() && meets[vct[j]].front() < mpos; j++);
            auto it = vct.begin() + j;
            vector<int> temp(1, gs);
            vct.insert(it, temp.begin(), temp.end());
            actions.push_back(j + 1);
        }
        int gs = vct.front();
        meets[gs].pop();
        int mpos = meets[gs].front();
        vct.erase(vct.begin(), vct.begin() + 1);
        int j;
        for (j = 0; j < vct.size() && meets[vct[j]].front() < mpos; j++);
        auto it = vct.begin() + j;
        vector<int> temp(1, gs);
        vct.insert(it, temp.begin(), temp.end());
        actions.push_back(j + 1);
    }
    cout << actions.size() << '\n';
    for (int i = 0; i < actions.size(); i++)
        cout << actions[i] << ' ';
    return 0;
}
/*
4 5
4 1 2 4 4
4 3 2 1
*/
