#include <bits/stdc++.h>
#define MOD 1000000007

using namespace std;

string bin(long long x) {
	unsigned long long cw = 1;
	string s = "";
	for (int i = 0; i < 63; i++) {
		s = s + (char)(x % 2 + '0');
		x >>= 1;
	}
	return s;
}

long long binp(long long a, long long n) {
	if (n == 0)
		return 1;
	if (n % 2)
		return (a * binp(a, n - 1)) % MOD;
	return binp((a * a) % MOD, n / 2);
}

long long get_cnk(long long n, long long k) {
	if (k == n || k == 0)
		return 1;
	if (k > n)
		return 0;
	long long gg = 1;
	for (long long i = n - k + 1; i <= n; i++)
		gg = (gg * i) % MOD;
	for (long long i = 1; i <= k; i++) {
		long long ob = binp(i, MOD - 2);
		gg = (gg * ob) % MOD;
	}
	return gg;
}

int main() {
	long long n, m, k;
	cin >> n >> m >> k;
	if (m != 0 || k > 10000000)
		return 0;
	vector<vector<int> > dp(n + 1, vector<int>(64, 0));
	for (int i = 0; i <= k; i++) {
		string bs = bin(i);
		int icn = 0;
		for (int i = 0; i < bs.size(); i++)
			if (bs[i] == '1')
				++icn;
		dp[1][icn]++;
	}
	long long cnks[64][64];
	for (int i = 0; i < 32; i++)
		for (int j = 0; j < 32; j++)
			cnks[i][j] = get_cnk(i, j);
	vector<long long> prefs(32, 0);
	for (int i = 2; i <= n; i++) {
		for (int j = 0; j < 32; j++) {
			dp[i][j] = 0;
			for (int l = j; l < 32; l++) 
				dp[i][j] = (dp[i][j] + cnks[l][j] * dp[i - 1][l]) % MOD;  
		}
	}
	long long sm = 0;
	for (int i = 0; i < 32; i++)
		sm = (sm + dp[n][i]) % MOD;
	cout << sm;
}