#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
//#define int long long
const int MOD = 1e9 + 7;
const int MAXN = 5010;
int dp[MAXN][MAXN][2];
int pref[MAXN][MAXN][2];

int n, k;
void read()
{
	cin >> n >> k;
}
int ans;
void run()
{
	if (n == k)
	{
		ans = 1;
		return;
	}
	ans = 0;
	dp[k][k][0] = 1;
	dp[k][k][1] = 1;
	for (int j = 1; j <= n; j++)
	{
		pref[k][j][0] += pref[k][j - 1][0] + dp[k][j][0];
		pref[k][j][1] += pref[k][j - 1][1] + dp[k][j][1];
		pref[k][j][0] %= MOD;
		pref[k][j][1] %= MOD;
	}
	for (int i = k + 1; i <= n; i++)
	{
		for (int j = 1; j <= i; j++)
		{
			if (i - j < 1)
				break;
			dp[i][j][0] += pref[i - j][n][1] - pref[i - j][j][1];
			dp[i][j][0] %= MOD;
			dp[i][j][1] += pref[i - j][j - 1][0];
			dp[i][j][1] %= MOD;
			/*for (int k = 1; k < i; k++)
			{
				if (k > j)
					{
						dp[i][j][0] += dp[i - j][k][1];
						dp[i][j][0] %= MOD;
					}
					if (k < j)
					{
						dp[i][j][1] += dp[i - j][k][0];
						dp[i][j][1] %= MOD;
					}
			}*/
		}
		for (int j = 1; j <= n; j++)
		{
			pref[i][j][0] += pref[i][j - 1][0] + dp[i][j][0];
			pref[i][j][1] += pref[i][j - 1][1] + dp[i][j][1];
			pref[i][j][0] %= MOD;
			pref[i][j][1] %= MOD;
		}
	}
	ans = 0;
	for (int i = 0; i <= n; i++)
	{
		ans += dp[n][i][0] + dp[n][i][1];
		ans %= MOD;
	}
}

void write()
{
	cout << ans;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}
