#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
using namespace std;
int n;
int k;
const int MAXN = 2 * 1e5 + 10;
vector <vector <int> > a;
vector <int> fans[7];
void read()
{
	cin >> n >> k;
	a.resize(n);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < k; j++)
		{
			int x;
			cin >> x;
			fans[j].push_back(x);
			a[i].push_back(x);
		}
	}
	for (int i = 0; i < k; i++)
		sort(fans[i].begin(), fans[i].end());
}
vector <int> help[200];
int obr[200];
int pows[10], opt[10];

void run()
{
	for (int i = 0; i < 200; i++)
		obr[i] = -1;
	pows[0] = 1;
	for (int i = 1; i < 10; i++)
		pows[i] = pows[i - 1] * 2;
	for (int i = 0; i < k; i++)
		opt[i] = fans[i][n / 2];
	for (int i = 0; i < n; i++)
	{
		int mask = 0;
		int mask2 = 0;
		for (int j = 0; j < k; j++)
		{
			if (a[i][j] >= opt[j])
				mask += pows[j];
			else
				mask2 += pows[j];
		}
		help[mask].push_back(i + 1);
		obr[mask] = mask2;
	}
	set <pair <int, int> > ans;
	for (int i = 0; i < 200; i++)
	{
		if (obr[i] == -1)
			continue;
		else
		{
			if (help[i].size() != help[obr[i]].size())
			{
				cout << "NO";
				exit(0);
			}

			for (int j = 0; j < help[i].size(); j++)
			{
				ans.insert({ min(help[i][j], help[obr[i]][j]),  max(help[i][j], help[obr[i]][j]) });
			}
		}
	}
	cout << "YES" << endl;
	for (auto i : ans)
		cout << i.first << " " << i.second << endl;
}

void write()
{

}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}

