#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>

using namespace std;

#define int long long

#define LATER(limit) if(1000 * clock() / CLOCKS_PER_SEC > limit)

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k;
	cin >> k;

	if(k == 0) {
		cout << 0;
		return 0;
	}

	vector<int> f;
	int k1 = abs(k);
	for(int i = 2; i <= abs(k1); i++) {
		while(k1 % i == 0) {
			f.push_back(i);
			k1 /= i;
		}
	}

	f.push_back(1);

	int best = 100000000000000000LL;
	for(int d: f) {
		int d1 = k / d;
		if(abs(d1 % 2) != abs(d % 2)) {
			continue;
		}

		// cerr << "a+b=" << d << ", a-b=" << d1 << endl;
		// d = b + a
		// d1 = b - a
		int b = (d + d1) / 2;
		// cerr << "a=" << (d - d1) / 2 << ", b=" << (d + d1) / 2 << endl;
		if(b < 0) {
			continue;
		}

		if(b < best) {
			best = b;
		}
	}

	if(best == 100000000000000000LL) {
		cout << "none";
	} else {
		cout << best << endl;
	}

//	int i = 1;
//	if(k < 0) {
//		int sq = (int)(sqrt(-k) + 0.5f);
//		if(k + sq * sq >= 0) {
//			k += sq * sq;
//		} else {
//			sq++;
//			k += sq * sq;
//		}
//		i = sq * 2;
//
//		i = 2 * sq - 1;
//	}
//
//	while(true) {
//		int sq = (int)(sqrt(k) + 0.5f);
//		if(sq * sq == k) {
//			cout << sq;
//			return 0;
//		}
//
//		LATER(900) {
//			cout << "none";
//			return 0;
//		}
//
//		k += i;
//		i += 2;
//	}

	return 0;
}
