#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <random>

using namespace std;

#define int long long

const int MOD = 1000000007LL;

int n, k;
//vector<int> a;
//int ans = 0;
//void gen(int sum) {
//	if(sum < 0) {
//		return;
//	}
//	if(sum == 0) {
//		ans++;
//	}
//
//	if(a.size() == 0) {
//		a.push_back(k);
//		gen(sum - k);
//		a.pop_back();
//		return;
//	}
//	if(a.size() == 1) {
//		for(int i = 1; i <= sum; i++) {
//			if(i == a.back()) {
//				continue;
//			}
//
//			a.push_back(i);
//			gen(sum - i);
//			a.pop_back();
//		}
//	} else {
//		if(a[a.size() - 2] < a[a.size() - 1]) {
//			for(int i = 1; i < a.back() && i <= sum; i++) {
//				a.push_back(i);
//				gen(sum - i);
//				a.pop_back();
//			}
//		} else {
//			for(int i = a.back() + 1; i <= n && i <= sum; i++) {
//				a.push_back(i);
//				gen(sum - i);
//				a.pop_back();
//			}
//		}
//	}
//}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> k;
	if(n == k) {
		cout << 1;
		return 0;
	}

	//                                asc                     first day             total
	vector< vector< vector<int> > > dp(2, vector< vector<int> >(n + 1, vector<int>(n + 1)));
	for(int i = 1; i <= n; i++) {
		dp[0][i][i] = 1;
		dp[1][i][i] = 1;
	}

	for(int j = 1; j <= n; j++) {
		for(int i = 1; i < j; i++) {
			dp[0][i][j] = 0;
			for(int l = 1; l < i; l++) {
				dp[0][i][j] += dp[1][l][j - i];
				dp[0][i][j] %= MOD;
			}

			dp[1][i][j] = 0;
			for(int l = i + 1; l <= n; l++) {
				dp[1][i][j] += dp[0][l][j - i];
				dp[1][i][j] %= MOD;
			}
		}
	}
	cout << (dp[0][k][n] + dp[1][k][n]) % MOD;

	return 0;
}