#pragma GCC target("tune=native")
#include <bits/stdc++.h>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;

namespace trandom {
    struct random {
        u32 seed = chrono::high_resolution_clock::now().time_since_epoch().count() ^ (u32)(make_unique<i32>().get() - (i32 *)0);
        mt19937 engine;
        uniform_int_distribution<i32> dist;

        random(i32 l = numeric_limits<i32>::min(), i32 r = numeric_limits<i32>::max()):
            engine(seed),
            dist(l, r) {

        }

        i32 operator() () {
            return dist(engine);
        }
    } next;
}

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "w", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);

    i32 n, m;
    cin >> n >> m;

    assert(n == m);

    vector<i32> a(m);
    for (i32 i = 0; i < m; ++i) {
        cin >> a[i];
    }

    vector<i32> b(n);
    for (i32 i = 0; i < n; ++i) {
        cin >> b[i];
    }

    if (a == b) {
        cout << n << endl;
        for (i32 i = 1; i <= n; ++i) {
            cout << n << endl;
        }
    } else {

    }
}