#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

void sol1(int n, int m, vector<int>& a, vector<int>& b) {
	if (n != m)
		return;
	for (int i = 0; i < n; ++i)
		if (a[i] != b[i])
			return;
	cout << n << "\n";
	for (int i = 0; i < n; ++i)
		cout << n << " ";
	exit(0);
}

void sol2(int n, int m, vector<int>& a, vector<int>& b) {
	if (n != m)
		return;
	for (int i = 0; i < n; ++i)
		if (a[i] != b[n - i - 1])
			return;
	cout << n + n - 1 << "\n";
	for (int i = 0; i < n - 1; ++i)
		cout << n - i << " ";
	for (int i = 0; i < n; ++i)
		cout << n << " ";
	exit(0);
}

void sol4(int n, int m, vector<int>& a, vector<int>& b) {
	vector<int> pos_num(n + 1);
	for (int i = 0; i < m; ++i)
		pos_num[a[i]] = i;
	pos_num[n] = m;

	vector<int> next(m);
	for (int i = 0; i < m - 1; ++i)
		next[i] = i + 1;
	next[m - 1] = -1;
	int ind = 0, ack = 0;

	vector<int> action;
	action.reserve(2 * m);

	for (int i = 0; i < n; ++i) {
		while (a[i] != b[ind]) {
			int j = ind, step = 0, bal = pos_num[b[ind]] - ack;
			while (bal > 0) {
				j = next[j];
				++step;
				if (pos_num[b[ind]] > pos_num[b[j]])
					--bal;
			}
			int new_ind = next[ind];
			next[ind] = next[j];
			next[j] = ind;
			action.push_back(step + 1);
			ind = new_ind;
		}
		ind = next[ind];
		action.push_back(m);
		++ack;
	}
	cout << action.size() << "\n";
	for (int elem : action)
		cout << elem << " ";
	exit(0);
}

int main() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n), b(m);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> b[i];
		--b[i];
	}
	sol1(n, m, a, b);
	sol2(n, m, a, b);
	sol4(n, m, a, b);
	cout << "error 1543";
}
