#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <cmath>

using  namespace std;

//#define DEBUG

int main() {
	const int Q = 1e9 + 7;
	int n, m, k;
	cin >> n >> m >> k;
	vector <vector <int>> dp(n, vector <int>(k + 1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= k; j++) {
			if (i == 0) {
				dp[i][j] = 1;
			}
			else {
				for (int z = 0; z <= j; z++) {
					if ((z & j) == z) {
						dp[i][j] += dp[i - 1][z];
						dp[i][j] %= Q;
					}
				}
			}
		}
	}
	int ans = 0;
	for (int i = 0; i <= k; i++) {
		ans += dp[n - 1][i];
		ans %= Q;
	}
	cout << ans;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}