#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

void prost(vector<pair<long long, long long> > &t, long long k) {
	for (long i = 2; i * i <= k; i++) {
		if (k % i == 0) {
			pair<long long, long long> pt;
			pt.first = i;
			pt.second = 0;
			while (k % i == 0) {
				k = k / i;
				pt.second++;
			}
			t.push_back(pt);
		}
	}
	if (k > 1) {
		pair<long long, long long> pt;
		pt.first = k;
		pt.second = 1;
		t.push_back(pt);
	}
}

long long ans = 1e18;

void chek(long long k, long long x) {
	long long y = k / x;
	if (((x + y) % 2 == 0) && (x + y >= 0)) {
		if (ans > (x + y) / 2) {
			ans = (x + y) / 2;
		}
	}

}

void del(vector<pair<long long, long long> > &t, long long k, long long num, long long ind) {
	if (ind == t.size()) {
		chek(k, num);
	}
	else {
		for (long i = 0; i <= t[ind].second; i++) {
			del(t, k, num, ind + 1);
			num = num * t[ind].first;
		}
	}
}

int main() {
	long long k;
	cin >> k;
	if (k == 0) {
		cout << 0;
		return 0;
	}
	else if (k > 0) {
		vector<pair<long long, long long> > t;
		prost(t, k);
		del(t, k, 1, 0);
	}
	else {
		vector<pair<long long, long long> > t;
		prost(t, -k);
		del(t, k, 1, 0);
	}
	if (ans == 1e18) {
		cout << "none";
	}
	else {
		cout << ans;
	}
}