#include <bits/stdc++.h>
using namespace std;

#define sz(v) int(v.size())
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define mp make_pair
#define pb push_back

typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair < int, int > pii;

ostream & operator << (ostream & out, vector < int > & lst) {
    for (auto a : lst)
        out << a << ' ';
    out << "\n";
    return out;
}

const ll mod = 1e9 + 7;
vector < int > lst;
const ll K = 62;
#ifdef MY
    const int N = 200;
#else
    const int N = 3e5 + 5;
#endif // MY
ll dp[N];

ll pw(ll n, ll k) {
    ll res = 1;
    for (int i = 0; i < k; i++)
        res = (res * n) % mod;
    return res;
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    ll k;
    cin >> n >> m >> k;
    if (m == 1) {
        cout << 2;
        return 0;
    }
    ll p = k;
    for (ll i = K; i >= 0; i--)
        if ((1ll << i) <= p)
            lst.pb(i), p -= (1ll << i);
    //cout << lst;
    ll res = 1, ans = 1;
    ll sum = 0;
    for (int i = 0; i < lst.size(); i++) {
        ans = (ans + (res * pw(n + 1, lst[i]) % mod)) % mod;
        sum = 0;
        if (i) {
            for (int j = 1; j <= n; j++) {
                dp[j] = (dp[j - 1] + dp[j]) % mod;
                sum += dp[j];
            }

        } else {
            fill(dp + 1, dp + n + 1, 1);
            sum = n;
        }
        res = sum;
    }
    cout << (ans + sum) % mod;
    return 0;
}
