#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e3 + 1, MOD = 1e9 + 7;
int pref[MAXN][MAXN], suf[MAXN][MAXN];

main() {
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    for (int i = k; i <= n; ++i) {
        pref[k][i] = 1;
    }
    for (int i = 0; i <= k; ++i) {
        suf[k][i] = 1;
    }
    for (int i = k + 1; i <= n; ++i) {
        for (int j = 1; j <= i; ++j) {
            pref[i][j] = ((int64_t)pref[i][j - 1] + suf[i - j][j + 1]) % MOD;
        }
        for (int j = i + 1; j <= n; ++j) {
            pref[i][j] = pref[i][j - 1];
        }
        for (int j = i; j > 0; --j) {
            suf[i][j] = ((int64_t)suf[i][j + 1] + pref[i - j][j - 1]) % MOD;
        }
        suf[i][0] = suf[i][1];
    }
    int64_t ans = 0;
    ans += suf[n][0];
    ans %= MOD;
    ans += pref[n][n];
    ans %= MOD;
    cout << ans;
    return 0;
}
