#include <bits/stdc++.h>
#define MAX (int)(1e5) + 7
#define INF (long long)(1e18) + 7
#define sz(a) (int)((a).size())

using namespace std;

long long k;
long long ans = INF;
int sgn;

bool isSqrt(long long a) {
    long long r = llround(sqrtl(a));

    return r * r == a;
}

void info(vector<int>& v) {
    for (auto &i : v) cout << i << " ";
    cout << endl;
}

void start() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int main() {
    start();

    cin >> k;

    if (isSqrt(k)) {
        cout << llround(sqrtl(k)) << endl;
        return 0;
    }

    if (k == 0) {
        cout << 0 << endl;
        return 0;
    }

    if (k > 0) {
        for (long long i = 1; i * i <= k; ++i) {
            if (k % i == 0) {
                long long a, b;
                a = i; b = k / i;

                long long y = (a + b) / 2;

                if ((a + b) % 2 == 0) ans = min(ans, y);
            }
            ++i;
        }
    }
    else {
        k = -k;

        for (long long i = 1; i * i <= k; ++i) {
            if (k % i == 0) {
                long long a, b;
                a = i; b = k / i;

                long long y1, y2;
                y1 = (a - b) / 2;
                y2 = (-a + b) / 2;

                if (((a - b) % 2 + 2) % 2 == 0) {
                    ans = min(ans, abs(y1));
                }
                if (((b - a) % 2 + 2) % 2 == 0) {
                    ans = min(ans, abs(y2));
                }
            }
        }
    }

    if (ans == INF) {
        cout << "none" << endl;
    }
    else {
        cout << ans << endl;
    }
}
