#include <bits/stdc++.h>
#define MAX (int)(1e5) + 7
#define INF (int)(1e9) + 7
#define sz(a) (int)((a).size())

using namespace std;

int n;
int ans;
vector<int> v;
vector<int> used;
vector<int> ms;
set<int> d;
vector<int> ps;
vector< set<int> > g;

void info(vector<int>& v) {
    for (auto &i : v) cout << i << " ";
    cout << endl;
}

void start() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

bool check() {
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            if (ms[i] == - 1) continue;
            if (used[ms[i]]) return false;
        }
    }

    return true;
}

void dfs(int u, int c) {
    used[u] = c;

    for (auto &v : g[u]) {
        if (!used[v]) dfs(v, c);
    }
}

bool megaCheck(int ans) {
    int col = 1;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs(i, col);
        col++;
    }
    set<int> ss;
    for (int i = 0; i < n; ++i) {
        if (!d.count(i)) ss.insert(used[i]);
    }

    return sz(ss) == ans;
}

bool cmp(int a, int b) {
    return sz(g[a]) > sz(g[b]);
}

int main() {
    start();

    cin >> n;
    ms.resize(n);
    used.resize(n);
    g.resize(n);
    v.push_back(0);

    for (int i = 0; i < n; ++i) {
        int u;
        cin >> u;
        v.push_back(u);
        if (u != -1) {
            --u;
            g[i].insert(u);
            g[u].insert(i);
        }

        ms[i] = u;
    }

    int flag = 0;
    if (v[1] == -1) flag = 1;

    for (int i = 2; i <= n; ++i) {
        if (v[i] != i - 1) flag = 0;
    }

    if (flag) {
        cout << (n + 1) / 2 << endl;
        return 0;
    }

    if (n <= 20) {
        for (int mask = 1; mask <= (1 << (n)) - 1; ++mask) {
            fill(used.begin(), used.end(), 0);
            int cur = 0;

            for (int i = n - 1; i >= 0; --i) {
                if ((mask >> i) & 1) {
                    used[i] = 1;
                    ++cur;
                }
            }

            if (check()) ans = max(ans, cur);
        }

        cout << ans << endl;
    }
    else {
        ps.resize(n);
        for (int i = 0; i < n; ++i) ps[i] = i;
        int ans = n;
        int cur = 0;
        sort(ps.begin(), ps.end(), &cmp);

        fill(used.begin(), used.end(), 0);

        while (!megaCheck(ans)) {
            int del = ps[cur++];
            d.insert(del);

            for (int i = 0; i < n; ++i) {
                g[i].erase(del);
            }
            --ans;
        }

        cout << ans + 1 << endl;
    }
}
