#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 300007;

int used[MAXN];

int p[MAXN];

vector<set<int>> g(MAXN);

int c1 = 0;
int c2 = 0;

int flag = true; //cycle
vector<int> cycle;
vector<int> comp;

int col[MAXN];

void dfs(int u, int pr)
{
    comp.push_back(u);
    p[u] = pr;
    used[u] = true;
    for (auto v : g[u])
    {
        if (v != pr)
        {
            if (!used[v])
            {
                dfs(v, u);
            }
            else if (flag)
            {
                cycle.push_back(v);
                int cur = u;
                while (p[cur] != v)
                {
                    cycle.push_back(cur);
                    cur = p[cur];
                }
                cycle.push_back(cur);
                cycle.push_back(v);
                flag = false;
            }
        }
    }
}

void dfs2(int u, int c)
{
    col[u] = c;
    if (c == 0)
    {
        c1++;
    }
    else
    {
        c2++;
    }
    used[u] = true;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            dfs2(v, c ^ 1);
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    int x;
    for (int i = 0; i < n; ++i)
    {
        cin >> x;
        --x;
        if (x >= 0)
        {
            g[i].insert(x);
            g[x].insert(i);
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        if (!used[i])
        {
            c1 = 0;
            c2 = 0;
            flag = true;
            cycle = {};
            comp = {};
            dfs(i, -1);
            if (!flag)
            {
                int cnt = 0;
                for (int i = 0; i < cycle.size() - 1; ++i)
                {
                    for (auto el : comp)
                    {
                        used[el] = false;
                    }
                    c1 = 0;
                    c2 = 0;
                    int u = cycle[i];
                    int v = cycle[i + 1];
                    g[u].erase(v);
                    g[v].erase(u);
                    dfs2(u, 0);
                    if (col[u] != col[v])
                    {
                        cnt = max(c1, c2);
                    }
                    else
                    {
                        cnt = max(c1 - 1, c2);
                    }
                    g[u].insert(v);
                    g[v].insert(u);
                }
                ans += cnt;
            }
            else
            {
                c1 = 0;
                c2 = 0;
                for (auto el : comp)
                {
                    used[el] = false;
                }
                dfs2(i, 0);
                ans += max(c1, c2);
            }
        }
    }
    cout << ans << endl;
    return 0;
}
