#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<int>> g;

int c1, c2;

const int MAXN = 3e5 + 7;

int used[MAXN];

void dfs(int u, int c)
{
    used[u] = true;
    if (c)
    {
        ++c1;
    }
    else
    {
        ++c2;
    }
    for (auto v : g[u])
    {
        if (!used[v])
        {
            dfs(v, c ^ 1);
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    if (n <= 20)
    {
        g.resize(n);
        for (int i = 0; i < n; ++i)
        {
            int x;
            cin >> x;
            --x;
            if (x >= 0)
            {
                g[i].push_back(x);
            }
        }
        int ans = 0;
        for (int i = 0; i < (1 << n); ++i)
        {
            int cur = 0;
            int flag = true;
            for (int u = 0; u < n; ++u)
            {
                for (auto v : g[u])
                {
                    if ((i & (1 << v)) && (i & (1 << u)))
                    {
                        flag = false;
                    }
                }
            }
            if (flag)
            {
                for (int u = 0; u < n; ++u)
                {
                    if ((i & (1 << u)))
                    {
                        ++cur;
                    }
                }
                ans = max(cur, ans);
            }
        }
        cout << ans << endl;
    }
    else
    {
        g.resize(n);
        for (int i = 0; i < n; ++i)
        {
            int x;
            cin >> x;
            --x;
            if (x >= 0)
            {
                g[i].push_back(x);
                g[x].push_back(i);
            }
        }
        int ans = 0;
        for (int i = 0; i < n; ++i)
        {
            if (!used[i])
            {
                c1 = 0;
                c2 = 0;
                dfs(i, 0);
                ans += max(c1, c2);
            }
        }
        cout << ans << endl;
    }
}
