#include <iostream>
#include <cmath>
#include <vector>
#include <assert.h>
using namespace std;

#define int long long



signed main()
{
    int k;
    cin >> k;
    if(k >= 0 && (k - 2) % 4 == 0)
    {
        cout << "none";
        return 0;
    }
    if(k <= 1e5)
    {
        for(int i = 0; i <= 1e6; ++i)
        {
            if(i * i + k >= 0 && i * i + k == (int)sqrt(i * i + k) * sqrt(i * i + k))
            {
                cout << (int)sqrt(i * i + k);
                return 0;
            }
        }
        cout << "none";
        return 0;
    }
    int ans = 1e18;
    for(int n = 1; n < 1e6; ++n)
    {
        int left = -1e17;
        int right = 1e17;
        while(left + 1 != right)
        {
            int a = (left + right) / 2;
            if((a + n - 1) * n > k)
            {
                right = a;
            }
            else
            {
                left = a;
            }
        }
        int q = (int)sqrt((left / 2) * (left / 2) + k);
        if(q * q == (left / 2) * (left / 2) + k)
        {
            ans = min(ans, q);
        }
    }
    if(ans == 1e18)
        cout << "none";
    else
        cout << ans;
}