#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
using namespace std;

const int N = 3e5 + 2;
vector<int> g[N];
int used[N];
int dfs(int v)
{
    if(used[v])
    {
        return 0;
    }
    used[v] = 1;
    int res = 0;
    for(auto i : g[v])
    {
        res += dfs(i);
    }
    return res + 1;
}
signed main()
{
    int n;
    cin >> n;
    if(n > 20)
    {
        int ans = 0;
        for(int i = 0; i < n; ++i)
        {
            int a;
            cin >> a;
            if(a != -1)
            {
                g[i + 1].push_back(a);
                g[a].push_back(i + 1);
            }
        }
        for(int i = n; i >= 1; --i)
        {
            ans += (dfs(i) + 1) / 2;
        }
        cout << ans;
    }
    else
    {
        vector<int> v(n);
        for(int i = 0; i < n; ++i)
        {
            int a;
            cin >> a;
            if(a != -1)
            {
                --a;
                v[i] = (v[i] | (1 << a));
                v[a] = (v[a] | (1 << i));
            }
        }
        int ans = 1;
        for(int mask = 0; mask < (1 << n); ++mask)
        {
            bool st = true;
            for(int j = 0; j < n; ++j)
            {
                if(((mask >> j) & 1) == 0)
                    continue;
                if((mask & (v[j])) == 0)
                    continue;
                if((mask & (v[j])) != (1 << j))
                {
                    st = false;
                    break;
                }
            }
            
            if(st)
            {
                ans = max(ans, __builtin_popcount(mask));
            }
        }
        cout << ans;
    }
}