#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
using namespace std;

#define int long long

const int N = 3e6 + 2;
set<int> g[N];
int used[N];
int dfs(int v)
{
    if(used[v])
    {
        return 0;
    }
    used[v] = 1;
    int res = 0;
    for(auto i : g[v])
    {
        res += dfs(i);
    }
    return res + 1;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    if(n <= 20)
    {
        vector<int> v(n);
        for(int i = 0; i < n; ++i)
        {
            int a;
            cin >> a;
            if(a != -1)
            {
                --a;
                v[i] = (v[i] | (1 << a));
                v[a] = (v[a] | (1 << i));
            }
        }
        int ans = 1;
        for(int mask = 0; mask < (1 << n); ++mask)
        {
            bool st = true;
            for(int j = 0; j < n; ++j)
            {
                if(((mask >> j) & 1) == 0)
                    continue;
                if((mask & (v[j])) == 0)
                    continue;
                if((mask & (v[j])) != (1 << j))
                {
                    st = false;
                    break;
                }
            }

            if(st)
            {
                ans = max((signed)ans, __builtin_popcount((signed)mask));
            }
        }
        cout << ans;
    } else{
        int ans = 0;
        for(int i = 0; i < n; ++i)
        {
            int a;
            cin >> a;
            if(a != -1)
            {
                g[i + 1].insert(a);
                g[a].insert(i + 1);
            }
        }
        set<int> ban;
        for(int i = n; i >= 1; --i)
        {
            if(ban.find(i) == ban.end())
            {
                ++ans;
                for(auto kek : g[i])
                    ban.insert(kek);
            }
        }
        cout << max(ans, n - ans);
    }
}