#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 2e5 + 1;

void get_div(int a, vector <int> &div) {
    int i = 1;
    while (i * i <= a) {
        if (a % i == 0) {
            div.push_back(i);
            if (i != a / i) {
                div.push_back(a / i);
            }
        }
        ++i;
    }
}

void get_prime(int a, vector <int> &div) {
    int i = 2;
    while (i * i <= a) {
        if (a % i == 0) {
            div.push_back(i);
            while (a % i == 0) {
                a /= i;
            }
        }
        ++i;
    }
    if (a != 1) {
        div.push_back(a);
    }
}

void print(vector <int> &a) {
    for (auto i : a) {
        cout << i << " ";
    }
    cout << "\n";
}

ll l, r, a;

ll res(ll i) {
    return (r - i) / a;
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    cin >> l >> r >> a;

    ll ost = (r - l) % a;
    ll L = l + ost;
    ll ans = 0;

    ll k = res(L);
    ans += ost * k;

    ans += k + a * k * (k - 1) / 2;

    cout << ans;

    return 0;
}
