#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 5004;
const int MOD = 1e9 + 7;

int cnt(ll num, int n) {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += ((num >> i) & 1);
    }
    return ans;
}

void p(ll num, int n) {
    for (int i = 0; i < n; ++i) {
        cout << ((num >> i) & 1);
    }
}

vector <vector <int>> g;

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    int n;
    cin >> n;

    if (n <= 20) {
        vector <int> a(n);
        vector <set <int>> s(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            --a[i];
            if (a[i] >= 0){
                s[a[i]].insert(i);
            }
        }

        vector <bool> dp((1LL << n), 0);
        dp[0] = 1;
        for (ll mask = 0; mask < (1LL << n); ++mask) {
            if (dp[mask]) {
                for (int i = 0; i < n; ++i) {
                    if (a[i] == -1 || ((1LL << a[i]) & mask) == 0) {
                        bool good = 1;
                        for (auto elem : s[i]) {
                            if ((1LL << elem) & mask) {
                                good = 0;
                                break;
                            }
                        }
                        if (good) {
                            dp[mask | (1LL << i)] = 1;
                        }
                    }
                }
            }
        }
        int ans = 0;
        for (ll mask = 0; mask < (1LL << n); ++mask) {
            if (dp[mask]) {
                ans = max(ans, cnt(mask, n));
            }
        }
        cout << ans;
        return 0;
    }

    vector <int> a(n);
    g.resize(n);
    bool good = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (i && a[i] != i) {
            good = 0;
        }
        if (a[0] != -1) {
            good = 0;
        }
        if (a[i] != -1) {
            --a[i];
            g[a[i]].push_back(i);
            g[i].push_back(a[i]);
        }
    }
    if (good) {
        cout << (n + 1) / 2;
        return 0;
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        vector <int> used(n, 0);
        used[i] = 1;
        int cnt = 1;
        for (auto v : g[i]) {
            used[v] = 2;
        }
        for (int j = 0; j < n; ++j) {
            if (used[j]) continue;
            used[j] = 1;
            ++cnt;
            for (auto v : g[j]) {
                used[v] = 2;
            }
        }
        ans = max(ans, cnt);
    }

    return 0;
}
