#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 5004;
const int MOD = 1e9 + 7;

int cnt(ll num, int n) {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += ((num >> i) & 1);
    }
    return ans;
}

void p(ll num, int n) {
    for (int i = 0; i < n; ++i) {
        cout << ((num >> i) & 1);
    }
}

int n, k;
vector <vector <int>> a;
set <pair <int, int>> pos;
vector <pair <int, int>> ans;

bool rec(int cnt, vector <bool> used) {
    if (cnt == n) {
        return 1;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            for (int j = 0; j < n; ++j) {
                if (i != j && !used[j]) {
                    if (pos.count({min(i, j), max(i, j)})) {
                        used[i] = 1;
                        used[j] = 1;
                        ans.push_back({min(i, j), max(i, j)});
                        if (rec(cnt + 2, used)) return 1;
                        ans.pop_back();
                        used[i] = 0;
                        used[j] = 0;
                    }
                }
            }
        }
    }
    return 0;
}

bool can(vector <int> &p1, vector <int> &p2) {
    int L = min(p1[0], p2[0]);
    int R = max(p1[0], p2[0]);

    for (int i = 0; i < k; ++i) {
        int L1 = min(p1[i], p2[i]);
        int R1 = max(p1[i], p2[i]);
        int L2 = max(L1, L);
        int R2 = min(R1, R);

        if (L2 > R2) return 0;
    }
    return 1;
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    cin >> n >> k;

    a.resize(n);
    for (int i = 0; i < n; ++i) {
        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (can(a[i], a[j])) {
                pos.insert({i, j});
            }
        }
    }

    vector <bool> used(n, 0);
    if (rec(0, used)) {
        cout << "YES\n";
        for (auto i : ans) cout << i.first + 1 << " " << i.second + 1 << "\n";
    }
    else {
        cout << "NO";
    }

    return 0;
}
