#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <sstream>
#include <iomanip>
#include <random>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(20)
#define RANDOM srand(23423)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define eps 1e-9
#define mod 1000000007
#define inf 4000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f first
#define s second
#define shuffle(a) \
	for (int i = 0; i < sz(a); ++i) \
		swap(a[i], a[rand() % sz(a)])

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &a) { return str >> a.f >> a.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }

signed main() {
	FAST; FIXED; RANDOM;
	ll n, m;
	cin >> n >> m;
	vector<ll> a(m), b(n);
	cin >> a >> b;
	for (auto &i : a) --i;
	for (auto &i : b) --i;
	int ptr = 0;
	vector<int> needed(1000000, -1);
	for (int i = 0; i < n; ++i) needed[i] = b[i];
	for (int i = 0; ptr < m; ++i) {
		if (needed[i] == a[ptr]) ++ptr;
		if (needed[i] < 0) needed[i] = a[ptr], ++ptr;
	}
	while (needed.back() < 0) needed.popb();
	cout << sz(needed) << '\n';
	vector<bool> used(sz(needed));
	for (int i = 0; i < n; ++i) used[i] = true;
	for (int i = 0; i < sz(needed); ++i) {
		int cnt = 0, ind = -1;
		for (int j = i + 1; j < sz(needed) && needed[j] != needed[i]; ++j) {
			cnt += used[j];
			ind = j;
		}
		if (ind == sz(needed) - 1 || ind < 0) cout << n << ' ';
		else cout << cnt + 1 << ' ';
	}
	return 0;
}