#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <sstream>
#include <iomanip>
#include <random>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(20)
#define RANDOM srand(23423)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define eps 1e-9
#define mod 1000000007
#define inf 4000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f first
#define s second
#define shuffle(a) \
	for (int i = 0; i < sz(a); ++i) \
		swap(a[i], a[rand() % sz(a)])

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &a) { return str >> a.f >> a.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }

signed main() {
	FAST; FIXED; RANDOM;
	ll n, m;
	cin >> n >> m;
	vector<ll> a(m), b(n);
	cin >> a >> b;
	for (auto &i : a) --i;
	for (auto &i : b) --i;
	vector<int> ans(n + m, -1);
	vector<int> curr(n + m);
	for (int i = 0; i < n; ++i) curr[i] = b[i];
	while (true) {
		int ptr = 0;
		vector<bool> used(sz(curr));
		vector<int> check;
		for (int i = 0; i < sz(curr) && ptr < m; ++i) {
			if (curr[i] == a[ptr]) {
				++ptr;
				used[i] = false;
				int ind = -1;
				int cnt = 0;
				for (int j = i + 1; j < sz(curr); ++j) {
					if (curr[j] == curr[i]) {
						used[j] = true;
						ind = j;
						break;
					}
					cnt += used[j];
				}
				if (ind < 0) check.pb(cnt);
				else check.pb(n - 1);
			} else check.pb(n - 1);
		}
		if (sz(check) < sz(ans) && ptr == m) ans = check;
		bool flag = true;
		for (int i = n; i < sz(curr); ++i)
			if (curr[i] != n - 1) flag = false;
		if (flag) break;
		for (int i = sz(curr) - 1; i >= n; --i) {
			++curr[i];
			if (curr[i] == n) curr[i] = 0;
			else break;
		}
	}
	cout << sz(ans) << '\n';
	for (auto i : ans) cout << i + 1 << ' ';
	return 0;
}