#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int INF = 2e9;

int f(int a, int b)
{
    if (a % 2 == b % 2) return (b - a) / 2;
    return (b + 1 - a) / 2;
}

int ff(int a, int b, int c)
{
    if (a == b) return 0;
    return (b - a) / c;
}

int tupoe(int a, int b, int c)
{
    if (c == 2)
    {
        return (b - a) / 2;
    }
    int one = 0;
    int two = 1;
    int three;
    if ((a + 1) % c == 0) two = INF;
    int cur = a + 1;
    while (cur < b)
    {
        cur++;
        if (cur % c == 0) three = INF;
        else three = min(one, two) + 1;
        one = two;
        two = three;
    }
    return two;
}

int ne_tupoe(int a, int b, int c)
{
    if (b == a + 1 || b == a + 2) return 1;
    if (c % 2 == 0)
    {
        if (a % 2 == 1)
        {
            if (b % 2 == 0) b++;
            return (b - a) / 2;
        }
        int clc = a + (c - (a % c));
        if (clc > b)
        {
            if (b % 2 == 1) b++;
            return (b - a) / 2;
        }
        a++;
        if (b % 2 == 0) b++;
        return (b - a) / 2 + 1;
    }
    else
    {
        int clc = a + (c - (a % c));
        if (clc > b) return f(a, b);
        int one = f(a, clc - 1);
        int seg = f(clc - 1, clc + c);
        int cprev = b - (b % c);
        int cam = ff(clc, cprev, c);
        int three = f(cprev - 1, b);
        //cout << one << " " << seg << " " << clc << " " << cprev << " " << cam << " " << three << endl;
        return one + seg * cam + three;
    }
}

int main()
{
    /*
    for (int i = 1000000; i < 100000000; ++i)
        for (int j = i + 1; j <= 100000000; ++j)
            for (int c = 2; c < 500; ++c)
            {
                if (i % c == 0 || j % c == 0) continue;
                cout << i << endl;
                if (tupoe(i, j, c) != ne_tupoe(i, j, c))
                {
                    cout << i << " " << j << " " << c << endl;
                    return 0;
                }
            }
    */
    int a, b, c;
    cin >> a >> b >> c;
    cout << ne_tupoe(a, b, c) << endl;
}
