#include <iostream>
#include <vector>

using namespace std;

int INF = 1e9 + 7;

int f(int k, int use, int up, vector<vector<int>> &vup, vector<vector<int>> &vdown)
{
    if (use == 0) return 1;
    int ans = 0;
    if (!up)
    {
        if (vdown[k][use] != -1) return vup[k][use];
        for (int i = 1; i < k; ++i)
        {
            if (i <= use) ans += f(i, use - i, 1, vup, vdown);
            ans %= INF;
        }
        vdown[k][use] = ans;
    }
    else
    {
        if (vup[k][use] != -1) return vup[k][use];
        for (int i = k + 1; i <= use; ++i)
        {
            if (i <= use) ans += f(i, use - i, 0, vup, vdown);
            ans %= INF;
        }
        vup[k][use] = ans;
    }
    return ans;
}

int main()
{
    int n, k;
    cin >> n >> k;
    if (k == n)
    {
        cout << 1 << endl;
        return 0;
    }
    vector<vector<int>> vup(n + 1, vector<int> (n + 1, -1));
    vector<vector<int>> vdown(n + 1, vector<int> (n + 1, -1));
    cout << f(k, n - k, 1, vup, vdown) + f(k, n - k, 0, vup, vdown) << endl;
}
