#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    int a;
    for (int i = 0; i < n; ++i)
    {
        cin >> a;
        if (a != -1)
            g[i].push_back(a - 1);
    }
    vector<int> cur(n);
    int curans;
    int maxans = -1;
    bool ifans;
    int ansans = 0;
    for (int i = 0; i <= pow(2, n) - 1; ++i)
    {
        curans = 0;
        ifans = true;
        for (int j = 0; j < n; ++j)
        {
            cur[j] = (i >> j) % 2;
            if (cur[j]) curans++;
        }
        for (int v = 0; v < n; ++v)
        {
            if (cur[v])
            {
                for (auto vv : g[v])
                {
                    if (cur[vv])
                    {
                        ifans = false;
                        break;
                    }
                }
            }
            if (!ifans) break;
        }
        if (ifans)
        {
            if (curans > maxans) {maxans = curans; ansans = i;}
        }
    }
    cout << maxans << endl;
}
