#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define pb push_back
#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < (int)x; i++)
#define rforn(i, x) for (int i = (int)x - 1; i >= 0; i--)

#define sz(x) (int)(x).size()

using namespace std;

vector<set<int> > g;
vector<bool> used;
vector<int> cmp;

vector<set<int> > g1;

void dfs(int v, int p = -1)
{
    used[v] = true;
    for (int to : g[v])
    {
        if (to == p)
            continue;

        if (used[to])
        {
            g1[v].insert(to);
            g1[to].insert(v);
        }
        else if (!used[to])
            dfs(to, v);
    }

    cmp.pb(v);
}

vector<bool> used1;
vector<vector<int> > dp;

void dfs1(int v)
{
    used1[v] = true;

    dp[v][1] = 1;
    dp[v][0] = 0;

    for (int to : g[v])
    {
        if (!used1[to])
        {
            dfs1(to);
            dp[v][1] += dp[to][0];
            dp[v][0] += max(dp[to][0], dp[to][1]);
        }
    }
}

void solve2(int n)
{
    dp = vector<vector<int> >(n, vector<int>(2, 0));

    int ans = 0;
    for (int v = 0; v < n; v++)
    {
        if (!used1[v])
        {
            dfs1(v);
            ans += max(dp[v][0], dp[v][1]);
        }
    }
    cout << ans;
}

signed main()
{
    //freopen("test.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    g.resize(n);
    g1.resize(n);
    used.assign(n, false);
    forn (i, n)
    {
        int a;
        cin >> a;
        if (a == -1)
            continue;
        g[i].insert(a - 1);
        g[a - 1].insert(i);
    }

    /*forn (v, n)
    {
        cout << v << ':' << ' ';
        for (int to : g[v])
            cout << to << ' ';
        cout << endl;
    }*/

    int ans = 0;
    used1.assign(n, false);
    forn (i, n)
    {
        if (!used[i])
        {
            cmp.clear();

            dfs(i);

            set<pii> s1;
            int sum1 = 0;
            for (int v : cmp)
            {
                s1.insert({-sz(g1[v]), v});

                sum1 += sz(g1[v]);

                //cout << sz(g1[v]) << ' ' << v << endl;
            }
            sum1 /= 2;

            while (sum1)
            {
                int v = s1.begin()-> ss;
                used1[v] = true;
                for (int to : g1[v])
                {
                    s1.erase({-sz(g1[to]), to});
                    g1[to].erase(v);
                    g[to].erase(v);
                    g[v].erase(to);
                    s1.insert({-sz(g1[to]), to});
                    sum1--;
                }
            }
        }
    }

    /*forn (v, n)
    {
        cout << v << ':' << ' ';
        for (int to : g[v])
            cout << to << ' ';
        cout << endl;
    }*/

    solve2(n);

    return 0;
}
