#include <iomanip>
#include <iostream>
#include <ctime>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>

#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <deque>

#define int long long
#define ll long long
#define ld long double
#define ins insert
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define rsz resize
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ff first
#define ss second

using namespace std;

mt19937 gen(time(nullptr));

const int INF = 1e18, P = 1e9 + 7, X = 2007;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    vector<vector<pii>> dp(n + 1, vector<pii> (n + 1));
    dp[k][k].ff = 1;
    dp[k][k].ss = 1;
    int ans = 0;
    for (int j = k; j <= n; j++) {
        for (int i = 1; i <= j; i++) {
            if (dp[i][j].ff != 0) {
                for (int q = 1; q <= min(i - 1, n - j); q++) {
                    dp[q][j + q].ss += dp[i][j].ff;
                    dp[q][j + q].ss %= P;
                }
            }
            if (dp[i][j].ss != 0) {
                for (int q = i + 1; q <= n - j; q++) {
                    dp[q][j + q].ff += dp[i][j].ss;
                    dp[q][j + q].ff %= P;
                }
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        ans += dp[i][n].ff + dp[i][n].ss;
        ans %= P;
    }
    cout << ans;
    return 0;
}
