#include <iomanip>
#include <iostream>
#include <ctime>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>

#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <deque>

#define ll long long
#define ld long double
#define ins insert
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define rsz resize
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ff first
#define ss second

using namespace std;

mt19937 gen(time(nullptr));

const int P = 1e9 + 7, MAX_N = 5000 + 1;

    pii dp[MAX_N][MAX_N];
    int pref[MAX_N][MAX_N], suff[MAX_N][MAX_N];

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }

    //vector<vector<pii>> dp(n + 1, vector<pii> (n + 1));
    //vector<vector<int>> pref(n + 1, vector<int> (n + 1)), suff(n + 1, vector<int> (n + 1));
    for (int i = 0; i <= n; i++) for (int j = 0; j <= n; j++) {
        dp[i][j].ff = 0;
        dp[i][j].ss = 0;
        pref[i][j] = 0;
        suff[i][j] = 0;
    }
    dp[k][k].ff = 1;
    dp[k][k].ss = 1;
    for (int i = 2; i <= n; i++) pref[k][i] = (pref[k][i - 1] + dp[i - 1][k].ff) % P;
    for (int i = n - 1; i >= 1; i--) suff[k][i] = (suff[k][i + 1] + dp[i + 1][k].ss) % P;
    int ans = 0;
    for (int j = k + 1; j <= n; j++) {
        for (int i = 1; i <= j; i++) {
            dp[i][j].ff = suff[j - i][i];
            dp[i][j].ss = pref[j - i][i];
        }
        for (int i = 2; i <= n; i++) {
            pref[j][i] = (pref[j][i - 1] + dp[i - 1][j].ff) % P;
        }
        for (int i = n - 1; i >= 1; i--) {
            suff[j][i] = (suff[j][i + 1] + dp[i + 1][j].ss) % P;
        }
    }
    for (int i = 1; i <= n; i++) {
        ans += (dp[i][n].ff + dp[i][n].ss) % P;
        ans %= P;
    }
    cout << ans;
    return 0;
}
