#include <iomanip>
#include <iostream>
#include <ctime>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>

#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <deque>

#define ll long long
#define ld long double
#define ins insert
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define rsz resize
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ff first
#define ss second

using namespace std;

mt19937 gen(time(nullptr));

vector<vector<int>> g;
vector<bool> used;
vector<int> s, col;
int bl = 0;

void dfs(int v) {
    used[v] = true;
    s.pb(v);
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

bool is_c(int v, int c) {
    col[v] = c;
    if (c == 1) bl++;
    for (int u : g[v]) {
        if (!col[u]) {
            is_c(u, 3 - c);
        }
    }
    return true;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    g.rsz(n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x == -1) continue;
        x--;
        g[i].pb(x);
        g[x].pb(i);
    }
    used.rsz(n);
    col.rsz(n);
    if (n <= 20) {
        vector<vector<int>> g2(n, vector<int> (n, 1));
        for (int i = 0; i < n; i++) {
            for (int j : g[i]) {
                g2[i][j] = 0;
                g2[j][i] = 0;
            }
        }
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            s = {};
            bool fl = true;
            for (int i = 0; i < n; i++) if (((1 << i) | mask) == mask) s.pb(i);
            int x = s.size();
            for (int i = 0; i < s.size(); i++) {
                for (int j = 0; j < s.size(); j++) {
                    if (!g2[s[i]][s[j]]) fl = false;
                }
            }
            if (fl) ans = max(ans, x);
        }
        cout << ans;
        return 0;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            bl = 0;
            s = {};
            dfs(i);
            is_c(i, 1);
            int x = s.size();
            ans += max(bl, x - bl);
        }
    }
    cout << ans;
    return 0;
}
