#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("sse,sse2,sse3,ssse3,abm,mvx,popcnt,tune=native")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <ctime>
#include <cassert>
#include <random>
#include <deque>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define pbc push_back
#define pob pop_back
#define vin(v) for(int i = 0;i < (v).size() ;++i) cin>>(v)[i];
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define rev(v) reverse(all((v)))
#define sp system("pause")
#define int long long
const int MAXN = 3e5 + 1;
const int inf = 1000000000;
const ll INF = 1ll * inf * inf;
const int mod = inf + 7;
vector<set<int>> g(MAXN);
vector<vector<int>> dp(MAXN, vector<int>(2));
vector<int> cl(MAXN);
vector<int> pr(MAXN);
set<int> cycle;
vector<int> mogila(MAXN);
int invert(int c)
{
    return c % 2 + 1;
}
void dfs(int v, int p, int nowcl)
{
    cl[v] = nowcl;
    mogila[v] = p;
    for (int i : g[v])
    {
        if (cl[i] == cl[v])
        {
            int tv = v;
            while (tv != i)
            {
                cycle.insert(tv);
                tv = mogila[tv];
            }
            cycle.insert(i);
        }
        else if (cl[i] == 0)
        {
            dfs(i, v, invert(nowcl));
        }
    }
    cl[v] = 3;
}
vector<int> used(MAXN);
void dfscount(int v, int p)
{
    used[v] = 1;
    if ((p!= -1 && g[v].size() == 1) || g[v].size() == 0)
    {
        dp[v][1] = 1;
        dp[v][0] = 0;
        return;
    }
    vector<int> zdp;
    vector<int> odp;
    for (int i : g[v])
    {
        if (i != p && cycle.find(i) == cycle.end())
        {
            dfscount(i, v);
            zdp.pbc(dp[i][0]);
            odp.pbc(dp[i][1]);
        }
    }
    dp[v][1] = 1;
    for (int i = 0; i < zdp.size(); ++i)
    {
        dp[v][0] += max(odp[i], zdp[i]);
        dp[v][1] += zdp[i];
    }
}
signed main()
{
    fastio();
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
    {
        int a;
        cin >> a;
        if (a == -1) continue;
        g[i].insert(a);
        g[a].insert(i);
    }
    for (int i = 1; i <= n; ++i)
    {
        if (!cl[i])
        {
            dfs(i, -1, 1);
        }
    }
    if (!cycle.size())
    {
        int ans = 0;
        for (int i = 1; i <= n; ++i)
        {
            if (!used[i])
            {
                dfscount(i, -1);
                ans += max(dp[i][0], dp[i][1]);
            }
        }
        cout << ans;
        return 0;

    }
    for (int i : cycle)
    {
        dfscount(i, 1);
    }
    vector<pair<int, int>> means;
    for (int i : cycle)
    {
        means.pbc({ dp[i][0], dp[i][1] });
    }

    vector<int> tc;
    for (int i : cycle) tc.pbc(i);
    vector<vector<int>> dp(tc.size(), vector<int>(2));
    dp[0][1] = means[0].second;
    dp[0][0] = means[0].first;
    int ans = 0;
    for (int i = 1; i < tc.size(); ++i)
    {
        if (i == tc.size() - 1)
        {
            dp[i][0] = max(dp[i - 1][1] + means[i].first, dp[i - 1][0] + means[i].first);
            dp[i][1] = dp[i - 1][0] + means[i].first - dp[0][1];

        }
        else
        {
            dp[i][0] = max(dp[i - 1][1] + means[i].first, dp[i - 1][0] + means[i].first);
            dp[i][1] = dp[i - 1][0] + means[i].second;
        }
        ans = max(ans, dp[i][0]);
        ans = max(ans, dp[i][1]);
    }
    cout << ans;
    sp;
}