#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

vector<long long> cicle;
vector<long long> used1(300003);
vector<long long> used2(300003);
vector<vector<long long> > vec(300003);
vector<pair<long long, long long> > tobeornottobe(300003);

long long fun(long long x, long long pred)
{
    long long r = 0;
    used1[x] = 1;
    int e = 0;
  for (long long i = 0;  i < vec[x].size(); i++)
  {
      if (vec[x][i] == pred && e == 0)
      {
          e = 1;
        continue;
      }
      if (used1[vec[x][i]] == 1)
      {
          r = vec[x][i];
          continue;
      }
      else
      {
          long long y = fun(vec[x][i], x);
          r = max(y, r);
      }
  }
  if (r != 0)
  {
        cicle.push_back(x);
        used2[x] = 1;
        if (x != r)
           return r;
         else
           return 0;
  }
  else
    return 0;
}

pair<long long , long long> der(long long x)
{
    used2[x] = 1;
    pair<long long, long long> p;
    p.first = 1; p.second = 0;
    for (int i = 0; i < vec[x].size(); i++)
    {
        if (used2[vec[x][i]] == 1)
            continue;
        pair<long long, long long> q = der(vec[x][i]);
        p.first += q.second;
        p.second += max(q.first, q.second);
    }
    tobeornottobe[x] = p;
    return p;
}

pair<long long, long long> der_in_cicle(long long x)
{
    pair<long long, long long> p;
    p.first = tobeornottobe[cicle[x]].first;
    p.second = tobeornottobe[cicle[x]].second;
    if (x == cicle.size() - 1)
    {
        p.first = -1e18;
        return p;
    }
    else
    {
        pair<long long, long long> q = der_in_cicle(x + 1);
        p.first += q.second;
        p.second += max(q.first, q.second);
        return p;
    }
}

pair<long long, long long> der_in_cicle2(long long x)
{
    pair<long long, long long> p;
    p.first = tobeornottobe[cicle[x]].first;
    p.second = tobeornottobe[cicle[x]].second;
    if (x == 0)
    {
        p.first = 0;
        return p;
    }
    else
    {
        pair<long long, long long> q = der_in_cicle2(x - 1);
        p.first += q.second;
        p.second += max(q.first, q.second);
        return p;
    }
}

int main()
{
  long long n, a, ans = 0;
  cin >> n;
  for (int i = 1; i <= n; i++)
  {
      cin >> a;
      if (a != -1)
      {
          vec[a].push_back(i);
          vec[i].push_back(a);
      }
  }
  for (int i = 1; i <= n; i++)
  {
      if (used1[i] == 0)
      {
          fun(i, -1);
          /*for (int i = 0 ; i < cicle.size(); i++)
            cout << cicle[i] << ' ';
          cout << endl;*/
          if (cicle.size() == 0)
          {
              der(i);
              ans += max(tobeornottobe[i].first,
                       tobeornottobe[i].second);
                       continue;
          }
          for (int i = 0; i < cicle.size(); i++)
            der(cicle[i]);
           // cout << endl;
            /*for (int i = 1; i <= 4; i++)
              cout << tobeornottobe[i].first <<  ' ' <<
                       tobeornottobe[i].second << endl;
                       cout << endl;*/
          pair<long long, long long> p = der_in_cicle(0);
          pair<long long, long long> q = der_in_cicle2(cicle.size() - 1);
          //cout << '!'<< p.first << ' ' << p.second << ' ' << q.first << ' ' << q.second << endl;
          ans += max(max(p.first, p.second), max(q.first, q.second));
      }
      cicle.resize(0);
  }
  cout << ans;
}









