#include <bits/stdc++.h>
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define read(FILENAME) freopen(((string)FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen(((string)FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, const pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
}


template<typename T> istream &operator >> (istream &_in, vector<T> &a) {for (auto &i : a) _in >> i; return _in;}
template<typename T> ostream &operator << (ostream &_out, const vector<T> &a) {
	for (int i = 0; i < a.size(); ++i) {
		if (i) _out << ' ';
		_out << a[i];
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const multiset<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T> ostream &operator << (ostream &_out, const unordered_set<T> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << i;
	}
	return _out;
} 

template<typename T1, typename T2> ostream &operator << (ostream &_out, const map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 


template<typename T1, typename T2> ostream &operator << (ostream &_out, const unordered_map<T1, T2> &a) {
	bool printed = false;
	for (auto i : a) {
		if (printed) _out << ' ';
		else printed = true;
		_out << "{" << i.x << ", " << i.y << "}";
	}
	return _out;
} 

#define getchar getchar_unlocked
#define putchar putchar_unlocked

int read_int() {
	int v = 0;
	char c = getchar();
	if (c > '9') return 0;
	while (c < '0') c = getchar();
	while (c >= '0') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar();
	}
	return v;
}

void print(const string &s) {
	for (auto c : s) {
		putchar(c);
	}
}

void print_int(int v) {
	print(to_string(v));
}

long long a, b, c;

long long solve(long long a, long long b) {
	if (a == b) return 0;
	// cout << a << ' ' << b << endl;
	long long M = ((a - 1) / c + 1) * c;
	if (M > b) {
		return (b - a - 1) / 2 + 1;
	}
	if (c & 1) {
		if (M % 2 != a % 2) {
			M += c;
		}
		if (M > b) {
			return (b - a - 1) / 2 + 1;
		}
		int d = (M - a) / 2 + 1;
		// cout << d << ':' << M << endl;
		if (a % (c * 2) == 1 && (b - a) > c * 2 && (M - a) > c) {
			int cnt = (b - a) / (c * 2);
			return d * cnt + solve(a + cnt * c * 2, b);
		}
		a = M + 1;
		return d + solve(a, b);
	} else {
		if (a % 2 == 0 && b % 2 == 0) {
			return (b - a) / 2 + 2;
		} else {
			return (b - a - 1) / 2 + 1;
		}
	}
}

int new_solve(int a, int b) {
	if (a >= b) return 0;
	if ((a + 2) % c == 0) {
		return new_solve(a + 1, b) + 1;
	}
	return new_solve(a + 2, b) + 1;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);	
	// read("input");
	cin >> a >> b >> c;	
	cout << solve(a, b) << '\n';
	// cout << new_solve(a, b) << endl;
	// assert(new_solve(a, b) == solve(a, b));
}