#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define sz(v) (signed)(v.size())
#define all(v) a.begin(), a.end()
#define rall(v) a.rbegin(), a.rend()

const int INF = 1e18, MOD = 1e9 + 7;
const ld EPS = 1e-7;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, k;
	cin >> n >> k;
	if (n == k) {
		cout << 1 << endl;
		return 0;
	}
	vector <vector <vector <int> > > dp(n + 1, vector <vector <int> >(n + 1, vector <int>(2, 0)));
	dp[k][k][1] = 1;
	dp[k][k][0] = 1;
	for (int i = 0; i <= n; ++i) {
		for (int j = 1; j <= i; ++j) {
			for (int t = 0; t < j; ++t) {
				dp[i][j][0] += dp[i - j][t][1];
			}
			for (int t = j + 1; t <= n; ++t) {
				dp[i][j][1] += dp[i - j][t][0];
			}
			dp[i][j][0] %= MOD;
			dp[i][j][1] %= MOD;
		}	
	}
	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		ans += dp[n][i][0] + dp[n][i][1];
	}
	ans %= MOD;
	cout << ans << endl;
	return 0;
}