#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

vector<int> g[300005];
vector<int> g1[300005];

int used[300005];
int col = 0;
int c1 = -1;
int c3 = -1;

int cnt = 0;

int ans[300005][2];
int res[300005][2][2];

vector<int> cycle[300005];


void dfs(int v) {
    used[v] = col;
    if (g[v].size() == 0) {
        c3 = v;
    }
    for (int s : g[v]) {
        if (used[s] == col) {
            c1 = v;
        } else {
            dfs(s);
        }
    }
}


int idx = 0;
void dfs1(int v) {
    used[v] = col;
    cycle[idx].pb(v);
    for (int s : g[v]) {
        if (used[s] != col) {
            dfs1(s);
        }
    }
}

void dfs2(int v) {
    //cout << v << " ";
    ++cnt;
    used[v] = col;
    for (int s : g1[v]) {
        if (used[s] != col) {
            dfs2(s);
        }
    }
}

void dfs3(int v, int pr) {
    for (int s : g1[v]) {
        if (s != pr) dfs3(s, pr);
    }
    ll mx1 = 0, mx0 = 0;
    for (int s : g1[v]) {
        if (s == pr) continue;
        mx0 += max(ans[s][0], ans[s][1]);
        mx1 += ans[s][0];
    }
    ans[v][1] = mx1 + 1;
    ans[v][0] = mx0;
}

int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        if (a != -1) {
            --a;
            g[i].pb(a);
            g1[a].pb(i);
        }
    }

    idx = -1;
    col = 1;

    while (cnt < n) {
        for (int i = 0; i < n; ++i) {
            if (used[i] > 0) continue;
            c1 = -1;
            c3 = -1;
            //cout << i + 1 << "\n";
            ++col;
            ++idx;
            dfs(i);
            //cout << c1 + 1 << " " << c3 + 1 << "\n";
            if (c3 != -1) {
                cycle[idx].pb(c3);
                //cycle[idx].pb(c3);
                ++col;
                dfs2(c3);
                //continue;
            } else {
                ++col;
                dfs1(c1);
                ++col;
                dfs2(c1);
                //cycle[idx].pb(cycle[idx][0]);
            }
            /*for (int j = 0; j < n; ++j) {
                cout << used[j] << " ";
            }
            cout << "\n";*/
        }
    }


    int sz = idx + 1;
    /*cout << "\n";
    for (int i = 0; i < sz; ++i) {
        for (int el : cycle[i]) {
            cout << el + 1 << " ";
        }
        cout << "\n";
    }*/



    for (int i = 0; i < sz; ++i) {
        for (int j = 0; j < cycle[i].size(); ++j) {
            int pr = -1;
            if (j > 0) {
                pr = cycle[i][j - 1];
            } else {
                pr = cycle[i][cycle[i].size() - 1];
            }
            dfs3(cycle[i][j], pr);
        }
    }

    int w = 0;

    for (int i = 0; i < sz; ++i) {
        if (cycle[i].size() == 1) {
            w += max(ans[cycle[i][0]][0], ans[cycle[i][0]][1]);
            continue;
        }
        res[0][0][0] = ans[cycle[i][0]][0];
        res[0][1][1] = ans[cycle[i][0]][1];
        for (int j = 1; j < cycle[i].size(); ++j) {
            res[j][0][0] = max(res[j - 1][1][0], res[j - 1][0][0]) + ans[cycle[i][j]][0];
            res[j][1][0] = res[j - 1][0][0] + ans[cycle[i][j]][1];
            res[j][0][1] = max(res[j - 1][1][1], res[j - 1][0][1]) + ans[cycle[i][j]][0];
            res[j][1][1] = res[j - 1][0][1] + ans[cycle[i][j]][1];
        }
        int szz = cycle[i].size() - 1;
        w += max(res[szz][1][0], max(res[szz][0][1], res[szz][0][0]));
    }
    cout << w;


    /*cout << "\n";
    for (int i = 0; i < n; ++i) {
        cout << i + 1 << "\n";
        cout << ans[i][0] << " " << ans[i][1] << "\n";
    }*/


    return 0;
}

