#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

vector<int> deleted(300001, 0);
int minusi = 0;

bool last_del(int last, int dur, vector<vector<int>> &q) {
    return q[last].size() > q[dur].size();
}

void dfs(int v, vector<vector<int>> &q, vector<int> &used, int last) {
    //cout << "dfs is:  ->  v: " << v << endl;
    used[v] = 1;

    /*
    if (last == 0) {
        minusi++;
        deleted[v] = 1;
    }
    */

    bool del_dur = false;
    for (auto p : q[v]) {
        if (!used[p]) {
            if (deleted[p]) {
                dfs(p, q, used, 1);
                continue;
            }
            dfs(p, q, used, 1 - last);
        } else {
            if (!deleted[p] && !deleted[v]) {
                if (last_del(p, v, q))
                    deleted[p] = 1;
            }
        }
    }
    bool to_del = false;
    for (auto p : q[v])
        if (!deleted[p])
            to_del = true;
    if (to_del)
        deleted[v] = 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n; ++n;
    vector<vector<int>> q(n);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        if (x > 0) {
            q[x].push_back(i);
            q[i].push_back(x);
        }
    }
    int pos = 1;
    for (int i = 2; i < n; ++i) {
        if (q[i].size() > q[pos].size())
            pos = i;
    }
    if (q[pos].empty()) {
        cout << n - 1 << endl;
        return 0;
    }
    vector<int> used(n, 0);
    dfs(pos, q, used, 0);
    do {
        pos = -1;
        for (int i = 1; i < n; ++i)
        if (!used[i]) {
            if (pos == -1)
                pos = i;
            else {
                if (q[i].size() > q[pos].size())
                    pos = i;
            }
        }
        if (pos > 0)
            dfs(pos, q, used, 0);
    } while (pos > 0);
    int ans = 0;
    for (int i = 1; i < n; ++i)
        if (!deleted[i])
            ++ans;
    cout << ans << endl;
    return 0;
}
