#pragma GCC(optimize, "Ofast, unroll-loops")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <numeric>
#include <functional>
#include <iomanip>
#include <random>
#include <string>
#include <math.h>
#include <bitset>
#define pb push_back
#define pf push_front
#define sz(a) (ll)((a).size())
#define all(a) ((a).begin(), (a).end())
#define popb pop_back
#define popf pop_front
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define endl "\n"
#define heap priority_queue
#define hash_set unordered_set
#define hash_map unordered_map
#define ft first
#define sd second
#define die(f) if (f) for (;;) {}
using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<ll> vll;
typedef vector<ld> vld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
const ll inf = numeric_limits<ll>::max() / 2;
const ld pi = acosl(-1);
const ld eps = 1e-9;
template<typename T> ll mineq(T& a, T b) { if (a > b) return a = b, 1; return 0; }
template<typename T> ll maxeq(T& a, T b) { if (a < b) return a = b, 1; return 0; }

inline void read(), solve();

signed main() {
	fast;
	read();
	solve();
	return 0;
}

const ll R = 1e9 + 7;
const ll MAXN = 31;
ll n, k;
ll dp[MAXN][MAXN][MAXN];

inline void solve() {
	dp[1][k][k] = 1;
	for (ll i = 1; i < n; i++) {
		for (ll j = 0; j <= n; j++) {
			for (ll k = 1; k <= n; k++) {
				if (i % 2 == 1) {
					for (ll p = k + 1; p <= n; p++) {
						dp[i + 1][j + p][p] += dp[i][j][k];
						dp[i + 1][j + p][p] %= R;
					}
				}
				else {
					for (ll p = 1; p < k; p++) {
						dp[i + 1][j + p][p] += dp[i][j][k];
						dp[i + 1][j + p][p] %= R;
					}
				}
			}
		}
	}
	ll ans = 0;
	for (ll i = 1; i <= n; i++) {
		for (ll p = 1; p <= n; p++) {
			ans += dp[i][n][p];
			ans %= R;
		}
	}
	for (ll i = 0; i <= n; i++) {
		for (ll j = 0; j <= n; j++) {
			for (ll k = 0; k <= n; k++) {
				dp[i][j][k] = 0;
			}
		}
	}
	dp[0][k][k] = 1;
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j <= n; j++) {
			for (ll k = 1; k <= n; k++) {
				if (i % 2 == 1) {
					for (ll p = k + 1; p <= n; p++) {
						dp[i + 1][j + p][p] += dp[i][j][k];
						dp[i + 1][j + p][p] %= R;
					}
				}
				else {
					for (ll p = 1; p < k; p++) {
						dp[i + 1][j + p][p] += dp[i][j][k];
						dp[i + 1][j + p][p] %= R;
					}
				}
			}
		}
	}
	for (ll i = 1; i < n; i++) {
		for (ll p = 1; p <= n; p++) {
			ans += dp[i][n][p];
			ans %= R;
		}
	}
	cout << ans << endl;
}

inline void read() {
	cin >> n >> k;
}
