#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <queue>
#include <deque>
#include <random>
#include <ctime>
#include <utility>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#pragma warning(disable:4996)

using namespace std;

typedef long long ll;
typedef long double ld;

const char el = '\n';
const int inf = 1e9;
const ll llinf = 1e18, mod = 1000'000'007;
const ld pi = 3.1415926;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define x first
#define y second
//#define int ll

template<typename T> void uin(T & a, T b) { if (b < a) a = b; }
template<typename T> void uax(T & a, T b) { if (b > a) a = b; }

mt19937 rnd(time(NULL));

vector<int> a[7], b[7];
int n, k, mask[400][7];
vector<int> g[400], mt;
vector<bool> used;
bool kuhn(int v) {
	if (used[v]) return false;
	used[v] = 1;
	for (auto to : g[v])
		if (mt[to] == -1 || kuhn(mt[to])) {
			mt[to] = v;
			return true;
		}
	return false;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k;
	forn(i, k) a[i].resize(n), b[i].resize(n);
	forn(i, n) {
		forn(j, k) {
			cin >> a[j][i];
			b[j][i] = a[j][i];
		}
	}
	forn(i, k) sort(all(b[i]));
	int raz[7];
	bool bd[7];
	forn(i, k) {
		raz[i] = b[i][(n - 1) / 2];
		bd[i] = b[i][n / 2] == raz[i];
	}
	forn(i, n) {
		for (int j = k - 1; j >= 0; --j) {
			if (a[j][i] < raz[j]) mask[i][k - j - 1] = 0;
			else if (a[j][i] > raz[j]) mask[i][k - j - 1] = 1;
			else if (bd[j]) mask[i][k - j - 1] = 2;
		}
	}
	vector<bool> dol(n, 0);
	int cnt = 0;
	forn(i, n)
		if (mask[i][k - 1] == 1) dol[i] = 1, cnt++;
	forn(i, n)
		forn(j, n) {
		if (mask[i][k - 1] == 1) continue;
		bool bad = 0;
		forn(l, k)
			if (mask[i][l] == mask[j][l] && mask[i][l] < 2) {
				bad = 1;
				break;
			}
		if (!bad)
			g[i].push_back(j);
	}
	mt.assign(n, -1);
	forn(i, n) {
		used.assign(n, 0);
		kuhn(i);
	}
	bool bad = 0;

	forn(i, n)
		if ((dol[i] && mt[i] == -1) || cnt != n / 2) {
			bad = 1;
			break;
		}
	if (bad)
		cout << "NO";
	else {
		cout << "YES" << el;
		forn(i, n)
			if (mt[i] >= 0)
				cout << i + 1 << ' ' << mt[i] + 1 << el;
	}
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}