#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <queue>
#include <deque>
#include <random>
#include <ctime>
#include <utility>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma comment(linker, "/STACK:256000000")
#pragma warning(disable:4996)

using namespace std;

typedef long long ll;
typedef long double ld;

const char el = '\n';
const int inf = 1e9;
const ll llinf = 1e18, mod = 1000'000'007;
const ld pi = 3.1415926;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define x first
#define y second
//#define int ll

template<typename T> void uin(T & a, T b) { if (b < a) a = b; }
template<typename T> void uax(T & a, T b) { if (b > a) a = b; }

mt19937 rnd(time(NULL));

vector<int> a[7], b[7];
int c[1500], n, k, mask[1500][7];
vector<int> t[1500];
int g[3000][3000], f[3000][3000];
vector<int> g1[3000];
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k;
	forn(i, k) a[i].resize(n), b[i].resize(n);
	forn(i, n) {
		forn(j, k) {
			cin >> a[j][i];
			b[j][i] = a[j][i];
		}
	}
	forn(i, k) sort(all(b[i]));
	int raz[7];
	bool bd[7];
	forn(i, k) {
		raz[i] = b[i][(n - 1) / 2];
		bd[i] = b[i][n / 2] == raz[i];
	}
	forn(i, n) {
		int tmp = 1, op = 0;
		for (int j = k - 1; j >= 0; --j) {
			if (a[j][i] < raz[j]) NULL;
			else if (a[j][i] > raz[j]) op += tmp;
			else if (bd[j]) op += tmp + tmp;
			tmp *= 3;
		}
		c[op]++;
		t[op].push_back(i);
	}
	int st = 1;
	forn(i, k - 1) st *= 3;
	forn(i, st + st) {
		int tmp = i;
		forn(j, k) {
			mask[i][j] = tmp % 3;
			tmp /= 3;
		}
	}
	forn(j, st) {
		g[st * 4][j + st + st] = 1e6;
		g1[st * 4].push_back(j + st + st);
		g1[j + st + st].push_back(st * 4);
	}
	for (int j = st; j < st + st; ++j) {
		g[j + st + st][st * 4 + 1] = 1e6;
		g1[j + st + st].push_back(st * 4 + 1);
		g1[st * 4 + 1].push_back(j + st + st);
	}
	forn(i, st) {
		g[i + st + st][i] = c[i];
		g1[i + st + st].push_back(i);
		g1[i].push_back(i + st + st);
	}
	for (int i = st; i < st + st; ++i) {
		g[i][i + st + st] = c[i];
		g1[i].push_back(i + st + st);
		g1[i + st + st].push_back(i);
	}
	forn(i, st)
		for (int j = st; j < st + st; ++j) {
			bool bad = 0;
			forn(l, k)
				if (mask[i][l] == mask[j][l] && mask[i][l] < 2) {
					bad = 1;
					break;
				}
			if (!bad) {
				g[i][j] = 1e6;
				g1[i].push_back(j);
				g1[j].push_back(i);
			}
		}
	vector<bool> used;
	vector<int> p;
	deque<int> q;
	int sz = 4 * st;
	int rr = 2 << 17;
	while (1) {
		used.assign(sz + 2, 0);
		p.assign(sz + 2, -1);
		p[sz] = sz;
		used[sz] = 1;
		q.clear();
		q.push_back(4 * st);
		while (!q.empty()) {
			int v = q.front();
			q.pop_front();
			if (v == sz + 1) break;
			for (auto j : g1[v]) {
				if (!used[j] && g[v][j] - f[v][j] > 0) {
					used[j] = 1;
					p[j] = v;
					q.push_back(j);
				}
			}
		}
		if (p[sz + 1] == -1) {
			break;
		}
		int del = inf;
		for (int i = sz + 1; i != sz; i = p[i])
			uin(del, g[p[i]][i] - f[p[i]][i]);
		for (int i = sz + 1; i != sz; i = p[i])
			f[p[i]][i] += del, f[i][p[i]] -= del;
	}
	int cnt = 0;
	forn(i, sz + 2) cnt += f[sz][i];
	if (cnt < n / 2)
		cout << "NO";
	else {
		cout << "YES" << el;
		vector<pair<int, int>> ans;
		forn(i, st)
			for (int j = st; j < st + st; ++j) {
				if (g[i][j] == 0) continue;
				forn(l, f[i][j]) {
					ans.push_back({ t[i].back(), t[j].back() });
					t[i].pop_back();
					t[j].pop_back();
				}
			}
		forn(i, ans.size())
			cout << ans[i].x + 1 << ' ' << ans[i].y + 1 << el;
	}
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}