#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > graph;
vector<vector<bool> > matrix;
vector<int> now;

bool check()
{
    for (auto i : now)
    {
        for (auto j : now)
        {
            if (i == j) continue;
            if (!matrix[i][j]) return false;
        }
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int n, x;
    cin >> n;
    graph.resize(n);
    if (n <= 20)
    {
        matrix.assign(n, vector<bool>(n, 1));
    }
    bool flag = true;
    bool flag2 = true;
    for (int i = 0; i < n; i++)
    {
        cin >> x;
        if (x > 0) x--;
        flag &= (x == i - 1);
        if (x == -1) continue;
        flag2 &= (x < i);
        graph[x].push_back(i);
        graph[i].push_back(x);
        if (n <= 20)
        {
            matrix[x][i] = matrix[i][x] = 0;
        }
    }

    if (flag)
    {
        cout << (n + 1) / 2;
        return 0;
    }

    if (flag2)
    {
        set<pair<int, int> > q;
        vector<int> used(n, 0);

        int ans = 0;
        for (int i = 0; i < n; i++)
        {
            if (graph[i].size() == 1)
            {
                q.insert({-1, i});
                used[i] = -1;
                ans++;
            }
            if (graph[i].size() == 0)
                ans++;
        }

        /*
        13
        -1
        1
        2
        2
        3
        2
        6
        6
        8
        9
        9
        9
        9
        */
        while (q.size())
        {
            pair<int, int> edge = *(q.begin());
            q.erase(q.begin());
            int v = edge.second;

            //cout << "v:" << v << endl;
            for (auto u : graph[v])
            {
                if (!used[u])
                {
                    if (used[v] == -1)
                    {
                        used[u] = 1;
                        q.insert({1, u});
                    }
                    if (used[v] == 1)
                    {
                        used[u] = -1;
                        //cout << endl << u << endl;
                        ans++;
                        q.insert({-1, u});
                    }
                }
            }
        }
        cout << ans;
        return 0;
    }

    int maxi = 0;
    for (int v = 0; v < (1 << n); v++)
    {
        now = {};
        for (int i = 0; i < n; i++)
        {
            if ((1 << i) & v)
                now.push_back(i);
        }

        if (check())
            maxi = max(maxi, (int)now.size());
    }
    cout << maxi;
}
