#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > graph;
vector<vector<bool> > matrix;
vector<int> now;

bool check()
{
    for (auto i : now)
    {
        for (auto j : now)
        {
            if (i == j) continue;
            if (!matrix[i][j]) return false;
        }
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int n, x;
    cin >> n;
    graph.resize(n);
    if (n <= 20)
    {
        matrix.assign(n, vector<bool>(n, 1));
    }
    bool flag = true;
    bool flag2 = true;
    for (int i = 0; i < n; i++)
    {
        cin >> x;
        if (x > 0) x--;
        flag &= (x == i - 1);
        if (x == -1) continue;
        flag2 &= (x < i);
        graph[x].push_back(i);
        graph[i].push_back(x);
        if (n <= 20)
        {
            matrix[x][i] = matrix[i][x] = 0;
        }
    }

    if (flag)
    {
        cout << (n + 1) / 2;
        return 0;
    }

    if (flag2)
    {
        vector<set<int> > graph2(n);
        set<int> vert;
        for (int i = 0; i < n; i++)
        {
            vert.insert(i);
            for (auto u : graph[i])
            {
                graph2[i].insert(u);
            }
        }

        int ans = 0;
        while (vert.size())
        {
            for (auto i : vert)
            {
                if (graph2[i].size() == 0)
                {
                    ans++;
                    vert.erase(i);
                    break;
                }
                if (graph2[i].size() == 1)
                {
                    flag = true;
                    int v = *(graph2[i].begin());
                    graph2[v].erase(i);
                    ans++;
                    vert.erase(i);
                    for (auto u : graph2[v])
                    {
                        graph2[u].erase(v);
                    }
                    vert.erase(v);
                    break;
                }
            }
        }
        /*
        13
        -1
        1
        2
        2
        3
        2
        6
        6
        8
        9
        9
        9
        9
        */
        cout << ans;
        return 0;
    }

    int maxi = 0;
    for (int v = 0; v < (1 << n); v++)
    {
        now = {};
        for (int i = 0; i < n; i++)
        {
            if ((1 << i) & v)
                now.push_back(i);
        }

        if (check())
            maxi = max(maxi, (int)now.size());
    }
    cout << maxi;
}
