#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
using namespace std;
//#define int long long
typedef long long ll;
#define pii pair<int, int>

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
};

const int N = 3e5 + 10;
int a[N];
vector<int> g[N];
int d0[N], d1[N];
int _d0[N], _d1[N];
int used[N];
int st = -1;

void dfs1(int v, int p, int x) {
    used[v] = true;
    for (int to : g[v]) {
        if (to != p && to != v && !(v == st && to == x)) {
            dfs1(to, v, x);
        }
    }
    d1[v] = 1;
    if (v == x) d1[v] = -1e9;
    for (int to : g[v]) {
        if (to != p) {
            d1[v] += d0[to];
            d0[v] += max(d1[to], d0[to]);
        }
    }
}

void dfs2(int v, int p, int x) {
    used[v] = true;
    for (int to : g[v]) {
        if (to != p && to != v && !(v == st && to == x)) {
            dfs2(to, v, x);
        }
    }
    _d1[v] = 1;
    //if (v == x) d1[v] = -1e9;
    for (int to : g[v]) {
        if (to != p) {
            _d1[v] += _d0[to];
            _d0[v] += max(_d1[to], _d0[to]);
        }
    }
}

signed main() {
    fast();
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] > 0) {
            a[i]--;
            if (a[a[i]] == i) {
                a[i] = -1;
            }
        }
    }
    int vv = -1;
    int answ = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] != -1) {
            g[a[i]].push_back(i);
            g[i].push_back(a[i]);
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i] || a[i] != -1) continue;
        st = i;
        dfs1(i, -1, a[i]); dfs2(i, -1, a[i]);
        answ += max({d0[i], d1[i], _d0[i]});
    }
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        st = i;
        dfs1(i, -1, a[i]); dfs2(i, -1, a[i]);
        answ += max({d0[i], d1[i], _d0[i]});
    }
    cout << answ;
    return 0;
}