#include <iostream>
#include <vector>
#define int long long
using namespace std;
const int mod = 1e9 + 7;
const int R = 60;

int n;

int powmod(int a, int b)
{
    if (!b)
        return 1;
    int c = powmod(a, b / 2), d = c * c % mod;
    return b % 2 ? d * a % mod : d;
}

int f(int k)
{
    int u = 0;
    for (int i = 0; i < R; ++i)
        u += bool((k >> i) & 1);
    return powmod(n, u);
}

signed main()
{
    int m, k;
    cin >> n >> m >> k;
    vector<int> v;
    bool a[R];
    for (int i = 0; i < R; ++i)
        a[i] = (k >> i) & 1;
    int ans = 0;
    for (int i = 0; i <= k; ++i)
        ans += f(i);
    cout << ans % mod;
    return 0;
}
