#include <iostream>
#include <vector>
#define int long long
using namespace std;
const int mod = 1e9 + 7;
const int R = 60;

int n;

int powmod(int a, int b)
{
    if (!b)
        return 1;
    int c = powmod(a, b / 2), d = c * c % mod;
    return b % 2 ? d * a % mod : d;
}

int f(int k)
{
    int u = 0;
    for (int i = 0; i < R; ++i)
        u += bool((k >> i) & 1);
    return powmod(n, u);
}

signed main()
{
    int m, k;
    cin >> n >> m >> k;
    vector<int> v;
    bool a[R];
    for (int i = 0; i < R; ++i)
        a[i] = (k >> i) & 1;
    int ans = f(k);
    for (int i = 0; i < R; ++i)
    {
        if (((k >> i) & 1) == 0)
            continue;
        /*for (int j = 0; j < R; ++j)
            if (j < i)
                cout << 'u';
            else if (j == i)
                cout << '0';
            else
                cout << a[j];*/
        int r = powmod(n + 1, i);
        for (int j = i + 1; j < R; ++j)
            if ((k >> j) & 1)
                r = r * n % mod;
        ans += r;
    }
    cout << ans % mod;
    return 0;
}
