#include <iostream>
using namespace std;
const int N = 5001;
const int mod = 1e9 + 7;

static int dpu[N][N], dpd[N][N], pdpu[N][N], pdpd[N][N];

int main()
{
    int n, k;
    cin >> n >> k;
    dpu[k][k] = dpd[k][k] = 1;
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    for (int i = k + 1; i <= n; ++i)
    {
        for (int j = 0; j < i; ++j)
        {
            dpu[i][j] = dpd[i][j] = 0;
            for (int k = 0; k < j; ++k)
                dpu[i][j] = (dpu[i][j] + dpd[i-j][k]) % mod;
            for (int k = j + 1; k < n; ++k)
                dpd[i][j] = (dpd[i][j] + dpu[i-j][k]) % mod;
        }
    }
    int ans = 0;
    for (int i = 0; i < N; ++i)
        ans = ((ans + dpu[n][i]) % mod + dpd[n][i]) % mod;
    cout << ans;
    return 0;
}
