#include <bits/stdc++.h>

using namespace std;

vector <bool> used;
vector <int> colors;

void dfs(int v, vector <vector <int> > & g, int color) {
    used[v] = true;
    colors[v] = color;
    for (int u : g[v]) {
        if (!used[u])
            dfs(u, g, -color);
    }
}

int main()
{
    int n; cin >> n;
    if (n <= 20) {
        set <pair <int, int> > blocked;
        for (int i = 1; i <= n; i++) {
            int x; cin >> x;
            blocked.insert(make_pair(i, x));
            blocked.insert(make_pair(x, i));
        }
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            vector <int> cur;
            for (int j = 0; j < n; j++)
                if ((mask) & (1 << j))
                    cur.push_back(j + 1);
            bool f = true;
            for (int i = 0; i < cur.size(); i++)
                for (int j = i; j < cur.size(); j++)
                    if (blocked.count(make_pair(cur[i], cur[j])))
                        f = false;
            if (f) ans = max(ans, (int)cur.size());
        }
        cout << ans;
        return 0;
    }
    vector <vector <int> > g(n);
    for (int i = 0; i < n; i++) {
        int u; cin >> u;
        if (u == -1) continue;
        g[i].push_back(u - 1);
        g[u - 1].push_back(i);
    }
    used.resize(n);
    colors.resize(n);
    int cnt = 1;
    for (int i = 0; i < n; i++)
        if (!used[i]) {
            dfs(i, g, cnt);
            cnt++;
        }
    vector <vector <int> > evercol(n + 1, vector <int>(2, 0));
    for (int i = 0; i < n; i++) {
        if (colors[i] < 0)
            evercol[-colors[i]][0]++;
        else
            evercol[colors[i]][1]++;
    }
    int ans = 0;
    for (int i = 0; i <= n; i++)
        ans += max(evercol[i][0], evercol[i][1]);
    cout << ans;
    return 0;
}
