#include <iostream>
#include <cmath>

using namespace std;

const long long SZ = 1e5 + 10;
const long long INF = 2e18;

long long k;

long long action()
{
    if (k == 0)
        return 0;
    bool need = false;
    if (k < 0)
        need = true;
    k = abs(k);
    long long s_res = -1, n_res = -1;
    for (long long A = 1; A * A <= k; A++) {
        if (k % A != 0)
            continue;
        long long B = k / A;
        if ((A + B) % 2 != 0)
            continue;
        long long s_now = (A + B) / 2;
        long long n_now = s_now - A;
        if (s_res == -1 || s_now < s_res) {
            s_res = s_now;
            n_res = n_now;
        }
    }
    if (need)
        return n_res;
    return s_res;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> k;
    long long ans = action();
    if (ans == -1)
        cout << "none";
    else
        cout << ans;
    return 0;
}
