#include <iostream>
#include <cmath>
using namespace std;

int min(int a, int b)
{
	return a < b ? a : b;
}
int max(int a, int b)
{
	return a > b ? a : b;
}
int countGroup(int k, int n)
{
	
	if (k >= n)
		return 0;
	int amount = min(n - k, k - 1);
	if (n - k <= 1)
		return amount;
	int a1 = max(n - k - 2, 0);
	if (a1 == 0)
		return amount;
	if ((n % 2 == 0 && k % 2 == 0) || (n % 2 == 1 && k % 2 == 1))
	{
		int x = (n - k - 1);
		if (x <= k - 1)
			return ((n - k - 2) * (n - k)) / 4;
		else
			return ((2 * n - 3 * k - 2) * (k - 1)) / 2;
	}
	else
	{
		int x = (n - k - 1);
		if (x <= k - 1)
			return ((n - k - 1) * (n - k - 1)) / 4;
		else
			return ((2 * n - 3 * k - 2) * (k - 1)) / 2;
	}
}
long long int  goDeep(int k, int n, int sum, bool down)
{
	long long int amount = 0;
	if (down)
	{
		for (int i = 1; i < k; ++i)
		{
			if (sum + i < n)
				amount += goDeep(i, n, sum + i, false);
			else
			{
				amount += 1;
				break;
			}
		}
	}
	else
	{
		for (int i = k + 1; i <= n - sum; ++i)
		{
			if (sum + i <= n)
				amount += goDeep(i, n, sum + i, true);
			else
			{
				amount += 1;
				break;
			}
		}
	}
	return amount;
}
int main()
{
	int n, k;
	cin >> n >> k;
	/*
	long long int amount = 0;
	amount += countGroup(k, n);
	for (int i = k + 3; i < n; ++i)
	{
		amount *= countGroup(i, n) * ( i <= k + 2 ? 0 : (1 + max(i - k - 5, 0)));
	}
	long long int sec_amount = n - 2 *  k;
	for (int i = k + 1; i < n; ++i)
	{
		sec_amount *= countGroup(i, n) * (1 + max(i - k - 2, 0));
	}
	cout << (amount == 0 && sec_amount == 0 ? 1 : (amount + sec_amount) % 1000000007);*/

	long long int amount = 0;
	amount += goDeep(k, n, k, true);
	amount += goDeep(k, n, k, false);
	cout << amount;
	//system("pause");
	
	return 0;
}