#include <iostream>
#include <map>
#include <vector>
#include <functional>
using namespace std;
int max(int a, int b)
{
	return a > b ? a : b;
}
int main()
{
	int n, amount;
	cin >> n;
	amount = 0;
	multimap < std::pair<int, int>, int, function<bool (std::pair<int, int>, std::pair<int, int>) >> cands(
		[](pair<int, int> a, pair<int, int> b)->bool {
		if (max(a.first, a.second) != max(b.first, b.second))
			return max(a.first, a.second) < max(b.first, b.second);
		else
			return a.first < b.first;
	});
	
	vector<int> v_cands(n, 0);
	vector<int> whwe_cands(n, 0);
	for (int i = 0; i < n; ++i)
	{
		int x;
		cin >> x;
		if (x != -1)
			++v_cands[x - 1];
		whwe_cands[i] = (x == -1 ? x : x - 1);
	}
	for (int i = 0; i < n; ++i)
	{
		cands.insert(std::pair<std::pair<int, int>, int>(std::pair<int, int>
			(v_cands[i], (whwe_cands[i] == -1 ? 0 : v_cands[whwe_cands[i]])), i));
	}

	vector<bool> erased(n, false);
	vector<bool> taken(n, false);
	for (auto &it : cands)
	{
		if (!erased[it.second] && (whwe_cands[it.second] == -1 || !taken[whwe_cands[it.second]]))
		{
			if (whwe_cands[it.second] != -1)
				erased[whwe_cands[it.second]] = true;
			
			taken[it.second] = true;
			++amount;
		}
	}
	cout << amount;
	//system("pause");
	return 0;
}