#include <iostream>
#include <vector>
#include <queue>
#define int long long

int ans = 0;
int n;
int iff = 0;

using namespace std;

bool check(vector<vector<int>> &graph, vector<int> &vec) {
    vector<int> forb(n, 0);
    for (int i = 0; i < vec.size(); i++) {
        forb[vec[i]] = 1;
    }
    for (int i = 0; i < vec.size(); i++) {
        for (auto elem : graph[vec[i]]) {
            if (forb[elem] == 1)
                return false;
        }
    }
    return true;
}

void pereb(vector<vector<int>> &graph, vector<int> taken, int u) {
    if (u == n) {
        if (check(graph, taken)) {
            int sz = taken.size();
            ans = max(ans, sz);
        }
    }
    else {
        pereb(graph, taken, u + 1);
        taken.push_back(u);
        pereb(graph, taken, u + 1);
    }
}

main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    vector<vector<int>> graph(n);
    int a;
    for (int i = 0; i < n; i++) {
        cin >> a;
        if (a != -1) {
            if (a != i) {
                iff = 1;
            }
            graph[i].push_back(a - 1);
            graph[a - 1].push_back(i);
        }
    }
    if (n > 20) {
        int anss = 0;
        vector<int> used(n, 0);
        for (int i = 0; i < n; i++) {
            if (used[i] == 0) {
                queue<pair<int, int>> bfs;
                int cnt_0 = 0, cnt_1 = 0;
                bfs.push(make_pair(i, 0));
                used[i] = 1;
                while (!bfs.empty()) {
                    pair<int, int> pa = bfs.front();
                    bfs.pop();
                    if (pa.second == 0) {
                        cnt_0++;
                    }
                    else {
                        cnt_1++;
                    }
                    for (auto elem : graph[pa.first]) {
                        if (used[elem] == 0) {
                            if (pa.second == 0) {
                                bfs.push(make_pair(elem, 1));
                            }
                            else {
                                bfs.push(make_pair(elem, 0));
                            }
                            used[elem] = 1;
                        }
                    }
                }
                anss += max(cnt_0, cnt_1);
            }
        }
        cout << anss;
        return 0;
    }
    vector<int> help(0);
    pereb(graph, help, 0);
    cout << ans;
    return 0;
}
