#include <iostream>
#include <vector>

using namespace std;

vector<vector<vector<int>>> mem;

long long n;

long long f(long long d,long long s,long long k)
{
    long long ans = 0;
    if (mem[d][s][k] != -1)
        return mem[d][s][k];
    if (s > n)
        return 0;
    if (s == n)
        return 1;
    if (k == 0){
        for (int i = d + 1; i <= n - s; ++i)
        {
            ans += f(i,s + i,1);
            ans %= 1000000007;
        }
    }
    else{
        for (int i = 1; i <= min(d - 1,n - s); ++i)
        {
            ans += f(i,s + i,0);
            ans %= 1000000007;
        }
    }
    mem[d][s][k] = ans;
    return ans;
}

int main()
{
    long long ans,k;
    cin >> n >> k;
    if (n == k){
        cout << 1;
        return 0;
    }
    mem = vector<vector<vector<int>>>(5000,vector<vector<int>>(5000, vector<int>(2,-1)));
    cout << f(k,k,0) + f(k,k,1);
    return 0;
}
