#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


vector<vector<int>> graph;
vector<int> cl;
int ccnt[2];


void dfs(int v) {
    for (int u : graph[v]) {
        if (cl[u] != -1) {
            continue;
        }

        ++ccnt[cl[u] = 1 - cl[v]];

        dfs(u);
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> prh(n);
    for (int i = 0; i < n; ++i) {
        cin >> prh[i];

        if (prh[i] > 0) {
            --prh[i];
        }
    }

    if (n <= 20) {
        int m = (1 << n);

        int answ = 0;
        for (int cm = 0; cm < m; ++cm) {
            int cur = 0;
            vector<int> used(n);
            for (int i = 0; i < n; ++i) {
                used[i] = (cm >> i) % 2;

                cur += used[i];
            }

            bool b = true;
            for (int i = 0; i < n; ++i) {
                if (used[i] && prh[i] != -1 && used[prh[i]]) {
                    b = false;

                    break;
                }
            }

            if (b) {
                answ = max(answ, cur);
            }
        }

        cout << answ;

        return 0;
    }

    graph.resize(n);

    for (int i = 0; i < n; ++i) {
        if (prh[i] != -1) {
            graph[i].push_back(prh[i]);
            graph[prh[i]].push_back(i);
        }
    }

    cl.resize(n, -1);

    int answ = 0;

    for (int i = 0; i < n; ++i) {
        if (cl[i] != -1) {
            continue;
        }

        ccnt[0] = 1;
        ccnt[1] = 0;
        cl[i] = 0;

        dfs(i);

        answ += max(ccnt[0], ccnt[1]);
    }

    cout << answ;

    return 0;
}