#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector<vector<int>> ks(k, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> ks[j][i];
        }
    }

    vector<vector<int>> kstd = ks;

    vector<int> part(k);
    for (int i = 0; i < k; ++i) {
        sort(kstd[i].begin(), kstd[i].end());

        part[i] = kstd[i][n / 2];
    }

    vector<vector<int>> pps(1 << k);
    for (int i = 0; i < n; ++i) {
        int mask = 0;
        for (int j = 0; j < k; ++j) {
            mask |= (ks[j][i] >= part[j]) << j;
        }

        pps[mask].push_back(i);
    }

    vector<pair<int, int>> answ;
    for (int i = 0; i < (1 << (k - 1)); ++i) {
        int comp = (1 << k) - 1 - i;
        if (pps[i].size() != pps[comp].size()) {
            cout << "NO";

            return 0;
        }

        for (int j = 0; j < pps[i].size(); ++j) {
            answ.emplace_back(pps[i][j], pps[comp][j]);
        }
    }

    cout << "YES" << '\n';
    for (auto p : answ) {
        cout << p.first + 1 << ' ' << p.second + 1 << '\n';
    }

    return 0;
}