#include <iostream>
#include <vector>
const long long INF = 1e9 + 7;
using namespace std;
int main()
{
    int n, k;
    cin >> n >> k;
    if (n == k)
    {
        cout << 1;
    }
    else
    {
        vector<vector<pair<long long, long long> > > dp(n - k + 1, vector<pair<long long, long long> > (n + 1, make_pair(0, 0)));
        dp[0][k].first = 1;
        dp[0][k].second = 1;
        for (int i = 0; i < n - k + 1; i++)
        {
            for (int j = 0; j <= n; j++)
            {
                if (dp[i][j].first != 0)
                {
                    for (int q = 1; q <= min(n - k - i, j - 1); q++)
                    {
                         dp[i + q][q].second += dp[i][j].first;
                         dp[i + q][q].second = dp[i + q][q].second % INF;
                    }
                }
                if (dp[i][j].second != 0)
                {
                    for (int q = j + 1; q <= n - k - i; q++)
                    {
                        dp[i + q][q].first += dp[i][j].second;
                        dp[i + q][q].first = dp[i + q][q].first % INF;
                    }
                }
            }
        }
        long long ans = 0;
        for (int i = 0; i <= n; i++)
        {
            ans = (ans + dp[n - k][i].first + dp[n - k][i].second) % INF;
        }
        cout << ans;
    }
}
