#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
int prov(vector<long long>& A, vector<vector<long long> >& G, long long n)
{
    for (int i = 0; i < n; i++)
    {
        if (A[i] == 1)
        {
            for (int j = 0; j < G[i].size(); j++)
            {
                if (A[G[i][j]] == 1)
                {
                    return 1;
                }
            }
        }
    }
    return 0;
}
vector<long long> per(long long a, long long n)
{
    vector<long long> P;
    while (a > 0)
    {
        P.push_back(a % 2);
        a = a / 2;
    }
    while (P.size() != n)
    {
        P.push_back(0);
    }
    return P;
}

int main()
{
    long long n;
    cin >> n;
    vector<vector<long long> > G(n);
    long long lol;
    for (int i = 0; i < n; i++)
    {
        cin >> lol;
        G[i].push_back(lol - 1);
        G[lol - 1].push_back(i);
    }
    long long ans = 1;
    for (long long i = 0; i < pow(2, n); i++)
    {
        vector<long long> P = per(i, n);
        if (prov(P, G, n) == 0)
        {
            long long sum = 0;
            for (int i = 0; i < n; i++)
            {
                sum += P[i];
            }
            ans = max(ans, sum);
        }
    }
    cout << ans;
}
