#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const long double EPS = 1e-9;
const long long INF = 1e9;

using namespace std;

long long n, m, k;
vector <vector <char>> vec;
vector <bool> used;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll sum(ll l, ll r) {
	return (r + l) / 2 * ((r - l) / 2 + 1);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> m;
	vector <ll> a(m), b(n);
	for (auto &x : a) {
		cin >> x;
	}
	for (auto &y : b) {
		cin >> y;
	}
	bool fs = true, fus = true;
	for (int i = 0; i < n; ++i) {
		if (a[i] != b[i]) fs = false;
		if (a[i] != b[n - i - 1]) fus = false;
	}
	if (n == m && fs) {
		cout << n << '\n';
		for (int i = 0; i < n; ++i) {
			cout << n << ' ';
		}
	}
	else if (n == m && fus) {
		cout << 2 * n - 1 << '\n';
		for (int i = 0; i < n - 1; ++i) {
			cout << n - i << ' ';
		}
		for (int i = 0; i < n; ++i) {
			cout << n << ' ';
		}
	}
	return 0;
}