#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const long double EPS = 1e-9;
const long long INF = 1e9;

using namespace std;

long long n, m, k;
vector <int> vec;
vector <vector <int>> rvec;
vector <vector <int>> g;
vector <int> used;
vector <int> smth;
vector <bool> tused;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
vector <int> cur;
vector <vector <int>> anime;

void f() {
	if (cur.size() == n) {
		for (int l = 0; l < k; ++l) {
			int f = ~(1 << 31), s = (1 << 31);
			for (int i = 0; i < cur.size(); i += 2) {
				f = min(f, max(anime[cur[i]][l], anime[cur[i + 1]][l]));
				s = max(s, min(anime[cur[i]][l], anime[cur[i + 1]][l]));
			}
			if (f < s) {
				return;
			}
		}
		cout << "YES\n";
		for (int i = 0; i < cur.size(); i += 2) {
			cout << cur[i] + 1 << ' ' << cur[i + 1] + 1 << '\n';
		}
		exit(0);
	}
	for (int j = 0; j < n; ++j) {
		if (!used[j]) {
			used[j] = true;
			cur.push_back(j);
			f();
			cur.pop_back();
			used[j] = false;
		}
	}
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> k;
	if (k == 1) {
		vector <pair <int, int>> tmp(n);
		for (int i = 0; i < n; ++i) {
			cin >> tmp[i].first;
			tmp[i].second = i + 1;
		}
		sort(tmp.begin(), tmp.end());
		cout << "YES\n";
		for (int i = 0; i < n / 2; ++i) {
			cout << tmp[i].second << ' ' << tmp[n - i - 1].second << '\n';
		}
	}
	else {
		anime.resize(n, vector <int> (k));
		used.resize(n, false);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < k; ++j) {
				cin >> anime[i][j];
			}
		}
		f();
		cout << "NO";
	}
	return 0;
}