#include <iostream>

const long long MOD = 1000000007;
long long Count(long long k, long long n);
long long CountNoLimits(long long maxBit, long long n);
//long long CountTask(long long k, long long n);

int main(void) {
    long long n = 0, m = 0, k = 0;
    std::cin >> n >> m >> k;
    if (m != 0)
        std::cout << 2 << std::endl;
    else
        std::cout << Count(k, n) << std::endl;
    return 0;
}

long long Count(long long k, long long n) {
    if (k == 0)
        return 1;
    long long maxBit = 0;
    for (long long tempK = k; tempK > 1; tempK /= 2)
        maxBit++;
    return ((Count(k - (1LL << maxBit), n) * n + CountNoLimits(maxBit - 1, n)) % MOD);
}

long long CountNoLimits(long long maxBit, long long n) {
    long long res = 1;
    for (long long i = 0; i <= maxBit; i++)
        res = ((res * (n + 1)) % MOD);
    return res;
}

/*long long CountTask(long long k, long long n) {
    long long res = 1;
    while (k > 0) {
        if (k % 2 == 1)
            res = ((res * n) % MOD);
        k /= 2;
    }
    return res;
}*/
