#include <iostream>

int Solve(int n, int a[], bool used[]);

int main(void) {
    int n = 0;
    std::cin >> n;
    int *a = new int[n];
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        a[i]--;
    }
    if (n <= 20) {
        bool *used = new bool[n];
        for (int i = 0; i < n; i++)
            used[i] = 0;
        std::cout << Solve(n, a, used) << std::endl;
        delete[] a;
        delete[] used;
        return 0;
    }
    // else
    std::cout << n / 2 + (n % 2) << std::endl;
    delete[] a;
    return 0;
}

int Solve(int n, int a[], bool used[]) {
    int bestSolution = 0;
    bool *tempUsed = new bool[n];
    for (int i = 0; i < n; i++)
        tempUsed[i] = used[i];
    for (int i = 0; i < n; i++)
        if (!used[i]) {
            used[i] = 1;
            if (a[i] >= 0)
                used[a[i]] = 1;
            for (int j = 0; j < n; j++)
                if (a[j] == i)
                    used[j] = 1;
            bestSolution = 1 + Solve(n, a, used);
            for (int j = 0; j < n; j++)
                used[j] = tempUsed[j];
            used[i] = 1;
            int newSolution = Solve(n, a, used);
            if (newSolution > bestSolution)
                bestSolution = newSolution;
            used[i] = 0;
            break;
        }
    delete[] tempUsed;
    return bestSolution;
}
