#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
using ll = long long;

inline void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const ll INF = 1e9 + 228;

struct Task {

    ll ans;
    ll n, k;
    vector<vector<vector<ll>>> dp;

    ll brt(ll cr, ll ost, bool st) {
        if (ost == 0) {
            ans++;
            ans %= ll(1e9 + 7);
            return 1;
        }
        if (dp[cr][ost][st] != INF) {
            ans += dp[cr][ost][st];
            ans %= ll(1e9 + 7);
            return dp[cr][ost][st];

        } else {
            ll cans = 0;
            if (st) {
                for (ll i = cr + 1; i <= ost; i++) {
                    if (dp[i][ost-i][!st] != INF) {
                        cans += dp[i][ost-i][!st];
                        cans %= ll(1e9 + 7);
                    }
                    cans += brt(i, ost - i, !st);
                    cans %= ll(1e9 + 7);
                }
            } else {
                for (ll i = min(cr - 1, ost); i >= 1; i--) {
                    cans += brt(i, ost - i, !st);
                    cans %= ll(1e9 + 7);
                }
            }
            dp[cr][ost][st] = cans;
            return cans;
        }
    }

    void run(istream &cin, ostream &cout) {
        fast_io();
        cin >> n >> k;
        ans = 0;
        if (n == k) {
            cout << 1;
            return;
        }
        dp.resize(n + 1, vector<vector<ll>>(n + 1, vector<ll>(2, INF)));
        brt(k, n - k, 1);
        brt(k, n - k, 0);
        cout << ans;
    }
};

signed main() {
    Task task;
    task.run(cin, cout);
    return 0;
}
