#include <bits/stdc++.h>

using ll = long long;
using namespace std;

struct Task {
    int n;
    vector<vector<int>> g;
    vector<char> usd1, usd2;
    vector<int> cnt_clr;
    vector<int> clrs1, clrs2;
    vector<int> a;


    void dfs(int v, int cl, vector<char> &usd, vector<int> &clrs) {
        usd[v] = 1;
        if (a[v] == -2) {
            clrs[v] = 1;
            return;
        }
        clrs[v] = cl;
        cnt_clr[cl - 1]++;
        int ncl = (cl == 1 ? 2 : 1);
        for (auto u : g[v]) {
            if (cl == 2 && clrs[u] == 2) {
                cnt_clr[cl - 1]--;
                clrs[v] = 1;
                cl = 1;
                ncl = 2;
                cnt_clr[cl - 1]++;
            }
        }
        for (auto u : g[v]) {
            if (!usd[u]) {
                dfs(u, ncl, usd, clrs);
            }
        }
    }

    void run(istream &cin, ostream &cout) {
        cin >> n;
        a.resize(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
        }
        g.resize(n);
        usd1.resize(n);
        usd2.resize(n);
        clrs1.resize(n);
        clrs2.resize(n);
        for (int i = 0; i < n; i++) {
            if (a[i] != -2) {
                g[a[i]].push_back(i);
            }
        }
        cnt_clr.resize(2);
        ll ans = 0;
        for (int i = 0; i < n; i++) {
            if (!usd1[i]) {
                cnt_clr.assign(2, 0);
                dfs(i, 1, usd1, clrs1);
                int cans = cnt_clr[1];
                cnt_clr.assign(2, 0);
                dfs(i, 2, usd2, clrs2);
                cans = max(cans, cnt_clr[1]);
                ans += cans;
            }
        }
        cout << ans;
    }
};

int main() {
    Task task;
    task.run(cin, cout);
    return 0;
}