#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
using ll = long long;

inline void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const ll INF = 1e9 + 228;

struct Task {
    int n;
    int ans;
    vector<int> a;

    void brt(string s, int n) {
        if (n > 0) {
            brt(s + '0', n - 1);
            brt(s + '1', n - 1);
        } else {
            n = s.size();
            int cans = 0;
            for (int i = 0; i < n; i++) {
                if (s[i] == '1' && a[i] == -2) cans++;
                else if (s[i] == '1' && s[a[i]] == '0') cans++;
                else if (s[i] == '1') return;
            }
            ans = max(cans, ans);
        }
    }

    vector<char> usd;
    vector<vector<int>> g;
    vector<vector<int>> org;
    vector<vector<int>> dp;
    vector<int> suns;

    void dfs(int v) {
        usd[v] = 1;
        dp[v][1] = 1;
        for (auto u : g[v]) {
            if (!usd[u]) {
                dfs(u);
                dp[v][0] += max(dp[u][0], dp[u][1]);
                dp[v][1] += dp[u][0];
            } else if (usd[u] == 1) {
                suns.push_back(v);
            }
        }
        usd[v] = 2;
    }

    int dfs1(int v) {
        if (org[v].size() == 0) return 1;
        return dfs1(org[v][0]) + 1;
    }

    int dfs2(int v) {
        int u = v;
        int cnt = 0;
        vector<int> c, all, od, ev, cc, ot;
        int ods = 0, evs = 0, ots = 0;
        do {
            cnt++;
            all.push_back(u);
            if (g[u].size() > 1) {
                if (g[u][0] == a[u]) {
                    c.push_back(dfs1(g[u][1]) + 1);
                } else {
                    c.push_back(dfs1(g[u][0]) + 1);
                }

            } else {
                c.push_back(0);
            }
            if (cnt % 2) {
                ev.push_back(c.back() / 2);
                od.push_back(c.back() / 2 + c.back() % 2);
            } else {
                ev.push_back(c.back() / 2 + c.back() % 2);
                od.push_back(c.back() / 2);
            }
            ods += od.back();
            evs += ev.back();
            u = a[u];
        } while (u != v);
        if (cnt % 2) {
            int cev = 0, cod = 0;
            for (int i = 0; i < cnt; i++) {
                od.push_back(ev[i]);
                ev.push_back(od[i]);
                cev += ev[i];
                cod += od[i];
            }
            int ans = cev;
            for (int i = 0; i < cnt; i++) {
                cev -= ev[i];
                cev += ev[cnt + i];
                cod -= od[i];
                cod += od[cnt + i];
                if (i % 2) {
                    ans = max(ans, cev);
                } else {
                    ans = max(ans, cod);
                }
            }
            return ans;
        } else {
            return max(ods, evs);
        }
    }

    void run(istream &cin, ostream &cout) {
        fast_io();
        cin >> n;
        a.resize(n);
        g.resize(n);
        usd.resize(n);
        org.resize(n);
        dp.resize(n, vector<int>(2));
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
            if (a[i] != -2) {
                g[i].push_back(a[i]);
                g[a[i]].push_back(i);
                org[i].push_back(a[i]);
            }
        }
        if (n <= 20) {
            ans = 0;
            brt("", n);
            cout << ans;
        } else {
            ll tans = 0;
            for (int i = 0; i < n; i++) {
                if (!usd[i]) {
                    int ss = suns.size();
                    dfs(i);
                    if (ss == suns.size())
                        tans += max(dp[i][0], dp[i][1]);
                    else {
                        tans += dfs2(suns.back());
                    }
                }
            }
            cout << tans;
        }
    }
};

signed main() {
    Task task;
    task.run(cin, cout);
    return 0;
}
