#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define MAXN 500000
#define int long long

using namespace std;

const int INF = 1000000000;
int n, ans, m, a[MAXN], b[MAXN], nxt[MAXN], mp[MAXN], pos[MAXN], num[MAXN], i, j, k;
set<pair<int, int> > s;
vector <int> answer;
map <int, int> f;

void erase1(pair <int, int> x){
    s.erase(x);

   // cout <<" - " << x.first << endl;
    for(int i = x.first; i <= (m + 1) * INF; i |= i + 1)
        f[i]--;
}

void insert1(pair <int, int> x, bool flag = 0){
    s.insert(x);// cout << flag << " + " << x.first << endl;

    for(int i = x.first; i <= (m + 1) * INF; i |= i + 1)
        f[i]++;

    int ind = 0;
    for(int i = x.first; i >= 0; i = (i & (i + 1)) - 1)
        ind += f[i];

    //cout << "*" << ind << endl;

    if(flag == 0)
        answer.push_back(ind);
}

main(){
    //freopen("input.txt", "r" , stdin);
    ios_base::sync_with_stdio(0);
    cin.tie();

    cin >> n >> m;

    for(i = 0; i < m; i++)
        cin >> a[i], a[i]--;

    for(i = 0; i < n; i++)
        cin >> b[i], pos[--b[i]] = i;

    for(i = 0; i < n; i++)
        mp[i] = m;

    for(i = m - 1; i >= 0; i--){
        nxt[i] = mp[a[i]];
        mp[a[i]] = i;
    }

    int mx = 0;
    for(i = 0; i < m; i++){
        int cnt = pos[a[i]] - mx;

        if(mx <= pos[a[i]]){
            for(j = mx; j <= pos[a[i]]; j++){
                insert1({INF * (i + 1) - cnt, b[j]}, 1);
                cnt--;
            }

            mx = pos[a[i]] + 1;
        }
    }

    for(i = 0; i < n; i++)
        num[i] = mp[i];

    for(i = 0; i < m; i++){
        set<pair<int, int> > :: iterator it = s.begin();
        vector <pair<int, int> > res;
        vector <pair<int, int> > del;

        while(it != s.end()){
            int v = it -> second;

            //cout << it -> first << " " << it -> second + 1 << endl;
            if(v == a[i]){
                del.push_back(*it);
                break;
            }
            else{
                del.push_back(*it);
                res.push_back({(mp[v] + 1) * INF, v});
            }
            ++it;
        }

        //cout << "*************" << endl;

        for(j = 0; j < res.size(); j++){
            erase1(del[j]);
            insert1(res[j]);
        }

        erase1(del.back());
        ans += res.size() + 1;
        insert1({(nxt[num[a[i]]] + 1) * INF, a[i]});
        //cout << nxt[num[a[i]]] << endl;
         num[a[i]] = nxt[num[a[i]]];

    }

    cout << answer.size() << endl;

    for(i = 0; i < answer.size(); i++)
        cout << answer[i] << " ";
    return 0;
}


//v19.893.790
//Y4osXsHr



















