#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <set>
#include <map>
#define ff first
#define ss second
#define MAXN 300005
#define int long long

using namespace std;

int n, k, i, j, a[MAXN][7], h[MAXN][2], used[MAXN], mt[MAXN];
vector <int> g[MAXN], mask[MAXN];
vector <pair<int, int> > c[10];

int dfs(int v){
    int i, to;

  //  cout << used[v] << " " << v << endl;
    used[v] = 1;

    for(i = 0; i < g[v].size(); i++){
        int to = g[v][i];

         //   cout << used[to] << " " << to << endl;
        if(mt[to] == -1 || (!used[mt[to]] && dfs(mt[to]))){
            mt[to] = v;
            return 1;
        }
    }

    return 0;
}

main(){
    //freopen("input.txt", "r" , stdin);
    ios_base::sync_with_stdio(0);
    cin.tie();

    cin >> n >> k;

    for(i = 0; i < n; i++){
        for(j = 0; j < k; j++){
            cin >> a[i][j];
            c[j].push_back({a[i][j], i});
        }
    }


    for(j = 0 ; j < k; j++){
        sort(c[j].begin(), c[j].end());

        for(i = 0; i < n; i++){
            if(c[j][i].ff == c[j][n / 2 - 1].ff && c[j][n / 2].ff == c[j][n / 2 - 1].ff)
                h[c[j][i].ss][1] |= 1 << j;
            else
                h[c[j][i].ss][0] |= (i < n / 2) * (1 << j);
        }
    }

    if(n > 400){
        for(i = 0; i < n; i++){
            mask[h[i][0]].push_back(i);
        }

        for(i = 0; i < (1 << k); i++){
            if(mask[i].size() != mask[i ^ ((1 << k) - 1)].size()){
                cout << "NO";
                return 0;
            }
        }

        cout << "YES" << endl;

        for(i = 0; i < (1 << (k - 1)); i++){
            for(j = 0; j < mask[i].size(); j++){
                cout << mask[i][j] + 1 << " " << mask[i ^ ((1 << k) - 1)][j] + 1 << endl;
            }
        }
        return 0;
    }

    for(i = 0; i < n; i++){
        for(j = 0; j < n; j++){
            if(((h[i][0] ^ h[j][0]) | h[i][1] | h[j][1]) == (1 << k) - 1){
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }

    fill(mt, mt + n, -1);

    int ans = 0;
    for(i = 0; i < n; i++){
        if(h[i][0] % 2){
            fill(used, used + n, 0);
            ans += dfs(i);
        }
    }

    if(ans != n / 2){
        cout << "NO";
        return 0;
    }

    cout << "YES" << endl;
    for(i = 0; i < n; i++){
        if(mt[i] != -1)
            cout << i + 1 << " " << mt[i] + 1 << endl;
    }
    return 0;
}
