#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

using namespace std;

vector < vector <int> > v;
vector <int> col;

int n, fi, se;


int dfs (int x){

    for (int i = 0; i < v[x].size(); i++){
        if (col[v[x][i]] == -1){
            col[v[x][i]] = 1 - col[x];

            if (col[x] == 1)
                fi++;
            else
                se++;

            dfs(v[x][i]);
        }

    }

    return 0;

}

int main(){

    cin >> n;

    col.resize(n + 1, -1);
    v.resize(n + 1);
    int a, ans = 0;

    for (int i = 0; i < n; i++){
        cin >> a;

        if (a > 0){
            v[i].push_back(a - 1);
            v[a - 1].push_back(i);
        }

    }

    for (int i = 0; i < n; i++){

        if (col[i] == -1){

            col[i] = 0;
            fi = 1;
            se = 0;
            dfs(i);

            ans += max(fi, se);
        }

    }

    cout << ans;

    return 0;
}
