#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main(){

    int n, k, INF = 1e9;
    cin >> n >> k;

    if (k == 1){

        vector < pair <int, int> > s(n);
        for (int i = 0; i < n; i++){
            cin >> s[i].first;
            s[i].second = i + 1;
        }

        sort(s.begin(), s.end());

        cout << "YES\n";

        for (int i = 0; i < n / 2; i++)
            cout << s[i].second << ' ' << s[n - 1 - i].second << '\n';

    }else{

        vector < vector <int> > s(n, vector <int> (3));

        for (int i = 0; i < n; i++){

            cin >> s[i][0] >> s[i][1];
            s[i][2] = i + 1;


        }

        sort (s.begin(), s.end());

        vector < pair <int, int> > s1(n / 2);
        vector < pair <int, int> > s2(n / 2);

        for (int i = 0; i < n / 2; i++){

            s1[i].first = s[i][1];
            s1[i].second = s[i][2];

            s2[i].first = s[n / 2 + i][1];
            s2[i].second = s[n / 2 + i][2];
        }

         sort (s1.begin(), s1.end());
         sort (s2.begin(), s2.end());

         int mx = -INF, mn = INF;
         for (int i = 0; i < n / 2; i++){

            mx = max(mx, min(s1[i].first, s2[n / 2 - 1 - i].first));
            mn = min(mn, max(s1[i].first, s2[n / 2 - 1 - i].first));

         }

         if (mx > mn)
            cout << "NO";
         else{

            cout << "YES\n";

            for (int i = 0; i < n / 2; i++)
                cout << s1[i].second << ' ' << s2[n / 2 - 1 - i].second << '\n';


         }

    }

    return 0;
}
