#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>

using namespace std;

int main()
{
    long long a = 1e9 + 7;
    long long n, m;
    cin >> n >> m;
    vector<vector<long long>> U(n + 2, vector<long long> (n + 2));
    vector<vector<long long>> D(n + 2, vector<long long> (n + 2));
    for (int i = 1; i <= n; ++i)
    {
        U[i][i] = 1;
        D[i][i] = 1;
    }
    long long p1 = 1;
    long long p2 = 0;
    for (int s = 2; s <= n; ++s)
    {
        p2 = 0;
        for (int k = 1; k < s; ++k)
        {
            D[s][k] = (D[s - 1][k - 1] % a + U[s - k][k - 1] % a) % a;
            p2 = (p2 % a + D[s][k] % a) % a;
        }
        U[s][1] = (p1 % a - D[s - 1][1] % a) % a;
        p1 = p2 % a;
        for (int k = 2; k < s; ++k)
        {
            U[s][k] = (U[s - 1][k - 1] % a - D[s - k][k] % a) % a;
        }
    }
    long long ans = (D[n][m] % a  + U[n][m] % a) % a;
    if (n > m)
        cout << ans % a << endl;
    else if (n == m)
        cout << "1" << endl;
    return 0;
}

