#include <iostream>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int INF = 1 << 30;
const ll LLINF = 1LL << 60;

template <class T>
istream& operator>>(istream &in, vector<T> &ar) {
    for (int i = 0; i < ar.size(); ++i)
        in >> ar[i];
    return in;
}

template <class T>
ostream& operator<<(ostream &out, vector<T> &ar) {
    for (T x : ar)
        out << x << ' ';
    return out;
}

int main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    ll k;
    cin >> k;
    if (k == 0) {
        cout << "0\n";
        return 0;
    }
    ll mk = abs(k);
    swap(mk, k);
    if (k % 2 == 0 && k % 4 != 0) {
        cout << "none\n";
        return 0;
    }

    ll l = 0, r = 1e8;
    while (r - l > 1) {
        ll m = (r + l) / 2;
        if (m * m >= k)
            r = m;
        else
            l = m;
    }
    ll a = r, b = 0;
    int c = 0;
    while (c < 1e7) {
        while (a * a - b * b > k)
            ++b;
        //cout << a << ' ' << b << ' ' << a * a - b * b << '\n';
        if (a * a - b * b == k)
            break;
        /*if (abs(k - a * a + b * b) < 2 * (a - b)) {
            cout << "none\n";
            return 0;
        }*/
        ++c;
        ++a;
    }
    if (c == 1e7)
        a = k / 2 + 1, b = a - 1;
    if (mk < 0)
        cout << b << '\n';
    else
        cout << a << '\n';
}
