#include <iostream>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int INF = 1 << 30;
const ll LLINF = 1LL << 60;

template <class T>
istream& operator>>(istream &in, vector<T> &ar) {
    for (int i = 0; i < ar.size(); ++i)
        in >> ar[i];
    return in;
}

template <class T>
ostream& operator<<(ostream &out, vector<T> &ar) {
    for (T x : ar)
        out << x << ' ';
    return out;
}

int main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(m), b(n);
    cin >> a >> b;
    if (a[0] == b[0]) {
        cout << n << '\n';
        for (int i = 0; i < n; ++i)
            cout << n << ' ';
        cout << '\n';
    }
    else {
        cout << 2 * n - 1 << '\n';
        for (int i = 0; i < n - 1; ++i)
            cout << n - i << ' ';
        for (int i = 0; i < n; ++i)
            cout << n << ' ';
        cout  << '\n';
    }
}
