#include <bits/stdc++.h>
using namespace std;
#include <cassert>

#ifdef _LOCAL_SRC
#define debug(...) fprintf (stderr, __VA_ARGS__)
#else
#define debug(...)
#endif

typedef long long i64;
typedef unsigned long long u64;

i64 solve_pos (i64 k) {
	vector <i64> ans;
	for (i64 i = 1; i * i <= k; ++i) {
		i64 n = -1;
		if ((k - i * i) % (2 * i) == 0) {
			n = ((k - i * i) / (2 * i));
		}
		if (n >= 0) {
			double _n = n;
			double res = sqrtl (_n  * _n + (double)k) + 0.00001;
			ans.push_back (res);
		}
	}
	if (ans.size () == 0)
		return -1;
	return *min_element (ans.begin (), ans.end ());
}

i64 solve_neg (i64 k) {
	vector <i64> ans;
	for (i64 i = 1; i * i <= k; ++i) {
		i64 n = -1;
		if ((k + i * i) % (2 * i) == 0) {
			debug ("%lld\n", i);
			n = ((k + i * i) / (2 * i));
		}
		if (n >= 0) {
			double _n = n;
			double res = sqrtl (_n  * _n - (double)k) + 0.00001;
			ans.push_back (res);
		}
	}
	if (ans.size () == 0)
		return -1;
	return *min_element (ans.begin (), ans.end ());
}

int main () {
	i64 k;
	cin >> k;
	if (k == 0) {
		cout << 0 << endl;
		return 0;
	}
	
	i64 ret;
	if (k > 0)
		ret = solve_pos (k);
	else
		ret = solve_neg (abs(k));

	if (ret == -1)
		cout << "none\n";
	else
		cout << ret << endl;
	return 0;
}