#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second
#define f(i, n) for (int i = 0; i < (n); i++)

using namespace std;

#define int long long

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << "{" << p.x << ", " << p.y << "}";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class T>
ostream &operator<<(ostream &os, const set<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const map<A, B> &v) {
	for (const auto &x : v) {
		os << x << " ";
	}
	return os;
}

void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

const int MOD = 1e9 + 7;

int n, k;
vector<int> v;

int mem[5001][5001][2];
int dp(int sum, int last, bool inc) {
	if (sum < last) return 0;
	if (sum == last) return (last == k);
	if (mem[sum][last][inc] != -1) return mem[sum][last][inc];
	if (inc) {
		int rez = 0;
		for (int j = 1; j < last; j++) {
			rez += dp(sum - last, j, !inc);
			rez %= MOD;
		}
		return mem[sum][last][inc] = rez;
	} else {
		int rez = 0;
		for (int j = last + 1; j <= n; j++) {
			rez += dp(sum - last, j, !inc);
			rez %= MOD;
		}
		return mem[sum][last][inc] = rez;
	}
}

void run() {
	memset(mem, -1, sizeof mem);
	cin >> n >> k;
	v.resize(n);
	f(i, n) cin >> v[i];
	int rez = 0;
	// for (int s = k + 1; s <= n; s++) {
		for (int j = 1; j <= n; j++) {
			// cout << s << " " << k << ":" << dp(s, j, false) + dp(s, j, true) << endl;
			rez += dp(n, j, false) + dp(n, j, true);
			rez %= MOD;
		}
	// }
	if (n == k) {
		cout << 1 << endl;
	} else {
		cout << rez << endl;
	}
	// if (k == n) {
	// 	cout << 1 << endl;
	// } else {
	// 	cout << rez << endl;
	// }
}