#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <math.h>
#include <fstream>
#include <iomanip>

#define ll long long
#define ull unsigned long long
#define ld long double
#define u_map unordered_map
#define mp make_pair
#define pb push_back

using namespace std;

vector<int> G;
vector<vector<int>> Back;
vector<int> used;// 0 -  , 1 -    , 2 - , 3 -  
vector<pair<int, int>> dp;

void dfs(int v) {
	//dp[v].first = 1;
	used[v] = 1;
	for (int i = 0; i < Back[v].size(); i++) {
		if (used[Back[v][i]] != 2) {
			dfs(Back[v][i]);
			dp[v].first += dp[Back[v][i]].second;
			dp[v].second += dp[Back[v][i]].first;
		}
	}
}

int main() {
	int n, i, ans = 0;
	cin >> n;
	G = vector<int>(n);
	Back = vector<vector<int>>(n);
	used = vector<int>(n, 0);
	dp = vector<pair<int, int>>(n, mp(1, 0));
	for (i = 0; i < n; i++) {
		int temp;
		cin >> temp;

		if (temp != -1) {
			G[i] = temp - 1;
			Back[temp - 1].pb(i);
		}
		else
			G[i] = -1;
	}
	for (i = 0; i < n; i++) {
		if (Back[i].size() == 0 && used[i] == 0) {
			int j = i, counter = 0;
			used[j] = 1;
			while (G[j] != -1 && used[G[j]] != 1) {
				j = G[j];
				used[j] = 1;
				counter++;
			}
			if (G[j] == -1) {
				dfs(j);
				ans += max(dp[j].first, dp[j].second);
			}
			else {
				int k = G[j];
				used[k] = 2;
				while (G[k] != G[j]) {
					k = G[k];
					used[k] = 2;
				}
				dfs(G[j]);
				used[G[j]] = 2;
			}
		}
	}
	for (i = 0; i < n; i++) {
		if (used[i] == 2) {
			int j = G[i], iter = 0, a = dp[i].first, b = dp[i].second, min1 = 1e9, min2 = 1e9;
			while (j != i) {
				iter++;
				if (iter % 2) {
					a += dp[j].second;
					b += dp[j].first;
					if (dp[j].first - dp[j].second < min2)
						min2 = dp[j].first - dp[j].second;
				}
				else {
					b += dp[j].second;
					a += dp[j].first;
					if (dp[j].first - dp[j].second < min1)
						min1 = dp[j].first - dp[j].second;
				}
				used[j] = 3;
				j = G[j];
			}
			// min1 and min 2 for nech
			if (iter % 2 == 0) {
				a -= min1;
				b -= min2;
			}
			ans += max(a, b);
		}
	}
	for (i = 0; i < n; i++) {
		if (used[i] == 0) {
			int j = G[i], iter = 0;
			while (j != i) {
				iter++;
				used[j] = 3;
				j = G[j];
			}
			ans += (iter+1) / 2;
		}
	}
	cout << ans;
	return 0;
}
