#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int maxn = 600 * 1000 + 228;

int a[maxn], ans[maxn], last[maxn], go_r[maxn], v[maxn];
vector< pair<int, int> > lefts[maxn];

bool marked[maxn];

int t[maxn];

int pointer = 0;

void update(int i, int x) {
	--i;
	for (; i < pointer; i |= (i + 1)) {
		t[i] += x;
	}
}

int getr(int i) {
	--i;
	int res = 0;
	for (; i >= 0; i = (i & (i + 1)) - 1) {
		res += t[i];
	}
	return res;
}

int get(int l, int r) {
	return getr(r) - getr(l - 1);
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector< bool > ex(n + 1);
	for (int i = 1; i <= m; ++i) {
		cin >> a[i];
	}
	vector<int> b;
	for (int i = 0; i < n; ++i) {
		int B;
		cin >> B;
		b.push_back(B);
	}
	int ptr = 1;
	for (int i = 0; i < n && ptr <= m; ++i) {
		while (ex[a[ptr]]) {
			v[++pointer] = a[ptr];
			++ptr;
		}
		if (ptr > m) break;
		v[++pointer] = b[i];
		ex[b[i]] = 1;
		if (a[ptr] == b[i]) ++ptr;
	}
	for (int i = ptr; i <= m; ++i) {
		v[++pointer] = a[i];
	}
	cout << pointer << endl;
	for (int i = pointer; i > 0; --i) {
		if (last[v[i]] == 0) {
			go_r[i] = pointer + 1;
		} else {
			go_r[i] = last[v[i]];
		}
		last[v[i]] = i;
	}
	for (int i = 1; i <= pointer; ++i) {
		int l = i + 1;
		int r = go_r[i] - 1;
		if (l > r) {
			ans[i] = 0;
		} else {
			lefts[r].push_back({l, i});
		}
	}
	memset(last, 0, sizeof(last));
	for (int i = 1; i <= pointer; ++i) {
		if (last[v[i]] != 0) {
			update(last[v[i]], -1);
		}
		last[v[i]] = i;
		update(last[v[i]], 1);
		for (auto p : lefts[i]) {
			ans[p.second] = get(p.first, i);
		}
	}
	for (int i = 1; i <= pointer; ++i) {
		cout << ans[i] + 1 << " ";
	}
	cout << '\n';
	return 0;
}