
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228

const int MOD = 1000 * 1000 * 1000 + 7;

const int maxn = 300 * 1000 + 228;

int n, m, k;

int C[100][100];

int left[maxn];

void add(int &x, int y) {
	x += y;
	if (x >= MOD) x -= MOD;
}

int result = 0;

int mult(int a, int b) {
	result = ((long long)a * (long long)b) % MOD;
	return result;
}

void CNK() {
	for (int i = 0; i < 100; ++i) {
		C[i][0] = 1;
	}
	for (int i = 1; i < 100; ++i) {
		for (int j = 1; j < 100; ++j) {
			C[i][j] = (C[i - 1][j] + C[i - 1][j - 1]) % MOD;
		}
	}
}


int power(int a, int b) {
	int res = 1;
	while (b) {
		if (b & 1) {
			res *= a;
			res %= MOD;
		}
		a *= a;
		a %= MOD;
		b >>= 1LL;
	}
	return res;
}

int pw[100];

int calc(int x) {
	vector<int> v;
	int K = k;
	while (K) {
		v.push_back(K & 1);
		K >>= 1;
	}
	int bits = __builtin_popcountll(k);
	int res = 0;
	if (bits == x) res = 1;
	reverse(v.begin(), v.end());
	int num = 0;
	for (int pref = 0; pref < (int)v.size(); ++pref) {
		if (num > x) break;
		if (v[pref] == 1) {
			add(res, C[(int)v.size() - pref - 1][x - num]);
		}
		num += v[pref];
	}
	return res;
}


void solve0() {
	for (int i = 0; i < 70; ++i) {
		pw[i] = power(n, i);
	}
	int res = 0;
	for (int bits = 0; bits <= 60; ++bits) {
		add(res, (calc(bits) * pw[bits]) % MOD);
	}
	cout << res << '\n';
}


int dp[maxn][61], sum[2000][61];


void solve1() {
	for (int i = 0; i < 70; ++i) {
		pw[i] = power(n, i);
	}
	for (int bit = 0; bit <= 60; ++bit) {
		dp[1][bit] = 1;
		sum[1][bit] = 1;
	}
	for (int i = 2; i <= n; ++i) {
		for (int bit = 0; bit <= 60; ++bit) {
			for (int b = 0; b < bit; ++b) {
				add(dp[i][bit], (sum[i - 1][b] * C[bit][b]) % MOD);
			}
			sum[i][bit] = sum[i - 1][bit];
			add(sum[i][bit], dp[i][bit]);
		}
	}
	int res = 0;
	for (int bits = 0; bits <= 60; ++bits) {
		add(res, (calc(bits) * dp[n][bits]) % MOD);
	}
	cout << res << '\n';
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> k;
	CNK();
	if (m == 0) {
		solve0();
	} else {
		for (int i = 0; i < m; ++i) {
			int li, ri;
			cin >> li >> ri;
			uax(left[ri], li);
		}
		solve1();
	}
	return 0;
}