
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

// #define int long long
#define left left228
#define right right228

const int MOD = 1000 * 1000 * 1000 + 7;

void add(int &x, int y) {
	x += y;
	if (x >= MOD) x -= MOD;
}

struct state
{
	int n, k, go;
	state() {
	}
	state(int _n, int _k, int _go) {
		n = _n;
		k = _k;
		go = _go;
	}
};

int dp[5001][5001][2];

bool calc[5001][5001][2];

int get(int n, int k, int go) {
	if (calc[n][k][go]) {
		return dp[n][k][go];
	}
	// cout << "(" << n << ", " << k << ", " << go << ")\n";
	calc[n][k][go] = 1;
	if (n == k) {
		dp[n][k][go] = 1;
		return 1;
	}
	if (go == 1) {
		for (int i = k + 1; i <= n - k; ++i) {
			add(dp[n][k][go], get(n - k, i, 0));
		}
	} else {
		for (int i = 1; i <= min(n - k, k - 1); ++i) {
			add(dp[n][k][go], get(n - k, i, 1));
		}
	}
	// cout << "dp[" << n << "][" << k << "][" << go << "]=" << dp[n][k][go] << endl;
	return dp[n][k][go];
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	int res = get(n, k, 0);
	add(res, get(n, k, 1));
	if (n == k) {
		--res;
		if (res < 0) res += MOD;
	}
	cout << res << endl;
	return 0;
}