
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

// #define int long long
#define left left228
#define right right228

const int maxn = 300 * 1000 + 228;

vector<int> g[maxn];
bool used[maxn], bip = 1;
int color[maxn], white = 0, black = 0;


void DFS(int v, int col) {
	used[v] = 1;
	color[v] = col;
	if (col == 0) {
		++white;
	} else {
		++black;
	}
	for (int to : g[v]) {
		if (!used[to]) {
			DFS(to, col ^ 1);
		}
		if (color[v] == color[to]) {
			bip = 0;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		int ai;
		cin >> ai;
		if (ai != -1) {
			g[i].push_back(ai);
			g[ai].push_back(i);
		}
	}
	int res = 0;
	for (int s = 1; s <= n; ++s) {
		if (!used[s]) {
			bip = 1;
			white = black = 0;
			DFS(s, 0);
			if (bip) {
				res += max(white, black);
			} else {
				//
			}
		}
	}
	cout << res << '\n';
	if (res == 0) {
		cout << 2 << '\n';
	}
	return 0;
}