#include <iostream>
#include <cmath>

#define ll long long
#define ull unsigned long long

using namespace std;

ll isSquare(ll num)
{
	ull l = 0, r = num, i = (l + r) / ull(2);
	while (l < r)
	{
		i = (l + r) / ull(2);
		if (i * i > ull(num)) r = i - ull(1);
		else if (i*i < ull(num)) l = i + ull(1);
		else  return i;
	}
	if (l*l == ull(num)) return l;
	return -1;
}

int main()
{
	
	ll k = 0;
	cin >> k;
	ll num = k;
	bool ok = false;
	for (ll i = 0; i <= abs(k); i++)
	{
		if (num >= ll(0))
		{
			if (isSquare(num) >= ll(0))
			{
				ok = true;
				break;
			}
		}
		num += i * ll(2) + (ll)1;
	}

	if (ok) cout << isSquare(num) << endl;
	else    cout << "none" << endl;

	//system("pause");
	return 0;
}