#include <iostream>
#include <cmath>

#define ll int64_t
#define ull uint64_t

using namespace std;

ll isSquare(ll num)
{
	ull l = 0, r = num, i = (l + r) / 2, p = 0;
	while (l < r)
	{
		i = (l + r) / 2;
		p = i * i;
		if (p > ull(num)) r = i - 1;
		else if (p < ull(num)) l = i + 1;
		else  return i;
	}
	if (l*l == ull(num)) return l;
	return -1;
}

int main()
{
	
	ll k = 0;
	cin >> k;
	ll num = k;
	bool ok = false;
	for (ll i = 0; i <= abs(k) / 2; i++)
	{
		if (num >= 0)
		{
			if (isSquare(num) != -1)
			{
				ok = true;
				break;
			}
		}
		num += i * 2 + 1;
	}

	if (ok) cout << isSquare(num) << endl;
	else    cout << "none" << endl;

	//system("pause");
	return 0;
}