#include <bits/stdc++.h>

using namespace std;

int n;
vector < vector < int > > g;
vector < int > used;
vector < int > tree;
int ns;
vector < int > dist;
vector < int > cnt;

void rebuild() {
    ns = 1;
    while (ns < n) {
        ns *= 2;
    }
    tree.assign(2 * ns, 0);
}

void sett(int v, int ql, int qr, int p, int x) {
    if (ql == p && qr == p + 1) {
        tree[v] = x;
        return;
    } else if (ql > p || qr <= p) {
        return;
    }
    sett(v * 2, ql, (ql + qr) / 2, p, x);
    sett(v * 2 + 1, (ql + qr) / 2, qr, p, x);
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

int gett(int v, int ql, int qr, int l, int r) {
    if (ql >= l && qr <= r) {
        return tree[v];
    }
    if (qr <= l || ql >= r) {
        return 0;
    }
    return max(gett(v * 2, ql, (ql + qr) / 2, l, r), gett(v * 2 + 1, (ql + qr) / 2, qr, l, r));
}

void bfs(int v) {
    cnt.assign(n, 0);
    dist.assign(n, 0);
    queue < int > q;
    dist[v] = 1;
    cnt[0]++;
    q.push(v);
    used[v] = true;
    while (q.size() != 0) {
        v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (!used[u]) {
                dist[u] = dist[v] + 1;
                cnt[dist[v]]++;
                q.push(u);
                used[u] = true;
            } else {
                if (dist[u] == dist[v]) {
                    cnt[dist[v] - 1]--;
                    cnt[dist[v]]++;
                    dist[v]++;
                }
            }
        }
    }
}

int maxx() {
    sett(1, 0, ns, 0, cnt[0]);
    sett(1, 0, ns, 1, cnt[1]);
    for (int i = 2; i < n; ++i) {
        sett(1, 0, ns, i, gett(1, 0, ns, 0, i - 1) + cnt[i]);
    }
    return tree[1];
}

int main() {
     int a, ans = 0;
     cin >> n;
     if (n == 1) {
        cout << 1 << "\n";
        return 0;
     }
     g.resize(n);
     used.resize(n, 0);
     for (int i = 0; i < n; ++i) {
        cin >> a;
        if (a == -1) {
            continue;
        }
        g[a - 1].push_back(i);
        g[i].push_back(a - 1);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            bfs(i);
            rebuild();
            ans += maxx();
        }
    }
    cout << ans << "\n";
}
