#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<vector<int>> g;
vector<int> used;
vector<int> m;
vector<int> cycle;
vector<int> timed;
int timer;
int countall, counter;

int dfs(int v, int x) {
	used[v] = 1;
	timed[v] = x;
	int flag = 0;
	for (int i = 0; i < g[v].size(); i++) {
		if (used[g[v][i]] == 0) {
			flag = dfs(g[v][i], x + 1);
			if (flag == 1) {
				cycle.push_back(v);
				return 1;
			}
		}
		else {
			if (timed[g[v][i]] != x - 1) {
				cycle.push_back(v);
				return 1;
			}
		}
	}
	return 0;
}

void second_dfs(int v, int x) {
	used[v] = 2;
	countall++;
	if (x == 1) {
		counter++;
	}
	for (int i = 0; i < g[v].size(); i++) {
		if (used[g[v][i]] != 2) {
			second_dfs(g[v][i], (x + 1) % 2);
		}
	}
}

void third_dfs(int v, int x) {
	used[v] = 3;
	if (x == 1) {
		counter++;
	}
	for (int i = 0; i < g[v].size(); i++) {
		if (used[g[v][i]] != 3) {
			third_dfs(g[v][i], (x + 1) % 2);
		}
	}
}

void fourth_dfs(int v, int x) {
	used[v] = 4;
	if (x == 1) {
		counter++;
	}
	for (int i = 0; i < g[v].size(); i++) {
		if (used[g[v][i]] != 4) {
			fourth_dfs(g[v][i], (x + 1) % 2);
		}
	}
}

int main() {
	int n, x;
	long long int answer = 0;
	vector<int> dp;
	vector<int> ddp;
	vector<set<int>> chosen;
	vector<set<int>> chosenn;
	cin >> n;
	g.resize(n + 1);
	used.resize(n + 1);
	timed.resize(n + 1);
	for (int i = 1; i < n + 1; i++) {
		cin >> x;
		if (x != -1) {
			g[x].push_back(i);
			g[i].push_back(x);
		}
	}
	timer = 0;
	for (int l = 1; l < n + 1; l++) {
		if (used[l] == 0) {
			x = dfs(l, 0);
			if (x == 1) {
				for (int i = 0; i < cycle.size(); i++) {
					used[cycle[i]] = 2;
				}
				m.resize(cycle.size());
				for (int i = 0; i < cycle.size(); i++) {
					second_dfs(cycle[i], 0);
					m[i] = countall - 2 * counter;
					countall = 0;
					counter = 0;
				}
				chosen.resize(m.size());
				chosenn.resize(m.size());
				dp.resize(m.size());
				ddp.resize(m.size());
				dp[0] = max(0, m[0]);
				if (dp[0] > 0) {
					chosen[0].insert(cycle[0]);
				}

				dp[1] = max(dp[0], m[1]);
				if (dp[1] == m[1]) {
					chosen[1].insert(cycle[1]);
				}
				else {
					chosen[1] = chosen[0];
				}

				for (int i = 2; i < m.size() - 1;i++) {
					dp[i] = max(dp[i - 1], dp[i - 2] + m[i]);
					if (dp[i] == dp[i - 1]) {
						chosen[i] = chosen[i - 1];
					}
					else {
						chosen[i] = chosen[i - 2];
						chosen[i].insert(cycle[i]);
					}
				}
				ddp[0] = max(0,m[1]);
				if (ddp[0] > 0) {
					chosenn[0].insert(cycle[1]);
				}
				ddp[1] = max(ddp[0], m[2]);
				if (ddp[1] == m[2]) {
					chosenn[1].insert(cycle[2]);
				}
				else {
					chosenn[1] = chosenn[0];
				}
				for (int i = 2; i < m.size() - 2; i++) {
					ddp[i] = max(ddp[i - 1], ddp[i - 2] + m[i + 1]);
					if (ddp[i] == dp[i - 1]) {
						chosenn[i] = chosenn[i - 1];
					}
					else {
						chosenn[i] = chosenn[i - 2];
						chosenn[i].insert(cycle[i + 1]);
					}
				}
				dp[m.size() - 1] = max(ddp[m.size() - 3] + m[m.size() - 1], dp[m.size() - 2]);
				if (dp[m.size() - 1] == ddp[m.size() - 3] + m[m.size() - 1]) {
					chosen[m.size() - 1] = chosenn[m.size() - 3];
					chosen[m.size() - 1].insert(cycle[m.size() - 1]);
				}
				else {
					chosen[m.size() - 1] = chosen[m.size() - 2];
				}
				for (int i = 0; i < cycle.size(); i++) {
					used[cycle[i]] = 2;
				}
				for (int i = 0; i < cycle.size(); i++) {
					if (chosen[m.size() - 1].find(cycle[i]) != chosen[m.size() - 1].end()) {
						third_dfs(cycle[i], 1);
					}
					else {
						third_dfs(cycle[i], 0);
					}
				}
				answer += counter;
				counter = 0;
				countall = 0;
			}
			else {
				third_dfs(l, 0);
				countall = counter;
				counter = 0;
				fourth_dfs(l, 1);
				answer += max(countall, counter);
				countall = 0;
				counter = 0;
			}
		}
	}
	cout << answer;
	return 0;
}